/*
**   VJE GAMMA
**			common.h
**
*/

#ifndef	EOF
#define	EOF			(-1)
#endif

#ifndef	NULL
#if	MSDOS
#define	NULL			((char *)0)
#else
#define	NULL			0
#endif
#endif

#define	YES			1
#define	NO			0
#define	ON			YES
#define	OFF			NO
#define	TRUE			YES
#define	FALSE		NO
#define	OK			0
#define	ERR			(-1)
#define	PLUS			1
#define	ZERO			0
#define	MINUS		(-1)

#define	EOS			'\0'
#define	TAB			'\t'
#define	CR			'\r'
#define	LF			'\n'
#define	BS			'\b'
#define	DEL			'\177'
#define	ESC			'\033'
#define	BLANK		' '
#define	BELL			'\007'
#define	DAKUTEN		0xde
#define	HANDAKUTEN	0xdf
#define	HATSUON		0xdd

#define	MASK			0377
#define	UC(c)		((c) & MASK)
#define	toggle(flag)	((flag) = !(flag))
#define	swap(a, b)	{(a) ^= (b); (b) ^= (a); (a) ^= (a);}
#define	TAB_STEP		8
#define	TAB_STOP(n)	(TAB_STEP - (n) % TAB_STEP)
#define	INC(c, base)	((c) = (++(c) % (base)))
#define	DEC(c, base)	((c) = ((--(c) + (base)) % (base)))

/*
 *	Macros for length prefixed string
 */
#define	Length(s)		(*((unsigned char *)(s)))
#define	Addchar(s, c)	((s)[++Length(s)] = (c))
#define	Addchar2(s, c)	((s)[++(s)[0]] = (c))

#define	SP(p) 		(UC(*(p)) + UC(*((p) + 1)) * 256)
#define	vjekanji(c)	(0x80 <= UC(c) && UC(c) <= 0x9f ||\
				 0xe0 <= UC(c) && UC(c) <= 0xfc)
#define	max(a,b)		(((a) > (b)) ? (a) : (b))
#define	min(a,b)		(((a) < (b)) ? (a) : (b))
#define	abs(a)		(((a) < 0) ? -(a) : (a))
#define	iscsymf(c)	(isalpha(c) || ((c) == '_'))
#define	iscsym(c)		(isalnum(c) || ((c) == '_'))


typedef	BYTE	BUFF;
typedef	short	FLAG;
typedef	BYTE	UCHAR;
typedef	unsigned short	USHORT;
#if OS2
typedef char far *	PCH;
#else
typedef BYTE *	PCH;
#endif
#define	public
#define	global

#if	MSDOS
#define	REG1			register
#define	REG2			register
#define	REG3
#define	REG4
#define	REG5
#define	REG6
#define	REG7
#define	REG8
#else
#define	REG1			register
#define	REG2			register
#define	REG3			register
#define	REG4			register
#define	REG5			register
#define	REG6			register
#define	REG7			register
#define	REG8			register
#endif

#if WINDOWS
#define	LowClose(fd)			(_lclose((fd)))
#define	LowSeek(fd, pos, mode)	(_llseek((fd), (pos), (mode)))
#define	LowRead(fd, buf, size)	((short)_lread((fd),(char far *)(buf),(size)))
#define	LowWrite(fd, buf, size)	((short)_lwrite((fd),(char far *)(buf),(size)))

#else
#define	LowClose(fd)			(close((fd)))
#define	LowSeek(fd, pos, mode)	(lseek((fd), (long)(pos), (mode)))
#define	LowRead(fd, buf, size)	((short)read((fd),(char *)(buf),(size)))
#define	LowWrite(fd, buf, size)	((short)write((fd),(char *)(buf),(size)))
#endif
