#!/bin/sh

	echo "VJE-Delta Ver.3.0 Makefile configure."

	Uname=/bin/uname
	if [ ! -x $Uname ]; then
		Uname=`whereis -b uname | egrep uname | awk '{ print $2 }'`
		if [ ! -x $Uname ]; then
			echo "uname: command not found"
			echo "Makefile build ....... Failed"
			exit 1
		fi
	fi
	SysName=`$Uname -s`
	Machine=`$Uname -m`

	echo "checking sysname ....." $SysName
	echo "checking machine ....." $Machine

	if [ $SysName = FreeBSD ]; then
		echo "Makefile build ....... FreeBSD"
		cp -f Makefile.FreeBSD Makefile
	else

		LddOut=/tmp/ldd.out.$$
		ldd $Uname > $LddOut
		LibcName=`egrep libc $LddOut | awk '{ print $1 }'`

		echo "checking libc ........" $LibcName
		echo -n "Makefile build ....... "
		
		case $Machine in
		i[3-6]86)
			case $LibcName in
			libc*.5)
				echo "Linux(libc5)"
				cp -f Makefile.Linux Makefile
				;;
			*)
				echo "Linux(libc6)"
				cp -f Makefile.Linux.libc6 Makefile
				;;
			esac
			;;
		*)
			case $LibcName in
			libc*.5)
				echo "MkLinux/LinuxPPC(libc5)"
				cp -f Makefile.MkLinux Makefile
				;;
			*)
				echo "MkLinux/LinuxPPC(libc6)"
				cp -f Makefile.MkLinux.libc6 Makefile
				;;
			esac
			;;
		esac
		rm -f $LddOut
	fi

