/******************************************************************************
	ENV.C
******************************************************************************/
#if !PCUNIX
#include	"exapp.h"
#else /* !PCUNIX */
#include	<X11/keysym.h>
#include	"typedef.h"
#include	"vjectrl.h"
#include	"vjeenv.h"
#include	"macro.h"
#include	"fileio.h"
#include	"env.h"
#include	"getstr.h"
#include	"strutl.h"
#endif /* !PCUNIX */

/*=============================================================================
	define
=============================================================================*/
#define	USE_FETCH	1
#define	MAX_CAND_LEN	(MAX_CAND_SIZE/DBCS_SIZE)
#define	NW		HTTOPLEFT
#define	NE		HTTOPRIGHT
#define	SW		HTBOTTOMLEFT
#define	SE		HTBOTTOMRIGHT

/*=============================================================================
	MACRO
=============================================================================*/
#define	VALID2(x,a,b)		( (x)==(a)||(x)==(b)		 	 )
#define	VALID3(x,a,b,c)		( (x)==(a)||(x)==(b)||(x)==(c)	         )
#define	VALID4(x,a,b,c,d)	( (x)==(a)||(x)==(b)||(x)==(c)||(x)==(d) )
#define	VALID5(x,a,b,c,d,e)	( (x)==(a)||(x)==(b)||(x)==(c)||(x)==(d) \
				||(x)==(e)                               )
#define	VALIDNY(x)		( (x)==NO ||(x)==YES			 )
#define	VALIDCOLOR(x)		(LOBYTE(x) < 48 && HIBYTE(x) < 48	 )

/*=============================================================================
	typedef
=============================================================================*/
typedef	struct	_tagDEFKEY	{
	WORD	wVirt;
	WORD	wCase;
	WORD	wFunc[MAX_STAGE];
	}	DEFKEY,FAR *LPDEFKEY;

/*=============================================================================
	Local	Data
=============================================================================*/
/*-----------------------------------------------------------------------------
	For LoadDefaultKey
-----------------------------------------------------------------------------*/
#ifndef	DPMI
static	DEFKEY	sDefKey[]	= {
#include	"defkey.h"
	};
#endif

/*-----------------------------------------------------------------------------
	For Map Checking	(DEBUG)
-----------------------------------------------------------------------------*/
#if	defined(DEBUG) && !defined(DPMI)
static	WORD	wMapArray[]	= {
#include	"map.h"
	};
#endif

/*-----------------------------------------------------------------------------
	For	*.STY	Section
-----------------------------------------------------------------------------*/
static	TCHAR	sztMod[]		= TEXT("Mode");
static	TCHAR	sztFix[]		= TEXT("SizeFix");
static	TCHAR	sztCmp[]		= TEXT("Composition");
static	TCHAR	sztCan[]		= TEXT("Candidate");
static	TCHAR	sztClr[]		= TEXT("Color");
#ifndef	DPMI
static	TCHAR	sztFnt[FONTS][32]	= {
#if !PCUNIX
					  TEXT("KeyboardFont"),
					  TEXT("FunctionFont"),
					  TEXT("CompositionFont"),
#else /* !PCUNIX */
					  TEXT("PreeditFont"),
					  TEXT("KohoFont"),
					  TEXT("BaseFont"),
#endif /* !PCUNIX */
					  };
static	TCHAR	sztBtn[]		= TEXT("Button");
#endif
static	TCHAR	sztKbd[]		= TEXT("Keyboard");
static	TCHAR	sztRom[]		= TEXT("Roma");
static	TCHAR	sztDci[]		= TEXT("DicInfo");
#ifndef	DPMI
static	TCHAR	sztAci[]		= TEXT("AccInfo");
static	TCHAR	sztWii[]		= TEXT("WinInfo");
#endif
static	TCHAR	sztDos[]		= TEXT("DosVje");
static	TCHAR	sztTitle[]		= TEXT("Title");
#if PCUNIX /* Add:SetFile */
#if !PCUNIX
static	TCHAR	sztSet[]		= TEXT("Set");
#endif /* !PCUNIX */
#endif /* PCUNIX */

/*-----------------------------------------------------------------------------
	GPSel/SPSel	Params
-----------------------------------------------------------------------------*/
#if PCUNIX
static	TCHAR	sztNoYesAuto[]	= TEXT("NO YES AUTO");
static	TCHAR	sztTateYoko[]	= TEXT("YOKO TATE");
#endif
static	TCHAR	sztNoYes[]	= TEXT("NO YES");
static	TCHAR	sztMojiType[]	= TEXT("HIRA KATA EISU");
static	TCHAR	sztMojiSize[]	= TEXT("ZEN HAN");
#if PCUNIX
#if	!XKP_SUPPORT
static	TCHAR	sztCode[]	= TEXT("SJIS JIS KUTEN UCS4 EUC");
#else
static	TCHAR	sztCode[]	= TEXT("SJIS JIS KUTEN UCS4 EUC");
#endif
#else /* PCUNIX */
#if	!XKP_SUPPORT
static	TCHAR	sztCode[]	= TEXT("SJIS JIS KUTEN");
#else								/* +960614 */
static	TCHAR	sztCode[]	= TEXT("SJIS JIS KUTEN UCS4");
#endif
#endif /* PCUNIX */
static	TCHAR	sztOkuriKana[]	= TEXT("NON OKURI HON ALL");
static	TCHAR	sztHenkan[]	= TEXT("SAKI REN BETA");
static	TCHAR	sztBunpou[]	= TEXT("BUN FUKU");
static	TCHAR	sztKigoSize[]	= TEXT("ZEN HAN AUTO");
static	TCHAR	sztCommaEtc[]	= TEXT("NO YES AUTO");
static	TCHAR	sztLearnMode[]	= TEXT("NO YES DON");
static	TCHAR	sztLearnType[]	= TEXT("LEARNDIC MYSELF");
static	TCHAR	sztRank[]	= TEXT("0 1 2 3 4 5 6 7 8");
static	TCHAR	sztKbdType[]	= TEXT("X 101 AX 002 A01 PC98");
#if !PCUNIX
static	TCHAR	sztKbdTypeV[]	= TEXT("NORMAL PAD");
#endif /* !PCUNIX */
static	TCHAR	sztBtnName[]	= TEXT("B20 B12 C20 C12");
static	WORD	wBtnRID[]	= {IDP_BTN20B,IDP_BTN12B,
				   IDP_BTN20C,IDP_BTN12C};
#if	VERSION == 20
static	TCHAR	sztOffHide[]	= TEXT("NO YES");
#elif	USE_APPBAR
static	TCHAR	sztOffHide[]	= TEXT("NO YES SHRINK APPBAR");
#else
static	TCHAR	sztOffHide[]	= TEXT("NO YES SHRINK");
#endif
#if !PCUNIX
#if	VERSION == 25
static	TCHAR	sztLocate[]	= TEXT("SE SW NE NW");
static	WORD	wLocateTBL[]	= {SE,SW,NE,NW};
#if	USE_APPBAR
static	TCHAR	sztEdge[]	= TEXT("float left top right bottom");
static	WORD	wEdgeTBL[]	= {ABE_FLOAT,	ABE_LEFT ,ABE_TOP,
						ABE_RIGHT,ABE_BOTTOM	};
#endif
#endif
#endif /* !PCUNIX */
#if PCUNIX
static	TCHAR	sztFixApp[]	= TEXT("FIX APP");
#endif /* PCUNIX */

/*-----------------------------------------------------------------------------
	Other
-----------------------------------------------------------------------------*/
#if !PCUNIX
static	TCHAR	sztPrefix[MAX_FCASE][4] = {
					  TEXT("" ),TEXT("@" ),
					  TEXT("^"),TEXT("^@"),
					  };
#else /* !PCUNIX */
static	TCHAR	sztPrefix[MAX_FCASE][4] = {
					  TEXT("" ), TEXT("@"),
					  TEXT("^"), TEXT("*"),
					  TEXT("^@"), TEXT("^*"),
					  TEXT("*@"), TEXT("^*@"),
					  };
#endif /* !PCUNIX */
static	TCHAR	sztNull[]		= TEXT("");
static	LPTSTR	lptDefDic[MAX_DIC]	= {
#if !PCUNIX
					  TEXT("Vjed95m.dic"),
					  TEXT("Vjed95y.dic"),
#else /* !PCUNIX */
					  TEXT("vjed95m.dic"),
					  sztNull,
#endif /* !PCUNIX */
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
#if !PCUNIX
					  TEXT("Vjed95u.dic"),
#else /* !PCUNIX */
					  TEXT("vjed95u.dic"),
#endif /* !PCUNIX */
					  };
#ifndef	DPMI
static	LPTSTR	lptDefAcc[MAX_ACC]	= {
#if !PCUNIX
					  TEXT("Vjed95f.dll"),
					  TEXT("Vjed95k.dll"),
					  TEXT("Vjed95t.dll"),
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  };
#else /* !PCUNIX */
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  sztNull,
					  };
#endif /* !PCUNIX */
#endif
#if !PCUNIX
static	TCHAR	sztDefClr[]		= TEXT("Vje.clr");
static	TCHAR	sztDefKey[]		= TEXT("Delta.key");
static	TCHAR	sztDefAch[]		= TEXT("Default.ach");
static	TCHAR	sztDefKch[]		= TEXT("Default.kch");
static	TCHAR	sztDefRom[]		= TEXT("Vje.rom");
static	TCHAR	sztDefSet[]		= TEXT("Vjed95.set");
static	TCHAR	sztNow[]		= TEXT("ʸߤ");
#else /* !PCUNIX */
static	TCHAR	sztDefClr[]		= TEXT("vje.clr");
static	TCHAR	sztDefKey[]		= TEXT("deltasr.key");
static	TCHAR	sztDefAch[]		= TEXT("default.ach");
static	TCHAR	sztDefKch[]		= TEXT("default.kch");
static	TCHAR	sztDefRom[]		= TEXT("vje.rom");
#if PCUNIX /* Add:SetFile */
#if !PCUNIX
static	TCHAR	sztDefSet[]		= TEXT("vjed95.set");
#endif /* !PCUNIX */
#endif /* PCUNIX */
#if PCUNIX
static	TCHAR	sztDefDat[]		= TEXT("vjed95e.dat");
#endif /* PCUNIX */
static	TCHAR	sztNow[]		= TEXT("ʸߤ");
#endif /* !PCUNIX */
static	TCHAR	sztBuff[2048];

/*=============================================================================
	Local	Function
=============================================================================*/
#ifndef	DPMI
static	void	LoadDefaultKey(LPENV lpEnv);
static	void	LoadDefaultRom(LPENV lpEnv);
static	WORD	GetKbdType(void);
#endif

/*=============================================================================
	LoadStyFile
=============================================================================*/
int	WINAPI	LoadStyFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPTSTR		k1,k2;
	LPENVMOD	mod;
	LPENVFIX	fix;
	LPENVCMP	cmp;
	LPENVCAN	can;
	LPENVCLR	clr;
#ifndef	DPMI
	LPENVFNT	fnt;
	LPENVBTN	btn;
#endif
	LPENVKBD	kbd;
	LPENVROM	rom;
	LPENVDCI	dci;
	LPENVDIC	dic;
#ifndef	DPMI
	LPENVACI	aci;
	LPENVACC	acc;
	LPENVWII	wii;
	LPENVWIN	win;
#if !PCUNIX
	LPENVSET	set;
#endif /* !PCUNIX */
	int		k;
#endif
#ifdef	DPMI
	LPENVDOS	dos;
#endif
	LPTSTR		lptOut;
	TCHAR		szt1[MAX_PATH + 1];
	int		i,j;

	InLog(__FILE__ "/LoadStyFile");
	k1	= lptFile;
	/*---------------------------------------------------------------------
		mod	Section
	---------------------------------------------------------------------*/
	k2		= sztMod;
	mod		= &lpEnv->mod;
	mod->wRoman	= GPSel(k1,k2,TEXT("Roman"    ),YES ,sztNoYes	 );
	mod->wMojiType	= GPSel(k1,k2,TEXT("MojiType" ),HIRA,sztMojiType );
	mod->wMojiSize	= GPSel(k1,k2,TEXT("MojiSize" ),ZEN ,sztMojiSize );
	mod->wOkuriKana	= GPSel(k1,k2,TEXT("OkuriKana"),ALL ,sztOkuriKana);
#if PCUNIX
	mod->wCode	= GPSel(k1,k2,TEXT("Code"     ),EUC ,sztCode     );
#else /* PCUNIX */
	mod->wCode	= GPSel(k1,k2,TEXT("Code"     ),SJIS,sztCode     );
#endif /* PCUNIX */
	mod->wHenkan	= GPSel(k1,k2,TEXT("Henkan"   ),SAKI,sztHenkan   );
	mod->wBunpou	= GPSel(k1,k2,TEXT("Bunpou"   ),BUN ,sztBunpou   );
	mod->wKougoConv	= GPSel(k1,k2,TEXT("KougoConv"),NO  ,sztNoYes    );
	mod->wKutouConv	= GPSel(k1,k2,TEXT("KutouConv"),YES ,sztNoYes    );
	mod->wCalc	= GPSel(k1,k2,TEXT("Calc"     ),NO  ,sztNoYes    );
	mod->wHosei	= GPSel(k1,k2,TEXT("Hosei"    ),YES ,sztNoYes    );
	mod->wYuragi	= GPSel(k1,k2,TEXT("Yuragi"   ),NO  ,sztNoYes    );
#if !PCUNIX
	mod->wKutenMode	= GPSel(k1,k2,TEXT("KutenMode"),YES ,sztNoYes    );
#endif /* !PCUNIX */
#if	VERSION == 25
	mod->wJisOnly	= GPSel(k1,k2,TEXT("JisOnly"  ),NO  ,sztNoYes    );
#if !PCUNIX
	mod->wKanaCtrl	= GPSel(k1,k2,TEXT("KanaCtrl" ),YES ,sztNoYes    );
#endif /* !PCUNIX */
#endif
	/*---------------------------------------------------------------------
		fix	Section
	---------------------------------------------------------------------*/
	k2		= sztFix;
	fix		= &lpEnv->fix;
	fix->wEisuFix	= GPSel(k1,k2,TEXT("EisuFix"),AUTO,sztKigoSize);
	fix->wKanaFix	= GPSel(k1,k2,TEXT("KanaFix"),AUTO,sztKigoSize);
	lptOut		= GPStr(k1,k2,TEXT("KigoFix"),sztNull);
	for	( i = 0 ; lptOut[i] && i < KIGOS ; i++ ) {
		switch	(lptOut[i]) {
		case	TEXT('Z'):	case	TEXT('z'):
			fix->wKigoFix[i]	= ZEN;
			break;
		case	TEXT('H'):	case	TEXT('h'):
			fix->wKigoFix[i]	= HAN;
			break;
		default:
			fix->wKigoFix[i]	= AUTO;
			break;
		}
	}
	for	( ; i < KIGOS ; i++ ) {
		fix->wKigoFix[i]	= AUTO;
	}
	/*---------------------------------------------------------------------
		cmp	Section
	---------------------------------------------------------------------*/
	k2		= sztCmp;
	cmp		= &lpEnv->cmp;
	cmp->wRank	= GPSel(k1,k2,TEXT("Rank")   ,0  ,sztRank);
	cmp->wKoyu	= GPSel(k1,k2,TEXT("Koyu")   ,NO ,sztNoYes);
	cmp->wMark	= GPSel(k1,k2,TEXT("Mark")   ,YES,sztNoYes);
#if !PCUNIX
	cmp->wSpot	= GPSel(k1,k2,TEXT("Spot")   ,YES,sztNoYes);
#endif /* !PCUNIX */
#ifndef	DPMI
#if !PCUNIX
	cmp->wOwnFont	= GPSel(k1,k2,TEXT("OwnFont"),NO ,sztNoYes);
#endif /* !PCUNIX */
#endif
	/*---------------------------------------------------------------------
		can	Section
	---------------------------------------------------------------------*/
	k2		= sztCan;
	can		= &lpEnv->can;
	can->wStart	= GPInt(k1,k2,TEXT("Start" ) ,2);
#ifndef	DPMI
#if PCUNIX
	can->wMatrix	= GPSel(k1,k2,TEXT("Matrix"),NO,sztNoYesAuto);
	can->wDirection	= GPSel(k1,k2,TEXT("Direction"),YOKO,sztTateYoko);
#else /* PCUNIX */
	can->wMatrix	= GPSel(k1,k2,TEXT("Matrix") ,NO,sztNoYes);
#endif /* PCUNIX */
#if PCUNIX
	if	( can->wMatrix == NO
	||	  can->wMatrix == AUTO ) {
#else /* PCUNIX */
	if	( can->wMatrix == NO ) {
#endif /* PCUNIX */
		can->wDonLen	= 0;
		can->wDonCol	= 1;
		can->wDonRow	= 9;
#if !PCUNIX
		can->wCodeLen	= 0;
		can->wCodeCol	= 1;
		can->wCodeRow	= 9;
#endif /* !PCUNIX */
	}
	else	{
#if PCUNIX
		can->wDonLen	= GPInt(k1,k2,TEXT("DonLen" ),8);
#else /* PCUNIX */
		can->wDonLen	= GPInt(k1,k2,TEXT("DonLen" ),8 * DBCS_SIZE);
#endif /* PCUNIX */
		can->wDonCol	= GPInt(k1,k2,TEXT("DonCol" ),4);
		can->wDonRow	= GPInt(k1,k2,TEXT("DonRow" ),9);
#if !PCUNIX
#if PCUNIX
		can->wCodeLen	= GPInt(k1,k2,TEXT("CodeLen"),1);
#else /* PCUNIX */
		can->wCodeLen	= GPInt(k1,k2,TEXT("CodeLen"),1 * DBCS_SIZE);
#endif /* PCUNIX */
		can->wCodeCol	= GPInt(k2,k2,TEXT("CodeCol"),8);
		can->wCodeRow	= GPInt(k2,k2,TEXT("CodeRow"),9);
#endif /* !PCUNIX */
	}
#endif
	/*---------------------------------------------------------------------
		clr	Section
	---------------------------------------------------------------------*/
	k2		= sztClr;
	clr		= &lpEnv->clr;
	lstrcpy(clr->sztClrFile,GPStr(k1,k2,TEXT("ClrFile"),sztDefClr));
	/*---------------------------------------------------------------------
		Fnt	Section
	---------------------------------------------------------------------*/
#if !PCUNIX
#ifndef	DPMI
	for	( i = 0 ; i < FONTS ; i++ ) {
		fnt	= &lpEnv->fnt[i];
		GetLogFont(NULL,&fnt->lf);
		k2	= sztFnt[i];
		lptOut	= GPStr(k1,k2,TEXT("FontFace"),TEXT("SYSTEM"));
		lstrcpy(fnt->lf.lfFaceName,lptOut);
		j		= GPInt(k1,k2,TEXT("FontSize"),12);
		fnt->lf.lfHeight= -j;
	//	fnt->lf.lfHeight= PointToHeight(j);
		fnt->lf.lfWidth	= 0;
		j		= GPInt(k1,k2,TEXT("FontModify"),0);
		fnt->lf.lfWeight= (j & 1) ? FW_BOLD : FW_NORMAL;
		fnt->lf.lfItalic= (j & 2) ? 1       : 0        ;
	}
#endif
#else /* !PCUNIX */
	for	( i = 0 ; i < FONTS ; i++ ) {
		fnt	= &lpEnv->fnt[i];
		k2	= sztFnt[i];
		if (i < FONTS-1) {
			fnt->lf.wFontType	=
				GPSel(k1,k2,TEXT("FontType"),APP,sztFixApp);
		} else {
			fnt->lf.wFontType	=
				GPSel(k1,k2,TEXT("FontType"),FIX,sztFixApp);
		}
		lptOut	= GPStr(k1,k2,TEXT("KanaName"),TEXT(KANA14));
		lstrcpy(fnt->lf.sztKanaName,lptOut);
		lptOut	= GPStr(k1,k2,TEXT("KanjiName"),TEXT(KANJI14));
		lstrcpy(fnt->lf.sztKanjiName,lptOut);
	}
#endif /* !PCUNIX */
	/*---------------------------------------------------------------------
		Btn	Section
	---------------------------------------------------------------------*/
#ifndef	DPMI
	k2		= sztBtn;
	btn		= &lpEnv->btn;
#if !PCUNIX
	i		= GPSel(k1,k2,TEXT("BtnType" ),2,sztBtnName);
	btn->wBtnType	= wBtnRID[i];
	btn->wBtnSize	= GPInt(k1,k2,TEXT("BtnSize" ),24);
#else /* !PCUNIX */
	i		= GPSel(k1,k2,TEXT("BtnType" ),3,sztBtnName);
	btn->wBtnType	= wBtnRID[i];
	btn->wBtnSize	= GPInt(k1,k2,TEXT("BtnSize" ),16);
#endif /* !PCUNIX */
	btn->wPopHelp	= GPSel(k1,k2,TEXT("PopHelp" ),YES,sztNoYes);
	lptOut		= GPStr(k1,k2,TEXT("BtnFunc" ),sztNull);
	i		= 0;
	if	( *lptOut ) {
		while	( (i      < MAX_BTNTOP			)
		&&	  (lptOut = lstrtok(lptOut,TEXT(' '))	) ) {
			k	= GetStrKey(GS_FKTAG,lptOut,0);
			if	( 1 /* does k have a btn bitmap ? */ ) {
				btn->wBtnFunc[i++]	= k;
			}
		}
	}
	btn->wBtnCount	= i;
#endif
	/*---------------------------------------------------------------------
		Kbd	Section
	---------------------------------------------------------------------*/
	k2		= sztKbd;
	kbd		= &lpEnv->kbd;
	kbd->wKbdType	= GPSel(k1,k2,TEXT("KbdType" ),0   ,sztKbdType );
#ifndef	DPMI
#if !PCUNIX
	i		= GPSel(k1,k2,TEXT("KbdTypeV"),0   ,sztKbdTypeV);
	kbd->wKbdTypeV	= ( i == 0 ) ? kbd->wKbdType : KBD_PAD1H;
	kbd->wRotArrow	= GPSel(k1,k2,TEXT("RotArrow"),YES ,sztNoYes);
#endif /* !PCUNIX */
#endif
	kbd->wComma	= GPSel(k1,k2,TEXT("Comma"   ),AUTO,sztCommaEtc);
	kbd->wPeriod	= GPSel(k1,k2,TEXT("Period"  ),AUTO,sztCommaEtc);
	kbd->wSlash	= GPSel(k1,k2,TEXT("Slash"   ),AUTO,sztCommaEtc);
	kbd->wHyphen	= GPSel(k1,k2,TEXT("Hyphen"  ),AUTO,sztCommaEtc);
	kbd->wBracket	= GPSel(k1,k2,TEXT("Bracket" ),YES ,sztNoYes);
	kbd->wTen	= GPSel(k1,k2,TEXT("Ten"     ),NO  ,sztNoYes);
	kbd->wMaru	= GPSel(k1,k2,TEXT("Maru"    ),NO  ,sztNoYes);
	lstrcpy(kbd->sztKeyFile,GPStr(k1,k2,TEXT("KeyFile" ),sztDefKey));
	lstrcpy(kbd->sztAchFile,GPStr(k1,k2,TEXT("AchFile" ),sztDefAch));
	lstrcpy(kbd->sztKchFile,GPStr(k1,k2,TEXT("KchFile" ),sztDefKch));
	/*---------------------------------------------------------------------
		ROM	Section
	---------------------------------------------------------------------*/
	k2		= sztRom;
	rom		= &lpEnv->rom;
	lstrcpy(rom->sztRomFile,GPStr(k1,k2,TEXT("RomFile" ),sztDefRom));
	/*---------------------------------------------------------------------
		DCI	Section
	---------------------------------------------------------------------*/
	k2		= sztDci;
	dci		= &lpEnv->dci;
	dci->wDicCount	= MAX_DIC;
	dci->wLearnDic	= MAX_DIC - 1;
	dci->wKanaGaku	= GPSel(k1,k2,TEXT("KanaGaku"),YES,sztNoYes);
	dci->wEisuGaku	= GPSel(k1,k2,TEXT("EisuGaku"),YES,sztNoYes);
#if PCUNIX
	lstrcpy(dci->sztDicDat,GPStr(k1,k2,TEXT("DicDat"),sztDefDat));
#endif
	/*---------------------------------------------------------------------
		DIC	Section
	---------------------------------------------------------------------*/
	for	( i = j = 0 ; i < MAX_DIC ; i++ ) {
		lstrcpy(szt1,TEXT("DIC"));
		lstrcat(szt1,litos(i + 1,10));
		dic		= &lpEnv->dic[i];
		lptOut		= GPStr(k1,szt1,TEXT("DicFile"),sztNull);
		lstrcpy(dic->sztDicFile,lptOut);
		if	( *lptOut ) {
			j++;
		}
		dic->wLearnMode	= GPSel(k1,szt1,TEXT("LearnMode"),
					YES,sztLearnMode		);
		dic->wLearnType	= GPSel(k1,szt1,TEXT("LearnType"),
					LEARNDIC,sztLearnType		);
		dic->wParallel	= GPSel(k1,szt1,TEXT("Parallel" ),
					YES,sztNoYes			);
	}
	/*---------------------------------------------------------------------
		ACI	Section
	---------------------------------------------------------------------*/
#ifndef	DPMI
	aci		= &lpEnv->aci;
	k2		= sztAci;
	aci->wAccCount	= GPInt(k1,k2,TEXT("AccCount"),0);
	aci->wAccCount	= min(aci->wAccCount,MAX_ACC);
#endif
	/*---------------------------------------------------------------------
		ACC	Section
	---------------------------------------------------------------------*/
#ifndef	DPMI
#if !PCUNIX
	for	( i = 0 ; i < aci->wAccCount ; i++ ) {
		lstrcpy(szt1,TEXT("ACC"));
		lstrcat(szt1,litos(i + 1,10));
		acc		= &lpEnv->acc[i];
		lptOut		= GPStr(k1,szt1,TEXT("AccFile"),sztNull);
		lstrcpy(acc->sztAccFile,lptOut);
	}
#else /* !PCUNIX */
	for	( i = 0 ; i < aci->wAccCount ; i++ ) {
		lstrcpy (szt1,TEXT("ACC"));
		lstrcat (szt1,litos(i + 1,10));
		acc		= &lpEnv->acc[i];
		lptOut		= GPStr (k1,szt1,TEXT("AccFile"), sztNull);
		lstrcpy (acc->sztAccFile, lptOut);
		lptOut		= GPStr (k1,szt1,TEXT("AccShortMsg"), sztNull);
		lstrcpy (acc->sztAccShort, lptOut);
		lstrcpy (acc->sztAccLong, lptOut);
	}
#endif /* !PCUNIX */
#endif
	/*---------------------------------------------------------------------
		WII	Section
	---------------------------------------------------------------------*/
#ifndef	DPMI
	k2		= sztWii;
	wii		= &lpEnv->wii;
#if !PCUNIX
	wii->wScreenW	= GPInt(k1,k2,TEXT("ScreenW" ),640);
	wii->wScreenH	= GPInt(k1,k2,TEXT("ScreenH" ),480);
#endif /* !PCUNIX */
#if !PCUNIX
	wii->wWinCount	= GPInt(k1,k2,TEXT("WinCount"),1  );
	wii->wWinCount	= min(wii->wWinCount,MAX_PARTS);
#else /* !PCUNIX */
	wii->wWinCount	= 1;
#endif /* !PCUNIX */
	wii->wMinimize	= GPSel(k1,k2,TEXT("Minimize"),NO,sztNoYes);
	wii->wOffHide	= GPSel(k1,k2,TEXT("OffHide" ),NO,sztOffHide);
#endif
	/*---------------------------------------------------------------------
		WIN	Section
	---------------------------------------------------------------------*/
#ifndef	DPMI
	for	( i = 0 ; i < wii->wWinCount ; i++ ) {
		lstrcpy(szt1,TEXT("WIN"));
		lstrcat(szt1,litos(i + 1,10));
		win		= &lpEnv->win[i];
#if !PCUNIX
		win->rc.left	= GPInt(k1,szt1,TEXT("left"  ),0);
		win->rc.top	= GPInt(k1,szt1,TEXT("top"   ),0);
		win->rc.right	= GPInt(k1,szt1,TEXT("right" ),0);
		win->rc.bottom	= GPInt(k1,szt1,TEXT("bottom"),0);
#else /* !PCUNIX */
		win->rStatus.x	= GPInt(k1,szt1,TEXT("StatusX"),0);
		win->rStatus.y	= GPInt(k1,szt1,TEXT("StatusY"),0);
		win->rStatus.w	= GPInt(k1,szt1,TEXT("StatusW"),0);
		win->rStatus.h	= GPInt(k1,szt1,TEXT("StatusH"),0);
		win->rPreeditRoot.x= GPInt(k1,szt1,TEXT("PreeditRootX"),0);
		win->rPreeditRoot.y= GPInt(k1,szt1,TEXT("PreeditRootY"),0);
		win->rPreeditRoot.w= GPInt(k1,szt1,TEXT("PreeditRootW"),0);
		win->rPreeditRoot.h= GPInt(k1,szt1,TEXT("PreeditRootH"),0);
#endif /* !PCUNIX */
#if !PCUNIX
#if	VERSION == 25
		j		= GPSel(k1,szt1,TEXT("locate"),0,sztLocate);
		win->wLocate	= wLocateTBL[j];
#if	USE_APPBAR
		j		= GPSel(k1,szt1,TEXT("edge"),0,sztEdge);
		win->wEdge	= wEdgeTBL[j];
#endif
#endif
		lptOut		= GPStr(k1,szt1,TEXT("Parts" ),TEXT("1"));
		j		= 0;
		while	( (j      < MAX_PARTS			)
		&&	  (lptOut = lstrtok(lptOut,TEXT(' '))	) ) {
			k	= latoi(lptOut);
			if	( PARTS_UNKNOWN < k && k < MAX_PARTS ) {
				win->wParts[j++]	= k;
			}
		}
		win->wPartsCount= j;
#endif /* !PCUNIX */
	}
#endif
	/*---------------------------------------------------------------------
		Set	Section
	---------------------------------------------------------------------*/
#ifndef	DPMI
#if !PCUNIX /* Add:SetFile */
	set		= &lpEnv->set;
	lstrcpy(set->sztSetFile,sztDefSet);
#else /* !PCUNIX */
#if !PCUNIX
	k2		= sztSet;
	set		= &lpEnv->set;
	lstrcpy(set->sztSetFile,GPStr(k1,k2,TEXT("SetFile"),sztDefSet));
#endif /* !PCUNIX */
#endif /* !PCUNIX */
#endif
	/*---------------------------------------------------------------------
		Dos	Section
	---------------------------------------------------------------------*/
#ifdef	DPMI
	k2		= sztDos;
	dos		= &lpEnv->dos;
	dos->wOldVje	= GPSel(k1,k2,TEXT("OldVje")    ,NO ,sztNoYes);
	dos->wAXMode	= GPSel(k1,k2,TEXT("AXMode")    ,NO ,sztNoYes);
	dos->wRedrawSpot= GPSel(k1,k2,TEXT("RedrawSpot"),YES,sztNoYes);
	dos->wIAEHandles= GPInt(k1,k2,TEXT("IAEHandles"),5           );
#endif
	OutLog(__FILE__ "/LoadStyFile");
	return	TRUE;
}

/*=============================================================================
	LoadClrFile
=============================================================================*/
int	WINAPI	LoadClrFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
#if !PCUNIX
#define	AT_Y		(AT_YELLOW           |AT_HIGH)
#define	AT_YR		(AT_YELLOW|AT_REVERSE|AT_HIGH)
#define	AT_C		(AT_CYAN             |AT_HIGH)
#define	AT_CR		(AT_CYAN  |AT_REVERSE|AT_HIGH)
#define	AT_G		(AT_GREEN            |AT_HIGH)
#define	AT_GR		(AT_GREEN |AT_REVERSE|AT_HIGH)
#endif /* !PCUNIX */
	LPTSTR		k1;
	LPTSTR		k2;
	LPENVCLR	clr;

	InLog(__FILE__ "/LoadClrFile");
	k1			= lptFile;
	k2			= sztClr;
	clr			= &lpEnv->clr;
#ifndef	DPMI
	clr->wColChar		= GPHex(k1,k2,TEXT("ColChar")       ,0x2d1c);
	clr->wColCursor		= GPHex(k1,k2,TEXT("ColCursor")     ,0x1c2f);
	clr->wColConv		= GPHex(k1,k2,TEXT("ColConv")       ,0x1c11);
	clr->wColConvCur	= GPHex(k1,k2,TEXT("ColConvCur")    ,0x2811);
	clr->wColConvTemp	= GPHex(k1,k2,TEXT("ColConvTemp")   ,0x280c);
	clr->wColEdit		= GPHex(k1,k2,TEXT("ColEdit")       ,0x2d1c);
	clr->wColList		= GPHex(k1,k2,TEXT("ColList")       ,0x2f28);
	clr->wColListCur	= GPHex(k1,k2,TEXT("ColListCur")    ,0x2d28);
	clr->wColPopHelp	= GPHex(k1,k2,TEXT("ColPopHelp")    ,0x0928);
	clr->wColBtn		= GPHex(k1,k2,TEXT("ColBtn")        ,0x2d28);
	clr->wColKbd		= GPHex(k1,k2,TEXT("ColKbd")        ,0x2d28);
	clr->wColFnc		= GPHex(k1,k2,TEXT("ColFnc")        ,0x2d28);
#if !PCUNIX
	clr->wColBox		= GPHex(k1,k2,TEXT("ColBox")        ,0x2f28);
#endif /* !PCUNIX */
#endif
#if !PCUNIX
	clr->wColCharDOS	= GPClr(k1,k2,TEXT("ColCharDOS")    ,AT_Y );
	clr->wColCursorDOS	= GPClr(k1,k2,TEXT("ColCursorDOS")  ,AT_YR);
	clr->wColConvDOS	= GPClr(k1,k2,TEXT("ColConvDOS")    ,AT_C );
	clr->wColConvCurDOS	= GPClr(k1,k2,TEXT("ColConvCurDOS") ,AT_CR);
	clr->wColConvTempDOS	= GPClr(k1,k2,TEXT("ColConvTempDOS"),AT_C );
	clr->wColEditDOS	= GPClr(k1,k2,TEXT("ColEditDOS")    ,AT_Y );
	clr->wColModeDOS	= GPClr(k1,k2,TEXT("ColModeDOS")    ,AT_C );
	clr->wColDModeDOS	= GPClr(k1,k2,TEXT("ColDModeDOS")   ,AT_CR);
	clr->wColGuidDOS	= GPClr(k1,k2,TEXT("ColGuidDOS")    ,AT_GR);
#endif /* !PCUNIX */
	OutLog(__FILE__ "/LoadClrFile");
	return	TRUE;
}

#if !PCUNIX
/*=============================================================================
	LoadKeyFile
=============================================================================*/
#if	!USE_FETCH
int	WINAPI	LoadKeyFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPTSTR		k1,k2;
	LPENVKBD	kbd;
	TCHAR		szt1[32];
	LPTSTR		lptOut1,lptOut2;
	int		i,j,k,l,m;

	InLog(__FILE__ "/LoadKeyFile");
	k1	= lptFile;
	k2	= TEXT("Key");
	kbd	= &lpEnv->kbd;
	for	( i = 0 ; i < MAX_VK    ; i++ )
	for	( j = 0 ; j < MAX_FCASE ; j++ )
	for	( k = 0 ; k < MAX_STAGE ; k++ ) {
		kbd->wVirtTable[i][j][k]	= F_FKEY;
	}
	m	= 0;
	for	( i = 0 ; i < MAX_VK ; i++ ) {
		lptOut1	= GetStr(GS_VKTAG,i,0);
		if	( !(lptOut1 && *lptOut1) ) continue;
		for	( j = 0 ; j < MAX_FCASE ; j++ ) {
			lstrcpy(szt1,sztPrefix[j]);
			lstrcat(szt1,lptOut1);
			lptOut2	= GPStr(k1,k2,szt1,sztNull);
			if	( !lptOut2[0] ) continue;
			k	= 0;
			while	( (k       < MAX_STAGE			)
			&&	  (lptOut2 = lstrtok(lptOut2,TEXT(' ')) ) ) {
				l	= GetStrKey(GS_FKTAG,lptOut2,0);
				kbd->wVirtTable[i][j][k++]	= l;
				if	( l != F_FKEY )	m++;
			}
		}
	}
#ifndef	DPMI
	if	( m == 0 ) {	/* may be file not found */
		LoadDefaultKey(lpEnv);
	}
#endif
	OutLog(__FILE__ "/LoadKeyFile");
	return	TRUE;
}
#endif
#endif /* !PCUNIX */

/*=============================================================================
	LoadKeyFile	(Fetch Version)
=============================================================================*/
#if	USE_FETCH
int	WINAPI	LoadKeyFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPTSTR		k1,k2;
	LPENVKBD	kbd;
	LPTSTR		lptOut1,lptOut2;
	LPVOID		lpVoid;
	TCHAR		sztTitle[64];
	TCHAR		sztValue[192];
	int		i,j,k,l,m;

	InLog(__FILE__ "/LoadKeyFile");
	k1	= lptFile;
	k2	= TEXT("Key");
	kbd	= &lpEnv->kbd;
	for	( i = 0 ; i < MAX_VK    ; i++ )
	for	( j = 0 ; j < MAX_FCASE ; j++ )
	for	( k = 0 ; k < MAX_STAGE ; k++ ) {
		kbd->wVirtTable[i][j][k]	= F_FKEY;
	}
	m	= 0;
	lpVoid	= BeginFetchPP(k2,k1);
	lpVoid	= FetchPPString(lpVoid,sztTitle,63,sztValue,191);
	while	( lpVoid ) {
		j	= 0;
		lptOut1	= sztTitle;
#if !PCUNIX
		if	( *lptOut1 == TEXT('^') ) {
			j	+= 2;
			lptOut1	+= 1;
		}
		if	( *lptOut1 == TEXT('@') ) {
			j	+= 1;
			lptOut1	+= 1;
		}
#else /* !PCUNIX */
		for (j=MAX_FCASE-1; j >= 1; j--) {
			if (0 == lstrncmp (lptOut1,
					   sztPrefix[j],
					   lstrlen (sztPrefix[j]))) {
				lptOut1	+= lstrlen (sztPrefix[j]);
				break;
			}
		}
#endif /* !PCUNIX */
		i	= GetStrKey(GS_VKTAG,lptOut1,0);
		if	( i ) {
			lptOut2	= sztValue;
			k	= 0;
			while	( (k       < MAX_STAGE			)
			&&	  (lptOut2 = lstrtok(lptOut2,TEXT(' ')) ) ) {
				l	= GetStrKey(GS_FKTAG,lptOut2,0);
				kbd->wVirtTable[i][j][k++]	= l;
				if	( l != F_FKEY )	m++;
			}
		}
		lpVoid	= FetchPPString(lpVoid,sztTitle,63,sztValue,191);
	}
#ifndef	DPMI
	if	( m == 0 ) {	/* may be file not found */
		LoadDefaultKey(lpEnv);
	}
#endif
	OutLog(__FILE__ "/LoadKeyFile");
	return	TRUE;
}
#endif

/*=============================================================================
	LoadRomFile
=============================================================================*/
#ifndef	DPMI
int	WINAPI	LoadRomFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPENVROM	rom;
	HANDLE		hFile;
	DWORD		dwT;
	int		i;

	InLog(__FILE__ "/LoadRomFile");
	rom		= &lpEnv->rom;
	rom->wRomCount	= 0;
#if !PCUNIX
	hFile		= CreateFile(
				lptFile,
				GENERIC_READ,
				FILE_SHARE_READ,
				(LPSECURITY_ATTRIBUTES) NULL,
				OPEN_EXISTING,
				FILE_FLAG_SEQUENTIAL_SCAN|
				FILE_ATTRIBUTE_NORMAL,
				(HANDLE) NULL
			);
#else /* !PCUNIX */
	hFile		= CreateFile (lptFile, O_RDONLY, 0);
#endif /* !PCUNIX */
	if	( hFile	!= INVALID_HANDLE_VALUE ) {
#if !PCUNIX
		ReadFile(hFile,rom->sztImage,MAX_ROMA_SIZE,&dwT,NULL);
#else /* !PCUNIX */
		dwT = MAX_ROMA_SIZE;
		ReadFile (hFile, rom->sztImage, &dwT);
#endif /* !PCUNIX */
		rom->wRomCount	= (WORD) dwT;
		if	( rom->wRomCount == MAX_ROMA_SIZE ) {
			i	= rom->wRomCount - 1;
			while	( rom->sztImage[i] != TEXT('\n') ) {
				i--;
			}
			rom->wRomCount	= i + 1;
		}
		CloseHandle(hFile);
	}
	rom->sztImage[rom->wRomCount]	= (TCHAR) 0;
	if	( !rom->wRomCount ) {
		LoadDefaultRom(lpEnv);
	}
	OutLog(__FILE__ "/LoadRomFile");
	return	TRUE;
}
#endif

/*=============================================================================
	LoadAchFile
=============================================================================*/
int	WINAPI	LoadAchFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPTSTR		k1,k2;
	LPENVKBD	kbd;
	TCHAR		szt1[32];
	LPTSTR		lptOut1,lptOut2;
	int		i,j;

	InLog(__FILE__ "/LoadAchFile");
	k1	= lptFile;
	k2	= TEXT("Ach");
	kbd	= &lpEnv->kbd;
	for	( i = 0 ; i < MAX_VK    ; i++ )
	for	( j = 0 ; j < MAX_CCASE ; j++ ) {
		kbd->sztATable[i][j][0]	= (TCHAR) 0;
	}
	for	( i = 0 ; i < MAX_VK ; i++ ) {
		if	( !IsCharVirt((WORD) i) ) continue;
		lptOut1	= GetStr(GS_VKTAG,i,0);
		if	( !(lptOut1 && *lptOut1) ) continue;
		for	( j = 0 ; j < MAX_CCASE ; j++ ) {
			lstrcpy(szt1,sztPrefix[j]);
			lstrcat(szt1,lptOut1);
			lptOut2	= GPStr(k1,k2,szt1,sztNull);
			lstrncpy(kbd->sztATable[i][j],lptOut2,MAX_SHORT_STR);
		}
	}
	OutLog(__FILE__ "/LoadAchFile");
	return	TRUE;
}

/*=============================================================================
	LoadKchFile
=============================================================================*/
int	WINAPI	LoadKchFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPTSTR		k1,k2;
	LPENVKBD	kbd;
	TCHAR		szt1[32];
	LPTSTR		lptOut1,lptOut2;
	int		i,j;

	InLog(__FILE__ "/LoadKchFile");
	k1	= lptFile;
	k2	= TEXT("Kch");
	kbd	= &lpEnv->kbd;
	for	( i = 0 ; i < MAX_VK    ; i++ )
	for	( j = 0 ; j < MAX_CCASE ; j++ ) {
		kbd->sztKTable[i][j][0]	= (TCHAR) 0;
	}
	for	( i = 0 ; i < MAX_VK ; i++ ) {
		if	( !IsCharVirt((WORD) i) ) continue;
		lptOut1	= GetStr(GS_VKTAG,i,0);
		if	( !(lptOut1 && *lptOut1) ) continue;
		for	( j = 0 ; j < MAX_CCASE ; j++ ) {
			lstrcpy(szt1,sztPrefix[j]);
			lstrcat(szt1,lptOut1);
			lptOut2	= GPStr(k1,k2,szt1,sztNull);
			lstrncpy(kbd->sztKTable[i][j],lptOut2,MAX_SHORT_STR);
		}
	}
	OutLog(__FILE__ "/LoadKchFile");
	return	TRUE;
}

#if !PCUNIX
/*=============================================================================
	LoadSetFile
=============================================================================*/
#ifndef	DPMI
#if	!USE_FETCH
int	WINAPI	LoadSetFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPTSTR		k1,k2;
	LPENVSET	set;
	TCHAR		sztTag[16];
	LPTSTR		lptOut;
	int		i,j;

	InLog(__FILE__ "/LoadSetFile");
	k1		= lptFile;
	k2		= TEXT("Set");
	set		= &lpEnv->set;
	set->wSetCount	= min(GPInt(k1,k2,TEXT("SetCount"),0),MAX_SET);
	for	( i = 0 ; i < set->wSetCount ; i++ ) {
		for	( j = 0 ; j < MAX_STAGE ; j++ ) {
			set->wFunc[i][j]= F_FKEY;
		}
		*set->sztDesc[i]	= (TCHAR) 0;
		lstrcpy(szt1,TEXT("Set"));
		lstrcat(szt1,litos(i + 1,10));
		lptOut	= GPStr(k1,k2,sztTag,sztNull);
		j	= 0;
		while	( ( lptOut = lstrtok(lptOut,TEXT(' '))	)
		&&	  ( j      < MAX_STAGE			) ) {
			set->wFunc[i][j++]	= GetStrKey(GS_FKTAG,lptOut,0);
		}
		if	( lptOut ) {
			lstrncpy(set->sztDesc[i],lptOut,MAX_LONG_STR);
		}
	}
	OutLog(__FILE__ "/LoadSetFile");
	return	TRUE;
}
#endif
#endif

/*=============================================================================
	LoadSetFile
=============================================================================*/
#ifndef	DPMI
#if	USE_FETCH
int	WINAPI	LoadSetFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPTSTR		k1,k2;
	LPENVSET	set;
	LPVOID		lpVoid;
	TCHAR		sztTitle[16];
	TCHAR		sztValue[240];
	LPTSTR		lptOut;
	int		i,j;

	InLog(__FILE__ "/LoadSetFile");
	k1	= lptFile;
	k2	= TEXT("Set");
	set	= &lpEnv->set;
	lpVoid	= BeginFetchPP(k2,k1);
	lpVoid	= FetchPPString(lpVoid,sztTitle,15,sztValue,239);
	for	( i = 0 ; i < MAX_SET && lpVoid ; i++ ) {
#if !PCUNIX
		if	( !lstrcmpi(sztTitle,TEXT("SetCount")) ) {
#else /* !PCUNIX */
		if	( !lstrcmp(sztTitle,TEXT("SetCount")) ) {
#endif /* !PCUNIX */
			i--;
		}
		else	{
			for	( j = 0 ; j < MAX_STAGE ; j++ ) {
				set->wFunc[i][j]= F_FKEY;
			}
			*set->sztDesc[i]	= (TCHAR) 0;
			lptOut	= sztValue;
			j	= 0;
			while	( ( lptOut = lstrtok(lptOut,TEXT(' '))	)
			&&	  ( j      < MAX_STAGE			) ) {
				set->wFunc[i][j]= GetStrKey(GS_FKTAG,lptOut,0);
				j		= j + 1;
			}
			if	( lptOut ) {
				lstrncpy(set->sztDesc[i],lptOut,MAX_LONG_STR);
			}
		}
		lpVoid	= FetchPPString(lpVoid,sztTitle,15,sztValue,239);
	}
	set->wSetCount	= i;
	OutLog(__FILE__ "/LoadSetFile");
	return	TRUE;
}
#endif
#endif
#endif /* !PCUNIX */

/*=============================================================================
	SaveStyFile
=============================================================================*/
int	WINAPI	SaveStyFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPTSTR		k1,k2;
	LPENVMOD	mod;
	LPENVFIX	fix;
	LPENVCMP	cmp;
	LPENVCAN	can;
	LPENVCLR	clr;
#ifndef	DPMI
	LPENVFNT	fnt;
	LPENVBTN	btn;
#endif
	LPENVKBD	kbd;
	LPENVROM	rom;
	LPENVDCI	dci;
	LPENVDIC	dic;
#ifndef	DPMI
	LPENVACI	aci;
	LPENVACC	acc;
	LPENVWII	wii;
	LPENVWIN	win;
#if PCUNIX /* Add:SetFile */
#if !PCUNIX
	LPENVSET	set;
#endif /* !PCUNIX */
#endif /* PCUNIX */
	int		j;
#endif
#ifdef	DPMI
	LPENVDOS	dos;
#endif
	TCHAR		szt1[MAX_PATH + 1];
	int		i;

	InLog(__FILE__ "/SaveStyFile");
	k1	= lptFile;
	/*---------------------------------------------------------------------
		mod	Section
	---------------------------------------------------------------------*/
	k2		= sztMod;
	mod		= &lpEnv->mod;
	WPSel(k1,k2,TEXT("Roman"    ),mod->wRoman    ,sztNoYes	  );
	WPSel(k1,k2,TEXT("MojiType" ),mod->wMojiType ,sztMojiType );
	WPSel(k1,k2,TEXT("MojiSize" ),mod->wMojiSize ,sztMojiSize );
	WPSel(k1,k2,TEXT("OkuriKana"),mod->wOkuriKana,sztOkuriKana);
	WPSel(k1,k2,TEXT("Code"     ),mod->wCode     ,sztCode     );
	WPSel(k1,k2,TEXT("Henkan"   ),mod->wHenkan   ,sztHenkan   );
	WPSel(k1,k2,TEXT("Bunpou"   ),mod->wBunpou   ,sztBunpou   );
	WPSel(k1,k2,TEXT("KougoConv"),mod->wKougoConv,sztNoYes    );
	WPSel(k1,k2,TEXT("KutouConv"),mod->wKutouConv,sztNoYes    );
	WPSel(k1,k2,TEXT("Calc"     ),mod->wCalc     ,sztNoYes    );
	WPSel(k1,k2,TEXT("Hosei"    ),mod->wHosei    ,sztNoYes    );
	WPSel(k1,k2,TEXT("Yuragi"   ),mod->wYuragi   ,sztNoYes    );
#if !PCUNIX
	WPSel(k1,k2,TEXT("KutenMode"),mod->wKutenMode,sztNoYes    );
#endif /* !PCUNIX */
#if	VERSION == 25
	WPSel(k1,k2,TEXT("JisOnly"  ),mod->wJisOnly  ,sztNoYes    );
#if !PCUNIX
	WPSel(k1,k2,TEXT("KanaCtrl" ),mod->wKanaCtrl ,sztNoYes    );
#endif /* !PCUNIX */
#endif
	/*---------------------------------------------------------------------
		fix	Section
	---------------------------------------------------------------------*/
	k2		= sztFix;
	fix		= &lpEnv->fix;
	WPSel(k1,k2,TEXT("EisuFix"),fix->wEisuFix,sztKigoSize);
	WPSel(k1,k2,TEXT("KanaFix"),fix->wKanaFix,sztKigoSize);
	for	( i = 0 ; i < KIGOS ; i++ ) {
		switch	( fix->wKigoFix[i] ) {
		case	ZEN:
			sztBuff[i]	= TEXT('Z');
			break;
		case	HAN:
			sztBuff[i]	= TEXT('H');
			break;
		default:
			sztBuff[i]	= TEXT('A');
			break;
		}
	}
	sztBuff[KIGOS]	= (TCHAR) 0;
	WPStr(k1,k2,TEXT("KigoFix"),sztBuff);
	/*---------------------------------------------------------------------
		cmp	Section
	---------------------------------------------------------------------*/
	k2		= sztCmp;
	cmp		= &lpEnv->cmp;
	WPSel(k1,k2,TEXT("Rank")   ,cmp->wRank   ,sztRank);
	WPSel(k1,k2,TEXT("Koyu")   ,cmp->wKoyu   ,sztNoYes);
	WPSel(k1,k2,TEXT("Mark")   ,cmp->wMark   ,sztNoYes);
#if !PCUNIX
	WPSel(k1,k2,TEXT("Spot")   ,cmp->wSpot   ,sztNoYes);
#endif /* !PCUNIX */
#ifndef	DPMI
#if !PCUNIX
	WPSel(k1,k2,TEXT("OwnFont"),cmp->wOwnFont,sztNoYes);
#endif /* !PCUNIX */
#endif
	/*---------------------------------------------------------------------
		can	Section
	---------------------------------------------------------------------*/
	k2		= sztCan;
	can		= &lpEnv->can;
	WPInt(k1,k2,TEXT("Start" ),can->wStart);
#ifndef	DPMI
#if PCUNIX
	WPSel(k1,k2,TEXT("Matrix"),can->wMatrix,sztNoYesAuto);
	WPSel(k1,k2,TEXT("Direction"),can->wDirection,sztTateYoko);
#else /* PCUNIX */
	WPSel(k1,k2,TEXT("Matrix"),can->wMatrix,sztNoYes);
#endif /* PCUNIX */
#if PCUNIX
	if	( can->wMatrix == NO
	||	  can->wMatrix == AUTO ) {
#else /* PCUNIX */
	if	( can->wMatrix == NO ) {
#endif /* PCUNIX */
		WPInt(k1,k2,TEXT("DonLen" ),0);
		WPInt(k1,k2,TEXT("DonCol" ),1);
		WPInt(k1,k2,TEXT("DonRow" ),9);
#if !PCUNIX
		WPInt(k1,k2,TEXT("CodeLen"),0);
		WPInt(k1,k2,TEXT("CodeCol"),1);
		WPInt(k1,k2,TEXT("CodeRow"),9);
#endif /* !PCUNIX */
	}
	else	{
		WPInt(k1,k2,TEXT("DonLen" ),can->wDonLen);
		WPInt(k1,k2,TEXT("DonCol" ),can->wDonCol );
		WPInt(k1,k2,TEXT("DonRow" ),can->wDonRow );
#if !PCUNIX
		WPInt(k1,k2,TEXT("CodeLen"),can->wCodeLen);
		WPInt(k1,k2,TEXT("CodeCol"),can->wCodeCol);
		WPInt(k1,k2,TEXT("CodeRow"),can->wCodeRow);
#endif /* !PCUNIX */
	}
#endif
	/*---------------------------------------------------------------------
		clr	Section
	---------------------------------------------------------------------*/
	k2		= sztClr;
	clr		= &lpEnv->clr;
	WPStr(k1,k2,TEXT("ClrFile"),clr->sztClrFile);
	/*---------------------------------------------------------------------
		Fnt	Section
	---------------------------------------------------------------------*/
#if !PCUNIX
#ifndef	DPMI
	for	( i = 0 ; i < FONTS ; i++ ) {
		fnt	= &lpEnv->fnt[i];
		k2	= sztFnt[i];
		WPStr(k1,k2,TEXT("FontFace")  ,fnt->lf.lfFaceName);
		j	= abs(fnt->lf.lfHeight);
	//	j	= HeightToPoint(fnt->lf.lfHeight);
		WPInt(k1,k2,TEXT("FontSize")  ,j);
		j	= ((fnt->lf.lfWeight >= FW_BOLD) ? 1 : 0)
			| ((fnt->lf.lfItalic           ) ? 2 : 0);
		WPInt(k1,k2,TEXT("FontModify"),j);
	}
#endif
#else /* !PCUNIX */
	for	( i = 0 ; i < FONTS ; i++ ) {
		fnt	= &lpEnv->fnt[i];
		k2	= sztFnt[i];
		WPSel(k1,k2,TEXT("FontType")  ,fnt->lf.wFontType,sztFixApp);
		WPStr(k1,k2,TEXT("KanaName")  ,fnt->lf.sztKanaName);
		WPStr(k1,k2,TEXT("KanjiName") ,fnt->lf.sztKanjiName);
	}
#endif /* !PCUNIX */
	/*---------------------------------------------------------------------
		Btn	Section
	---------------------------------------------------------------------*/
#ifndef	DPMI
	k2		= sztBtn;
	btn		= &lpEnv->btn;
	for	( i = 0 ; i < recof(wBtnRID) ; i++ ) {
		if	( btn->wBtnType == wBtnRID[i] ) break;
	}
	if	( i == recof(wBtnRID) ) i = 0;
	WPSel(k1,k2,TEXT("BtnType" ),(WORD) i,sztBtnName);
	WPInt(k1,k2,TEXT("BtnSize" ),btn->wBtnSize);
	WPSel(k1,k2,TEXT("PopHelp" ),btn->wPopHelp,sztNoYes);
	sztBuff[0]	= (TCHAR) 0;
	for	( i = 0 ; i < btn->wBtnCount ; i++ ) {
		lstrcat(sztBuff,GetStr(GS_FKTAG,btn->wBtnFunc[i],0));
		lstrcat(sztBuff,TEXT(" ")			   );
	}
	sztBuff[lstrlen(sztBuff)-1]	= (TCHAR) 0;
	WPStr(k1,k2,TEXT("BtnFunc"),sztBuff);
#endif
	/*---------------------------------------------------------------------
		Kbd	Section
	---------------------------------------------------------------------*/
	k2		= sztKbd;
	kbd		= &lpEnv->kbd;
	WPSel(k1,k2,TEXT("KbdType" ),kbd->wKbdType,sztKbdType);
#ifndef	DPMI
#if !PCUNIX
	i		= ( kbd->wKbdTypeV == kbd->wKbdType ) ? 0 : 1;
	WPSel(k1,k2,TEXT("KbdTypeV"),(WORD) i,sztKbdTypeV);
	WPSel(k1,k2,TEXT("RotArrow"),kbd->wRotArrow,sztNoYes);
#endif /* !PCUNIX */
#endif
	WPSel(k1,k2,TEXT("Comma"   ),kbd->wComma   ,sztCommaEtc);
	WPSel(k1,k2,TEXT("Period"  ),kbd->wPeriod  ,sztCommaEtc);
	WPSel(k1,k2,TEXT("Slash"   ),kbd->wSlash   ,sztCommaEtc);
	WPSel(k1,k2,TEXT("Hyphen"  ),kbd->wHyphen  ,sztCommaEtc);
	WPSel(k1,k2,TEXT("Bracket" ),kbd->wBracket ,sztNoYes);
	WPSel(k1,k2,TEXT("Ten"     ),kbd->wTen     ,sztNoYes);
	WPSel(k1,k2,TEXT("Maru"    ),kbd->wMaru    ,sztNoYes);
	WPStr(k1,k2,TEXT("KeyFile") ,kbd->sztKeyFile);
	WPStr(k1,k2,TEXT("AchFile") ,kbd->sztAchFile);
	WPStr(k1,k2,TEXT("KchFile") ,kbd->sztKchFile);
	/*---------------------------------------------------------------------
		ROM	Section
	---------------------------------------------------------------------*/
	k2		= sztRom;
	rom		= &lpEnv->rom;
	WPStr(k1,k2,TEXT("RomFile") ,rom->sztRomFile);
	/*---------------------------------------------------------------------
		DCI	Section
	---------------------------------------------------------------------*/
	k2		= sztDci;
	dci		= &lpEnv->dci;
	WPSel(k1,k2,TEXT("KanaGaku"),dci->wKanaGaku,sztNoYes);
	WPSel(k1,k2,TEXT("EisuGaku"),dci->wEisuGaku,sztNoYes);
#if PCUNIX
	WPStr(k1,k2,TEXT("DicDat"),dci->sztDicDat);
#endif
	/*---------------------------------------------------------------------
		DIC	Section
	---------------------------------------------------------------------*/
	for	( i = 0 ; i < MAX_DIC ; i++ ) {
		dic		= &lpEnv->dic[i];
		lstrcpy(szt1,TEXT("DIC"));
		lstrcat(szt1,litos(i + 1,10));
		WPStr(k1,szt1,TEXT("DicFile")  ,dic->sztDicFile);
		WPSel(k1,szt1,TEXT("LearnMode"),dic->wLearnMode,sztLearnMode);
		WPSel(k1,szt1,TEXT("LearnType"),dic->wLearnType,sztLearnType);
		WPSel(k1,szt1,TEXT("Parallel") ,dic->wParallel ,sztNoYes    );
	}
	/*---------------------------------------------------------------------
		ACI	Section
	---------------------------------------------------------------------*/
#ifndef	DPMI
	aci		= &lpEnv->aci;
	k2		= sztAci;
	WPInt(k1,k2,TEXT("AccCount"),aci->wAccCount);
#endif
	/*---------------------------------------------------------------------
		ACC	Section
	---------------------------------------------------------------------*/
#ifndef	DPMI
	for	( i = 0 ; i < aci->wAccCount ; i++ ) {
		lstrcpy(szt1,TEXT("ACC"));
		lstrcat(szt1,litos(i + 1,10));
		acc		= &lpEnv->acc[i];
		WPStr(k1,szt1,TEXT("AccFile"),acc->sztAccFile);
		WPStr(k1,szt1,TEXT("AccShortMsg"),acc->sztAccShort);
		WPStr(k1,szt1,TEXT("AccShortMsg"),acc->sztAccLong);
	}
#endif
	/*---------------------------------------------------------------------
		WII	Section
	---------------------------------------------------------------------*/
#ifndef	DPMI
	k2		= sztWii;
	wii		= &lpEnv->wii;
#if !PCUNIX
	WPInt(k1,k2,TEXT("ScreenW" ),wii->wScreenW);
	WPInt(k1,k2,TEXT("ScreenH" ),wii->wScreenH);
#endif /* !PCUNIX */
#if !PCUNIX
	WPInt(k1,k2,TEXT("WinCount"),wii->wWinCount);
#endif /* !PCUNIX */
	WPSel(k1,k2,TEXT("Minimize"),wii->wMinimize,sztNoYes);
	WPSel(k1,k2,TEXT("OffHide" ),wii->wOffHide ,sztOffHide);
#endif
	/*---------------------------------------------------------------------
		WIN	Section
	---------------------------------------------------------------------*/
#ifndef	DPMI
	for	( i = 0 ; i < wii->wWinCount ; i++ ) {
		lstrcpy(szt1,TEXT("WIN"));
		lstrcat(szt1,litos(i + 1,10));
		win		= &lpEnv->win[i];
#if !PCUNIX
		WPInt(k1,szt1,TEXT("left"  ),win->rc.left  );
		WPInt(k1,szt1,TEXT("top"   ),win->rc.top   );
		WPInt(k1,szt1,TEXT("right" ),win->rc.right );
		WPInt(k1,szt1,TEXT("bottom"),win->rc.bottom);
#else /* !PCUNIX */
		WPInt(k1,szt1,TEXT("StatusX"),win->rStatus.x);
		WPInt(k1,szt1,TEXT("StatusY"),win->rStatus.y);
		WPInt(k1,szt1,TEXT("StatusW"),win->rStatus.w);
		WPInt(k1,szt1,TEXT("StatusH"),win->rStatus.h);
		WPInt(k1,szt1,TEXT("PreeditRootX"),win->rPreeditRoot.x);
		WPInt(k1,szt1,TEXT("PreeditRootY"),win->rPreeditRoot.y);
		WPInt(k1,szt1,TEXT("PreeditRootW"),win->rPreeditRoot.w);
		WPInt(k1,szt1,TEXT("PreeditRootH"),win->rPreeditRoot.h);
#endif /* !PCUNIX */
#if !PCUNIX
#if	VERSION == 25
		for	( j = 0 ; j < recof(wLocateTBL) ; j++ ) {
			if	( win->wLocate == wLocateTBL[j] ) break;
		}
		j	%= recof(wLocateTBL);
		WPSel(k1,szt1,TEXT("locate"),j,sztLocate);
#if	USE_APPBAR
		for	( j = 0 ; j < recof(wEdgeTBL) ; j++ ) {
			if	( win->wEdge == wEdgeTBL[j] ) break;
		}
		j	%= recof(wEdgeTBL);
		WPSel(k1,szt1,TEXT("edge"),j,sztEdge);
#endif
#endif
		sztBuff[0]	= (TCHAR) 0;
		for	( j = 0 ; j < win->wPartsCount ; j++ ) {
			lstrcat(sztBuff,litos(win->wParts[j],10));
			lstrcat(sztBuff,TEXT(" ")	     );
		}
		sztBuff[lstrlen(sztBuff)-1]	= (TCHAR) 0;
		WPStr(k1,szt1,TEXT("Parts"),sztBuff);
#endif /* !PCUNIX */
	}
#endif
#if PCUNIX /* Add:SetFile */
#if !PCUNIX
	/*---------------------------------------------------------------------
		Set	Section
	---------------------------------------------------------------------*/
	k2		= sztSet;
	set		= &lpEnv->set;
	lstrcpy(set->sztSetFile,GPStr(k1,k2,TEXT("SetFile"),sztDefSet));
	WPStr(k1,k2,TEXT("SetFile"),set->sztSetFile);
#endif /* !PCUNIX */
#endif /* PCUNIX */
	/*---------------------------------------------------------------------
		Dos	Section
	---------------------------------------------------------------------*/
#ifdef	DPMI
	k2		= sztDos;
	dos		= &lpEnv->dos;
	WPSel(k1,k2,TEXT("OldVje")    ,dos->wOldVje    ,sztNoYes);
	WPSel(k1,k2,TEXT("AXMode")    ,dos->wAXMode    ,sztNoYes);
	WPSel(k1,k2,TEXT("RedrawSpot"),dos->wRedrawSpot,sztNoYes);
	WPInt(k1,k2,TEXT("IAEHandles"),dos->wIAEHandles         );
#endif
	FlushPP();
	OutLog(__FILE__ "/SaveStyFile");
	return	TRUE;
}

/*=============================================================================
	SaveClrFile
=============================================================================*/
#ifndef	DPMI
int	WINAPI	SaveClrFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPTSTR		k1;
	LPTSTR		k2;
	LPENVCLR	clr;

	InLog(__FILE__ "/SaveClrFile");
	k1	= lptFile;
	WPStr(k1,sztTitle,sztTitle,sztNow);
	k2	= sztClr;
	clr	= &lpEnv->clr;
#ifndef	DPMI
	WPHex(k1,k2,TEXT("ColChar")       ,clr->wColChar);
	WPHex(k1,k2,TEXT("ColCursor")     ,clr->wColCursor);
	WPHex(k1,k2,TEXT("ColConv")       ,clr->wColConv);
	WPHex(k1,k2,TEXT("ColConvCur")    ,clr->wColConvCur);
	WPHex(k1,k2,TEXT("ColConvTemp")   ,clr->wColConvTemp);
	WPHex(k1,k2,TEXT("ColEdit")       ,clr->wColEdit);
	WPHex(k1,k2,TEXT("ColList")       ,clr->wColList);
	WPHex(k1,k2,TEXT("ColListCur")    ,clr->wColListCur);
	WPHex(k1,k2,TEXT("ColPopHelp")    ,clr->wColPopHelp);
	WPHex(k1,k2,TEXT("ColBtn")        ,clr->wColBtn);
	WPHex(k1,k2,TEXT("ColKbd")        ,clr->wColKbd);
	WPHex(k1,k2,TEXT("ColFnc")        ,clr->wColFnc);
#if !PCUNIX
	WPHex(k1,k2,TEXT("ColBox")        ,clr->wColBox);
#endif /* !PCUNIX */
#endif
#if !PCUNIX
	WPClr(k1,k2,TEXT("ColCharDOS")    ,clr->wColCharDOS);
	WPClr(k1,k2,TEXT("ColCursorDOS")  ,clr->wColCursorDOS);
	WPClr(k1,k2,TEXT("ColConvDOS")    ,clr->wColConvDOS);
	WPClr(k1,k2,TEXT("ColConvCurDOS") ,clr->wColConvCurDOS);
	WPClr(k1,k2,TEXT("ColConvTempDOS"),clr->wColConvTempDOS);
	WPClr(k1,k2,TEXT("ColEditDOS")    ,clr->wColEditDOS);
	WPClr(k1,k2,TEXT("ColModeDOS")    ,clr->wColModeDOS);
	WPClr(k1,k2,TEXT("ColDModeDOS")   ,clr->wColDModeDOS);
	WPClr(k1,k2,TEXT("ColGuidDOS")    ,clr->wColGuidDOS);
#endif /* !PCUNIX */
	FlushPP();
	OutLog(__FILE__ "/SaveClrFile");
	return	TRUE;
}
#endif

/*=============================================================================
	SaveKeyFile
=============================================================================*/
#ifndef	DPMI
int	WINAPI	SaveKeyFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPTSTR		k1,k2;
	LPENVKBD	kbd;
	TCHAR		szt1[32];
	TCHAR		szt2[64 * MAX_STAGE];
	LPTSTR		lpt2;
	LPTSTR		lptOut;
	int		i,j,k;
	WORD		w;
	int		iNop;

	InLog(__FILE__ "/SaveKeyFile");
	k1	= lptFile;
	WPStr(k1,sztTitle,sztTitle,sztNow);
	k2	= TEXT("Key");
	kbd	= &lpEnv->kbd;
	for	( i = 0 ; i < MAX_VK ; i++ ) {
		lptOut	= GetStr(GS_VKTAG,i,0);
		if	( !(lptOut && *lptOut) ) continue;
		for	( j = 0 ; j < MAX_FCASE ; j++ ) {
			lstrcpy(szt1,sztPrefix[j]);
			lstrcat(szt1,lptOut);
			szt2[0]	= (TCHAR) 0;
			iNop	= 0;
			for	( k = 0 ; k < MAX_STAGE ; k++ ) {
				w	= kbd->wVirtTable[i][j][k];
				if	( w == F_FKEY ) iNop++;
				lstrcat(szt2,GetStr(GS_FKTAG,w,0));
				lstrcat(szt2,TEXT(" ")		 );
			}
			szt2[lstrlen(szt2) - 1]	= (TCHAR) 0;
			lpt2	= ( iNop == MAX_STAGE ) ? NULL : szt2;
			WPStr(k1,k2,szt1,lpt2);
		}
	}
	FlushPP();
	OutLog(__FILE__ "/SaveKeyFile");
	return	TRUE;
}
#endif

/*=============================================================================
	SaveRomFile
=============================================================================*/
#ifndef	DPMI
int	WINAPI	SaveRomFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPENVROM	rom;
	HANDLE		hFile;
	DWORD		dwT;

	InLog(__FILE__ "/SaveRomFile");
	rom	= &lpEnv->rom;
	if	( rom->wRomCount ) {
#if !PCUNIX
		hFile	= CreateFile(
				lptFile,
				GENERIC_WRITE,
				0,
				(LPSECURITY_ATTRIBUTES) NULL,
				OPEN_ALWAYS,
				FILE_FLAG_SEQUENTIAL_SCAN|
				FILE_ATTRIBUTE_NORMAL,
				(HANDLE) NULL
			);
#else /* !PCUNIX */
		hFile	= CreateFile (lptFile, O_CREAT|O_WRONLY|O_TRUNC, 0644);
#endif /* !PCUNIX */
		if	( hFile != INVALID_HANDLE_VALUE ) {
#if !PCUNIX
			WriteFile(
				hFile,
				(LPVOID) rom->sztImage,
				(DWORD ) rom->wRomCount,
				&dwT,
				NULL
			);
			SetEndOfFile(hFile);
#else /* !PCUNIX */
			dwT = rom->wRomCount;
			WriteFile (hFile, (LPVOID )rom->sztImage, &dwT);
			dwT = 0;
			WriteFile (hFile, (LPVOID )rom->sztImage, &dwT);
#endif /* !PCUNIX */
			CloseHandle(hFile);
#if !PCUNIX
			WritePrivateProfileString(
				sztTitle,
				sztTitle,
				sztNow,
				lptFile
			);
#else /* !PCUNIX */
			WritePPString(
				sztTitle,
				sztTitle,
				sztNow,
				lptFile
			);
#endif /* !PCUNIX */
		}
	}
	OutLog(__FILE__ "/SaveRomFile");
	return	TRUE;
}
#endif

/*=============================================================================
	SaveAchFile
=============================================================================*/
#ifndef	DPMI
int	WINAPI	SaveAchFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPTSTR		k1,k2;
	LPENVKBD	kbd;
	TCHAR		szt1[32];
	LPTSTR		lptOut;
	LPTSTR		lpt2;
	int		i,j;

	InLog(__FILE__ "/SaveAchFile");
	k1	= lptFile;
	WPStr(k1,sztTitle,sztTitle,sztNow);
	k2	= TEXT("Ach");
	kbd	= &lpEnv->kbd;
	for	( i = 0 ; i < MAX_VK ; i++ ) {
		if	( !IsCharVirt((WORD) i) ) continue;
		lptOut	= GetStr(GS_VKTAG,i,0);
		if	( !(lptOut && *lptOut) ) continue;
		for	( j = 0 ; j < MAX_CCASE ; j++ ) {
			lstrcpy(szt1,sztPrefix[j]);
			lstrcat(szt1,lptOut);
			lpt2	= kbd->sztATable[i][j];
			if	( !(*lpt2) ) lpt2	= NULL;
			WPStr(k1,k2,szt1,lpt2);
		}
	}
	FlushPP();
	OutLog(__FILE__ "/SaveAchFile");
	return	TRUE;
}
#endif

/*=============================================================================
	SaveKchFile
=============================================================================*/
#ifndef	DPMI
int	WINAPI	SaveKchFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPTSTR		k1,k2;
	LPENVKBD	kbd;
	TCHAR		szt1[32];
	LPTSTR		lptOut;
	LPTSTR		lpt2;
	int		i,j;

	InLog(__FILE__ "/SaveKchFile");
	k1	= lptFile;
	WPStr(k1,sztTitle,sztTitle,sztNow);
	k2	= TEXT("Kch");
	kbd	= &lpEnv->kbd;
	for	( i = 0 ; i < MAX_VK ; i++ ) {
		if	( !IsCharVirt((WORD) i) ) continue;
		lptOut	= GetStr(GS_VKTAG,i,0);
		if	( !(lptOut && *lptOut) ) continue;
		for	( j = 0 ; j < MAX_CCASE ; j++ ) {
			lstrcpy(szt1,sztPrefix[j]);
			lstrcat(szt1,lptOut);
			lpt2	= kbd->sztKTable[i][j];
			if	( !(*lpt2) ) lpt2	= NULL;
			WPStr(k1,k2,szt1,lpt2);
		}
	}
	FlushPP();
	OutLog(__FILE__ "/SaveKchFile");
	return	TRUE;
}
#endif

#if !PCUNIX
/*=============================================================================
	SaveSetFile
=============================================================================*/
#ifndef	DPMI
int	WINAPI	SaveSetFile
(
	LPENV		lpEnv,
	LPTSTR		lptFile
)
{
	LPTSTR		k1,k2;
	LPENVSET	set;
	TCHAR		sztTag[16];
	TCHAR		sztDat[512];
	int		i,j;

	InLog(__FILE__ "/SaveSetFile");
	k1	= lptFile;
	k2	= TEXT("Set");
	set	= &lpEnv->set;
	WPInt(k1,k2,TEXT("SetCount"),set->wSetCount);
	for	( i = 0 ; i < set->wSetCount ; i++ ) {
		lstrcpy(sztTag,TEXT("Set"));
		lstrcat(sztTag,litos(i + 1,10));
		*sztDat	= (TCHAR) 0;
		for	( j = 0 ; j < MAX_STAGE ; j++ ) {
			lstrcat(sztDat,GetStr(GS_FKTAG,set->wFunc[i][j],0));
			lstrcat(sztDat,TEXT(" "));
		}
		lstrcat(sztDat,set->sztDesc[i]);
		WPStr(k1,k2,sztTag,sztDat);
	}
	for	(       ; i < MAX_SET ; i++ ) {
		lstrcpy(sztTag,TEXT("Set"));
		lstrcat(sztTag,litos(i + 1,10));
		WPStr(k1,k2,sztTag,NULL);
	}
	FlushPP();
	OutLog(__FILE__ "/SaveSetFile");
	return	TRUE;
}
#endif
#endif /* !PCUNIX */

/*=============================================================================
	CheckEnv
=============================================================================*/
#ifndef	DPMI
int	WINAPI	CheckEnv
(
	LPENV		lpEnv,
	LPENV		lpEnvO
)
{
	LPENVMOD	mod,modO;
	LPENVFIX	fix,fixO;
	LPENVCMP	cmp,cmpO;
	LPENVCAN	can,canO;
	LPENVCLR	clr,clrO;
	LPENVBTN	btn,btnO;
	LPENVKBD	kbd,kbdO;
	LPENVROM	rom,romO;
	LPENVDCI	dci,dciO;
	LPENVDIC	dic,dicO;
	LPENVACI	aci,aciO;
	LPENVWII	wii,wiiO;
#if PCUNIX /* Add:SetFile */
#if !PCUNIX
	LPENVSET	set,setO;
#endif /* !PCUNIX */
#endif /* PCUNIX */
	LPENVWIN	win;
#ifdef	DPMI
	LPENVDOS	dos,dosO;
#endif
	WORD		wSum[MAX_PARTS];
	int		i,j,k;
	int		m,n;
	int		ret;

	InLog(__FILE__ "/CheckEnv");
	ret	= TRUE;
	/*---------------------------------------------------------------------
		mod	Section
	---------------------------------------------------------------------*/
	mod		= &lpEnv->mod;
	modO		= &lpEnvO->mod;
	if	( !VALIDNY(mod->wRoman) ) {
		mod->wRoman	= modO->wRoman;
		ret		= FALSE;
	}
	if	( !VALID3(mod->wMojiType,HIRA,KATA,EISU) ) {
		mod->wMojiType	= modO->wMojiType;
		ret		= FALSE;
	}
	if	( !VALID2(mod->wMojiSize,ZEN,HAN) ) {
		mod->wMojiSize	= modO->wMojiSize;
		ret		= FALSE;
	}
	if	( !VALID4(mod->wOkuriKana,NON,OKURI,HON,ALL) ) {
		mod->wOkuriKana	= modO->wOkuriKana;
		ret		= FALSE;
	}
#if PCUNIX
#if	!XKP_SUPPORT
	if	( !VALID4(mod->wCode,SJIS,JIS,KUTEN,EUC) ) {
		mod->wCode	= modO->wCode;
		ret		= FALSE;
	}
#else
	if	( !VALID5(mod->wCode,SJIS,JIS,KUTEN,UCS4,EUC) ) {
		mod->wCode	= modO->wCode;
		ret		= FALSE;
	}
#endif
#else /* PCUNIX */
#if	!XKP_SUPPORT
	if	( !VALID3(mod->wCode,SJIS,JIS,KUTEN) ) {
		mod->wCode	= modO->wCode;
		ret		= FALSE;
	}
#else								/* +960614 */
	if	( !VALID4(mod->wCode,SJIS,JIS,KUTEN,UCS4) ) {
		mod->wCode	= modO->wCode;
		ret		= FALSE;
	}
#endif
#endif /* PCUNIX */
	if	( !VALID3(mod->wHenkan,SAKI,REN,BETA) ) {
		mod->wHenkan	= modO->wHenkan;
		ret		= FALSE;
	}
	if	( !VALID2(mod->wBunpou,BUN,FUKU) ) {
		mod->wBunpou	= modO->wBunpou;
		ret		= FALSE;
	}
	if	( !VALIDNY(mod->wKougoConv) ) {
		mod->wKougoConv	= modO->wKougoConv;
		ret		= FALSE;
	}
	if	( !VALIDNY(mod->wKutouConv) ) {
		mod->wKutouConv	= modO->wKutouConv;
		ret		= FALSE;
	}
	if	( !VALIDNY(mod->wCalc) ) {
		mod->wCalc	= modO->wCalc;
		ret		= FALSE;
	}
	if	( !VALIDNY(mod->wHosei) ) {
		mod->wHosei	= modO->wHosei;
		ret		= FALSE;
	}
	if	( !VALIDNY(mod->wYuragi) ) {
		mod->wYuragi	= modO->wYuragi;
		ret		= FALSE;
	}
#if !PCUNIX
	if	( !VALIDNY(mod->wKutenMode) ) {
		mod->wKutenMode	= modO->wKutenMode;
		ret		= FALSE;
	}
#endif /* !PCUNIX */
#if	VERSION == 25
	if	( !VALIDNY(mod->wJisOnly) ) {
		mod->wJisOnly	= modO->wJisOnly;
		ret		= FALSE;
	}
#if !PCUNIX
	if	( !VALIDNY(mod->wKanaCtrl) ) {
		mod->wKanaCtrl	= modO->wKanaCtrl;
		ret		= FALSE;
	}
#endif /* !PCUNIX */
#endif
	/*---------------------------------------------------------------------
		fix	Section
	---------------------------------------------------------------------*/
	fix		= &lpEnv->fix;
	fixO		= &lpEnvO->fix;
	if	( !VALID3(fix->wEisuFix,NO,YES,AUTO) ) {
		fix->wEisuFix	= fixO->wEisuFix;
		ret		= FALSE;
	}
	if	( !VALID3(fix->wKanaFix,NO,YES,AUTO) ) {
		fix->wKanaFix	= fixO->wKanaFix;
		ret		= FALSE;
	}
	for	( i = 0 ; i < KIGOS ; i++ ) {
		if	( !VALID3(fix->wKigoFix[i],NO,YES,AUTO) ) {
			fix->wKigoFix[i]	= fixO->wKigoFix[i];
			ret			= FALSE;
		}
	}
	/*---------------------------------------------------------------------
		cmp	Section
	---------------------------------------------------------------------*/
	cmp		= &lpEnv->cmp;
	cmpO		= &lpEnvO->cmp;
#if !PCUNIX
	if	( !(0 <= cmp->wRank && cmp->wRank <= 8) ) {
#else /* !PCUNIX */
	if	( !(0 <= (short )cmp->wRank && (short )cmp->wRank <= 8) ) {
#endif /* !PCUNIX */
		cmp->wRank	= cmpO->wRank;
		ret		= FALSE;
	}
	if	( !VALIDNY(cmp->wKoyu) ) {
		cmp->wKoyu	= cmpO->wKoyu;
		ret		= FALSE;
	}
	if	( !VALIDNY(cmp->wMark) ) {
		cmp->wMark	= cmpO->wMark;
		ret		= FALSE;
	}
#if !PCUNIX
	if	( !VALIDNY(cmp->wSpot) ) {
		cmp->wSpot	= cmpO->wSpot;
		ret		= FALSE;
	}
#endif /* !PCUNIX */
#if !PCUNIX
	if	( !VALIDNY(cmp->wOwnFont) ) {
		cmp->wOwnFont	= cmpO->wOwnFont;
		ret		= FALSE;
	}
#endif /* !PCUNIX */
	/*---------------------------------------------------------------------
		can	Section
	---------------------------------------------------------------------*/
	can		= &lpEnv->can;
	canO		= &lpEnvO->can;
#if !PCUNIX
	if	( !(0 <= can->wStart && can->wStart <= 9) ) {
#else /* !PCUNIX */
	if	( !(0 <= (short )can->wStart && (short )can->wStart <= 9) ) {
#endif /* !PCUNIX */
		can->wStart	= canO->wStart;
		ret		= FALSE;
	}
	i	= 0;
#if !PCUNIX
	if	( can->wMatrix == YES ) {
		if	( can->wDonLen  < DBCS_SIZE
		||	  can->wDonLen  > MAX_CAND_LEN ) i++;
		if	( can->wDonCol  < 1
		||	  can->wDonCol  > MAX_CAND_COL ) i++;
		if	( can->wDonRow  < 1
		||	  can->wDonRow  > MAX_CAND_ROW ) i++;
#if	1
		can->wCodeLen	= can->wDonLen;
		can->wCodeCol	= can->wDonCol;
		can->wCodeRow	= can->wDonRow;
#else
		if	( can->wCodeLen < DBCS_SIZE
		||	  can->wCodeLen > MAX_CAND_LEN ) i++;
		if	( can->wCodeCol < 1
		||	  can->wCodeCol > MAX_CAND_COL ) i++;
		if	( can->wCodeRow < 1
		||	  can->wCodeRow > MAX_CAND_ROW ) i++;
#endif
	}
#else /* !PCUNIX */
	if	( can->wMatrix == YES ) {
		if	( can->wDonLen  < DBCS_SIZE
		||	  can->wDonLen  > MAX_CAND_LEN ) i++;
		if	( can->wDonCol  < MIN_CAND_COL
		||	  can->wDonCol  > MAX_CAND_COL ) i++;
		if	( can->wDonRow  < MIN_CAND_ROW
		||	  can->wDonRow  > MAX_CAND_ROW ) i++;
	}
#endif /* !PCUNIX */
#if PCUNIX
	else if	( can->wMatrix == NO
	||	  can->wMatrix == AUTO ) {
#else /* PCUNIX */
	else if	( can->wMatrix == NO ) {
#endif /* PCUNIX */
		can->wDonLen	= 0;
		can->wDonCol	= 1;
		can->wDonRow	= 9;
#if !PCUNIX
		can->wCodeLen	= 0;
		can->wCodeCol	= 1;
		can->wCodeRow	= 9;
#endif /* !PCUNIX */
	}
	else	{
		i		= 1;
	}
	if	( i ) {
		can->wMatrix	= canO->wMatrix;
		can->wDonLen	= canO->wDonLen;
		can->wDonCol	= canO->wDonCol;
		can->wDonRow	= canO->wDonRow;
#if !PCUNIX
		can->wCodeLen	= canO->wCodeLen;
		can->wCodeCol	= canO->wCodeCol;
		can->wCodeRow	= canO->wCodeRow;
#endif /* !PCUNIX */
		ret		= FALSE;
	}
	/*---------------------------------------------------------------------
		clr	Section
	---------------------------------------------------------------------*/
	clr		= &lpEnv->clr;
	clrO		= &lpEnvO->clr;
	if	( !(*clr->sztClrFile) ) {
		lstrcpy(clr->sztClrFile,clrO->sztClrFile);
	}
	if	( !VALIDCOLOR(clr->wColChar) ) {
		clr->wColChar		= clrO->wColChar;
		ret			= FALSE;
	}
	if	( !VALIDCOLOR(clr->wColCursor) ) {
		clr->wColCursor		= clrO->wColCursor;
	}
	if	( !VALIDCOLOR(clr->wColConv) ) {
		clr->wColConv		= clrO->wColConv;
	}
	if	( !VALIDCOLOR(clr->wColConvCur) ) {
		clr->wColConvCur	= clrO->wColConvCur;
		ret			= FALSE;
	}
	if	( !VALIDCOLOR(clr->wColConvTemp) ) {
		clr->wColConvTemp	= clrO->wColConvTemp;
		ret			= FALSE;
	}
	if	( !VALIDCOLOR(clr->wColEdit) ) {
		clr->wColEdit		= clrO->wColEdit;
		ret			= FALSE;
	}
	if	( !VALIDCOLOR(clr->wColList) ) {
		clr->wColList		= clrO->wColList;
		ret			= FALSE;
	}
	if	( !VALIDCOLOR(clr->wColListCur) ) {
		clr->wColListCur	= clrO->wColListCur;
		ret			= FALSE;
	}
	if	( !VALIDCOLOR(clr->wColPopHelp) ) {
		clr->wColPopHelp	= clrO->wColPopHelp;
		ret			= FALSE;
	}
	if	( !VALIDCOLOR(clr->wColBtn) ) {
		clr->wColBtn		= clrO->wColBtn;
		ret			= FALSE;
	}
	if	( !VALIDCOLOR(clr->wColKbd) ) {
		clr->wColKbd		= clrO->wColKbd;
		ret			= FALSE;
	}
	if	( !VALIDCOLOR(clr->wColFnc) ) {
		clr->wColFnc		= clrO->wColFnc;
		ret			= FALSE;
	}
#if !PCUNIX
	if	( !VALIDCOLOR(clr->wColBox) ) {
		clr->wColBox		= clrO->wColBox;
		ret			= FALSE;
	}
#endif /* !PCUNIX */
	/*---------------------------------------------------------------------
		Fnt	Section
	---------------------------------------------------------------------*/
		/* no operation */
	/*---------------------------------------------------------------------
		Btn	Section
	---------------------------------------------------------------------*/
	btn		= &lpEnv->btn;
	btnO		= &lpEnvO->btn;
	if	( !VALID4(btn->wBtnType,IDP_BTN20B,IDP_BTN12B,
					IDP_BTN20C,IDP_BTN12C) ) {
		btn->wBtnType	= btnO->wBtnType;
		ret		= FALSE;
	}
	if	( !(16 <= btn->wBtnSize && btn->wBtnSize <= 32) ) {
		btn->wBtnSize	= btnO->wBtnSize;
		ret		= FALSE;
	}
#if PCUNIX
	if	(24 <= btn->wBtnSize && btn->wBtnSize <= 32) {
		if	(btn->wBtnType == IDP_BTN12B) {
			btn->wBtnType = IDP_BTN20B;
		} else if	(btn->wBtnType == IDP_BTN12C) {
			btn->wBtnType = IDP_BTN20C;
		}
	} else {
		if	(btn->wBtnType == IDP_BTN20B) {
			btn->wBtnType = IDP_BTN12B;
		} else if	(btn->wBtnType == IDP_BTN20C) {
			btn->wBtnType = IDP_BTN12C;
		}
	}
#endif /* PCUNIX */
	if	( !VALIDNY(btn->wPopHelp) ) {
		btn->wPopHelp	= btnO->wPopHelp;
		ret		= FALSE;
	}
	j	= 0;
	if	( btn->wBtnCount <= MAX_BTNTOP ) {
		for	( i = 0 ; i < btn->wBtnCount ; i++ ) {
			if	( btn->wBtnFunc[i] <= F_MAX ) {
				btn->wBtnFunc[j++]	= btn->wBtnFunc[i];
			}
		}
		btn->wBtnCount	= j;
	}
	if	( j == 0 ) {
		btn->wBtnCount	= btnO->wBtnCount;
		for	( i = 0 ; i < btn->wBtnCount ; i++ ) {
			btn->wBtnFunc[i]	= btnO->wBtnFunc[i];
		}
	}
	/*---------------------------------------------------------------------
		Kbd	Section
	---------------------------------------------------------------------*/
	kbd		= &lpEnv->kbd;
	kbdO		= &lpEnvO->kbd;
#if !PCUNIX
	if	( kbd->wKbdType != KBD_101
	&&	  kbd->wKbdType != KBD_AX
	&&	  kbd->wKbdType != KBD_002
	&&	  kbd->wKbdType != KBD_A01
	&&	  kbd->wKbdType != KBD_PC98 ) {
#else /* !PCUNIX */
	if	( kbd->wKbdType != KBD_101
	&&	  kbd->wKbdType != KBD_A01
	&&	  kbd->wKbdType != KBD_PC98 ) {
#endif /* !PCUNIX */
		kbd->wKbdType	= kbdO->wKbdType;
		ret		= FALSE;
	}
#if !PCUNIX
	if	( kbd->wKbdTypeV != kbd->wKbdType
	&&	  kbd->wKbdTypeV != KBD_PAD1H
	&&	  kbd->wKbdTypeV != KBD_PAD1K
	&&	  kbd->wKbdTypeV != KBD_PAD1A	) {
		kbd->wKbdTypeV	= kbdO->wKbdTypeV;
		ret		= FALSE;
	}
	if	( !VALIDNY(kbd->wRotArrow) ) {
		kbd->wRotArrow	= kbdO->wRotArrow;
		ret		= FALSE;
	}
#endif /* !PCUNIX */
	if	( !VALID3(kbd->wComma,NO,YES,AUTO) ) {
		kbd->wComma	= kbdO->wComma;
		ret		= FALSE;
	}
	if	( !VALID3(kbd->wPeriod,NO,YES,AUTO) ) {
		kbd->wPeriod	= kbdO->wPeriod;
		ret		= FALSE;
	}
	if	( !VALID3(kbd->wSlash,NO,YES,AUTO) ) {
		kbd->wSlash	= kbdO->wSlash;
		ret		= FALSE;
	}
	if	( !VALID3(kbd->wHyphen,NO,YES,AUTO) ) {
		kbd->wHyphen	= kbdO->wHyphen;
		ret		= FALSE;
	}
	if	( !VALIDNY(kbd->wBracket) ) {
		kbd->wBracket	= kbdO->wBracket;
		ret		= FALSE;
	}
	if	( !VALIDNY(kbd->wTen) ) {
		kbd->wTen	= kbdO->wTen;
		ret		= FALSE;
	}
	if	( !VALIDNY(kbd->wMaru) ) {
		kbd->wMaru	= kbdO->wMaru;
		ret		= FALSE;
	}
	if	( !(*kbd->sztKeyFile) ) {
		lstrcpy(kbd->sztKeyFile,kbdO->sztKeyFile);
	}
	if	( !(*kbd->sztAchFile) ) {
		lstrcpy(kbd->sztAchFile,kbdO->sztAchFile);
	}
	if	( !(*kbd->sztKchFile) ) {
		lstrcpy(kbd->sztKchFile,kbdO->sztKchFile);
	}
	for	( i = 0 ; i < MAX_VK    ; i++ )
	for	( j = 0 ; j < MAX_FCASE ; j++ )
	for	( k = 0 ; k < MAX_STAGE ; k++ ) {
		if	( kbd->wVirtTable[i][j][k] > F_MAX ) {
			kbd->wVirtTable[i][j][k] = kbdO->wVirtTable[i][j][k];
		}
	}
		/* ach no operation */
		/* kch no operation */
	/*---------------------------------------------------------------------
		ROM	Section
	---------------------------------------------------------------------*/
	rom		= &lpEnv->rom;
	romO		= &lpEnvO->rom;
	if	( !(*rom->sztRomFile) ) {
		lstrcpy(rom->sztRomFile,romO->sztRomFile);
	}
	/*---------------------------------------------------------------------
		DCI	Section
	---------------------------------------------------------------------*/
	dci		= &lpEnv->dci;
	dciO		= &lpEnvO->dci;
	if	( !VALIDNY(dci->wKanaGaku) ) {
		dci->wKanaGaku	= dciO->wKanaGaku;
		ret		= FALSE;
	}
	if	( !VALIDNY(dci->wEisuGaku) ) {
		dci->wEisuGaku	= dciO->wEisuGaku;
		ret		= FALSE;
	}
#if PCUNIX
	if	( !(*dci->sztDicDat) ) {
		lstrcpy(dci->sztDicDat,dciO->sztDicDat);
	}
#endif
	/*---------------------------------------------------------------------
		DIC	Section
	---------------------------------------------------------------------*/
	dic	= &lpEnv->dic[MAX_DIC - 1];
	dicO	= &lpEnvO->dic[MAX_DIC - 1];
	if	( !(*dic->sztDicFile) ) {
		lstrcpy(dic->sztDicFile,dicO->sztDicFile);
		lstrcpy(dic->sztDicDesc,dicO->sztDicDesc);
		dic->wLearnMode	= dicO->wLearnMode;
		dic->wLearnType	= dicO->wLearnType;
		dic->wParallel	= dicO->wParallel;
		ret		= FALSE;
	}
	/*---------------------------------------------------------------------
		ACI/ACC	Section
	---------------------------------------------------------------------*/
	aci		= &lpEnv->aci;
	aciO		= &lpEnvO->aci;
	j		= 0;
	if	( aci->wAccCount <= MAX_ACC ) {
		for	( i = 0 ; i < aci->wAccCount ; i++ ) {
			if	( *(lpEnv->acc[i].sztAccFile) ) {
				lpEnv->acc[j++]	= lpEnv->acc[i];
			}
		}
		aci->wAccCount	= j;
	}
	/*---------------------------------------------------------------------
		WII/WIN Section
	---------------------------------------------------------------------*/
	wii		= &lpEnv->wii;
	wiiO		= &lpEnvO->wii;
	if	( !VALIDNY(wii->wMinimize) ) {
		wii->wMinimize	= wiiO->wMinimize;
		ret		= FALSE;
	}
#if	VERSION == 20
	if	( !VALIDNY(wii->wOffHide) )
#elif	USE_APPBAR
	if	( !VALID4(wii->wOffHide,NO,YES,SHRINK,APPBAR) )
#else
	if	( !VALID3(wii->wOffHide,NO,YES,SHRINK) )
#endif
	{
		wii->wOffHide	= wiiO->wOffHide;
		ret		= FALSE;
	}
#if !PCUNIX
	for	( i = 0 ; i < MAX_PARTS ; i++ ) {
		wSum[i]	= 0;
	}
	m	= min(wii->wWinCount,MAX_WIN);
	for	( i = 0 ; i < m ; i++ ) {
		win	= &lpEnv->win[i];
		n	= min(win->wPartsCount,MAX_PARTS);
		for	(j = 0 ; j < n ; j++) {
			if	(win->wParts[j] > 0 
			&&	 win->wParts[j] < MAX_PARTS) {
				wSum[win->wParts[j]]	+= 1;
			}
		}
#if	VERSION == 25
		k	= 0;
		for	( j = 0 ; j < recof(wLocateTBL) ; j++ ) {
			if	( win->wLocate == wLocateTBL[j] ) {
				k	+= 1;
				break;
			}
		}
#if	USE_APPBAR
		for	( j = 0 ; j < recof(wEdgeTBL)   ; j++ ) {
			if	( win->wEdge   == wEdgeTBL[j]   ) {
				k	+= 2;
				break;
			}
		}
		if	( k != 3 ) {
#if !PCUNIX
			win->rc		= lpEnvO->win[i].rc;
#else /* !PCUNIX */
			win->rStatus		= lpEnvO->win[i].rStatus;
			win->rPreeditRoot	= lpEnvO->win[i].rPreeditRoot;
#endif /* !PCUNIX */
			win->wLocate	= lpEnvO->win[i].wLocate;
			win->wEdge	= lpEnvO->win[i].wEdge;
			ret		= FALSE;
		}
#else
		if	( k != 1 ) {
#if !PCUNIX
			win->rc		= lpEnvO->win[i].rc;
#else /* !PCUNIX */
			win->rStatus		= lpEnvO->win[i].rStatus;
			win->rPreeditRoot	= lpEnvO->win[i].rPreeditRoot;
#endif /* !PCUNIX */
			win->wLocate	= lpEnvO->win[i].wLocate;
			ret		= FALSE;
		}
#endif
#endif
	}
	for	( i = k = 0 ; i < MAX_PARTS ; i++ ) {
		if	( wSum[i] > 1  ) {
			k	= 0;
			break;
		}
		else	{
			k	= k + wSum[i];
		}
	}
	if	( !k ) {
		wii->wWinCount	= wiiO->wWinCount;
		for	( i = 0 ; i < wii->wWinCount ; i++ ) {
			lpEnv->win[i]	= lpEnvO->win[i];
		}
		ret	= FALSE;
	}
#endif /* !PCUNIX */
#if PCUNIX /* Add:SetFile */
#if !PCUNIX
	/*---------------------------------------------------------------------
		Set	Section
	---------------------------------------------------------------------*/
	set		= &lpEnv->set;
	setO		= &lpEnvO->set;
	if	( !(*set->sztSetFile) ) {
		lstrcpy(set->sztSetFile,setO->sztSetFile);
	}
#endif /* !PCUNIX */
#endif /* PCUNIX */
	/*---------------------------------------------------------------------
		DOS Section
	---------------------------------------------------------------------*/
#ifdef	DPMI
	dos		= &lpEnv->dos;
	dosO		= &lpEnvO->dos;
	if	( !VALIDNY(dos->wOldVje    ) ) {
		dos->wOldVje	= dosO->wOldVje;
		ret		= FALSE;
	}
	if	( !VALIDNY(dos->wAXMode    ) ) {
		dos->wAXMode	= dosO->wAXMode;
		ret		= FALSE;
	}
	if	( !VALIDNY(dos->wRedrawSpot) ) {
		dos->wRedrawSpot= dosO->wRedrawSpot;
		ret		= FALSE;
	}
	if	( !(1 <= dos->wIAEHandles && dos->wIAEHandles <= 9) ) {
		dos->wIAEHandles= dosO->wIAEHandles;
		ret		= FALSE;
	}
#endif
	OutLog(__FILE__ "/CheckEnv");
	return	ret;
}
#endif

/*=============================================================================
	MakeDefaultEnv
=============================================================================*/
#ifndef	DPMI
void	WINAPI	MakeDefaultEnv
(
	LPENV		lpEnv
)
{
	LPENVMOD	mod;
	LPENVFIX	fix;
	LPENVCMP	cmp;
	LPENVCAN	can;
	LPENVCLR	clr;
	LPENVFNT	fnt;
	LPENVBTN	btn;
	LPENVKBD	kbd;
	LPENVROM	rom;
	LPENVDCI	dci;
	LPENVDIC	dic;
	LPENVACI	aci;
	LPENVACC	acc;
	LPENVWII	wii;
	LPENVWIN	win;
#if !PCUNIX
	LPENVSET	set;
#endif /* !PCUNIX */
#ifdef	DPMI
	LPENVDOS	dos;
#endif
	int		i,j;

	InLog(__FILE__ "/MakeDefaultEnv");
	/*---------------------------------------------------------------------
		mod	Section
	---------------------------------------------------------------------*/
	mod		= &lpEnv->mod;
	mod->wRoman	= YES;
	mod->wMojiType	= HIRA;
	mod->wMojiSize	= ZEN;
	mod->wOkuriKana	= ALL;
#if PCUNIX
	mod->wCode	= EUC;
#else /* PCUNIX */
	mod->wCode	= SJIS;
#endif /* PCUNIX */
	mod->wHenkan	= SAKI;
	mod->wBunpou	= BUN;
	mod->wKougoConv	= NO;
	mod->wKutouConv	= YES;
	mod->wCalc	= NO;
	mod->wHosei	= YES;
	mod->wYuragi	= NO;
#if !PCUNIX
	mod->wKutenMode	= YES;
#endif /* !PCUNIX */
#if	VERSION == 25
	mod->wJisOnly	= NO;
#if !PCUNIX
	mod->wKanaCtrl	= YES;
#endif /* !PCUNIX */
#endif
	/*---------------------------------------------------------------------
		mod	Section
	---------------------------------------------------------------------*/
	fix		= &lpEnv->fix;
	fix->wEisuFix	= AUTO;
	fix->wKanaFix	= AUTO;
	for	( i = 0 ; i < KIGOS ; i++ ) {
		fix->wKigoFix[i]	= AUTO;
	}
	/*---------------------------------------------------------------------
		cmp	Section
	---------------------------------------------------------------------*/
	cmp		= &lpEnv->cmp;
	cmp->wRank	= 0;
	cmp->wKoyu	= NO;
	cmp->wMark	= YES;
#if !PCUNIX
	cmp->wSpot	= YES;
#endif /* !PCUNIX */
#if !PCUNIX
	cmp->wOwnFont	= NO;
#endif /* !PCUNIX */
	/*---------------------------------------------------------------------
		can	Section
	---------------------------------------------------------------------*/
	can		= &lpEnv->can;
	can->wStart	= 2;
	can->wMatrix	= NO;
	can->wDirection	= YOKO;
	can->wDonLen	= 0;
	can->wDonCol	= 1;
	can->wDonRow	= 9;
#if !PCUNIX
	can->wCodeLen	= 0;
	can->wCodeCol	= 1;
	can->wCodeRow	= 9;
#endif /* !PCUNIX */
	/*---------------------------------------------------------------------
		clr	Section
	---------------------------------------------------------------------*/
	clr		= &lpEnv->clr;
	lstrcpy(clr->sztClrFile,sztDefClr);
	clr->wColChar		= 0x2d1c;
	clr->wColCursor		= 0x1c2f;
	clr->wColConv		= 0x1c11;
	clr->wColConvCur	= 0x2811;
	clr->wColConvTemp	= 0x280c;
	clr->wColEdit		= 0x2d1c;
	clr->wColList		= 0x2d1c;
	clr->wColListCur	= 0x2d1c;
	clr->wColPopHelp	= 0x0928;
	clr->wColBtn		= 0x2d28;
	clr->wColKbd		= 0x2d28;
	clr->wColFnc		= 0x2d28;
#if !PCUNIX
	clr->wColBox		= 0x2f28;
#endif /* !PCUNIX */
	/*---------------------------------------------------------------------
		Fnt	Section
	---------------------------------------------------------------------*/
#if !PCUNIX
	for	( i = 0 ; i < FONTS ; i++ ) {
		fnt	= &lpEnv->fnt[i];
		GetLogFont(NULL,&fnt->lf);
		lstrcpy(fnt->lf.lfFaceName,TEXT("SYSTEM"));
		fnt->lf.lfHeight= -12;
	//	fnt->lf.lfHeight= PointToHeight(j);
		fnt->lf.lfWidth	= 0;
		fnt->lf.lfWeight= FW_NORMAL;
		fnt->lf.lfItalic= 0;
	}
#else /* !PCUNIX */
	for	( i = 0 ; i < FONTS ; i++ ) {
		fnt	= &lpEnv->fnt[i];
		if (i < FONTS-1) {
			fnt->lf.wFontType	= APP;
		} else {
			fnt->lf.wFontType	= FIX;
		}
		lstrcpy(fnt->lf.sztKanaName,TEXT(KANA14));
		lstrcpy(fnt->lf.sztKanjiName,TEXT(KANJI14));
	}
#endif /* !PCUNIX */
	/*---------------------------------------------------------------------
		Btn	Section
	---------------------------------------------------------------------*/
	btn			= &lpEnv->btn;
#if !PCUNIX
	btn->wBtnType		= IDP_BTN20C;
	btn->wBtnSize		= 24;
#else /* !PCUNIX */
	btn->wBtnType		= IDP_BTN12C;
	btn->wBtnSize		= 16;
#endif /* !PCUNIX */
	btn->wPopHelp		= YES;
	i			= 0;
	btn->wBtnFunc[i++]	= F_SCRN;
	btn->wBtnFunc[i++]	= F_EX_CHAR_TOG;
	btn->wBtnFunc[i++]	= F_ZEN;
	btn->wBtnFunc[i++]	= F_EX_ACC1;
#if !PCUNIX
	btn->wBtnFunc[i++]	= F_EX_ACC2;
	btn->wBtnFunc[i++]	= F_EX_ACC3;
#if	VERSION == 25
	btn->wBtnFunc[i++]	= F_EX_ACC4;
	btn->wBtnFunc[i++]	= F_EX_ACC5;
#endif
	btn->wBtnFunc[i++]	= F_EX_RECONV;
	btn->wBtnFunc[i++]	= F_UNDO;
	btn->wBtnFunc[i++]	= F_EX_REGWORD;
	btn->wBtnFunc[i++]	= F_EX_DELWORD;
	btn->wBtnFunc[i++]	= F_EX_ENV;
	btn->wBtnFunc[i++]	= F_EX_HELP;
#endif /* !PCUNIX */
	btn->wBtnCount		= i;
	/*---------------------------------------------------------------------
		Kbd	Section
	---------------------------------------------------------------------*/
	kbd		= &lpEnv->kbd;
	kbd->wKbdType	= GetKbdType();
#if !PCUNIX
	kbd->wKbdTypeV	= kbd->wKbdType;
	kbd->wRotArrow	= YES;
#endif /* !PCUNIX */
	kbd->wComma	= AUTO;
	kbd->wPeriod	= AUTO;
	kbd->wSlash	= AUTO;
	kbd->wHyphen	= AUTO;
	kbd->wBracket	= YES;
	kbd->wTen	= NO;
	kbd->wMaru	= NO;
	LoadDefaultKey(lpEnv);
	lstrcpy(kbd->sztAchFile,sztDefAch);
	lstrcpy(kbd->sztKchFile,sztDefKch);
	for	( i = 0 ; i < MAX_VK    ; i++ )
	for	( j = 0 ; j < MAX_CCASE ; j++ ) {
		kbd->sztATable[i][j][0]	= (TCHAR) 0;
		kbd->sztKTable[i][j][0]	= (TCHAR) 0;
	}
	/*---------------------------------------------------------------------
		ROM	Section
	---------------------------------------------------------------------*/
	rom		= &lpEnv->rom;
	lstrcpy(rom->sztRomFile,sztDefRom);
	rom->wRomCount	= 0;
	/*---------------------------------------------------------------------
		DCI	Section
	---------------------------------------------------------------------*/
	dci		= &lpEnv->dci;
	dci->wDicCount	= MAX_DIC;
	dci->wLearnDic	= MAX_DIC - 1;
	dci->wKanaGaku	= YES;
	dci->wEisuGaku	= YES;
#if PCUNIX
	lstrcpy(dci->sztDicDat,sztDefDat);
#endif
	/*---------------------------------------------------------------------
		DIC	Section
	---------------------------------------------------------------------*/
	for	( i = 0 ; i < MAX_DIC ; i++ ) {
		dic	= &lpEnv->dic[i];
		lstrcpy(dic->sztDicFile,lptDefDic[i]);
		dic->wLearnMode	= YES;
		dic->wLearnType	= LEARNDIC;
		dic->wParallel	= YES;
	}
	/*---------------------------------------------------------------------
		ACI	Section
	---------------------------------------------------------------------*/
	aci		= &lpEnv->aci;
#if !PCUNIX
	aci->wAccCount	= 2;
#else /* !PCUNIX */
	aci->wAccCount	= 1;
#endif /* !PCUNIX */
	/*---------------------------------------------------------------------
		ACC	Section
	---------------------------------------------------------------------*/
	for	( i = 0 ; i < aci->wAccCount ; i++ ) {
		acc	= &lpEnv->acc[i];
		lstrcpy(acc->sztAccFile,lptDefAcc[i]);
	}
	/*---------------------------------------------------------------------
		WII	Section
	---------------------------------------------------------------------*/
	wii		= &lpEnv->wii;
#if !PCUNIX
	wii->wScreenW	= 640;
	wii->wScreenH	= 480;
#endif /* !PCUNIX */
	wii->wWinCount	= 1;
	wii->wMinimize	= NO;
	wii->wOffHide	= NO;
	/*---------------------------------------------------------------------
		WIN	Section
	---------------------------------------------------------------------*/
	win		= &lpEnv->win[0];
#if !PCUNIX
	win->rc.left	= 0;
	win->rc.top	= 0;
	win->rc.right	= 0;
	win->rc.bottom	= 0;
#else /* !PCUNIX */
	win->rStatus.x		= 0;
	win->rStatus.y		= 0;
	win->rStatus.w		= 0;
	win->rStatus.h		= 0;
	win->rPreeditRoot.x	= 0;
	win->rPreeditRoot.y	= 0;
	win->rPreeditRoot.w	= 0;
	win->rPreeditRoot.h	= 0;
#endif /* !PCUNIX */
#if !PCUNIX
#if	VERSION == 25
	win->wLocate	= HTBOTTOMRIGHT;
#if	USE_APPBAR
	win->wEdge	= ABE_FLOAT;
#endif
#endif
	win->wParts[0]	= PARTS_BTN;
	win->wPartsCount= 1;
#endif /* !PCUNIX */
	/*---------------------------------------------------------------------
		SET	Section
	---------------------------------------------------------------------*/
#if !PCUNIX
	set		= &lpEnv->set;
	lstrcpy(set->sztSetFile,sztDefSet);
	set->wSetCount	= 0;
#endif /* !PCUNIX */
	/*---------------------------------------------------------------------
		DOS	Section
	---------------------------------------------------------------------*/
#ifdef	DPMI
	dos		= &lpEnv->dos;
	dos->wOldVje	= NO;
	dos->wAXMode	= NO;
	dos->wRedrawSpot= YES;
	dos->wIAEHandles= 5;
#endif
	OutLog(__FILE__ "/MakeDefaultEnv");
	return;
}
#endif

/*=============================================================================
	GetKbdType
=============================================================================*/
#ifndef	DPMI
static	WORD	GetKbdType(void)
{
	WORD	ret;
	int	i;

#if !PCUNIX
	i	= GetKeyboardType(0);
	if	( i != 7 ) {
		ret	= KBD_101;
	}
	else	{
		i	= GetKeyboardType(1);
		switch	(i) {
		case	0x0000:		/* գӥܡ	*/
			ret	= KBD_101;
			break;
		case	0x0001:		/* إܡ	*/
			ret	= KBD_AX;
			break;
		case	0x0002:		/* ɣ£ 106    	*/
			ret	= KBD_A01;
			break;
		case	0x0003:		/* ɣ£ 002/003	*/
		case	0x0004:		/* ɣ£ 001    	*/
			ret	= KBD_002;
			break;
		case	0x000d:		/* ǥǥȥå	*/
		case	0x000e:		/* ǥΡȥ֥å	*/
		case	0x000f:		/* ǥåץȥå	*/
			ret	= KBD_101;
			break;
		case	0x0d01:		/* 			*/
		case	0x0d02:		/* Ʊ			*/
		case	0x0d03:		/* Ʊ			*/
		case	0x0d04:		/* Ʊ			*/
		case	0x0d05:		/* Ʊ(106)		*/
			ret	= KBD_PC98;
			break;
		default:
			ret	= KBD_A01;
			break;
		}
	}
#else /* !PCUNIX */
	ret	= KBD_A01;
#endif /* !PCUNIX */
	return	ret;
}
#endif

/*=============================================================================
	LoadDefaultKey
=============================================================================*/
#ifndef	DPMI
static	void	LoadDefaultKey
(
	LPENV		lpEnv
)
{
	LPENVKBD	kbd;
	WORD		v,c;
	int		i,j;

	InLog(__FILE__ "/LoadDefaultKey");
	kbd	= &lpEnv->kbd;
	lstrcpy(kbd->sztKeyFile,sztDefKey);
	for	( i = 0 ; i < recof(sDefKey) ; i++ ) {
#if !PCUNIX
		v	= sDefKey[i].wVirt;
#else /* !PCUNIX */
		v	= ConvVK (sDefKey[i].wVirt);
#endif /* !PCUNIX */
		c	= sDefKey[i].wCase;
		for	( j = 0 ; j < MAX_STAGE ; j++ ) {
			kbd->wVirtTable[v][c][j]	= sDefKey[i].wFunc[j];
		}
	}
	OutLog(__FILE__ "/LoadDefaultKey");
	return;
}
#endif

/*=============================================================================
	LoadDefaultRom
=============================================================================*/
#ifndef	DPMI
static	void	LoadDefaultRom
(
	LPENV	lpEnv
)
{
	return;
}
#endif

/*=============================================================================
	DumpEnv
=============================================================================*/
#if 0 /* debug */
#define DUMPSTR(x)	printf("%-30s " "%s" "\n", #x, (x));
#define DUMPINT(x)	printf("%-30s " "%d" "\n", #x, (x));
#define DUMPHEX(x)	printf("%-30s " "%x" "\n", #x, (x));
#define DumpLogFont(f)\
{\
	printf("FontType  " "%d" "\n", f.wFontType);\
	printf("KanaName  " "%s" "\n", f.sztKanaName);\
	printf("KanjiName " "%s" "\n", f.sztKanjiName);\
}
void	WINAPI	DumpEnv
(
	LPENV	lpEnv,
	DWORD	dwMode
)
{
	int	i,j,k;

	if	( dwMode & ENVNOT_INI ) {
#if !PCUNIX
		DUMPSTR(lpEnv->ini.sztWin);
		DUMPSTR(lpEnv->ini.sztUsr);
		DUMPSTR(lpEnv->ini.sztApp);
		DUMPSTR(lpEnv->ini.sztVje);
		DUMPSTR(lpEnv->ini.sztVersion);
		DUMPSTR(lpEnv->ini.sztUserID1);
		DUMPSTR(lpEnv->ini.sztUserID2);
		DUMPINT(lpEnv->ini.wUserNo);
		DUMPINT(lpEnv->ini.wUserCount);
		DUMPINT(lpEnv->ini.wUserMark);
		DUMPINT(lpEnv->ini.wSaveAsUsr);
		DUMPINT(lpEnv->ini.wSaveAsApp);
		DUMPSTR(lpEnv->ini.sztProgDir);
		DUMPSTR(lpEnv->ini.sztUserDir);
		DUMPSTR(lpEnv->ini.sztDatBase);
#else /* !PCUNIX */
		DUMPSTR(lpEnv->ini.sztUsr);
		DUMPSTR(lpEnv->ini.sztVersion);
		DUMPSTR(lpEnv->ini.sztEtcDir);
		DUMPSTR(lpEnv->ini.sztInsDir);
		DUMPSTR(lpEnv->ini.sztComDir);
		DUMPSTR(lpEnv->ini.sztEnvDir);
		DUMPSTR(lpEnv->ini.sztDicDir);
		DUMPSTR(lpEnv->ini.sztUsrDir);
		DUMPSTR(lpEnv->ini.sztDatBase);
		DUMPSTR(lpEnv->ini.sztAtwTitle);
#endif /* !PCUNIX */
	}
	if	( dwMode & ENVNOT_MOD ) {
		DUMPINT(lpEnv->mod.wRoman);
		DUMPINT(lpEnv->mod.wMojiType);
		DUMPINT(lpEnv->mod.wMojiSize);
		DUMPINT(lpEnv->mod.wOkuriKana);
		DUMPINT(lpEnv->mod.wCode);
		DUMPINT(lpEnv->mod.wHenkan);
		DUMPINT(lpEnv->mod.wBunpou);
		DUMPINT(lpEnv->mod.wKougoConv);
		DUMPINT(lpEnv->mod.wKutouConv);
		DUMPINT(lpEnv->mod.wCalc);
		DUMPINT(lpEnv->mod.wHosei);
		DUMPINT(lpEnv->mod.wYuragi);
#if !PCUNIX
		DUMPINT(lpEnv->mod.wKutenMode);
#endif /* !PCUNIX */
#if	VERSION == 25
		DUMPINT(lpEnv->mod.wJisOnly);
#if !PCUNIX
		DUMPINT(lpEnv->mod.wKanaCtrl);
#endif /* !PCUNIX */
#endif
	}
	if	( dwMode & ENVNOT_FIX ) {
		DUMPINT(lpEnv->fix.wEisuFix);
		DUMPINT(lpEnv->fix.wKanaFix);
		printf("lpEnv->fix.wKigoFix ");
		for	( i = 0 ; i < KIGOS ; i++ ) {
			printf("%d ",lpEnv->fix.wKigoFix[i]);
		}
		printf("\n");
	}
	if	( dwMode & ENVNOT_CMP ) {
		DUMPINT(lpEnv->cmp.wRank);
		DUMPINT(lpEnv->cmp.wKoyu);
		DUMPINT(lpEnv->cmp.wMark);
#if !PCUNIX
		DUMPINT(lpEnv->cmp.wSpot);
#endif /* !PCUNIX */
#if !PCUNIX
		DUMPINT(lpEnv->cmp.wOwnFont);
#endif /* !PCUNIX */
	}
	if	( dwMode & ENVNOT_CAN ) {
		DUMPINT(lpEnv->can.wStart);
		DUMPINT(lpEnv->can.wMatrix);
		DUMPINT(lpEnv->can.wDirection);
		DUMPINT(lpEnv->can.wDonLen);
		DUMPINT(lpEnv->can.wDonCol);
		DUMPINT(lpEnv->can.wDonRow);
#if !PCUNIX
		DUMPINT(lpEnv->can.wCodeLen);
		DUMPINT(lpEnv->can.wCodeCol);
		DUMPINT(lpEnv->can.wCodeRow);
#endif /* !PCUNIX */
	}
	if	( dwMode & ENVNOT_CLR ) {
		DUMPSTR(lpEnv->clr.sztClrFile);
		DUMPINT(lpEnv->clr.wClrFrom);
		DUMPINT(lpEnv->clr.wClrUpdate);
		DUMPHEX(lpEnv->clr.wColChar);
		DUMPHEX(lpEnv->clr.wColCursor);
		DUMPHEX(lpEnv->clr.wColConv);
		DUMPHEX(lpEnv->clr.wColConvCur);
		DUMPHEX(lpEnv->clr.wColConvTemp);
		DUMPHEX(lpEnv->clr.wColEdit);
		DUMPHEX(lpEnv->clr.wColList);
		DUMPHEX(lpEnv->clr.wColListCur);
		DUMPHEX(lpEnv->clr.wColPopHelp);
		DUMPHEX(lpEnv->clr.wColBtn);
		DUMPHEX(lpEnv->clr.wColKbd);
		DUMPHEX(lpEnv->clr.wColFnc);
#if !PCUNIX
		DUMPHEX(lpEnv->clr.wColBox);
#endif /* !PCUNIX */
	}
	if	( dwMode & ENVNOT_FNT ) {
		for	( i = 0 ; i < FONTS ; i++ ) {
			printf("Font %s\n",sztFnt[i]);
			DumpLogFont(lpEnv->fnt[i].lf);
			printf("\n");
		}
	}
	if	( dwMode & ENVNOT_BTN ) {
		DUMPINT(lpEnv->btn.wBtnType);
		DUMPINT(lpEnv->btn.wBtnSize);
		DUMPINT(lpEnv->btn.wPopHelp);
		DUMPINT(lpEnv->btn.wBtnCount);
		printf("lpEnv->btn.wBtnFunc ");
		for	( i = 0 ; i < lpEnv->btn.wBtnCount ; i++ ) {
			printf("%d ",lpEnv->btn.wBtnFunc[i]);
		}
		printf("\n");
	}
	if	( dwMode & ENVNOT_KBD ) {
		DUMPINT(lpEnv->kbd.wKbdType);
#if !PCUNIX
		DUMPINT(lpEnv->kbd.wKbdTypeV);
		DUMPINT(lpEnv->kbd.wRotArrow);
#endif /* !PCUNIX */
		DUMPINT(lpEnv->kbd.wComma);
		DUMPINT(lpEnv->kbd.wPeriod);
		DUMPINT(lpEnv->kbd.wSlash);
		DUMPINT(lpEnv->kbd.wHyphen);
		DUMPINT(lpEnv->kbd.wBracket);
		DUMPINT(lpEnv->kbd.wTen);
		DUMPINT(lpEnv->kbd.wMaru);
		DUMPSTR(lpEnv->kbd.sztKeyFile);
		DUMPINT(lpEnv->kbd.wKeyFrom);
		DUMPINT(lpEnv->kbd.wKeyUpdate);
		DUMPSTR(lpEnv->kbd.sztAchFile);
		DUMPINT(lpEnv->kbd.wAchFrom);
		DUMPINT(lpEnv->kbd.wAchUpdate);
		DUMPSTR(lpEnv->kbd.sztKchFile);
		DUMPINT(lpEnv->kbd.wKchFrom);
		DUMPINT(lpEnv->kbd.wKchUpdate);
		for	( i = 0 ; i < MAX_VK    ; i++ )
		for	( j = 0 ; j < MAX_FCASE ; j++ ) {
			if	( lpEnv->kbd.wVirtTable[i][j][0] == F_FKEY
			&&	  lpEnv->kbd.wVirtTable[i][j][1] == F_FKEY
			&&	  lpEnv->kbd.wVirtTable[i][j][2] == F_FKEY
			&&	  lpEnv->kbd.wVirtTable[i][j][3] == F_FKEY
			&&	  lpEnv->kbd.wVirtTable[i][j][4] == F_FKEY ) {
				continue;
			}
			printf(
				"vk (0x%04x)%04s%-15.15s ",
				i, sztPrefix[j], GetStr(GS_VKTAG,i,0)
			);
			for	( k = 0 ; k < MAX_STAGE ; k++ ) {
				printf(
					"(%04d)%-15.15s ",
					lpEnv->kbd.wVirtTable[i][j][k],
					GetStr(
						GS_FKTAG,
						lpEnv->kbd.wVirtTable[i][j][k],
						0
					)
				);
			}
			printf("\n");
		}
		printf("\n");
		for	( i = 0 ; i < MAX_VK    ; i++ )
		for	( j = 0 ; j < MAX_CCASE ; j++ ) {
			if	( !lpEnv->kbd.sztATable[i][j][0] ) {
				continue;
			}
			printf(
				"vk (0x%04x)%04s%-15.15s %s",
				i, sztPrefix[j], GetStr(GS_VKTAG,i,0),
				lpEnv->kbd.sztATable[i][j]
			);
			printf("\n");
		}
		printf("\n");
		for	( i = 0 ; i < MAX_VK    ; i++ )
		for	( j = 0 ; j < MAX_CCASE ; j++ ) {
			if	( !lpEnv->kbd.sztKTable[i][j][0] ) {
				continue;
			}
			printf(
				"vk (0x%04x)%04s%-15.15s %s",
				i, sztPrefix[j], GetStr(GS_VKTAG,i,0),
				lpEnv->kbd.sztKTable[i][j]
			);
			printf("\n");
		}
		printf("\n");
	}
	if	( dwMode & ENVNOT_ROM ) {
		DUMPSTR(lpEnv->rom.sztRomFile);
		DUMPINT(lpEnv->rom.wRomFrom);
		DUMPINT(lpEnv->rom.wRomUpdate);
		DUMPINT(lpEnv->rom.wRomCount);
		printf("lpEnv->rom.sztImage\n");
		printf(lpEnv->rom.sztImage);
	}
	if	( dwMode & ENVNOT_DCI ) {
		DUMPINT(lpEnv->dci.wDicCount);
		DUMPINT(lpEnv->dci.wLearnDic);
		DUMPINT(lpEnv->dci.wKanaGaku);
		DUMPINT(lpEnv->dci.wEisuGaku);
#if PCUNIX
		DUMPSTR(lpEnv->dci.sztDicDat);
#endif
	}
	if	( dwMode & ENVNOT_DIC ) {
		for	( i = 0 ; i < MAX_DIC ; i++ ) {
			printf("Dic %d\n",i);
			DUMPSTR(lpEnv->dic[i].sztDicFile);
			DUMPSTR(lpEnv->dic[i].sztDicDesc);
			DUMPINT(lpEnv->dic[i].wLearnMode);
			DUMPINT(lpEnv->dic[i].wLearnType);
			DUMPINT(lpEnv->dic[i].wParallel);
		}
	}
	if	( dwMode & ENVNOT_ACI ) {
		DUMPINT(lpEnv->aci.wAccCount);
	}
	if	( dwMode & ENVNOT_ACC ) {
		for	( i = 0 ; i < lpEnv->aci.wAccCount ; i++ ) {
			printf("Acc %d\n",i);
			DUMPSTR(lpEnv->acc[i].sztAccFile);
			DUMPSTR(lpEnv->acc[i].sztAccLong);
			DUMPSTR(lpEnv->acc[i].sztAccShort);
		}
	}
	if	( dwMode & ENVNOT_WII ) {
#if !PCUNIX
		DUMPINT(lpEnv->wii.wScreenW);
		DUMPINT(lpEnv->wii.wScreenH);
#endif /* !PCUNIX */
		DUMPINT(lpEnv->wii.wWinCount);
		DUMPINT(lpEnv->wii.wMinimize);
		DUMPINT(lpEnv->wii.wOffHide);
	}
	if	( dwMode & ENVNOT_WIN ) {
		for	( i = 0 ; i < lpEnv->wii.wWinCount ; i++ ) {
#if !PCUNIX
			DUMPINT(lpEnv->win[i].rc.left);
			DUMPINT(lpEnv->win[i].rc.top);
			DUMPINT(lpEnv->win[i].rc.right);
			DUMPINT(lpEnv->win[i].rc.bottom);
#else /* !PCUNIX */
			DUMPINT(lpEnv->win[i].rStatus.x);
			DUMPINT(lpEnv->win[i].rStatus.y);
			DUMPINT(lpEnv->win[i].rStatus.w);
			DUMPINT(lpEnv->win[i].rStatus.h);
			DUMPINT(lpEnv->win[i].rPreeditRoot.x);
			DUMPINT(lpEnv->win[i].rPreeditRoot.y);
			DUMPINT(lpEnv->win[i].rPreeditRoot.w);
			DUMPINT(lpEnv->win[i].rPreeditRoot.h);
#endif /* !PCUNIX */
#if !PCUNIX
			DUMPINT(lpEnv->win[i].wPartsCount);
			printf("lpEnv->win[i].wParts ");
			for	(j = 0 ; j < lpEnv->win[i].wPartsCount ; j++) {
				printf("%d ",lpEnv->win[i].wParts[j]);
			}
#endif /* !PCUNIX */
			printf("\n");
		}
	}
	if	( dwMode & ENVNOT_SET ) {
#if !PCUNIX
		DUMPSTR(lpEnv->set.sztSetFile);
		DUMPINT(lpEnv->set.wSetFrom);
		DUMPINT(lpEnv->set.wSetUpdate);
		DUMPINT(lpEnv->set.wSetCount);
		for	( i = 0 ; i < lpEnv->set.wSetCount ; i++ ) {
			printf("Set %d ",i);
			for	( j = 0 ; j < MAX_STAGE ; j++ ) {
				printf("%d ",lpEnv->set.wFunc[i][j]);
			}
			printf("%s\n",lpEnv->set.sztDesc[i]);
		}
#endif /* !PCUNIX */
	}
	return;
}
#endif
