/******************************************************************************
	ENV.H
******************************************************************************/
/*=============================================================================
	define
=============================================================================*/
#define	NO		0
#define	YES		1
#define	AUTO		2
#define	DON		2
#define	HIRA		0
#define	KATA		1
#define	EISU		2
#define	ZEN		0
#define	HAN		1
#define	SJIS		0
#define	JIS		1
#define	KUTEN		2
#define	UCS4		3
#if PCUNIX
#define	EUC		4
#endif /* PCUNIX */
#define	ALL		3
#define	HON		2
#define	OKURI		1
#define	NON		0
#define	SAKI		0
#define	REN		1
#define	BETA		2
#define	BUN		0
#define	FUKU		1
#define	APL		0
#define	FLOW		1
#define	ITA		1
#define	BOL		2
#define	LEARNDIC	0
#define	MYSELF		1
#define	RELOAD		2
#define	SHRINK		2					/* +970121 */
#define	APPBAR		3

#if PCUNIX
#define	FIX		0
#define	APP		1
#define	YOKO		0
#define	TATE		1
#endif /* PCUNIX */

#if !PCUNIX
#define	KEYB		0
#define	FUNC		1
#define	COMP		2
#define	FONTS		4
#else /* !PCUNIX */
#define	FONTS		3
#endif /* !PCUNIX */

#define	KIGOS		31			/* Kigo Size 		     */

#define	LOAD_ERR	0
#define	LOAD_FULL	1
#define	LOAD_PROG	2
#define	LOAD_USER	3

#if PCUNIX
#define	YES_COMMA		0xa4
#define	YES_PERIOD		0xa1
#define	YES_SLASH		0xa5
#define	YES_HYPHEN		0xb0
#define	YES_BRACKETLEFT		0xa2
#define	YES_BRACKETRIGHT	0xa3
#define	YES_TEN			0x2c
#define	YES_MARU		0x2e

#define	AUTO_COMMA		0xff2c
#define	AUTO_PERIOD		0xff2e
#define	AUTO_SLASH		0xff2f
#define	AUTO_HYPHEN		0xff2d
#define	AUTO_TEN		0xffa4
#define	AUTO_MARU		0xffa1
#define	AUTO_KIGO_1ST		0xff
#endif /* PCUNIX */

#if PCUNIX
#define KANA14	"-misc-fixed-medium-r-normal--14-130-75-75-c-70-jisx0201.1976-0"
#define KANJI14	"-misc-fixed-medium-r-normal--14-130-75-75-c-140-jisx0208.1983-0"
#endif /* PCUNIX */

/*=============================================================================
	typedef
=============================================================================*/
#if PCUNIX
typedef	struct	_tagRECT {
	SHORT	x;
	SHORT	y;
	SHORT	w;
	SHORT	h;
} RECT;

typedef	struct	_tagLOGFONT {
	WORD	wFontType;
	TCHAR	sztKanaName[MAX_PATH];
	TCHAR	sztKanjiName[MAX_PATH];
} LOGFONT;
#endif /* PCUNIX */

/*=============================================================================
	INI	subStruc	[Ini]
=============================================================================*/
typedef	struct	_tagENVINI	{
#if !PCUNIX
#ifndef	DPMI
	TCHAR		sztWin[MAX_PATH + 1];	/* "C:\WINDOWS\"	     */
	TCHAR		sztUsr[MAX_PATH + 1];	/* "IIDA.USR" or ""	     */
	TCHAR		sztApp[MAX_PATH + 1];	/* "EXCEL"		     */
	TCHAR		sztVje[MAX_PATH + 1];	/* "D:\VJED95\"		     */
	TCHAR		sztVersion[16];		/* Сֹ	     */
	TCHAR		sztUserID1[64];		/* 桼ID1		     */
	TCHAR		sztUserID2[64];		/* 桼ID2		     */
	WORD		wUserNo;		/* IniեΥ桼ֹ */
	WORD		wUserCount;		/* Iniե桼 */
	WORD		wUserMark;		/* ޡƤYES     */
	WORD		wSaveAsUsr;	/* 桼̥ǥ쥯ȥ¸    */
	WORD		wSaveAsApp;	/* ץꥱ̥ե¸*/
	TCHAR		sztProgDir[MAX_PATH+1];	/* "D:\VJED95\PROG\"	     */
	TCHAR		sztUserDir[MAX_PATH+1];	/* "D:\VJED95\IIDA.USR\" or  */
						/* "D:\VJED95\COMMON\"	     */
	TCHAR		sztDatBase[MAX_PATH+1];	/* "EXCEL" or "DEFAULT"	     */
#else
	TCHAR		sztUsr[MAX_PATH + 1];	/* "IIDA.USR" or ""	     */
	TCHAR		sztVje[MAX_PATH + 1];	/* "D:\VJED95\"		     */
	TCHAR		sztProgDir[MAX_PATH+1];	/* "D:\VJED95\PROG\"	     */
	TCHAR		sztUserDir[MAX_PATH+1];	/* "D:\VJED95\IIDA.USR\" or  */
						/* "D:\VJED95\COMMON\"	     */
	TCHAR		sztDatBase[MAX_PATH+1];	/* "EXCEL" or "DEFAULT"	     */
#endif
#else /* !PCUNIX */
	TCHAR		sztUsr[MAX_PATH+1];	/* UserID(ex."root")       */
	TCHAR		sztVersion[16];		/* Version                 */
	TCHAR		sztEtcDir[MAX_PATH+1];	/* "/etc/vje30/"           */
	TCHAR		sztInsDir[MAX_PATH+1];	/* "/usr/local/vje30/"     */
	TCHAR		sztComDir[MAX_PATH+1];	/* "/usr/local/vje30/com/" */
	TCHAR		sztEnvDir[MAX_PATH+1];	/* "/usr/local/vje30/env/" */
	TCHAR		sztDicDir[MAX_PATH+1];	/* "/usr/local/vje30/dic/" */
	TCHAR		sztUsrDir[MAX_PATH+1];	/* "$HOME/.vje/"           */
	TCHAR		sztDatBase[MAX_PATH+1];	/* "general"               */
	TCHAR		sztAtwTitle[MAX_AWT_BUFF+1];
#endif /* !PCUNIX */
	}		ENVINI,FAR *LPENVINI;

/*=============================================================================
	Mode	subStruc	[Mode]
=============================================================================*/
typedef	struct	_tagENVMOD {
	WORD		wRoman;			/* ޻[YES/NO]	     */
	WORD		wMojiType;		/* ʸ[HIRA/KATA/EISU]    */
	WORD		wMojiSize;		/* ʸ[ZEN/HAN]	     */
	WORD		wOkuriKana;		/* [ALL/HON/OKURI/NON]   */
	WORD		wCode;			/* η[SJIS/JIS/KUTEN]*/
	WORD		wHenkan;		/* Ѵ[SAKI/REN/BETA]	     */
	WORD		wBunpou;		/* ʸˡ[BUN/FUKU]	     */
	WORD		wKougoConv;		/* Ѵ[YES/NO]	     */
	WORD		wKutouConv;		/* Ѵ[YES/NO]	     */
	WORD		wCalc;			/* ɽ׻⡼[YES/NO]	     */
	WORD		wHosei;			/* ϥߥ[YES/NO]	     */
	WORD		wYuragi;		/* 餮[YES/NO]	     */
#if !PCUNIX
	WORD		wKutenMode;		/* Ѵ[YES/NO]    */
#endif /* !PCUNIX */
#if	VERSION == 25
	WORD		wJisOnly;		/* ʣɣʸ[YES/NO]    */
#if !PCUNIX
	WORD		wKanaCtrl;		/* УФ̵	     */
						/* ʥå[YES/NO]  */
#endif /* !PCUNIX */
#endif
	}		ENVMOD,FAR *LPENVMOD;

/*=============================================================================
	Comp	subStruc	[Composition]
=============================================================================*/
typedef	struct	_tagENVFIX {
	WORD		wEisuFix;		/* ѿ[ZEN/HAN/AUTO]  */
	WORD		wKanaFix;		/* ʥ[ZEN/HAN/AUTO]  */
	WORD		wKigoFix[KIGOS];	/* 極[ZEN/HAN/AUTO]
						()	{}	[]	֡
						<>	.,		!
						"	#	$	%
						&	'	*	+
						-	/	:	;
						=	?	@	\
						^	_	`	|
						~		Space	     */
	}		ENVFIX,FAR *LPENVFIX;

/*=============================================================================
	Comp	subStruc	[Composition]
=============================================================================*/
typedef	struct	_tagENVCMP {
	WORD		wRank;			/* Ʊ		     */
						/* 0=¤ʤ 1-6 = 1-6ǯ  */
						/* 7=(ɤ) 8=(ɽ) */
	WORD		wKoyu;			/* ͭ̾ɽ[YES/NO]	     */
	WORD		wMark;			/* ޡɽ[YES/NO]	     */
#if !PCUNIX
	WORD		wSpot;			/* Ѵ[YES/NO]  */
#endif /* !PCUNIX */
#ifndef	DPMI
#if !PCUNIX
	WORD		wOwnFont;		/* ͭեȻ[YES/NO]  */
#endif /* !PCUNIX */
#endif
	}		ENVCMP,FAR *LPENVCMP;

/*=============================================================================
	Cand	subStruc	[Candidate]
=============================================================================*/
typedef	struct	_tagENVCAN {
	WORD		wStart;			/* ܹԲ		     */
#ifndef	DPMI
	WORD		wMatrix;		/* YES/ɽ NO/̾	     */
#if PCUNIX
	WORD		wDirection;		/* Ʊɽ          */
#endif /* PCUNIX */
	WORD		wDonLen;		/* Ʊɽλ(ɽ)    */
	WORD		wDonCol;		/* Ʊɽ(ɽ)    */
	WORD		wDonRow;		/* ƱɽιԿ(ɽ)    */
#if !PCUNIX
	WORD		wCodeLen;		/* ɽλ(ɽ)  */
	WORD		wCodeCol;		/* ɽ(ɽ)  */
	WORD		wCodeRow;		/* ɽιԿ(ɽ)  */
#endif /* !PCUNIX */
#endif
	}		ENVCAN,FAR *LPENVCAN;

/*=============================================================================
	Color	subStruc	[Color]
=============================================================================*/
typedef	struct _tagENVCLR {			/* Ķ ɽ	     */
	TCHAR		sztClrFile[MAX_PATH+1];	/* ե̾		     */
#ifndef	DPMI
	WORD		wClrFrom;		/* LOAD_xxx		     */
	WORD		wClrUpdate;		/* YES	     */
	WORD		wColChar;		/* ʸ		     */
	WORD		wColCursor;		/* 		     */
	WORD		wColConv;		/* ѴѤʸ		     */
	WORD		wColConvCur;		/* ʸ		     */
	WORD		wColConvTemp;		/* Ѵʸ		     */
	WORD		wColEdit;		/* Խʸ		     */
	WORD		wColList;		/* ꥹȥܥå	     */
	WORD		wColListCur;		/* ꥹȥܥå*/
	WORD		wColPopHelp;		/* ݥåץإʸ	     */
	WORD		wColBtn;		/* Btn طʿ		     */
	WORD		wColKbd;		/* Kbd طʿ		     */
	WORD		wColFnc;		/* Fnc طʿ		     */
#if !PCUNIX
	WORD		wColBox;		/* ѴBOX(̤)	     */
#endif /* !PCUNIX */
#endif
#if !PCUNIX
	WORD		wColCharDOS;		/* DOSBOXʸ	     */
	WORD		wColCursorDOS;		/* DOSBOXѥ	     */
	WORD		wColConvDOS;		/* DOSBOXѴѤʸ	     */
	WORD		wColConvCurDOS;		/* DOSBOXʸ	     */
	WORD		wColConvTempDOS;	/* DOSBOXѲѴʸ	     */
	WORD		wColEditDOS;		/* DOSBOXѺԽʸ	     */
	WORD		wColModeDOS;		/* ϥ⡼ɽ	     */
	WORD		wColDModeDOS;		/* ϥ⡼ɽ	     */
	WORD		wColGuidDOS;		/* ʸ	     */
#endif /* !PCUNIX */
	}		ENVCLR,FAR *LPENVCLR;

/*=============================================================================
	FNT	subStruc	[CompositionFont]/[KeyboardFont]
=============================================================================*/
#ifndef	DPMI
typedef	struct	_tagENVFNT {
	LOGFONT		lf;
	}		ENVFNT,FAR *LPENVFNT;
#endif

/*=============================================================================
	BTN	subStruc	[Button]
=============================================================================*/
#ifndef	DPMI
typedef	struct	_tagENVBTN {
	WORD		wBtnType;		/* ܥμ(IDP_xx)	     */
	WORD		wBtnSize;		/* ܥ礭	     */
	WORD		wPopHelp;		/* ݥåץإ[YES/NO]	     */
	WORD		wBtnCount;		/* ܥο		     */
	WORD		wBtnFunc[MAX_BTNTOP];	/* ƥܥ[=F_xx]	     */
	}		ENVBTN,FAR *LPENVBTN;
#endif

/*=============================================================================
	KBD	subStruc	[Keyboard]
=============================================================================*/
typedef	struct	_tagENVKBD {
#ifndef	DPMI
	WORD		wKbdType;		/* ܡɥ(KBD_xx)  */
#if !PCUNIX
	WORD		wKbdTypeV;	/* ӥ奢륭ܡ(KBD_xx)      */
	WORD		wRotArrow;		/* YES/Ľž  */
#endif /* !PCUNIX */
	WORD		wComma;			/* ,  [No/Yes/Auto]	     */
	WORD		wPeriod;		/* .  [No/Yes/Auto]	     */
	WORD		wSlash;			/* /  [No/Yes/Auto]	     */
	WORD		wHyphen;		/* -  [No/Yes/Auto]	     */
	WORD		wBracket;		/* [] [No/Yes]		     */
	WORD		wTen;			/*  [No/Yes]		     */
	WORD		wMaru;			/*  [No/Yes]		     */
	TCHAR		sztKeyFile[MAX_PATH + 1];
	WORD		wKeyFrom;		/* LOAD_xxx		     */
	WORD		wKeyUpdate;		/* KEYƤѹYES  */
	TCHAR		sztAchFile[MAX_PATH + 1];
	WORD		wAchFrom;		/* LOAD_xxx		     */
	WORD		wAchUpdate;		/* ACHƤѹYES  */
	TCHAR		sztKchFile[MAX_PATH + 1];
	WORD		wKchFrom;		/* LOAD_xxx		     */
	WORD		wKchUpdate;		/* KCHƤѹYES  */
	WORD		wVirtTable[MAX_VK][MAX_FCASE][MAX_STAGE        ];
	TCHAR		sztATable [MAX_VK][MAX_CCASE][MAX_SHORT_STR + 1];
	TCHAR		sztKTable [MAX_VK][MAX_CCASE][MAX_SHORT_STR + 1];
#else
	WORD		wKbdType;		/* ܡɥ(KBD_xx)  */
	WORD		wComma;			/* ,  [No/Yes/Auto]	     */
	WORD		wPeriod;		/* .  [No/Yes/Auto]	     */
	WORD		wSlash;			/* /  [No/Yes/Auto]	     */
	WORD		wHyphen;		/* -  [No/Yes/Auto]	     */
	WORD		wBracket;		/* [] [No/Yes]		     */
	WORD		wTen;			/*  [No/Yes]		     */
	WORD		wMaru;			/*  [No/Yes]		     */
	TCHAR		sztKeyFile[MAX_PATH + 1];
	TCHAR		sztAchFile[MAX_PATH + 1];
	TCHAR		sztKchFile[MAX_PATH + 1];
	WORD		wVirtTable[MAX_VK][MAX_FCASE][MAX_STAGE        ];
	TCHAR		sztATable [MAX_VK][MAX_CCASE][MAX_SHORT_STR + 1];
	TCHAR		sztKTable [MAX_VK][MAX_CCASE][MAX_SHORT_STR + 1];
#endif
	}		ENVKBD,FAR *LPENVKBD;

/*=============================================================================
	ROM	subStruc	[Roma]
=============================================================================*/
typedef	struct	_tagENVROM {
	TCHAR		sztRomFile[MAX_PATH + 1];
#ifndef	DPMI
	WORD		wRomFrom;		/* LOAD_xxx		     */
	WORD		wRomUpdate;		/* ROMƤѹYES  */
	WORD		wRomCount;
	TCHAR		sztImage[MAX_ROMA_SIZE + 1];
#endif
	}		ENVROM,FAR *LPENVROM;

/*=============================================================================
	DIC	subStruc	[DicInfo]	[DicN]
=============================================================================*/
typedef	struct	_tagENVDCI	{
	WORD		wDicCount;		/* Always 10		     */
	WORD		wLearnDic;		/* Always 9		     */
	WORD		wKanaGaku;		/* Ͽ[YES/NO]	     */
	WORD		wEisuGaku;		/* ѿϿ[YES/NO]	     */
#if PCUNIX
	TCHAR		sztDicDat[MAX_PATH + 1];/* vjed95e.dat		     */
#endif /* PCUNIX */
	}		ENVDCI,FAR *LPENVDCI;

typedef	struct	_tagENVDIC	{
	TCHAR		sztDicFile[MAX_PATH+1];	/* ե̾	     */
#ifndef	DPMI
	TCHAR		sztDicDesc[MAX_PATH+1];	/* إåΥȥ	     */
#endif
	WORD		wLearnMode;		/* ؽ⡼[YES/NO/DON]    */
	WORD		wLearnType;		/* ؽ[LEARNDIC/MYSELF]   */
	WORD		wParallel;		/* 󼭽[YES/NO]	     */
	}		ENVDIC,FAR *LPENVDIC;

/*=============================================================================
	ACC	subStruc	[AccInfo]	[AccN]
=============================================================================*/
#ifndef	DPMI
typedef	struct	_tagENVACI	{
	WORD		wAccCount;		/* 0 ~ MAX_ACC - 1	     */
	}		ENVACI,FAR *LPENVACI;

typedef	struct	_tagENVACC	{
	TCHAR		sztAccFile [MAX_PATH+1];/* ե̾	     */
	TCHAR		sztAccLong [MAX_LONG_STR +1];	/* Ĺ	     */
	TCHAR		sztAccShort[MAX_SHORT_STR+1];	/* û	     */
	} ENVACC,FAR *LPENVACC;
#endif

/*=============================================================================
	WIN	subStruc	[WinInfo]	[WinN]
=============================================================================*/
#ifndef	DPMI
typedef	struct	_tagENVWII	{
#if !PCUNIX
	WORD		wScreenW;		/* ̤		     */
	WORD		wScreenH;		/* ̤		     */
#endif /* !PCUNIX */
	WORD		wWinCount;		/* ο		     */
	WORD		wMinimize;		/* YES/Ǿ		     */
	WORD		wOffHide;		/* YES/Hide when off	     */
	}		ENVWII,FAR *LPENVWII;
typedef	struct	_tagENVWIN	{
#if !PCUNIX
	RECT		rc;			/* ɽ		     */
#else /* !PCUNIX */
	RECT		rStatus;		/* ɽ		     */
	RECT		rPreeditRoot;		/* ɽ		     */
#endif /* !PCUNIX */
#if !PCUNIX
#if	VERSION == 25
	WORD		wLocate;		/* ϣΣϣƣƥܥ	     */
	WORD		wEdge;			/* å֡APPBARб)   */
#endif
	WORD		wPartsCount;		/* ѡĤο		     */
	WORD		wParts[MAX_PARTS];	/* ѡֹꥹ(PARTS_xx)*/
#endif /* !PCUNIX */
	}		ENVWIN,FAR *LPENVWIN;
#endif

#if !PCUNIX
/*=============================================================================
	Set	subStruc	[For SetEnv]
=============================================================================*/
#ifndef	DPMI
typedef	struct	_tagENVSET	{
	TCHAR		sztSetFile[MAX_PATH + 1];
	WORD		wSetFrom;		/* LOAD_xxx		     */
	WORD		wSetUpdate;		/* SETƤѹYES  */
	WORD		wSetCount;
	WORD		wFunc  [MAX_SET][MAX_STAGE];
	TCHAR		sztDesc[MAX_SET][MAX_LONG_STR + 1];
	}		ENVSET,FAR *LPENVSET;
#endif
#endif /* !PCUNIX */

/*=============================================================================
	DOS	subStruc	[For SetEnv]
=============================================================================*/
typedef	struct	_tagENVDOS	{
	WORD		wOldVje;		/* NO YES		     */
	WORD		wAXMode;		/* NO YES		     */
	WORD		wRedrawSpot;		/* NO YES		     */
	WORD		wIAEHandles;		/* 1..9 default 5 (IAS)	     */
	}		ENVDOS,FAR *LPENVDOS;

/*=============================================================================
	Main	Struc
=============================================================================*/
typedef	struct	_tagENV	{
	ENVINI		ini;
	ENVMOD		mod;
	ENVFIX		fix;
	ENVCMP		cmp;
	ENVCAN		can;
	ENVCLR		clr;
#ifndef	DPMI
	ENVFNT		fnt[FONTS];
	ENVBTN		btn;
#endif
	ENVKBD		kbd;
	ENVROM		rom;
	ENVDCI		dci;
	ENVDIC		dic[MAX_DIC];
#ifndef	DPMI
	ENVACI		aci;
	ENVACC		acc[MAX_ACC];
	ENVWII		wii;
	ENVWIN		win[MAX_WIN];
#if !PCUNIX
	ENVSET		set;
#endif /* !PCUNIX */
#endif
#ifdef	DPMI
	ENVDOS		dos;
#endif
	}		ENV,FAR *LPENV;

/*=============================================================================
	Function	Prototype
=============================================================================*/
int	WINAPI	LoadStyFile(LPENV lpEnv,LPTSTR lptFile);
int	WINAPI	LoadClrFile(LPENV lpEnv,LPTSTR lptFile);
int	WINAPI	LoadKeyFile(LPENV lpEnv,LPTSTR lptFile);
int	WINAPI	LoadRomFile(LPENV lpEnv,LPTSTR lptFile);
int	WINAPI	LoadAchFile(LPENV lpEnv,LPTSTR lptFile);
int	WINAPI	LoadKchFile(LPENV lpEnv,LPTSTR lptFile);
#if !PCUNIX
int	WINAPI	LoadSetFile(LPENV lpEnv,LPTSTR lptFile);
#endif /* !PCUNIX */
int	WINAPI	SaveStyFile(LPENV lpEnv,LPTSTR lptFile);
int	WINAPI	SaveClrFile(LPENV lpEnv,LPTSTR lptFile);
int	WINAPI	SaveKeyFile(LPENV lpEnv,LPTSTR lptFile);
int	WINAPI	SaveRomFile(LPENV lpEnv,LPTSTR lptFile);
int	WINAPI	SaveAchFile(LPENV lpEnv,LPTSTR lptFile);
int	WINAPI	SaveKchFile(LPENV lpEnv,LPTSTR lptFile);
#if !PCUNIX
int	WINAPI	SaveSetFile(LPENV lpEnv,LPTSTR lptFile);
#endif /* !PCUNIX */
int	WINAPI	CheckEnv(LPENV lpEnv,LPENV lpEnvO);
void	WINAPI	MakeDefaultEnv(LPENV lpEnv);

/*=============================================================================
	For	VJED95S.DLL
=============================================================================*/
//	ʲΣĤIMM.HInclude
//	IME_CONFIG_GENERAL
//	IME_CONFIG_REGISTERWORD
//	IME_CONFIG_SELECTDICTIONARY
#define	IME_CONFIG_OWN_START		0x80000000
#define	IME_CONFIG_OWN_REGWORD		(IME_CONFIG_OWN_START+1)
#define	IME_CONFIG_OWN_DELWORD		(IME_CONFIG_OWN_START+2)
#define	IME_CONFIG_OWN_CHAR		(IME_CONFIG_OWN_START+3)
#define	IME_CONFIG_OWN_FUNC		(IME_CONFIG_OWN_START+4)
#define	IME_CONFIG_OWN_BTNPROP		(IME_CONFIG_OWN_START+5)
#define	IME_CONFIG_OWN_KBDPROP		(IME_CONFIG_OWN_START+6)
#define	IME_CONFIG_OWN_FUNCPROP		(IME_CONFIG_OWN_START+7)
#define	IME_CONFIG_OWN_BOXPROP		(IME_CONFIG_OWN_START+8)
#define	IME_CONFIG_OWN_VERSION		(IME_CONFIG_OWN_START+9)

/*-----------------------------------------------------------------------------
	Interface	Function
-----------------------------------------------------------------------------*/
int	WINAPI	SetEnv			/* IDOK or IDCANCEL		     */
(
	HWND	hwndParent,		/* ƥɥϥɥ		     */
	DWORD	dwMode,			/* ⡼(IME_CONFIG_xxx)	     */
	LPVOID	lpVoid,			/* ɲåǡ(CHAR,FUNCλ,VK_xx    */
	LPENV	lpEnv,			/* Ķǡ¤Υݥ	     */
	HWND	hwndNotify,		/* 襦ɥϥɥ	     */
	UINT	uMsgNotify		/* Υåֹ		     */
);
/*
	OK򲡤졢IME ȿǤ򤵤ΤϰʲΤ褦˹Ԥ

	SendMessage(hwndNotify,		 Υɥ(ƽлhwndNotify)
		    uMsgNotify,		 Υå(ƽлuMsgNotify)
		    (WPARAM) wEnvNot,	 ENVNOT_xxxȤ߹碌
		    (LPARAM)(DWORD)lpEnv EnvؤΥݥ
		   );
*/
#define	ENVNOT_SAVE	0x00000001
#define	ENVNOT_INI	0x00000002
#define	ENVNOT_MOD	0x00000004
#define	ENVNOT_FIX	0x00000008
#define	ENVNOT_CMP	0x00000010
#define	ENVNOT_CAN	0x00000020
#define	ENVNOT_CLR	0x00000040
#define	ENVNOT_FNT	0x00000080
#define	ENVNOT_BTN	0x00000100
#define	ENVNOT_KBD	0x00000200
#define	ENVNOT_DCI	0x00000400
#define	ENVNOT_DIC	0x00000800
#define	ENVNOT_ACI	0x00001000
#define	ENVNOT_ACC	0x00002000
#define	ENVNOT_WII	0x00004000
#define	ENVNOT_WIN	0x00008000
#define	ENVNOT_ROM	0x00010000
#define	ENVNOT_SET	0x00010000

/*=============================================================================
	For	DEBUG
=============================================================================*/
void	WINAPI	DumpEnv(LPENV lpEnv,DWORD dwMode);
