/******************************************************************************
	GetStr.C
******************************************************************************/
#if !PCUNIX
#include	"define.h"
#ifndef	DPMI
#include	<windows.h>
#else
#include	"typedef.h"
#include	"vkorg.h"
#endif
#include	"vksub.h"
#include	"vjed95i.h"			/*	For KBD_xx	*/
#include	"vjectrl.h"
#include	"strutl.h"
#include	"getstr.h"
#else /* !PCUNIX */
#include	<stdlib.h>
#include	<X11/keysym.h>
#include	"typedef.h"
#include	"vjeenv.h"
#include	"vjectrl.h"
#include	"strutl.h"
#include	"getstr.h"
#endif /* !PCUNIX */

/*=============================================================================
	define
=============================================================================*/
#define	recof(x)	((sizeof x)/(sizeof x[0]))

/*=============================================================================
	struc
=============================================================================*/
/*-----------------------------------------------------------------------------
	FK Structure
-----------------------------------------------------------------------------*/
typedef	struct	_tagFKS	{
	WORD	wFunc;
	LPTSTR	lptTag;
	LPTSTR	lptShort;
#ifndef	DPMI
	LPTSTR	lptLong;
	LPTSTR	lptButton;
	LPTSTR	lptBtnTog;
	LPTSTR	lptDesc;
#endif
	DWORD	dwPrc;
	}	FKS,FAR *LPFKS;

/*-----------------------------------------------------------------------------
	KBDSTR Structure
-----------------------------------------------------------------------------*/
typedef	struct	_tagKBDSTR	{
#ifndef	DPMI
	LPTSTR	lptStr;
#endif
	LPTSTR	lptChr;
	}	KBDSTR,FAR *LPKBDSTR;

/*-----------------------------------------------------------------------------
	VK Structure
-----------------------------------------------------------------------------*/
typedef	struct	_tagVKS		{
	WORD	wVirt;
	LPTSTR	lptTag;
	KBDSTR	kbdStr[5];
	}	VKS,FAR *LPVKS;

/*=============================================================================
	local	data
=============================================================================*/
/*-----------------------------------------------------------------------------
	FK
-----------------------------------------------------------------------------*/
static	FKS	FAR FKTable[]	= {
#ifndef	DPMI
#include	"fk.h"
#else
#include	"fkdos.h"
#endif
	};
#define	LEN_FK		recof(FKTable)
#define	SIZ_LPFKS	sizeof(LPFKS)

/*-----------------------------------------------------------------------------
	VK
-----------------------------------------------------------------------------*/
static	VKS	FAR VKTable[]	= {
#ifndef	DPMI
#include	"vk.h"
#else
#include	"vkdos.h"
#endif
	};
#define	LEN_VK		recof(VKTable)
#define	SIZ_LPVKS	sizeof(LPVKS)

/*-----------------------------------------------------------------------------
	For	Search
-----------------------------------------------------------------------------*/
static	LPFKS	lpFKSFunc[LEN_FK];
static	LPFKS	lpFKSTag [LEN_FK];
static	LPVKS	lpVKSVirt[LEN_VK];
static	LPVKS	lpVKSTag [LEN_VK];

/*=============================================================================
	fkscmpf
=============================================================================*/
int	_cdecl	fkscmpf(const void *arg1,const void *arg2)
{
	LPFKS	lpFKS1,lpFKS2;

	lpFKS1	= (*(LPFKS FAR *)arg1);
	lpFKS2	= (*(LPFKS FAR *)arg2);
	return	(int)(lpFKS1->wFunc - lpFKS2->wFunc);
}

/*=============================================================================
	fkscmpt
=============================================================================*/
int	_cdecl	fkscmpt(const void *arg1,const void *arg2)
{
	LPFKS	lpFKS1,lpFKS2;

	lpFKS1	= (*(LPFKS FAR *)arg1);
	lpFKS2	= (*(LPFKS FAR *)arg2);
#if !PCUNIX
	return	lstrcmpi(lpFKS1->lptTag,lpFKS2->lptTag);
#else /* !PCUNIX */
	return	lstrcmp(lpFKS1->lptTag,lpFKS2->lptTag);
#endif /* !PCUNIX */
}

/*=============================================================================
	vkscmpv
=============================================================================*/
int	_cdecl	vkscmpv(const void *arg1,const void *arg2)
{
	LPVKS	lpVKS1,lpVKS2;

	lpVKS1	= (*(LPVKS FAR *)arg1);
	lpVKS2	= (*(LPVKS FAR *)arg2);
	return	(int)(lpVKS1->wVirt - lpVKS2->wVirt);
}

/*=============================================================================
	vkscmpt
=============================================================================*/
int	_cdecl	vkscmpt(const void *arg1,const void *arg2)
{
	LPVKS	lpVKS1,lpVKS2;

	lpVKS1	= (*(LPVKS FAR *)arg1);
	lpVKS2	= (*(LPVKS FAR *)arg2);
#if !PCUNIX
	return	lstrcmpi(lpVKS1->lptTag,lpVKS2->lptTag);
#else /* !PCUNIX */
	return	lstrcmp(lpVKS1->lptTag,lpVKS2->lptTag);
#endif /* !PCUNIX */
}

/*=============================================================================
	StrSetup
=============================================================================*/
static	int	StrSetup(void)
{
static	int	ret	= FALSE;
	int	i;

	if	( !ret ) {
		ret	= TRUE;
		for	( i = 0 ; i < LEN_FK ; i++ ) {
			lpFKSFunc[i]	= &FKTable[i];
			lpFKSTag [i]	= &FKTable[i];
		}
		for	( i = 0 ; i < LEN_VK ; i++ ) {
			lpVKSVirt[i]	= &VKTable[i];
			lpVKSTag [i]	= &VKTable[i];
		}
#ifndef	DPMI
		qsort((LPVOID)lpFKSFunc,LEN_FK,SIZ_LPFKS,fkscmpf);
		qsort((LPVOID)lpFKSTag ,LEN_FK,SIZ_LPFKS,fkscmpt);
		qsort((LPVOID)lpVKSVirt,LEN_VK,SIZ_LPVKS,vkscmpv);
		qsort((LPVOID)lpVKSTag ,LEN_VK,SIZ_LPVKS,vkscmpt);
#endif
	}
	return	ret;
}

/*=============================================================================
	GetStr
=============================================================================*/
LPTSTR	WINAPI	GetStr(UINT uType,UINT uKey,UINT uOpt)
{
	LPVOID	lpv;
	LPCVOID	lpcv;
	FKS	fks;
	LPFKS	lpFKS;
	VKS	vks;
	LPVKS	lpVKS;
	LPTSTR	ret;
	int	i;

	StrSetup();
	ret	= NULL;
	switch	( uType ) {
	case	GS_FKTAG:
	case	GS_FKSHORT:
	case	GS_FKLONG:
	case	GS_FKBUTTON:
	case	GS_FKDESC:
		fks.wFunc	= uKey;
		lpFKS		= &fks;
		lpv		= (LPVOID ) &lpFKS;
		lpcv		= (LPCVOID) &lpFKSFunc[0];
#ifndef	DPMI
		lpv		= bsearch(lpv,lpcv,LEN_FK,SIZ_LPFKS,fkscmpf);
#else
		lpv		= lsearch(lpv,lpcv,LEN_FK,SIZ_LPFKS,fkscmpf);
#endif
		if	( lpv ) {
			lpFKS	= *(LPFKS FAR *)lpv;
			switch	(uType) {
			case	GS_FKTAG:
				ret	= lpFKS->lptTag;
				break;
			case	GS_FKSHORT:
				ret	= lpFKS->lptShort;
				break;
#ifndef	DPMI
			case	GS_FKLONG:
				ret	= lpFKS->lptLong;
				break;
			case	GS_FKBUTTON:
				ret	= lpFKS->lptButton;
				break;
			case	GS_FKDESC:
				ret	= lpFKS->lptDesc;
				break;
#endif
			}
		}
		break;
	case	GS_VKTAG:
	case	GS_VKSTRING:
	case	GS_VKCHAR:
#if !PCUNIX
		vks.wVirt	= uKey;
#else /* !PCUNIX */
		vks.wVirt	= ConvVK (uKey);
#endif /* !PCUNIX */
		lpVKS		= &vks;
		lpv		= (LPVOID ) &lpVKS;
		lpcv		= (LPCVOID) &lpVKSVirt[0];
#ifndef	DPMI
		lpv		= bsearch(lpv,lpcv,LEN_VK,SIZ_LPVKS,vkscmpv);
#else
		lpv		= lsearch(lpv,lpcv,LEN_VK,SIZ_LPVKS,vkscmpv);
#endif
		if	( lpv ) {
			lpVKS	= *(LPVKS FAR *)lpv;
			if	( uType != GS_VKTAG ) {
				switch	(uOpt) {
				case	KBD_101:
					i	= 0;
					break;
				case	KBD_AX:
					i	= 1;
					break;
				case	KBD_002:
					i	= 2;
					break;
				case	KBD_A01:
					i	= 3;
					break;
				case	KBD_PC98:
					i	= 4;
					break;
				default:
					i	= 0;
					break;
				}
			}
			switch	(uType) {
			case	GS_VKTAG:
				ret	= lpVKS->lptTag;
				break;
#ifndef	DPMI
			case	GS_VKSTRING:
				ret	= lpVKS->kbdStr[i].lptStr;
				break;
#endif
			case	GS_VKCHAR:
				ret	= lpVKS->kbdStr[i].lptChr;
				break;
			}
		}
		break;
	}
	if	( !ret ) {
		ret	= TEXT("");
	}
	return	ret;
}

/*=============================================================================
	GetVal
=============================================================================*/
DWORD	WINAPI	GetVal(UINT uType,UINT uKey,UINT uOpt)
{
	LPVOID	lpv;
	LPCVOID	lpcv;
	FKS	fks;
	LPFKS	lpFKS;
	DWORD	ret;

	StrSetup();
	ret	= (DWORD) uOpt;
	switch	( uType ) {
	case	GV_FKPRC:
		fks.wFunc	= uKey;
		lpFKS		= &fks;
		lpv		= (LPVOID ) &lpFKS;
		lpcv		= (LPCVOID) &lpFKSFunc[0];
#ifndef	DPMI
		lpv		= bsearch(lpv,lpcv,LEN_FK,SIZ_LPFKS,fkscmpf);
#else
		lpv		= lsearch(lpv,lpcv,LEN_FK,SIZ_LPFKS,fkscmpf);
#endif
		if	( lpv ) {
			lpFKS	= *(LPFKS FAR *)lpv;
			switch	(uType) {
			case	GV_FKPRC:
				ret	= lpFKS->dwPrc;
				break;
			}
		}
		break;
	}
	return	ret;
}

/*=============================================================================
	GetStrKey	(Only GS_FKTAG/GS_VKTAG)
=============================================================================*/
UINT	WINAPI	GetStrKey(UINT uType,LPTSTR lptKey,UINT uOpt)
{
	LPVOID	lpv;
	LPCVOID	lpcv;
	FKS	fks;
	LPFKS	lpFKS;
	VKS	vks;
	LPVKS	lpVKS;
	UINT	ret;

	StrSetup();
	ret	= 0;
	if	( uType == GS_FKTAG ) {
		ret		= F_FKEY;
		fks.lptTag	= lptKey;
		lpFKS		= &fks;
		lpv		= (LPVOID ) &lpFKS;
		lpcv		= (LPCVOID) &lpFKSTag[0];
#ifndef	DPMI
		lpv		= bsearch(lpv,lpcv,LEN_FK,SIZ_LPFKS,fkscmpt);
#else
		lpv		= lsearch(lpv,lpcv,LEN_FK,SIZ_LPFKS,fkscmpt);
#endif
		if	( lpv ) {
			ret	= (*(LPFKS FAR *)lpv)->wFunc;
		}
	}
	else if	( uType == GS_VKTAG ) {
		ret		= 0;
		vks.lptTag	= lptKey;
		lpVKS		= &vks;
		lpv		= (LPVOID)  &lpVKS;
		lpcv		= (LPCVOID) &lpVKSTag[0];
#ifndef	DPMI
		lpv		= bsearch(lpv,lpcv,LEN_VK,SIZ_LPVKS,vkscmpt);
#else
		lpv		= lsearch(lpv,lpcv,LEN_VK,SIZ_LPVKS,vkscmpt);
#endif
		if	( lpv ) {
#if !PCUNIX
			ret	= (*(LPVKS FAR *)lpv)->wVirt;
#else /* !PCUNIX */
			ret	= ConvVK ((*(LPVKS FAR *)lpv)->wVirt);
#endif /* !PCUNIX */
		}
	}
	return	ret;
}
