/******************************************************************************
	Strdef.C
******************************************************************************/
#include "vjeenvinc.h"

unsigned char ___kanjitbl[257] = { 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0,
	2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	2, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
	14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
	14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
	14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
	7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
	7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 4, 4, 0	};


/*=============================================================================
	AsciiToUshort
=============================================================================*/
int	AsciiToUshort
(
	unsigned short	*out,
	unsigned char	*in
)
{
	unsigned short	*top_of_out;
	int		wk;

	top_of_out = out;
	while (wk = *in++) {
		*out++ = (unsigned short )((wk<0x80) ? wk: ((wk<<8)|*in++));
	}
	*out = (unsigned short )0;
	return ((int )(out - top_of_out));
}

/*=============================================================================
	euc2jis
	EUC  JIS ؤѴ
	Ⱦѥʤ
	ͤʸ
=============================================================================*/
short	euc2jis
(
	unsigned char	*out,
	unsigned char	*str
)
{
	short 	i;
	short	cnt = 0;
	for (i=0; str[i] != 0; i++) {
		if (str[i] & 0x80) {
			if (str[i] == EUC_kanashift) {
				*out++ = (str[i + 1] & 0xff);
				cnt ++;
			} else {
				*out++ = (str[i] & 0x7f);
				*out++ = (str[i + 1] & 0x7f);
				cnt ++;
			}
			i++;
		} else {
			*out++ = str[i];
			cnt ++;
		}	
	}
	return cnt;
}

/*=============================================================================
	sjis2euc
	Shift-JIS  EUC(char )ؤѴ
	Ⱦѥʤ(1byte -->2byte)
=============================================================================*/
char	*sjis2euc
(
	char *str
)
{
	unsigned hi, lo, c1, c2;
	unsigned char *buf, *dst;

	if (str == NULL) {
		return NULL;
	}
	buf = dst = (unsigned char *)XtMalloc((unsigned)(strlen(str) + 1) * 2);

	while (*str) {
		if (issjiskanji(*(unsigned char *)str)) {
			c1 = *(unsigned char *)str++;
			c2 = *(unsigned char *)str++;
			hi = c1 << 1;
			if (c1 < 0xa0 && 0x9e < c2)
				hi -= 0xe0;
			else if (c1 < 0xa0 && c2 < 0x9f)
				hi -= 0xe1;
			else if (0xdf < c1 && 0x9e < c2)
				hi -= 0x160;
			else if (0xdf < c1 && c2 < 0x9f)
				hi -= 0x161;
			if (hi % 2 == 0)
				lo = c2 - 0x7e;
			else {
				if (c2 < 0x7f)
					lo = c2 - 0x1f;
				else
					lo = c2 - 0x20;
			}
			*dst++ = hi | 0x80;
			*dst++ = lo | 0x80;
		} else if (issjiskana(*(unsigned char *)str)) {
			*dst++ = EUC_kanashift;
			*dst++ = *(unsigned char *)str++;
		} else {
			*dst++ = *(unsigned char *)str++;
		}
	}
	*dst = '\0';
	return ((char *)buf);
}

/*=============================================================================
	euc2sjis
	EUC(char )  Shift-JIS Ѵ
	Ⱦѥʤ(2byte --> 1byte)
=============================================================================*/
char	*euc2sjis
(
	char	*str
)
{
	unsigned hi, lo, c1, c2;
	unsigned char *buf, *dst;

	if (str == NULL) {
		return NULL;
	}
	buf = dst = (unsigned char *)XtMalloc(strlen(str) + 1);

	while (*str) {
		if (iseuckanji(*(unsigned char *)str)) {
			c1 = *(unsigned char *)str++ & 0x7f;
			c2 = *(unsigned char *)str++ & 0x7f;
			hi = (c1 - 1) / 2;
			lo = c2 + 0x1f;
			if (c1 % 2 == 0)
				lo += 0x5e;
			if (lo >= 0x7f)
				lo++;
			if (hi < 0x2f)
				hi += 0x71;
			else
				hi += 0xb1;
			*dst++ = hi;
			*dst++ = lo;
		} else if (iseuckana(*(unsigned char *)str)) {
			str++;
			*dst++ = *(unsigned char *)str++;
		} else {
			*dst++ = *(unsigned char *)str++;
		}
	}
	*dst = '\0';
	return ((char *)buf);
}

/*=============================================================================
	EUC_To_CompoundText
	EUC(USHORT)  CompoundText ؤѴ
	˳ʸ˻Ѥ
=============================================================================*/
int	EUC_To_CompoundText
(
	unsigned char	*out,
	unsigned short	*in,
	int		in_length
)
{
    unsigned char	*top_of_out = out;
#define output(a)	     *out++ = (a)
#define setJISX0201L_ascii() output(0x1b),output(0x28),output(0x4a)
#define setJISX0201R_kana()  output(0x1b),output(0x29),output(0x49)
#define setJISX0208_kanji()  output(0x1b),output(0x24),output(0x29),output(0x42)
    enum	_GL_code { ISO8859L_ascii, JISX0201L_ascii }
		 GL_code = ISO8859L_ascii;
    enum	_GR_code { ISO_Lation1R,   JISX0201R_kana, JISX0208_kanji }
    		 GR_code = ISO_Lation1R;
    int 	work;
	
    while( (work = *in++) != 0 && in_length-- > 0 ) {
	if( work < 0x20 ) {
	    if( work == 0x09 || work == 0x0a )
		output( work );
    	} else if ( work < 0x80 ) {
		if( GL_code != JISX0201L_ascii ) {
			GL_code = JISX0201L_ascii;
    		 	GR_code = ISO_Lation1R;/*991201*/
			setJISX0201L_ascii();
		}
	    	output( work );
	}
	else if( work < 0x100 ) {
		if( GR_code != JISX0201R_kana ) {
			GR_code = JISX0201R_kana;
		 	GL_code = ISO8859L_ascii;/*991201*/
			setJISX0201R_kana();
	    	}
	    	output( work );
    	}
	else {
	    	if( GR_code != JISX0208_kanji ) {
			GR_code = JISX0208_kanji;
		 	GL_code = ISO8859L_ascii;/*991201*/
			setJISX0208_kanji();
			}
	    	output( (work & 0xff00) >> 8 );
	    	output(  work & 0x00ff );
	}
    }
    *out = 0x00;
    return( (int)(out - top_of_out ) );
}

/*=============================================================================
	ShiftjisToUshortEuc
	Shift-JIS  EUC(USHORT)ؤѴ
=============================================================================*/
short	ShiftjisToUshortEuc
(
	unsigned short	*out_buff,
	unsigned char	*in_buff
)
{
	char	*work;
	short	cnt;

	work	= sjis2euc ((char *)in_buff);
	cnt	= AsciiToUshort (out_buff, work);
	XtFree (work);
	return (cnt);
}

/*=============================================================================
	ShiftjisToEuc
	Shift-JIS  EUC(UCHAR)ؤѴ
=============================================================================*/
short	ShiftjisToEuc
(
	unsigned char	*out_buff,
	unsigned char	*in_buff
)
{
	char	*work;
	short	cnt;

	work	= sjis2euc ((char *)in_buff);
	cnt	= lstrlen (work);
	lstrcpy (out_buff, (unsigned char *)work);
	XtFree (work);
	return (cnt);
}

/*=============================================================================
	ShiftjisToJis
	Shift-JIS  JIS(UCHAR)ؤѴ
	ɽؿؤΥǡ(X11R5)
=============================================================================*/
short	ShiftjisToJis
(
	unsigned char	*out_buff,
	unsigned char	*in_buff
)
{
	char	*work;
	short	cnt;

	work	= sjis2euc ((char *)in_buff);
	cnt	= euc2jis (out_buff, (unsigned char *)work);
	XtFree (work);
	return (cnt);
}

/*=============================================================================
	EucToShiftjis
	EUC(UCHAR)  Shift-JISؤѴ
=============================================================================*/
short	EucToShiftjis
(
	unsigned char	*out_buff,
	unsigned char	*in_buff
)
{
	char	*work;
	short	cnt;

	work	= euc2sjis ((char *)in_buff);
	cnt	= lstrlen (work);
	lstrcpy (out_buff, (unsigned char *)work);
	XtFree (work);
	return (cnt);
}

/*=============================================================================
	EucJstrLen
=============================================================================*/
int	EucJstrLen
(
	unsigned char	*data
)
{
	int i, j, k;

	k = lstrlen (data);
	for (i=0,j=0; i < k; i++,j++) {
		if (*(data + i) == EUC_kanashift
		 || *(data + i) & 0x80) {
			i++;
		}
	}
	return (j);
}

/*=============================================================================
	EucJstrCpy
=============================================================================*/
int	EucJstrCpy
(
	unsigned char	*out,
	unsigned char	*in,
	int		len
)
{
	int i, j, k;

	k = lstrlen (in);
	for (i=0,j=0; i < k && j < len; j++) {
		if (*(in + i) == EUC_kanashift
		 || *(in + i) & 0x80) {
			*(out + i) = *(in + i++);
			*(out + i) = *(in + i++);
		} else {
			*(out + i) = *(in + i++);
		}
	}
	*(out + i) = (unsigned char )0;
	return (i);
}

