/*
**	strdef.h
**
**	Create XmString
**
*/

typedef enum {
	codeset_default,
	codeset_sjis,
	codeset_euc
} codeset_t;
extern codeset_t codeset;

extern unsigned char ___kanjitbl[257];
#define EUC_kanashift   0x8e
#define issjiskanji(c)	(___kanjitbl[(c) + 1] & 1)
#define issjiskanji2(c)	(___kanjitbl[(c) + 1] & 2)
#define iseuckanji(c)	(___kanjitbl[(c) + 1] & 4)
#define issjiskana(c)	(___kanjitbl[(c) + 1] & 8)
#define iseuckana(c)	((c) == EUC_kanashift)
#define iskanji(c)	(___kanjitbl[(c) + 1] & 1)
#define iskanji2(c)	(___kanjitbl[(c) + 1] & 2)

#define mk_xmstr_from_euc(s)	make_xmstring((s), codeset_euc)
#define mk_xmstr_from_sjis(s)	make_xmstring((s), codeset_sjis)

#define mk_xmstr(s)		make_xmstring((s), codeset_sjis)

#define mk_titlestr(s)		(codeset == codeset_euc ? sjis2euc(s) : s)

#if NeedFunctionPrototypes
char *sjis2euc(char *);
char *euc2sjis(char *);
#else
char *sjis2euc();
char *euc2sjis();
#endif

