/*
**	structio.h	environment setup structure i/o unit
*/


typedef char const *VjeStrucBackup_t;

typedef struct {
	int doucnt;
	unsigned char box[6];
	unsigned char toggle[3];
	unsigned char keybind[7];
} envstruc_t;

extern char WhiteSpace[];
extern const int num_func;
extern const int num_editkey;
#define NUM_SHIFTKEY	3

typedef struct {
 	unsigned foreground;
 	unsigned background;
} colors_t;

typedef struct {
	unsigned char shift;
	unsigned char ekey;
} key_set_t;

typedef struct {
	int cnt;
	int oldflg;
	key_set_t keys[KEY_MATRIX];
} priority_table_t;

typedef struct {
	unsigned shift_sense;
	unsigned key_index;
} key_index_t;

typedef struct {
	int cnt;
	key_index_t keys[KEY_MATRIX];
} func_def_t;

#define KEYDEF_TOGGLE_BIT	0x80U
#define KEYDEF_OK		0x0000U
#define KEYDEF_OK_TOGGLE	0x0100U
#define KEYDEF_EXT		0x8000U
#define KEYDEF_NULL		(KEYDEF_EXT | 0x0100U)
#define KEYDEF_REDEF		(KEYDEF_EXT | 0x0200U)
#define KEYDEF_RESERVED		(KEYDEF_EXT | 0x0300U)
#define KEYDEF_TOOMANY		(KEYDEF_EXT | 0x0400U)
#define KEYDEF_NONE		(KEYDEF_EXT | 0x0500U)
#define is_vkey_on(c)		(!((c) & KEYDEF_EXT))
#define is_vkey_off(c)		((c) == KEYDEF_NULL)
#define is_vkey_reserved(c)	((c) == KEYDEF_RESERVED)
#define is_vkey_normal(c)	(!((c) & 0xff00U))
#define is_vkey_toggle(c)	(((c) & 0xff00U) == 0x0100U)
#define is_keydef_redefinition(c)	(((c) & 0xff00U) == KEYDEF_REDEF)
#define set_redefinition_key(c)		((c) |= KEYDEF_REDEF)

#if NeedFunctionPrototypes
/* from structio.c */
char *get_maindic(void);
char *get_userdic(void);
int set_maindic(char *);
int set_userdic(char *);
void get_env_radio(int *);
void set_env_radio(int *);
void get_env_toggles(char *);
void set_env_toggles(char *);
int get_env_douongo(void);
void set_env_douongo(int);
void get_env_keys(char *);
void set_env_keys(char *);
void get_colors(int *, colors_t *);
void set_colors(int *, colors_t *);
VjeStrucBackup_t backup_struc(void);
void restore_struc(VjeStrucBackup_t);
void perge_struc(VjeStrucBackup_t);
/* from keydefio.c */
char *get_shiftkey_longname(unsigned);
char *get_shiftkey_shortname(unsigned);
char *get_key_dispname(unsigned);
char *get_func_dispname(unsigned);
int chk_keydef_reserved(unsigned char, unsigned char);
int get_redefinition_key(unsigned);
int is_kanjikey(int);
void get_keydef(int, func_def_t *);
unsigned add_keydef(int, unsigned char, unsigned char);
unsigned del_keydef(int, unsigned char, unsigned char);
int str_to_keydef(char *, char *);
void defstr_to_keydef(void);
char *keydef_to_str(unsigned);
void keydef_init(void);
char **dup_vkeytbl(void);
priority_table_t *dup_ptbl(void);
void restore_vkeytbl(char **);
void restore_ptbl(priority_table_t *);
void perge_vkeytbl(char **);
void perge_ptbl(priority_table_t *);
/* from fileio.c */
int load_envfile(char *);
int save_envfile(char *, int);
int get_envfilename(char *);
#else
char *get_maindic();
char *get_userdic();
int set_maindic();
int set_userdic();
void get_env_radio();
void set_env_radio();
void get_env_toggles();
void set_env_toggles();
int get_env_douongo();
void set_env_douongo();
void get_env_keys();
void set_env_keys();
void get_colors();
void set_colors();
VjeStrucBackup_t backup_struc();
void restore_struc();
void perge_struc();
/* from keydefio.c */
char *get_shiftkey_longname();
char *get_shiftkey_shortname();
char *get_key_dispname();
char *get_func_dispname();
int chk_keydef_reserved();
int get_redefinition_key();
int is_kanjikey();
void get_keydef();
unsigned add_keydef();
unsigned del_keydef();
int str_to_keydef();
void defstr_to_keydef();
char *keydef_to_str();
void keydef_init();
char **dup_vkeytbl();
priority_table_t *dup_ptbl();
void restore_vkeytbl();
void restore_ptbl();
void perge_vkeytbl();
void perge_ptbl();
/* from fileio.c */
int load_envfile();
int save_envfile();
int get_envfilename();
#endif
