/******************************************************************************
	Vjeinit.C
******************************************************************************/
#define		XK_KATAKANA
#include	<X11/keysym.h>
#include	"typedef.h"
#include	"xim.h"
#include	"xui.h"
#include	"macro.h"
#include	"fileio.h"
#include	"env.h"
#include	"getstr.h"
#include	"strutl.h"
#include	"getvcode.h"

/*=============================================================================
	Define
=============================================================================*/

/*=============================================================================
	Local	Data
=============================================================================*/

/*=============================================================================
	VjeMemoryAlloc
=============================================================================*/
int	VjeMemoryAlloc
(
	FXim_Client	*client
)
{
#define	Alloc(p,b,s)			\
	if (p = (PSZ )XtMalloc (s)) {	\
		b = (PSZ )p;		\
	} else {			\
		return (-1);		\
	}
	PBD	bdata;
	bdata	= (PBD )GetBDATA (client);

	Alloc (client->chResult_Pnt,	bdata->lpchResult,    MAX_COMP_SIZE+1);
	Alloc (client->chMode_Pnt,	bdata->lpchMode,      MAX_MODE_SIZE+1);
	Alloc (client->attrMode_Pnt,	bdata->lpattrMode,    MAX_MODE_SIZE+1);
	Alloc (client->MBText_Pnt,	bdata->lpchMBText,    MAX_MSG_SIZE+1);
	Alloc (client->MBTitle_Pnt,	bdata->lpchMBTitle,   MAX_TITLE_SIZE+1);
	Alloc (client->chDisplay_Pnt,	bdata->lpchDisplay,   MAX_COMP_SIZE+1);
	Alloc (client->attrDisplay_Pnt,	bdata->lpattrDisplay, MAX_COMP_SIZE+1);
	Alloc (client->LBList_Pnt,	bdata->lpchLBList,    MAX_CAND_NUM *
							      MAX_CAND_SIZE+1);
	Alloc (client->LBTitle_Pnt,	bdata->lpchLBTitle,   MAX_TITLE_SIZE+1);
	return (0);
}

/*=============================================================================
	VjeMemoryFree
=============================================================================*/
void	VjeMemoryFree
(
	FXim_Client	*client
)
{
#define	Free(ptr)			\
	if (ptr) {			\
		XFree (ptr);		\
		ptr = (UCHAR *)NULL;	\
	}
	Free (client->chResult_Pnt);
	Free (client->chMode_Pnt);
	Free (client->attrMode_Pnt);
	Free (client->MBText_Pnt);
	Free (client->MBTitle_Pnt);
	Free (client->chDisplay_Pnt);
	Free (client->attrDisplay_Pnt);
	Free (client->LBList_Pnt);
	Free (client->LBTitle_Pnt);

	return ;
}

#if 1 /* 20000301:OPEN-VJE */
/*=============================================================================
	InitBdata
=============================================================================*/
void	InitBdata
(
	FXim_Client	*client,
	LPENV		lpEnv
)
{
static	BUFF		bufDummy/*[2]*/;/*990916*/
static	BUNINF		bunDummy;
	PBD		bdata;
	LPENVMOD	mod;
	LPENVDCI	dci;
	LPENVCMP	cmp;
	LPENVCAN	can;
	LONG		usVje;
	LONG		lHen;
	LONG		lHenV;
	LONG		lHenL;
	USHORT		usCode;

	bdata		= (PBD )GetBDATA (client);

	mod		= (LPENVMOD )&lpEnv->mod;
	dci		= (LPENVDCI )&lpEnv->dci;
	cmp		= (LPENVCMP )&lpEnv->cmp;
	can		= (LPENVCAN )&lpEnv->can;

	bufDummy.len/*[0]*/			= 0;
#if 0
	bufDummy/*[1]*/			= 0;
#endif
	bunDummy.max_bun		= 0;

	bdata->wDataStatus		= 0;
	bdata->wDataUpdate		= 0;
	bdata->wCharCode		= 0;
	bdata->wVkey			= 0;
	bdata->cchResult		= 0;
	bdata->cchMode			= 0;
	bdata->wMBStyle			= 0;
	bdata->cchDisplay		= 0;
	bdata->cchCurPosition		= 0;
	bdata->cchCurAttr		= 0;
	bdata->ichDisplayAct		= 0;
	bdata->cchLBListLen		= 0;
	bdata->cLBItemPageFirst		= 0;
	bdata->cLBItemTotal		= 0;
	bdata->cLBItemNum		= 0;
	bdata->cLBItemNumMax		= 9;
	bdata->cLBItemLenMax		= MAX_CAND_NUM * MAX_CAND_SIZE;
	bdata->cLBItemHead		= 0;
	bdata->wMainStage		= PRC_EMP;

	usVje				= 0;
	if (mod->wRoman==NO		) usVje	|= KATA_BIT;
	else				  ;
	if (mod->wMojiType==EISU	) usVje	|= EISUU_BIT;
	else if (mod->wMojiType==KATA	) usVje	|= KANA_BIT;
	else				  ;
	if (mod->wMojiSize==ZEN		) usVje	|= ZENKAKU_BIT;
	else				  ;
	bdata->wVjeModeFlag		= usVje;

	lHen				= MOD_KUTEN_YES
					| MOD_TANKAN_YES;
	if (mod->wCode==SJIS		) lHen	|= MOD_SJIS;
	else if (mod->wCode==JIS	) lHen	|= MOD_JIS;
#if	XKP_SUPPORT
	else if (mod->wCode==UCS4	) lHen	|= MOD_UNICODE;
#endif
	else if (mod->wCode==EUC	) lHen	|= MOD_EUC;
	else				  lHen	|= MOD_KUTEN;
	if (mod->wHenkan==SAKI		) lHen	|= MOD_SAKI;
	else if (mod->wHenkan==REN	) lHen	|= MOD_REN;
	else				  lHen	|= MOD_BETA;
	if (mod->wCalc==YES		) lHen	|= MOD_CALC_ON;
	else				  lHen	|= MOD_CALC_OFF;
	if (mod->wKutouConv==YES	) lHen	|= MOD_KUTEN_CNV_YES;
	else				  lHen	|= MOD_KUTEN_CNV_NO;
	bdata->wHenModFlag		= lHen;

	lHenV				= MOD_GAKU_OFF
					| MOD_KOUBUN_ON;
	if (mod->wOkuriKana==HON	) lHenV	|= MOD_OKURI_HONSOKU;
	else if (mod->wOkuriKana==OKURI	) lHenV	|= MOD_OKURI_OKURU;
	else if (mod->wOkuriKana==NON	) lHenV	|= MOD_OKURI_HABUKU;
	else				  lHenV	|= MOD_OKURI_ZENBU;
	if (mod->wKougoConv==YES	) lHenV	|= MOD_KOUGO_ON;
	else				  lHenV	|= MOD_KOUGO_OFF;
	if (mod->wBunpou==BUN		) lHenV	|= MOD_BUNSETU;
	else				  lHenV	|= MOD_FUKUGOU;
	if (mod->wHosei==YES		) lHenV	|= MOD_HOSEI_ON;
	else				  lHenV	|= MOD_HOSEI_OFF;
	if (mod->wYuragi==YES		) lHenV	|= MOD_YURAGI_ON;
	else				  lHenV	|= MOD_YURAGI_OFF;
	if (dci->wKanaGaku==YES		) lHenV	|= MOD_KATAKANA_ON;
	else				  lHenV	|= MOD_KATAKANA_OFF;
	if (dci->wEisuGaku==YES		) lHenV	|= MOD_EISU_ON;
	else				  lHenV	|= MOD_EISU_OFF;
	bdata->wHenModFlagV		= lHenV;

	lHenL				= ((dwLim[cmp->wRank]	))
					| ((cmp->wKoyu	== YES	)
					?  (MOD_LIM_KOYU_YES	)
					:  (MOD_LIM_KOYU_NO	))
					| ((cmp->wMark	== YES	)
					?  (MOD_LIM_MARK_YES	)
					:  (MOD_LIM_MARK_NO	))
					| ((mod->wJisOnly== YES	)
					?  (MOD_LIM_JIS_YES	)
					:  (MOD_LIM_JIS_NO	))
					;
	bdata->wHenModFlagLim		= lHenL;

	usCode				= 0;
	if (mod->wCode==SJIS		) usCode= 0x987e;
	else if (mod->wCode==JIS	) usCode= 0x987e;
#if	XKP_SUPPORT
	else if (mod->wCode==UCS4	) usCode= 0;
#endif
	else if (mod->wCode==EUC	) usCode= 0x7a7e;
	else				  usCode= 0x987e;
	bdata->wCodeMax			= usCode;

	bdata->wDispListBox		= can->wStart;
	bdata->wHinshi			= 0;
	bdata->wKeyType			= KEY_STANDARD;
	bdata->wColorType		= CL_SPECIAL;
	bdata->wOptDicNo		= 0;
	bdata->wErrorCode		= 0;
	bdata->lpchDisplayYomi		= (BUFF   *) &bufDummy/*[0]*/;
	bdata->lpchDisplayBuninf	= (BUNINF *) &bunDummy;
	bdata->lpchResultYomi		= (BUFF   *) &bufDummy/*[0]*/;
	bdata->lpchResultBuninf		= (BUNINF *) &bunDummy;
	bdata->lpchRomFlName		= NULL;
	bdata->lpchRomTbName		= NULL;
	bdata->lpchDicName		= NULL;

	return ;
}

/*=============================================================================
	InitVJE
=============================================================================*/
BOOL	InitVJE
(
	FXim_Client	*client
)
{
	int		ret;
	LPENV		lpEnv;

	lpEnv		= (LPENV    )GetEnv (0);

	switch (client->vjeState) {
	case	VJE_INIT:
	case	VJE_OPEN:
		return (TRUE);
	case	VJE_CLOSE:
	default:
		InitBdata (client, lpEnv);
		ret	= VjeMemoryAlloc (client);
		if (ret != 0) {
			return (FALSE);
		}
		break;
	}
	client->vjeState	= VJE_INIT;

	return (TRUE);
}

/*=============================================================================
	OpenVJE
=============================================================================*/
BOOL	OpenVJE
(
	FXim_Client	*client
)
{
	int		ret;
	HBASEDT		*pbebuf;
	LPENV		lpEnv;
	LPVWIN		lpVWin;

	pbebuf		= (HBASEDT *)GetBEBUF_P (client);
	lpEnv		= (LPENV    )GetEnv (0);
	lpVWin		= (LPVWIN   )GetVWin ();

	lpVWin->Param	= MAKELONG ((WORD )ENV_ALL, (WORD )0);

	switch (client->vjeState) {
	case	VJE_INIT:
		ret	= BasicEditOpen (pbebuf);
		if (ret != 0) {
			return (FALSE);
		}
		OpenVjeFiles (client, lpEnv);
		EnvToClient (client, lpVWin, lpEnv);
		break;
	case	VJE_OPEN:
		return (TRUE);
	case	VJE_CLOSE:
	default:
		return (FALSE);
	}
	client->vjeState	= VJE_OPEN;

	return (TRUE);
}

/*=============================================================================
	CloseVJE
=============================================================================*/
void	CloseVJE
(
	FXim_Client	*client
)
{
	HBASEDT		*pbebuf;

	pbebuf		= (HBASEDT *)GetBEBUF_P (client);

	switch (client->vjeState) {
	case	VJE_INIT:
		VjeMemoryFree (client);
		break;
	case	VJE_OPEN:
		VjeMemoryFree (client);
		CloseVjeFiles (client);
		if (*pbebuf) {
			BasicEditClose (*pbebuf);
			*pbebuf = (HBASEDT )NULL;
		}
		break;
	case	VJE_CLOSE:
	default:
		break;
	}
	client->vjeState	= VJE_CLOSE;

	return ;
}

#else  /* 20000301:OPEN-VJE */
/*=============================================================================
	InitBdata
=============================================================================*/
void	InitBdata
(
	PBD	bdata
)
{
static	BUFF	bufDummy/*[2]*/;/*990916*/
static	BUNINF	bunDummy;

	bufDummy.len/*[0]*/			= 0;
#if 0
	bufDummy/*[1]*/			= 0;
#endif
	bunDummy.max_bun		= 0;

	bdata->wDataStatus		= 0;
	bdata->wDataUpdate		= 0;
	bdata->wCharCode		= 0;
	bdata->wVkey			= 0;
	bdata->cchResult		= 0;
	bdata->cchMode			= 0;
	bdata->wMBStyle			= 0;
	bdata->cchDisplay		= 0;
	bdata->cchCurPosition		= 0;
	bdata->cchCurAttr		= 0;
	bdata->ichDisplayAct		= 0;
	bdata->cchLBListLen		= 0;
	bdata->cLBItemPageFirst		= 0;
	bdata->cLBItemTotal		= 0;
	bdata->cLBItemNum		= 0;
	bdata->cLBItemNumMax		= 9;
	bdata->cLBItemLenMax		= MAX_CAND_NUM * MAX_CAND_SIZE;
	bdata->cLBItemHead		= 0;
	bdata->wVjeModeFlag		= INITIAL_VJE_MODE;
	bdata->wMainStage		= PRC_EMP;
	bdata->wHenModFlag		= MOD_TANKAN_YES
					| MOD_KUTEN_YES
					| MOD_KUTEN_CNV_YES
					| MOD_SJIS
					| MOD_SAKI;
	bdata->wHenModFlagV		= MOD_KOUGO_ON
					| MOD_KOUBUN_ON
					| MOD_BUNSETU
					| MOD_GAKU_OFF
					| MOD_OKURI_ZENBU
					| MOD_KATAKANA_ON;
	bdata->wHenModFlagLim		= MOD_LIM_OFF;
	bdata->wHinshi			= 0;
	bdata->wCodeMax			= 0x987e;
	bdata->wKeyType			= KEY_STANDARD;
	bdata->wColorType		= CL_SPECIAL;
	bdata->wDispListBox		= 2;
	bdata->wOptDicNo		= 0;
	bdata->wErrorCode		= 0;
	bdata->lpchDisplayYomi		= (BUFF   *) &bufDummy/*[0]*/;
	bdata->lpchDisplayBuninf	= (BUNINF *) &bunDummy;
	bdata->lpchResultYomi		= (BUFF   *) &bufDummy/*[0]*/;
	bdata->lpchResultBuninf		= (BUNINF *) &bunDummy;
	bdata->lpchRomFlName		= NULL;
	bdata->lpchRomTbName		= NULL;
	bdata->lpchDicName		= NULL;
}

/*=============================================================================
	OpenVJE
=============================================================================*/
BOOL	OpenVJE
(
	FXim_Client	*client
)
{
	int		ret;
	PBD		bdata;
	HBASEDT		*pbebuf;
	LPENV		lpEnv;
	LPVWIN		lpVWin;
	KD		kd;

	bdata	= (PBD      )GetBDATA (client);
	pbebuf	= (HBASEDT *)GetBEBUF_P (client);
	lpEnv	= (LPENV    )GetEnv (0);
	lpVWin	= (LPVWIN   )GetVWin ();

	ret = BasicEditOpen (pbebuf);
	if (ret != 0) {
		return (FALSE);
	}
	InitBdata (bdata);
	ret = VjeMemoryAlloc (client);
	if (ret != 0) {
		return (FALSE);
	}
#if 1 /* 20000214 ROM-FILE */
	OpenVjeFiles (client, lpEnv);
#else
	OpenVjeFiles (*pbebuf, bdata, lpEnv);
#endif

	lpVWin->Param	= MAKELONG ((WORD )ENV_ALL, (WORD )0);
	EnvToClient (client, lpVWin, lpEnv);

	return (TRUE);
}

/*=============================================================================
	CloseVJE
=============================================================================*/
void	CloseVJE
(
	FXim_Client	*client
)
{
	PBD		bdata;
	HBASEDT		*pbebuf;

	bdata	= (PBD      )GetBDATA (client);
	pbebuf	= (HBASEDT *)GetBEBUF_P (client);

	VjeMemoryFree (client);
#if 1 /* 20000214 ROM-FILE */
	CloseVjeFiles (client);
#else
	CloseVjeFiles (*pbebuf, bdata);
#endif
	if (*pbebuf) {
		BasicEditClose (*pbebuf);
		*pbebuf = (HBASEDT )NULL;
	}
}
#endif /* 20000301:OPEN-VJE */
