/*
 *	VJE-Delta Version 2.5 for Windows95
 *
 *
 *
 * Revision History:
 *
 * Yasuo Mogi, 30-4-93
 *      - Initial Revision
 */

#if WINDOWS
#include	<windows.h>
#include	<dos.h>
#else
#include	<errno.h>
#endif	/* if WINDOWS end */
#include	<fcntl.h>
#if unix
#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#endif	/* if unix end */
#if MSDOS
/**
#include	<sys\types.h>
#include	<sys\stat.h>
**/
#include	<io.h>
#include	<malloc.h>
#endif	/* if MSDOS end */
#if MAC
#include	<errors.h>
#endif	/* if MAC end */

/*#define DEFTEXT 1 */
#define DEFTEXT 0

#include	"common.h"
#include	"vje.h"
#include	"vjelib.h"
#include	"vroomaji.h"
#include	"vfzk.h"
#include	"vfncdef.h"

#define ERR_NOT_ERROR	0	/*  */
#define ERR_FILE_NOT	1	/* ꤵƥե뤬ɤ߹ʤ */
#define ERR_TABLE_NOT	2	/* ꤵ줿ơ֥뤬ʤ */
#define ERR_NOT_ALLOC	3	/* ꤬ȤǤʤ */
#define ERR_NOT_READ	4	/* ե뤬Ŭɤ߹ʤä */
#define ERR_NOT_DEFINE	5	/* ե٥å饤󤬰Ĥʤ */

#define swapp(a,b)	{char PWIN *temp; temp = a; a = b; b = temp;}

typedef	char PWIN * PSEL;

/*UCHAR	PWIN	*RoomajiOpen ( SHORT,UCHAR PWIN *, UCHAR PWIN * ); */
/*void	RoomajiClose ( void PWIN * ); */
/*int 	ErrCodeGet ( void ); */

static	int FTYPE 	chcount ( UCHAR PWIN *, UCHAR PWIN * );
static	int FTYPE 	check ( UCHAR PWIN *, UCHAR PWIN *, int PWIN * );
static	int FTYPE 	line_get ( UCHAR PWIN *, int PWIN * , int PWIN * );
static	void FTYPE	strncopy ( UCHAR PWIN *, UCHAR PWIN *, int );
static	short FTYPE	strcmpnam ( UCHAR PWIN *, UCHAR PWIN * );
static	short FTYPE	strcmpalh ( UCHAR PWIN *, UCHAR PWIN * );
static	void FTYPE	rsort ( UCHAR PWIN * PWIN *, int, int );
static	int FTYPE 	chkendname ( UCHAR PWIN * );

PROMAJI pRomaTable = (PROMAJI)NULL ;
int 	ErrorCode ;

#if PCUNIX/*PCUX9908*/
extern char *euc2sjis(char *euc);
#endif

#if DEFTEXT
static	UCHAR	*RomaTblText [ ] = {
	{ "[romavje0]" },
	{ "A=\x82\xa0" },
	{ "BA=\x82\xce" }   ,{ "BE=\x82\xd7" }	 ,{ "BI=\x82\xd1" }	,{ "BO=\x82\xda" }   ,{ "BU=\x82\xd4" },
	{ "BYA=\x82\xd1\x82\xe1" },{ "BYE=\x82\xd1\x82\xa5" },{ "BYI=\x82\xd1\x82\xa1" },{ "BYO=\x82\xd1\x82\xe5" },{ "BYU=\x82\xd1\x82\xe3" },
	{ "CA=\x82\xa9" }   ,{ "CE=\x82\xb9" }	 ,{ "CI=\x82\xb5" }	,{ "CO=\x82\xb1" }   ,{ "CU=\x82\xab\x82\xe3" },
	{ "CHA=\x82\xbf\x82\xe1" },{ "CHE=\x82\xbf\x82\xa5" },{ "CHI=\x82\xbf" }	,{ "CHO=\x82\xbf\x82\xe5" },{ "CHU=\x82\xbf\x82\xe3" },
	{ "CYA=\x82\xbf\x82\xe1" },{ "CYE=\x82\xbf\x82\xa5" },{ "CYI=\x82\xbf\x82\xa1" },{ "CYO=\x82\xbf\x82\xe5" },{ "CYU=\x82\xbf\x82\xe3" },
	{ "DA=\x82\xbe" }   ,{ "DE=\x82\xc5" }	 ,{ "DI=\x82\xc0" }	,{ "DO=\x82\xc7" }   ,{ "DU=\x82\xc3" },
	{ "DHA=\x82\xc5\x82\xe1" },{ "DHE=\x82\xc5\x82\xa5" },{ "DHI=\x82\xc5\x82\xa1" },{ "DHO=\x82\xc5\x82\xe5" },{ "DHU=\x82\xc5\x82\xe3" },
	{ "DYA=\x82\xc0\x82\xe1" },{ "DYE=\x82\xc0\x82\xa5" },{ "DYI=\x82\xc0\x82\xa1" },{ "DYO=\x82\xc0\x82\xe5" },{ "DYU=\x82\xc0\x82\xe3" },
	{ "E=\x82\xa6" },
	{ "FA=\x82\xd3\x82\x9f" } ,{ "FE=\x82\xd3\x82\xa5" } ,{ "FI=\x82\xd3\x82\xa1" } ,{ "FO=\x82\xd3\x82\xa7" } ,{ "FU=\x82\xd3" },
	{ "FYA=\x82\xd3\x82\xe1" },{ "FYE=\x82\xd3\x82\xa5" },{ "FYI=\x82\xd3\x82\xa1" },{ "FYO=\x82\xd3\x82\xe5" },{ "FYU=\x82\xd3\x82\xe3" },
	{ "GA=\x82\xaa" }   ,{ "GE=\x82\xb0" }	 ,{ "GI=\x82\xac" }	,{ "GO=\x82\xb2" }   ,{ "GU=\x82\xae" },
	{ "GWA=\x82\xae\x82\x9f" },{ "GWE=\x82\xae\x82\xa5" },{ "GWI=\x82\xae\x82\xa1" },{ "GWO=\x82\xae\x82\xa7" },{ "GWU=\x82\xae" },
	{ "GYA=\x82\xac\x82\xe1" },{ "GYE=\x82\xac\x82\xa5" },{ "GYI=\x82\xac\x82\xa1" },{ "GYO=\x82\xac\x82\xe5" },{ "GYU=\x82\xac\x82\xe3" },
	{ "HA=\x82\xcd" }   ,{ "HE=\x82\xd6" }	 ,{ "HI=\x82\xd0" }	,{ "HO=\x82\xd9" }   ,{ "HU=\x82\xd3" },
	{ "HYA=\x82\xd0\x82\xe1" },{ "HYE=\x82\xd0\x82\xa5" },{ "HYI=\x82\xd0\x82\xa1" },{ "HYO=\x82\xd0\x82\xe5" },{ "HYU=\x82\xd0\x82\xe3" },
	{ "I=\x82\xa2" },
	{ "JA=\x82\xb6\x82\xe1" } ,{ "JE=\x82\xb6\x82\xa5" } ,{ "JI=\x82\xb6" }	,{ "JO=\x82\xb6\x82\xe5" } ,{ "JU=\x82\xb6\x82\xe3" },
	{ "JYA=\x82\xb6\x82\xe1" },{ "JYE=\x82\xb6\x82\xa5" },{ "JYI=\x82\xb6\x82\xa1" },{ "JYO=\x82\xb6\x82\xe5" },{ "JYU=\x82\xb6\x82\xe3" },
	{ "KA=\x82\xa9" }   ,{ "KE=\x82\xaf" }	 ,{ "KI=\x82\xab" }	,{ "KO=\x82\xb1" }   ,{ "KU=\x82\xad" },
	{ "KWA=\x82\xad\x82\x9f" },{ "KWE=\x82\xad\x82\xa5" },{ "KWI=\x82\xad\x82\xa1" },{ "KWO=\x82\xad\x82\xa7" },{ "KWU=\x82\xad" },
	{ "KYA=\x82\xab\x82\xe1" },{ "KYE=\x82\xab\x82\xa5" },{ "KYI=\x82\xab\x82\xa1" },{ "KYO=\x82\xab\x82\xe5" },{ "KYU=\x82\xab\x82\xe3" },
	{ "LA=\x82\xe7" }   ,{ "LE=\x82\xea" }	 ,{ "LI=\x82\xe8" }	,{ "LO=\x82\xeb" }   ,{ "LU=\x82\xe9" },
	{ "LYA=\x82\xe8\x82\xe1" },{ "LYE=\x82\xe8\x82\xa5" },{ "LYI=\x82\xe8\x82\xa1" },{ "LYO=\x82\xe8\x82\xe5" },{ "LYU=\x82\xe8\x82\xe3" },
	{ "MA=\x82\xdc" }   ,{ "ME=\x82\xdf" }	 ,{ "MI=\x82\xdd" }	,{ "MO=\x82\xe0" }   ,{ "MU=\x82\xde" },
	{ "MYA=\x82\xdd\x82\xe1" },{ "MYE=\x82\xdd\x82\xa5" },{ "MYI=\x82\xdd\x82\xa1" },{ "MYO=\x82\xdd\x82\xe5" },{ "MYU=\x82\xdd\x82\xe3" },
	{ "N'=\x82\xf1" }   ,{ "NN=\x82\xf1" },
	{ "NA=\x82\xc8" }   ,{ "NE=\x82\xcb" }	 ,{ "NI=\x82\xc9" }	,{ "NO=\x82\xcc" }   ,{ "NU=\x82\xca" },
	{ "NYA=\x82\xc9\x82\xe1" },{ "NYE=\x82\xc9\x82\xa5" },{ "NYI=\x82\xc9\x82\xa1" },{ "NYO=\x82\xc9\x82\xe5" },{ "NYU=\x82\xc9\x82\xe3" },
	{ "O=\x82\xa8" },
	{ "PA=\x82\xcf" }   ,{ "PE=\x82\xd8" }	 ,{ "PI=\x82\xd2" }	,{ "PO=\x82\xdb" }   ,{ "PU=\x82\xd5" },
	{ "PYA=\x82\xd2\x82\xe1" },{ "PYE=\x82\xd2\x82\xa5" },{ "PYI=\x82\xd2\x82\xa1" },{ "PYO=\x82\xd2\x82\xe5" },{ "PYU=\x82\xd2\x82\xe3" },
	{ "QA=\x82\xad\x82\x9f" } ,{ "QE=\x82\xad\x82\xa5" } ,{ "QI=\x82\xad\x82\xa1" } ,{ "QO=\x82\xad\x82\xa7" } ,{ "QU=\x82\xad" },
	{ "QYA=\x82\xad\x82\xe1" },{ "QYE=\x82\xad\x82\xa5" },{ "QYI=\x82\xad\x82\xa1" },{ "QYO=\x82\xad\x82\xe5" },{ "QYU=\x82\xad\x82\xe3" },
	{ "RA=\x82\xe7" }   ,{ "RE=\x82\xea" }	 ,{ "RI=\x82\xe8" }	,{ "RO=\x82\xeb" }   ,{ "RU=\x82\xe9" },
	{ "RYA=\x82\xe8\x82\xe1" },{ "RYE=\x82\xe8\x82\xa5" },{ "RYI=\x82\xe8\x82\xa1" },{ "RYO=\x82\xe8\x82\xe5" },{ "RYU=\x82\xe8\x82\xe3" },
	{ "SA=\x82\xb3" }   ,{ "SE=\x82\xb9" }	 ,{ "SI=\x82\xb5" }	,{ "SO=\x82\xbb" }   ,{ "SU=\x82\xb7" },
	{ "SHA=\x82\xb5\x82\xe1" },{ "SHE=\x82\xb5\x82\xa5" },{ "SHI=\x82\xb5" }	,{ "SHO=\x82\xb5\x82\xe5" },{ "SHU=\x82\xb5\x82\xe3" },
	{ "SYA=\x82\xb5\x82\xe1" },{ "SYE=\x82\xb5\x82\xa5" },{ "SYI=\x82\xb5\x82\xa1" },{ "SYO=\x82\xb5\x82\xe5" },{ "SYU=\x82\xb5\x82\xe3" },
	{ "TA=\x82\xbd" }   ,{ "TE=\x82\xc4" }	 ,{ "TI=\x82\xbf" }	,{ "TO=\x82\xc6" }   ,{ "TU=\x82\xc2" },
	{ "THA=\x82\xc4\x82\xe1" },{ "THE=\x82\xc4\x82\xa5" },{ "THI=\x82\xc4\x82\xa1" },{ "THO=\x82\xc4\x82\xe5" },{ "THU=\x82\xc4\x82\xe3" },
	{ "TSA=\x82\xc2\x82\x9f" },{ "TSE=\x82\xc2\x82\xa5" },{ "TSI=\x82\xc2\x82\xa1" },{ "TSO=\x82\xc2\x82\xa7" },{ "TSU=\x82\xc2" },
	{ "TYA=\x82\xbf\x82\xe1" },{ "TYE=\x82\xbf\x82\xa5" },{ "TYI=\x82\xbf\x82\xa1" },{ "TYO=\x82\xbf\x82\xe5" },{ "TYU=\x82\xbf\x82\xe3" },
	{ "U=\x82\xa4" },
	{ "VA=\x83\x94\x82\x9f" } ,{ "VE=\x83\x94\x82\xa5" } ,{ "VI=\x83\x94\x82\xa1" } ,{ "VO=\x83\x94\x82\xa7" } ,{ "VU=\x83\x94" },
	{ "VYA=\x83\x94\x82\xe1" },{ "VYE=\x83\x94\x82\xa5" },{ "VYI=\x83\x94\x82\xa1" },{ "VYO=\x83\x94\x82\xe5" },{ "VYU=\x83\x94\x82\xe3" },
	{ "WA=\x82\xed" }   ,{ "WE=\x82\xa4\x82\xa5" } ,{ "WI=\x82\xa4\x82\xa1" } ,{ "WO=\x82\xf0" }   ,{ "WU=\x82\xa4" },
	{ "WHA=\x82\xa4\x82\x9f" },{ "WHE=\x82\xa4\x82\xa5" },{ "WHI=\x82\xa4\x82\xa1" },{ "WHO=\x82\xa4\x82\xa7" },{ "WHU=\x82\xa4" },
	{ "XA=\x82\x9f" }   ,{ "XE=\x82\xa5" }	 ,{ "XI=\x82\xa1" }	,{ "XO=\x82\xa7" }   ,{ "XU=\x82\xa3" },
	{ "XKA=\x83\x95" }  ,{ "XKE=\x83\x96" }  ,{ "XTU=\x82\xc1" },
	{ "XYA=\x82\xe1" }  ,{ "XYE=\x82\xa5" }  ,{ "XYI=\x82\xa1" }	,{ "XYO=\x82\xe5" }  ,{ "XYU=\x82\xe3" },
	{ "YA=\x82\xe2" }   ,{ "YE=\x82\xa2\x82\xa5" } ,{ "YI=\x82\xa2" }	,{ "YO=\x82\xe6" }   ,{ "YU=\x82\xe4" },
	{ "ZA=\x82\xb4" }   ,{ "ZE=\x82\xba" }	 ,{ "ZI=\x82\xb6" }	,{ "ZO=\x82\xbc" }   ,{ "ZU=\x82\xb8" },
	{ "ZYA=\x82\xb6\x82\xe1" },{ "ZYE=\x82\xb6\x82\xa5" },{ "ZYI=\x82\xb6\x82\xa1" },{ "ZYO=\x82\xb6\x82\xe5" },{ "ZYU=\x82\xb6\x82\xe3" },
	{ "a=\x82\xa0" },
	{ "ba=\x82\xce" }   ,{ "be=\x82\xd7" }	 ,{ "bi=\x82\xd1" }	,{ "bo=\x82\xda" }   ,{ "bu=\x82\xd4" },
	{ "bya=\x82\xd1\x82\xe1" },{ "bye=\x82\xd1\x82\xa5" },{ "byi=\x82\xd1\x82\xa1" },{ "byo=\x82\xd1\x82\xe5" },{ "byu=\x82\xd1\x82\xe3" },
	{ "ca=\x82\xa9" }   ,{ "ce=\x82\xb9" }	 ,{ "ci=\x82\xb5" }	,{ "co=\x82\xb1" }   ,{ "cu=\x82\xab\x82\xe3" },
	{ "cha=\x82\xbf\x82\xe1" },{ "che=\x82\xbf\x82\xa5" },{ "chi=\x82\xbf" }	,{ "cho=\x82\xbf\x82\xe5" },{ "chu=\x82\xbf\x82\xe3" },
	{ "cya=\x82\xbf\x82\xe1" },{ "cye=\x82\xbf\x82\xa5" },{ "cyi=\x82\xbf\x82\xa1" },{ "cyo=\x82\xbf\x82\xe5" },{ "cyu=\x82\xbf\x82\xe3" },
	{ "da=\x82\xbe" }   ,{ "de=\x82\xc5" }	 ,{ "di=\x82\xc0" }	,{ "do=\x82\xc7" }   ,{ "du=\x82\xc3" },
	{ "dha=\x82\xc5\x82\xe1" },{ "dhe=\x82\xc5\x82\xa5" },{ "dhi=\x82\xc5\x82\xa1" },{ "dho=\x82\xc5\x82\xe5" },{ "dhu=\x82\xc5\x82\xe3" },
	{ "dya=\x82\xc0\x82\xe1" },{ "dye=\x82\xc0\x82\xa5" },{ "dyi=\x82\xc0\x82\xa1" },{ "dyo=\x82\xc0\x82\xe5" },{ "dyu=\x82\xc0\x82\xe3" },
	{ "e=\x82\xa6" },
	{ "fa=\x82\xd3\x82\x9f" } ,{ "fe=\x82\xd3\x82\xa5" } ,{ "fi=\x82\xd3\x82\xa1" } ,{ "fo=\x82\xd3\x82\xa7" } ,{ "fu=\x82\xd3" },
	{ "fya=\x82\xd3\x82\xe1" },{ "fye=\x82\xd3\x82\xa5" },{ "fyi=\x82\xd3\x82\xa1" },{ "fyo=\x82\xd3\x82\xe5" },{ "fyu=\x82\xd3\x82\xe3" },
	{ "ga=\x82\xaa" }   ,{ "ge=\x82\xb0" }	 ,{ "gi=\x82\xac" }	,{ "go=\x82\xb2" }   ,{ "gu=\x82\xae" },
	{ "gwa=\x82\xae\x82\x9f" },{ "gwe=\x82\xae\x82\xa5" },{ "gwi=\x82\xae\x82\xa1" },{ "gwo=\x82\xae\x82\xa7" },{ "gwu=\x82\xae" },
	{ "gya=\x82\xac\x82\xe1" },{ "gye=\x82\xac\x82\xa5" },{ "gyi=\x82\xac\x82\xa1" },{ "gyo=\x82\xac\x82\xe5" },{ "gyu=\x82\xac\x82\xe3" },
	{ "ha=\x82\xcd" }   ,{ "he=\x82\xd6" }	 ,{ "hi=\x82\xd0" }	,{ "ho=\x82\xd9" }   ,{ "hu=\x82\xd3" },
	{ "hya=\x82\xd0\x82\xe1" },{ "hye=\x82\xd0\x82\xa5" },{ "hyi=\x82\xd0\x82\xa1" },{ "hyo=\x82\xd0\x82\xe5" },{ "hyu=\x82\xd0\x82\xe3" },
	{ "i=\x82\xa2" },
	{ "ja=\x82\xb6\x82\xe1" } ,{ "je=\x82\xb6\x82\xa5" } ,{ "ji=\x82\xb6" }	,{ "jo=\x82\xb6\x82\xe5" } ,{ "ju=\x82\xb6\x82\xe3" },
	{ "jya=\x82\xb6\x82\xe1" },{ "jye=\x82\xb6\x82\xa5" },{ "jyi=\x82\xb6\x82\xa1" },{ "jyo=\x82\xb6\x82\xe5" },{ "jyu=\x82\xb6\x82\xe3" },
	{ "ka=\x82\xa9" }   ,{ "ke=\x82\xaf" }	 ,{ "ki=\x82\xab" }	,{ "ko=\x82\xb1" }   ,{ "ku=\x82\xad" },
	{ "kwa=\x82\xad\x82\x9f" },{ "kwe=\x82\xad\x82\xa5" },{ "kwi=\x82\xad\x82\xa1" },{ "kwo=\x82\xad\x82\xa7" },{ "kwu=\x82\xad" },
	{ "kya=\x82\xab\x82\xe1" },{ "kye=\x82\xab\x82\xa5" },{ "kyi=\x82\xab\x82\xa1" },{ "kyo=\x82\xab\x82\xe5" },{ "kyu=\x82\xab\x82\xe3" },
	{ "la=\x82\xe7" }   ,{ "le=\x82\xea" }	 ,{ "li=\x82\xe8" }	,{ "lo=\x82\xeb" }   ,{ "lu=\x82\xe9" },
	{ "lya=\x82\xe8\x82\xe1" },{ "lye=\x82\xe8\x82\xa5" },{ "lyi=\x82\xe8\x82\xa1" },{ "lyo=\x82\xe8\x82\xe5" },{ "lyu=\x82\xe8\x82\xe3" },
	{ "ma=\x82\xdc" }   ,{ "me=\x82\xdf" }	 ,{ "mi=\x82\xdd" }	,{ "mo=\x82\xe0" }   ,{ "mu=\x82\xde" },
	{ "mya=\x82\xdd\x82\xe1" },{ "mye=\x82\xdd\x82\xa5" },{ "myi=\x82\xdd\x82\xa1" },{ "myo=\x82\xdd\x82\xe5" },{ "myu=\x82\xdd\x82\xe3" },
	{ "n'=\x82\xf1" }   ,{ "nn=\x82\xf1" },
	{ "na=\x82\xc8" }   ,{ "ne=\x82\xcb" }	 ,{ "ni=\x82\xc9" }	,{ "no=\x82\xcc" }   ,{ "nu=\x82\xca" },
	{ "nya=\x82\xc9\x82\xe1" },{ "nye=\x82\xc9\x82\xa5" },{ "nyi=\x82\xc9\x82\xa1" },{ "nyo=\x82\xc9\x82\xe5" },{ "nyu=\x82\xc9\x82\xe3" },
	{ "o=\x82\xa8" },
	{ "pa=\x82\xcf" }   ,{ "pe=\x82\xd8" }	 ,{ "pi=\x82\xd2" }	,{ "po=\x82\xdb" }   ,{ "pu=\x82\xd5" },
	{ "pya=\x82\xd2\x82\xe1" },{ "pye=\x82\xd2\x82\xa5" },{ "pyi=\x82\xd2\x82\xa1" },{ "pyo=\x82\xd2\x82\xe5" },{ "pyu=\x82\xd2\x82\xe3" },
	{ "qa=\x82\xad\x82\x9f" } ,{ "qe=\x82\xad\x82\xa5" } ,{ "qi=\x82\xad\x82\xa1" } ,{ "qo=\x82\xad\x82\xa7" } ,{ "qu=\x82\xad" },
	{ "qya=\x82\xad\x82\xe1" },{ "qye=\x82\xad\x82\xa5" },{ "qyi=\x82\xad\x82\xa1" },{ "qyo=\x82\xad\x82\xe5" },{ "qyu=\x82\xad\x82\xe3" },
	{ "ra=\x82\xe7" }   ,{ "re=\x82\xea" }	 ,{ "ri=\x82\xe8" }	,{ "ro=\x82\xeb" }   ,{ "ru=\x82\xe9" },
	{ "rya=\x82\xe8\x82\xe1" },{ "rye=\x82\xe8\x82\xa5" },{ "ryi=\x82\xe8\x82\xa1" },{ "ryo=\x82\xe8\x82\xe5" },{ "ryu=\x82\xe8\x82\xe3" },
	{ "sa=\x82\xb3" }   ,{ "se=\x82\xb9" }	 ,{ "si=\x82\xb5" }	,{ "so=\x82\xbb" }   ,{ "su=\x82\xb7" },
	{ "sha=\x82\xb5\x82\xe1" },{ "she=\x82\xb5\x82\xa5" },{ "shi=\x82\xb5" }	,{ "sho=\x82\xb5\x82\xe5" },{ "shu=\x82\xb5\x82\xe3" },
	{ "sya=\x82\xb5\x82\xe1" },{ "sye=\x82\xb5\x82\xa5" },{ "syi=\x82\xb5\x82\xa1" },{ "syo=\x82\xb5\x82\xe5" },{ "syu=\x82\xb5\x82\xe3" },
	{ "ta=\x82\xbd" }   ,{ "te=\x82\xc4" }	 ,{ "ti=\x82\xbf" }	,{ "to=\x82\xc6" }   ,{ "tu=\x82\xc2" },
	{ "tha=\x82\xc4\x82\xe1" },{ "the=\x82\xc4\x82\xa5" },{ "thi=\x82\xc4\x82\xa1" },{ "tho=\x82\xc4\x82\xe5" },{ "thu=\x82\xc4\x82\xe3" },
	{ "tsa=\x82\xc2\x82\x9f" },{ "tse=\x82\xc2\x82\xa5" },{ "tsi=\x82\xc2\x82\xa1" },{ "tso=\x82\xc2\x82\xa7" },{ "tsu=\x82\xc2" },
	{ "tya=\x82\xbf\x82\xe1" },{ "tye=\x82\xbf\x82\xa5" },{ "tyi=\x82\xbf\x82\xa1" },{ "tyo=\x82\xbf\x82\xe5" },{ "tyu=\x82\xbf\x82\xe3" },
	{ "u=\x82\xa4" },
	{ "va=\x83\x94\x82\x9f" } ,{ "ve=\x83\x94\x82\xa5" } ,{ "vi=\x83\x94\x82\xa1" } ,{ "vo=\x83\x94\x82\xa7" } ,{ "vu=\x83\x94" },
	{ "vya=\x83\x94\x82\xe1" },{ "vye=\x83\x94\x82\xa5" },{ "vyi=\x83\x94\x82\xa1" },{ "vyo=\x83\x94\x82\xe5" },{ "vyu=\x83\x94\x82\xe3" },
	{ "wa=\x82\xed" }   ,{ "we=\x82\xa4\x82\xa5" } ,{ "wi=\x82\xa4\x82\xa1" } ,{ "wo=\x82\xf0" }   ,{ "wu=\x82\xa4" },
	{ "wha=\x82\xa4\x82\x9f" },{ "whe=\x82\xa4\x82\xa5" },{ "whi=\x82\xa4\x82\xa1" },{ "who=\x82\xa4\x82\xa7" },{ "whu=\x82\xa4" },
	{ "xa=\x82\x9f" }   ,{ "xe=\x82\xa5" }	 ,{ "xi=\x82\xa1" }	,{ "xo=\x82\xa7" }   ,{ "xu=\x82\xa3" },
	{ "xka=\x83\x95" }  ,{ "xke=\x83\x96" }  ,{ "xtu=\x82\xc1" },
	{ "xya=\x82\xe1" }  ,{ "xye=\x82\xa5" }  ,{ "xyi=\x82\xa1" }	,{ "xyo=\x82\xe5" }  ,{ "xyu=\x82\xe3" },
	{ "ya=\x82\xe2" }   ,{ "ye=\x82\xa2\x82\xa5" } ,{ "yi=\x82\xa2" }	,{ "yo=\x82\xe6" }   ,{ "yu=\x82\xe4" },
	{ "za=\x82\xb4" }   ,{ "ze=\x82\xba" }	 ,{ "zi=\x82\xb6" }	,{ "zo=\x82\xbc" }   ,{ "zu=\x82\xb8" },
	{ "zya=\x82\xb6\x82\xe1" },{ "zye=\x82\xb6\x82\xa5" },{ "zyi=\x82\xb6\x82\xa1" },{ "zyo=\x82\xb6\x82\xe5" },{ "zyu=\x82\xb6\x82\xe3" },
	{ "\1\0" }
};
#endif	/* if DEFTEXT end */

/*PUCH*/UCHAR	PWIN  *RoomajiOpen ( SHORT hVjeLib, UCHAR PWIN *infilename, UCHAR PWIN *fepname )
{
	UCHAR	chr ;
	UCHAR	chrsv = 0;
	UCHAR	PWIN *ptr ;
	UCHAR	PWIN *ptrbuf ;
	UCHAR	PWIN *pTextBuff ;
	USHORT	tablelength = 0;
	USHORT	reccount	= 0;
	int 	i;
	int 	j;
	int 	addflag ;
	int 	charnum ;
	int 	yomicnt ;
	int 	length ;
	int 	linecnt ;
	int 	cntsave ;
	int 	fd ;
	int 	rdlen ;
	int 	memflag = 0;
	int 	filelen = 0;
	int 	start	= 0;
	UCHAR	outbuf [ MAXSTRING ];
	UCHAR	pindex [ INDEXMAX ];
	UCHAR	workbuf [ READLEN + 1 ];
	UCHAR	PWIN * precadr [ DEFROMAMAX ];

#if DEFTEXT
	ErrorCode = ERR_NOT_ERROR;
#endif	/* if DEFTEXT end */
	/* INI ե礭 filelen  */
	if ( ( fd = LowOpen ( infilename, O_RDONLY /*| O_BINARY*/ ) ) < 0 ) {
		ErrorCode = ERR_FILE_NOT;
#if !DEFTEXT
		return NULL;			/* error return */
#endif	/* if DEFTEXT end */
	}

#if DEFTEXT
	if ( ErrorCode == ERR_NOT_ERROR ) {
		while ( 1 ) {
			rdlen = LowRead ( fd, workbuf, READLEN );
			filelen += rdlen;
			if ( rdlen < READLEN )
				break;
		}
		LowClose ( fd );

		/* INI եΥƥȥǡ pTextBuff ɤ߹ */
		fd = LowOpen ( infilename, O_RDONLY /*| O_BINARY*/ );
#if WINDOWS || DPMI
		pTextBuff = LowMalloc ( (size_t)filelen + 1, hVjeLib, /*MAX_SDIC + 2*/MALLOC_7);
#else
		pTextBuff = LowMalloc ((size_t)filelen + 1);
#endif
		memflag = 1;
		rdlen = LowRead ( fd, pTextBuff, filelen );
		LowClose ( fd );
		if ( rdlen != filelen  )
			ErrorCode = ERR_NOT_READ;
	}
#else
	while ( 1 ) {
		rdlen = LowRead ( fd, workbuf, READLEN );
		filelen += rdlen;
		if ( rdlen < READLEN )
			break;
	}
	LowClose ( fd );

	/* INI եΥƥȥǡ pTextBuff ɤ߹ */
	fd = LowOpen ( infilename, O_RDONLY /*| O_BINARY*/ );
#if WINDOWS || DPMI
	pTextBuff = (UCHAR PWIN *) LowMalloc ((size_t)filelen + 1,hVjeLib,/*MAX_SDIC+2*/MALLOC_7);
#else
	pTextBuff = (UCHAR PWIN *) LowMalloc ((size_t)filelen + 1);
#endif
	memflag = 1;
	rdlen = LowRead ( fd, pTextBuff, filelen );
	LowClose ( fd );
	if ( rdlen != filelen  ) {
		ErrorCode = ERR_NOT_READ;
		return NULL;			/* error return */
	}
#endif	/* if DEFTEXT end */
#if PCUNIX/*PCUX9908*/
{	unsigned char *pTextEuc;
	pTextBuff[filelen]= 0;
	pTextEuc = euc2sjis(pTextBuff);
	LowFree((PSEL)pTextBuff);
	pTextBuff = pTextEuc;
}
#endif

	i	= INDEXMAX ;			/* stack clear */
	ptr = pindex ;
	while ( i-- )
		*ptr++ = 0;

#if DEFTEXT
retry:
	if ( ErrorCode == ERR_NOT_ERROR )
		ptr = pTextBuff;
	else {
		strncopy ( fepname, "ROMA", 4 );
		ptr = (UCHAR PWIN *)RomaTblText [ 0 ];
		while ( (chr = *ptr) != 0x01 ) {
			if ( chr == 0 )
				*ptr = 0x0A;
			ptr++ ;
		}
		*ptr = 0x00;
		ptr = (UCHAR *)RomaTblText [ 0 ];
	}
#else
	ptr = pTextBuff;
#endif	/* if DEFTEXT end */

	/* Ѵơ֥̾õƥȥեγϰ֤ */
	linecnt = 0;
	while ( line_get ( ptr, &rdlen, &addflag ) ) {
		if ( start ) {
			if ( addflag )
				precadr [ linecnt++ ] = ptr ;
		}
		if ( ptr [ 0 ] == '[' ) {	/* Ѵơ֥̾ϵ */
			if ( start ) {
				if ( chkendname ( ptr ) ) {
					linecnt--;
					break;
				}
			}
			else {
				if ( strcmpnam ( &ptr [ 1 ], fepname ) == 0 )
					start = 1;
			}
		}
		if ( linecnt >= DEFROMAMAX )		/*	*/
			break;
		ptr += rdlen;
	}
	cntsave = linecnt ;

	if ( !linecnt ) {
		ErrorCode = ERR_NOT_DEFINE;
#if DEFTEXT
		goto retry;
#else
/*		return NULL;			/ * error return * / */
		pRomaTable = (PROMAJI)-1;
		goto end ;
#endif	/* if DEFTEXT end */
	}
	if ( !start ) {
		ErrorCode = ERR_TABLE_NOT;
#if DEFTEXT
		goto retry;
#else
/*		return NULL;			/ * error return * / */
		pRomaTable = (PROMAJI)-1;
		goto end ;
#endif	/* if DEFTEXT end */
	}

	/* ʸ precadr 򥯥åȤ */
	rsort ( precadr, 0, linecnt - 1 );
	/*  pindex ɤߤγʸƱǼơ֥ */
	linecnt = 0;
	while ( 1 ) {
		if ( charnum = chcount ( precadr [ linecnt++ ], &chr ) ) {
			if ( chr == chrsv )
				++pindex [ chr - 0x20 ];
			else {
				pindex [ chr - 0x20 ] = (UCHAR)1;
				chrsv = chr;
			}
			tablelength += charnum ;	/* +1 moji record inf / -1 moji = */
			reccount++;
		}
/*		if ( linecnt > cntsave ) */
/*BUG*/		if ( linecnt >= cntsave )
			break;
	}
    /*
	 * Dynamically allocate a large file buffer.
	 * If there's not enough memory for it,
	 * find the largest amount available on the near heap and allocate that.
	 * This can't fail, no matter what the memory model.
     */
	length = 5*sizeof(USHORT) + INDEXMAX*sizeof(INDEX) + tablelength ;
#if WINDOWS || DPMI
	if ( ( pRomaTable = (PROMAJI)LowMalloc ((size_t)length,hVjeLib,/*MAX_SDIC+3*/MALLOC_8 ) ) == NULL ) {
#else
	if ( ( pRomaTable = (PROMAJI)LowMalloc ((size_t)length ) ) == NULL ) {
#endif
		ErrorCode = ERR_NOT_ALLOC;
#if DEFTEXT
		goto retry;
#else
		return NULL;			/* error return */
#endif	/* if DEFTEXT end */
	}
	ptr = (UCHAR PWIN *)pRomaTable;
	i = length;
	while ( i-- )
		*ptr++ = 0; 						/* allocate memory clear */
	pRomaTable->filelength	= length ;
	pRomaTable->tablelength = tablelength ;
	pRomaTable->indexcount	= INDEXMAX ;
	pRomaTable->reccount	= reccount ;

	ptrbuf = (UCHAR PWIN *)pRomaTable;
	ptr    = (UCHAR PWIN *)&ptrbuf [ 5*sizeof(USHORT) + INDEXMAX*sizeof(INDEX) ];
	linecnt = 0;
	for ( i = 0; i < INDEXMAX; i++ ) {
		for ( j = 0; j < (int)pindex [ i ]; j++ ) {
			if ( charnum = check ( precadr [ linecnt++ ], outbuf, &yomicnt ) ) {
				chr = (UCHAR)yomicnt;
				chr <<= 4;
				chr = (UCHAR)(chr + charnum);
				ptr [ 0 ] = chr;				/* moji suu */
				strncopy ( &ptr [ 1 ], outbuf, charnum );
				if ( j == 0 ) {
					pRomaTable->index [ i ].count	= pindex [ i ];
					pRomaTable->index [ i ].prectop = (USHORT)((long)ptr - (long)&pRomaTable->filelength);
				}
				ptr += (charnum + 1);			/* +1 moji suu */
			}
			else
				--j;
			if ( linecnt > cntsave )
				goto end;
		}
	}
end:
	if ( memflag )
		LowFree ( (PSEL)pTextBuff );		/* malloc memory for text file is free */
	return (UCHAR PWIN *)pRomaTable;
}

void RoomajiClose (pbuf )
void PWIN *pbuf;
{
	LowFree ( (PSEL)pRomaTable );
	pRomaTable = (PROMAJI)NULL;
}

int ErrCodeGet ( void )
{
	return ErrorCode;
}

/*
 *	ʸ ptr 򥯥åȤ
 */
static void FTYPE rsort ( UCHAR PWIN * PWIN * ptr, int lower, int upper )
{
	int 	t1 = lower;
	int 	t2 = upper;
	UCHAR	PWIN *mid = ptr [ lower + upper >> 1 ];

	while ( t1 <= t2 ) {
		while ( strcmpalh ( mid, ptr [ t2 ] ) )
			t2--;
		while ( strcmpalh ( ptr [ t1 ], mid ) )
			t1++;
		if ( t1 <= t2 ) {
			swapp ( ptr [ t1 ], ptr [ t2 ] );
			t1++;
			t2--;
		}
    }
	if ( lower < t2 )
		rsort ( ptr, lower, t2 );
	if ( t1 < upper )
		rsort ( ptr, t1, upper );
}

/*
 *	input  : pfile	-> text file pointer
 *	output : length -> one line character length
 *		return 0 -> ƥȥǡνǤ
 *			   1 -> ƥȥǡλĤ꤬
 */
static	int FTYPE line_get ( UCHAR PWIN *pfile, int PWIN *length, int PWIN *addflag )
{
	UCHAR	chr;
	UCHAR	PWIN *ptr;
	UCHAR	PWIN *ptrin;
	int 	eqcnt;
	int 	wdpos;
	int 	wdcnt;

	ptr = ptrin = pfile;
	eqcnt = wdpos = wdcnt = 0;
	while ( (chr = *pfile) != 0x0A && chr != 0x0D && chr != 0 ) {
		if ( chr == 0x81 && *(pfile+1) == 0x40 ) {	/* ѥڡ̵뤹 */
			pfile += 2;
			wdcnt	+= 2;
		}
		else {
			if ( chr == '=' )
				eqcnt++;
			if ( chr != ' ' )						/* Ⱦѥڡ̵뤹 */
				ptr [ wdpos++ ] = chr;
			pfile++;
			wdcnt++;
		}
	}
	while ( (chr = *pfile) == 0x0A || chr == 0x0D ) {
		ptr [ wdpos++ ] = 0;
		pfile++ ;
		wdcnt++ ;
	}
	*length = wdcnt;
	if ( eqcnt >= 1 && eqcnt <= 4 ) {
		if ( ptrin [ 0 ] == '[' ) {
			if ( chkendname ( ptrin ) ) 	/* case [  =  ] ? */
				*addflag = 0;				/* out of yomi line 	*/
			else
				*addflag = 1;				/* alphabet define line */
		}
		else
			*addflag = 1;
	}
	else
		*addflag = 0;
/*BUGFIX:95/7/24 */
	if ( *pfile == 0 && wdcnt == 0 )
		return 0;				/* file end */
	return 1;
}

/*
 *	return : ʸ ptr =װʳʸ
 */
static	int FTYPE chcount ( UCHAR PWIN *ptr, UCHAR PWIN *chr )
{
	int 	count = 0;

	*chr = *ptr;				/* ʸ ptr ƬʸΥ */
	while ( *ptr++ != 0 )
		count++;
	return count;
}

/*
 *	convert from hiragana to katakana
 */
static	int FTYPE check ( UCHAR PWIN *ptr, UCHAR PWIN *outbuf, int PWIN *pyomicnt )
{
	UCHAR	chr;
	UCHAR	PWIN *ptrsav;
	UCHAR	PWIN *outsav;
	int 	count = 0;
	int 	eqcnt = 0;

	ptrsav = ptr;
	outsav = outbuf;
	while ( (chr = *ptr++) != 0 ) {
		if ( chr >= 0x81 && chr <= 0x9f || chr >= 0xe0 && chr <= 0xfc ) {
			if (chr == 0x82 && (*ptr >= 0x9F && *ptr <= 0xF1)) {
				*outbuf++ = (UCHAR)(chr + 1);
				if ( *ptr > 0xDD )
					*outbuf++ = (UCHAR)(*ptr++ - 0x5E);
				else
					*outbuf++ = (UCHAR)(*ptr++ - 0x5F);
			}
			else {
				*outbuf++ = chr ;
				*outbuf++ = *ptr++;
			}
			count += 2;
		}
		else {
			if ( chr == '=' ) {
				eqcnt++;
				*pyomicnt = count;
			}
			else {
				count++;
				*outbuf++ = chr;
			}
		}
	}
	*outbuf = 0;
	if ( eqcnt >= 2 ) {
		int 	len;
		int 	add;
		UCHAR	workbuf [ 8 ];
		add = eqcnt - 1;
		ptr = workbuf;
		strncopy ( ptr, ptrsav, (len = *pyomicnt + add) );
		ptr += len;
		strncopy ( ptr, &outsav [ *pyomicnt ], count - *pyomicnt + 1 );
		count += add;
		*pyomicnt += add;
		strncopy ( outsav, workbuf, count + 1 );
	}
	return count;
}

/*
 *	copy from s to d by length len
 */
static	void FTYPE	strncopy ( UCHAR PWIN *d, UCHAR PWIN *s, int len )
{
	while ( len-- )
		*d++ = *s++;
}

/*
 *	large and small alphabet is same
 *		return : 0	  ʸ  ʸ  
 *				 1
 */
static	short FTYPE	strcmpnam ( UCHAR PWIN *s, UCHAR PWIN *t )
{
	while ( *s != ']' && *s && *t ) {
		if ( (*s++ & 0xDF) != (*t++ & 0xDF) )
			return 1;
	}
	return 0;
}

/*
 *	string s and t have one of '='	( not many than 1 - only one )
 *		return : s <  t -> 1	ʸ  ʸ  꾮
 *				 s >= t -> 0
 */
static	short FTYPE	strcmpalh ( UCHAR PWIN *s, UCHAR PWIN *t )
{
	short	cnt = 4;

	while ( --cnt ) {
		if ( *s < *t )
			return 1;
		else if ( *s++ == *t++ ) {
			if ( *s == '=' || *t == '=' )
				break;
		}
		else
			break;
	}
	return 0;
}

/*
 *	return 0 : not table name define line
 *		   1 : table name define line [ table name ]
 */
static	int FTYPE chkendname ( UCHAR PWIN *ptr )
{
	UCHAR	chr;

	while ( (chr = *ptr) != 0x0A && chr != 0x0D && chr != 0 )
		ptr++;
	if ( *(ptr - 1) == ']' )
		return 1;
	else
		return 0;
}
