/*
**	VJE Delta
**
**			vstring2.c
**
*/

#include	"common.h"
#include	"vjestr.h"
#include	"vje.h"
#include	"vjelib.h"
#include	"vfzk.h"
#include	"vfncdef.h"


/*
 * 	Hankaku to zenkaku
 *             ret_inf = 0: successful operation
 *                  Not 0 : Error
 */
global short han_zen(han, zen)
BUFF PWIN	*han;
BUFF PWIN	*zen;
{
	UCHAR	sjchr[4];
	REG1 short	i;
	REG2 UCHAR	c;

	PLength(zen) = 0;
	for (i = 1; i <= PLength(han); i++) {
		c = han->str[i];
		if (0x81 <= c && c <= 0x9f || 0xe0 <= c && c <= 0xfc) {
			Addc2(zen, &han->str[i]);
			++i;
		}
		else {
			if (Jissj(c, sjchr, (short) 0) == 3)
				return (i);
			Addc2(zen, &sjchr[1]);
		}
		if (PLength(zen) >= NUM_CHAR * 2)
			return (0);
	}
	return (0);
}


/*
 *	Hankaku to zenkaku hiragana
 */
global short han_hira(han, zen)
BUFF PWIN	*han;
BUFF PWIN	*zen;
{
	ZBUFF	work;	/*[NUM_CHAR * 2 * 3];*/
	REG1 short	i;

	i = han_kata(han, (BUFF *)&work, 1);/*991210 WRN*/
	kata_hira((BUFF *)&work, zen);/*991210 WRN*/
	return (i);
}


/*
 *	Katakana to hiragana
 */
global void	kata_hira(kata, hira)
BUFF PWIN	*kata;
BUFF PWIN	*hira;
{
	REG1 short	ip;
	REG2 UCHAR	c2;
	REG3 UCHAR	c1;

	PLength(hira) = 0;
	for (ip = 1; ip <= PLength(kata); ip += 2) {
		c1 = kata->str[ip];
		c2 = kata->str[ip + 1];
		if (ChkTyp(&kata->str[ip]) == 5) {
			if (c2 <= 0x93) {
				if (c2 >= 0x80)
					--c2;
				c2 += 0x5f;
				c1 = 0x82;
			}
		}
		PAddchar(hira, c1);
		PAddchar(hira, c2);
	}
}


/*
 *	Hiragana to katakana
 */
global void	hira_kata(hira, kata)
BUFF PWIN	*hira;
BUFF PWIN	*kata;
{
	REG2 UCHAR	c2;
	REG3 UCHAR	c1;
	REG1 short	ip;

	PLength(kata) = 0;
/*WIN95:BUGFIX (Hankaku majiri) */
	for (ip = 1; ip <= PLength(hira); ip += /*2*/1) {
		c1 = hira->str[ip];
		c2 = hira->str[ip + 1];
		if (c1 != 0x82 || c2 < 0x9f) {
			if (!VjeKanji(c1))
				PAddchar(kata, c1);
			else {
				PAddchar(kata, c1);
				PAddchar(kata, c2);
				ip++;
			}
		}
		else {
			PAddchar(kata, 0x83);
			if (c2 <= 0xdd)
				PAddchar(kata, c2 - (UCHAR)0x5f);
			else
				PAddchar(kata, c2 - (UCHAR)0x5e);
			ip++;
		}
	}
}


#if MAC
	global UCHAR	katakana[] = {
		'\xa7', '\xb1', '\xa8', '\xb2', '\xa9', '\xb3', '\xaa', '\xb4',
		'\xab', '\xb5', '\xb6', '\xb6', '\xb7', '\xb7', '\xb8', '\xb8',
		'\xb9', '\xb9', '\xba', '\xba', '\xbb', '\xbb', '\xbc', '\xbc',
		'\xbd', '\xbd', '\xbe', '\xbe', '\xbf', '\xbf', '\xc0', '\xc0',
		'\xc1', '\xc1', '\xaf', '\xc2', '\xc2', '\xc3', '\xc3', '\xc4',
		'\xc4', '\xc5', '\xc6', '\xc7', '\xc8', '\xc9', '\xca', '\xca',
		'\xca', '\xcb', '\xcb', '\xcb', '\xcc', '\xcc', '\xcc', '\xcd',
		'\xcd', '\xcd', '\xce', '\xce', '\xce', '\xcf', '\xd0', (UCHAR)ERR,
		'\xd1', '\xd2', '\xd3', '\xac', '\xd4', '\xad', '\xd5', '\xae',
		'\xd6', '\xd7', '\xd8', '\xd9', '\xda', '\xdb', '\xdc', '\xdc',
		(UCHAR)ERR, (UCHAR)ERR, '\xa6', '\xdd', '\xb3', '\xb6', '\xb9'
	};
	global UCHAR	kigou[] ={
		0x20, 0xa4, 0xa1, 0x2c, 0x2e, 0xa5, 0x3a, 0x3b,
		0x3f, 0x21, 0xde, 0xdf, 0x00, 0x60, 0x00, 0x5e,
		0x7e, 0x5f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0xb0, 0x2D, 0x00, 0x2f, 0x5C,
		0x7e, 0x00, 0x7c, 0x00, 0x00, 0x60, 0x27, 0x00,
		0x22, 0x28, 0x29, 0x00, 0x00, 0x5b, 0x5d, 0x7b,
		0x7d, 0x00, 0x00, 0x00, 0x00, 0xa2, 0xa3, 0x00,
		0x00, 0x00, 0x00, 0x2b, 0x2d, 0x00, 0x00, 0x00,
		0x00, 0x3d, 0x00, 0x3c, 0x3e, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5c,
		0x24, 0x00, 0x00, 0x25, 0x23, 0x26, 0x2a, 0x40
	};
#endif
/*
 *	Zenkaku to hankaku
 */
global short zen_han(zen, han)
BUFF PWIN	*zen;
BUFF PWIN	*han;
{
#if !MAC
	static UCHAR	katakana[] = {
		'\xa7', '\xb1', '\xa8', '\xb2', '\xa9', '\xb3', '\xaa', '\xb4',
		'\xab', '\xb5', '\xb6', '\xb6', '\xb7', '\xb7', '\xb8', '\xb8',
		'\xb9', '\xb9', '\xba', '\xba', '\xbb', '\xbb', '\xbc', '\xbc',
		'\xbd', '\xbd', '\xbe', '\xbe', '\xbf', '\xbf', '\xc0', '\xc0',
		'\xc1', '\xc1', '\xaf', '\xc2', '\xc2', '\xc3', '\xc3', '\xc4',
		'\xc4', '\xc5', '\xc6', '\xc7', '\xc8', '\xc9', '\xca', '\xca',
		'\xca', '\xcb', '\xcb', '\xcb', '\xcc', '\xcc', '\xcc', '\xcd',
		'\xcd', '\xcd', '\xce', '\xce', '\xce', '\xcf', '\xd0', (UCHAR)ERR,
		'\xd1', '\xd2', '\xd3', '\xac', '\xd4', '\xad', '\xd5', '\xae',
		'\xd6', '\xd7', '\xd8', '\xd9', '\xda', '\xdb', '\xdc', '\xdc',
		(UCHAR)ERR, (UCHAR)ERR, '\xa6', '\xdd', '\xb3', '\xb6', '\xb9'
	};
	static UCHAR	kigou[] ={
		0x20, 0xa4, 0xa1, 0x2c, 0x2e, 0xa5, 0x3a, 0x3b,
		0x3f, 0x21, 0xde, 0xdf, 0x00, 0x60, 0x00, 0x5e,
		0x7e, 0x5f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0xb0, 0x2D, 0x00, 0x2f, 0x5C,
		0x7e, 0x00, 0x7c, 0x00, 0x00, 0x60, 0x27, 0x00,
		0x22, 0x28, 0x29, 0x00, 0x00, 0x5b, 0x5d, 0x7b,
		0x7d, 0x00, 0x00, 0x00, 0x00, 0xa2, 0xa3, 0x00,
		0x00, 0x00, 0x00, 0x2b, 0x2d, 0x00, 0x00, 0x00,
		0x00, 0x3d, 0x00, 0x3c, 0x3e, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5c,
		0x24, 0x00, 0x00, 0x25, 0x23, 0x26, 0x2a, 0x40
	};
#endif
	REG3 UCHAR	y;
	REG5 short	ten;
	REG1 short	i;
	REG4 UCHAR	c1;
	REG2 UCHAR	c2;

	PLength(han) = 0;
	for (i = 1; i <= PLength(zen); i += 2) {
		ten = NORMAL_TYP;
		c1 = zen->str[i];
		c2 = zen->str[i + 1];
#if	PENWIN
		if (Vrchk_knj(&zen[i]) == 1) {
			Addchar(han, 0x80);
			continue;
		}
#endif
		switch (c1) {
		case 0x81: /* Kigou */
			if (0x40 <= c2 && c2 <= 0x97) {
				if ((y = kigou[c2 - 0x40]) == 0x00) {
#if	PENWIN
					Addchar(han, 0x80);
					continue;
#else
					return (i + 1);
#endif
				}
			}
			else {
#if	PENWIN
				Addchar(han, 0x80);
				continue;
#else
				return (i + 1);
#endif
			}
			break;
		case 0x82:
			if (0x4f <= c2 && c2 <= 0x58)	/* Suuji */
				y = c2 - (UCHAR)0x1f;
			else if (0x60 <= c2 && c2 <= 0x79)	/* oomoji */
				y = c2 - (UCHAR)0x1f;
			else if (0x81 <= c2 && c2 <= 0x9a)	/* komoji */
				y = c2 - (UCHAR)0x20;
			else {
#if	PENWIN
				Addchar(han, 0x80);
				continue;
#else
				return (i + 1);
#endif
			}
			break;
		case 0x83:
			if (0x40 <= c2 && c2 <= 0x96) {
				if ((y = katakana[c2 - 0x40]) == (UCHAR) ERR) {
#if	PENWIN
					Addchar(han, 0x80);
					continue;
#else
					return (i + 1);
#endif
				}
				ten = chk_dakhan(c2);
			}
			else {
#if	PENWIN
				Addchar(han, 0x80);
				continue;
#else
				return (i + 1);
#endif
			}
			break;
		default:
#if	PENWIN
			Addchar(han, 0x80);
			continue;
#else
			return (i + 1);
#endif
		}
		PAddchar(han, y);
		if (ten == DAKU_TYP)
			PAddchar(han, DAKUTEN);
		else if (ten == HANDAKU_TYP)
			PAddchar(han, HANDAKUTEN);
	}
	return (0);
}

global UCHAR	dakuon_table [MAX_TABLE]={
	Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N|A_V, Q_N|A_N, Q_N|A_N,
	Q_N|A_N, Q_N|A_N, Q_N|A_D, Q_D|A_N, Q_N|A_D, Q_D|A_N, Q_N|A_D, Q_D|A_N,
	Q_N|A_D, Q_D|A_N, Q_N|A_D, Q_D|A_N, Q_N|A_D, Q_D|A_N, Q_N|A_D, Q_D|A_N,
	Q_N|A_D, Q_D|A_N, Q_N|A_D, Q_D|A_N, Q_N|A_D, Q_D|A_N, Q_N|A_D, Q_D|A_N,
	Q_N|A_D, Q_D|A_N, Q_N|A_N, Q_N|A_D, Q_D|A_N, Q_N|A_D, Q_D|A_N, Q_N|A_D,

	Q_D|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_D|A_H, Q_D|A_N,
/*BUGFIX 94/9/28 */
/*ѤԤפ A_D()A_N(ػ)˽*/
/*   *Q_H|A_D, Q_N|A_D|A_H, Q_D|A_N,*Q_H|A_D, Q_N|A_D|A_H, Q_D|A_N,*Q_H|A_D, Q_N|A_D|A_H, */
	Q_H|A_N, Q_N|A_D|A_H, Q_D|A_N, Q_H|A_N, Q_N|A_D|A_H, Q_D|A_N, Q_H|A_N, Q_N|A_D|A_H,
/*	Q_D|A_N,*Q_H|A_D, Q_N|A_D|A_H, Q_D|A_N,*Q_H|A_D, Q_N|A_N, Q_N|A_N, Q_E|A_N, */
	Q_D|A_N, Q_H|A_N, Q_N|A_D|A_H, Q_D|A_N, Q_H|A_N, Q_N|A_N, Q_N|A_N, Q_E|A_N,

	Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N,
	Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N,
	Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_N|A_N, Q_D|A_N, Q_N|A_N, Q_N|A_N
};
/*
 *	Check dakuon
 */
global short FTYPE	chk_dakhan(c)
UCHAR	c;
{
	REG1 short	i;

#if MAC				/* OFFSETͽ󤵤Ƥ뤿*/
	i = c - OFF_SET;
#else
	i = c - OFFSET;
#endif
	if (0 <= i && i < MAX_TABLE) {
		i = dakuon_table[i];
		if (i & Q_H)
			return (HANDAKU_TYP);
		else if (i & Q_D)
			return (DAKU_TYP);
	}
	return (NORMAL_TYP);
}

