/*
**	VJE Delta
**
**			vstrsub.c
**
*/

#include	"common.h"
#include	"vje.h"
#include	"vjelib.h"
#include	"vfzk.h"
#include	"vfncdef.h"



/*
 *	Copy string
 */
#if WINDOWS|MSDOS
	#if	WIN32
	global void	Copylng(a, b, n)
	UCHAR PWIN	*a;
	UCHAR PWIN	*b;
	XLONG	n;
	{
	if (n < 0 && n > -256)
		return;
	while (n--)
		*b++ = *a++;
	}
	#else
	#endif
#else
global void	Copylng(a, b, n)
UCHAR PWIN	*a;
UCHAR PWIN	*b;
XLONG	n;
{

/*
_asm {
	push	si
	push	di
	push	ds
	lds	si, a
	les	di, b
	mov	cx, n
	and	cx, cx
	jz	copy_ret
	xor	ax,ax
	cld
	shr	cx, 1
	jnc	copy_020
	movsb
copy_020:
	rep	movsw
copy_ret:
	pop	ds
	pop	di
	pop	si
	}
*/
	if (n < 0 && n > -256)
		return;
	while (n--)
		*b++ = *a++;
}
#endif

void Copylngb(a,b,len)
UCHAR PWIN	*a;
UCHAR PWIN	*b;
XLONG	len;
{
	while (len > 0) {
		--len;
		*(b + len) = *(a + len);
	} 
}



/*
 *	Copy
 */
global void	CopyKb(a, b)
/*REG1*/ BUFF PWIN	*a;
/*REG2*/ BUFF PWIN	*b;
{
	REG3	short	i;
#if 1
	REG1	UCHAR PWIN	*s;
	REG2	UCHAR PWIN	*d;

	PLength(b) = i = PLength(a);
	s = &a->str[1];
	d = &b->str[1];
	while (i--)		/* ! */
		*d++ = *s++;	/* ! */
#else
	i = PLength(a);
	*b++ = *a++;		/* ! */
	while (i--)		/* ! */
		*b++ = *a++;	/* ! */
#endif
}


/*
 *	Copy (addition mode)
 */
global void	CopyAdd(a, b)
BUFF PWIN	*a;
BUFF PWIN	*b;
{
	REG1 USHORT	i;

	for (i = 1; i <= PLength(a); i++)
		PAddchar(b, a->str[i]);
}




/*
 *	Kanji string compare
 */
global short	KstrCmp(buf1, buf2)
BUFF PWIN	*buf1;
BUFF PWIN	*buf2;
{
	REG1 USHORT	i;
	REG2 UCHAR	c;

	for (i = 1; i <= PLength(buf1); i++) {
		if (i > PLength(buf2))
			break;
		if ((c = buf1->str[i]) != buf2->str[i])
			break;
		if (0x81 <= c && c <= 0x9f || 0xe0 <= c && c <= 0xfc) {
			if (buf1->str[i + 1] != buf2->str[i + 1])
				break;
			++i;
		}
	}
	return (i);
}


/*
 *	Komoji check
 *  SJI_G              °ƬˤϤʤʸΥå
 *  SJI_G|SJI_F|SJI_GF ʸƬˤϤʤʸΥå
 *  SJI_DIC            嵭+ʸΥå
 *   entry none  : ->  
 *	       SJI_G : 
 *	       SJI_F : 
 *         SJI_GF: 
 *         SJI_XTU: XTU
 *   return: 0: gaitou komoji dehanai
 *	         1: komoji
 *           2: KATAKANA
 */
global short	ChKomoji(c, ep)
REG1 short	c;
REG2 short	ep;
{
	if (c == _XA || c == _XI || c == _XU || c == _XE || c == _XO || c == _XYA || c == _XYO)
		return (1);
	else if ((ep & SJI_GF) && c == __N)
		return (1);
	else if ((ep & SJI_G) && c == _XYU)
		return (1);
	else if ((ep & SJI_XTU) && c == _XTU)
		return (1);
	else if (ep & SJI_PA) {
		if (c == _TYOUON ||	c == _PA || c == _PI || c == _PU || c == _PE || c == _PO
		|| (c >= _RA && c <= _RO))
			return (2);
		return (0);
	}
	else if ((ep & SJI_F) && c == _TYOUON)
		return (1);
	else if (ep & SJI_MATUBI) {
 		if (c == _KI || c == _I || c == _TI || c == _TO || c == _MI
		|| c == _RI || c == __U || c == _KU || c == _TU)
			return (1);
		return (0);
	}
	else
		return (0);
}

