/*
**	VJE Delta
**
**			wsetbuf.c
**
*/

#include	"common.h"
#include	"basicedt.h"
#include	"vjestr.h"
#include	"wfncdef.h"
#include	"vjelib.h"
#include	"vfzk.h"
#include	"vfncdef.h"

#define NX	1


extern UCHAR	Jissjtb[];
/*extern	short	roomaji_hen ( UCHAR PWIN *, UCHAR PWIN * ); */

/*
 * return 0: OK
 *        1: hiragana not completed (still alphanumeric)
 *        2: buffer over flow
 *        3: hiragana not available (ka sa ta ha etc.)
 *
 */
global	short FTYPE	set_buf ( pbe, para, bdata )
PBEBUF	pbe;
UCHAR PWIN	*para;
PBD	bdata;
{
	short	i;
	short	cnv_cnt;			/* romaji cnvert count */
	short	rc; 				/* return information */
	short	k_i, k_s, k_e;		/* work for kihon_buf_Q */
	short	byt_cnt;
	short 	fHosei ;
	short	k;

	if ( V_FUNC != MOJI )
		return ( 1 );
	if ( pbe->key_max <= SLength(pbe->key_buf_Q) )		/* if key_buf_Q over */
		return ( 2 );
	pbe->wVjeModeFlag2 = bdata->wVjeModeFlag;
	pbe->wVjeModeFlag3 = bdata->wVjeModeFlag;
	if ( !(bdata->wVjeModeFlag & KATA_BIT) ) {		/* ROMAJI */
		if ( !(bdata->wVjeModeFlag & KANA_BIT) && 
                     !(bdata->wVjeModeFlag & ZENKAKU_BIT) ) {	/* HIRAGANA HANKAKU */
			if (CAR > 0x80 || ((CAR|0x20) >= 'a' && (CAR|0x20) <= 'z'))
					;
		}
		else if ( bdata->wVjeModeFlag & EISUU_BIT )
			pbe->wVjeModeFlag2 |= KATA_BIT;
	}
	else {
		if ( !(bdata->wVjeModeFlag & KANA_BIT) && !(bdata->wVjeModeFlag & ZENKAKU_BIT) ) {	/* HIRAGANA HANKAKU */
			if ( CAR > 0x80 )
				pbe->wVjeModeFlag2 |= ZENKAKU_BIT;
		}
	}
	cnv_cnt = Length(pbe->cnv_data) = 0;

	/*980427-DEBUG*/
	chk_blk ( pbe,pbe->kihon_pos );/*Kya --> ki (i) xya*/

	Length(pbe->key_data) = 5;						/* set counter */
        if (pbe->key_pos - 3 > 0)
	pbe->key_data [ 1 ] = pbe->key_buf_Q.str[ pbe->key_pos - 3 ]; /* before 4 moji */
        if (pbe->key_pos - 2 > 0)
	pbe->key_data [ 2 ] = pbe->key_buf_Q.str[ pbe->key_pos - 2 ]; /* before 3 moji */
        if (pbe->key_pos - 1 > 0)
	pbe->key_data [ 3 ] = pbe->key_buf_Q.str[ pbe->key_pos - 1 ]; /* before 2 moji */
        if (pbe->key_pos  > 0)
	pbe->key_data [ 4 ] = pbe->key_buf_Q.str[ pbe->key_pos	 ]; /* before 1 moji */
	pbe->key_data [ 5 ] = CAR;						/* current postion moji */

	fHosei = 0;

	/* input ROMAJI */
	if ((pbe->wVjeModeFlag2 & KATA_BIT) == 0)
		cnv_cnt = inp_roma(pbe);
	if (cnv_cnt < 0)
		return (1);		/* illiagal code */
	if (cnv_cnt == 0)	/* non romaji mode or dakuon in romaji mode */
	/* input KANAMOJI */
		cnv_cnt = inp_kana(pbe);
	if (cnv_cnt < 0)
		return (1);		/* illigal code */
	else if (cnv_cnt == 0)
		goto key1_set;		/* dakuten or handakuten */
	/*  set kihon & attribute buffer */
	k_i = get_kpos ( pbe,(-cnv_cnt) + 1 );	/* get insert start addr (current) */
	k_s = get_kpos ( pbe,0 );				/* get move start */
	k_e = k_i + pbe->cnv_data [ 0 ]; 		/* get move end */
	if ( /*(UCHAR)*/pbe->kihon_pos < SLength(pbe->kihon_buf_Q) ) {
		if ( (rc = buf_move ( &pbe->kihon_buf_Q, pbe->kihon_max, k_s, k_e )) != 0 )
			return ( rc );
		buf_move2 ( pbe->kihon_atr_Q, pbe->kihon_max, k_s, k_e );
		byt_cnt = k_e - k_s;
	}
	if ( cnv_cnt == 1 ) {
		byt_cnt = 1;
/*WIN95		if ( pbe->wVjeModeFlag2 & ZENKAKU_BIT ) */
/*			byt_cnt++; */
		if ( Length(pbe->cnv_data) == 2 )
			byt_cnt++;
	}
	else
		byt_cnt = k_e - k_s;
	for ( i = 1; (UCHAR)i <= Length(pbe->cnv_data); i++ ) {
		pbe->kihon_buf_Q.str[ ++k_i ] = pbe->cnv_data [ i ];
		pbe->kihon_atr_Q [ k_i	] = pbe->atr_data [ i ];
	}
	/*990916 byt_cnt ξ礬 */
	Length(pbe->kihon_atr_Q) = SLength(pbe->kihon_buf_Q) += /*(UCHAR)*/byt_cnt;
	pbe->kihon_pos = k_e;
/*WIN95:ѻϻ */
	fHosei = set_hosei(pbe,pbe->kihon_pos);
key1_set:
	/* set keybuffer1 */
	for ( i = SLength(pbe->key_buf_Q); i > pbe->key_pos; i-- )
		pbe->key_buf_Q.str[ i + 1 ] = pbe->key_buf_Q.str[ i - 1 + 1 ];
	k = CAR ;
	if (pbe->key_pos == 0 && (pbe->kihon_atr_Q[pbe->kihon_pos] & C_AUTO_HOSEI) &&
		(k == 0x2d || k == 0x2c || k == 0x2e || k == 0x2f)) {
		if (k == 0x2d)
			k = 0xb0;
		else if (k == 0x2c)
			k = 0xa4;
		else if (k == 0x2e)
			k = 0xa1;
		else if (k == 0x2f)
			k = 0xa5;
	} else {
/*ѿ⡼ɤλϡ˴طʤԥꥪɥޤȤ */
		if ((pbe->wVjeModeFlag3 & EISUU_BIT) != 0) {
			if (k == 0xb0)
				k = 0x2d;
			else if (k == 0xa4)
				k = 0x2c;
			else if (k == 0xa1)
				k = 0x2e;
			else if (k == 0xa5)
				k = 0x2f;
		}
	}
	pbe->key_buf_Q.str[ pbe->key_pos + 1 ] = (UCHAR)k;
/*	pbe->key_buf_Q.str[ pbe->key_pos + 1 ] = CAR; */
	SLength(pbe->key_buf_Q)++;
	pbe->key_pos = get_pos1 ( pbe,pbe->kihon_pos );
/*ϥХåեι */
	k = pbe->key_buf_Q.str[ pbe->key_pos ] ;
	if (fHosei != 0 && k == (UCHAR)((fHosei >> 8) & 0xff)) {
		pbe->key_buf_Q.str[ pbe->key_pos ] = (UCHAR)(fHosei & 0xff);
		bdata->wCharCode = (UCHAR)(fHosei & 0xff);
	}
	k = pbe->key_buf_Q.str[ pbe->key_pos + 1 ] ;
	if (fHosei != 0 && k == (UCHAR)((fHosei >> 8) & 0xff)) {
		pbe->key_buf_Q.str[ pbe->key_pos + 1 ] = (UCHAR)(fHosei & 0xff);
		bdata->wCharCode = (UCHAR)(fHosei & 0xff);
	}
	if ( (pbe->wVjeModeFlag2 & KATA_BIT) == 0 ) {
#if NX
		if ( cnv_cnt == 2 ) {
			if ( (pbe->key_buf_Q.str[ pbe->key_pos - 1 ] & 0xDF) == 'N' ) {
				if ( pbe->kihon_atr_Q [ pbe->kihon_pos ] & ZENKAKU_BIT ) {
					UCHAR	chr = pbe->kihon_buf_Q.str[ pbe->kihon_pos - 1 ];
/*bug 94/5/17 				if ( (chr == 0x82 && pbe->kihon_atr_Q [ pbe->kihon_pos ] < 0x9F) || chr == 0x81 ) */
					if ( (chr == 0x82 && pbe->kihon_buf_Q.str[ pbe->kihon_pos ] < 0x9F) || chr == 0x81 )
						return ( 1 );
				}
				else {
					if ( pbe->kihon_buf_Q.str[ pbe->kihon_pos ] <= 0x7F )
						return ( 1 );
				}
			}
		}
		else if ( cnv_cnt == 1 && chk_shin ( pbe->key_buf_Q.str[ pbe->key_pos ] ) == YES )
			return ( 1 );
#else
		if ( cnv_cnt == 1 && chk_shin ( pbe->key_buf_Q.str[ pbe->key_pos ] ) == YES )
			return ( 1 );
#endif
	}
	if (Jissjtb[((pbe->key_buf_Q.str[pbe->key_pos] - 0x20) << 1) + 1] & 0x60)
			return (3);
	return ( OK );
}

/*
*       int ret = inp_roma()    return information
*            -2 = not T_ADD (kihon_buf_Q is Over)
*            -1 = error charctar
*             0 = not romaji converted charctar ( )
*             1 = romaji 1st byte
*             2 = romaji 2nd byte
*/
static	short FTYPE	inp_roma ( pbe )
PBEBUF	pbe;
{
	short	i;
	short	len;
	short	length ;
	short	cnv_cnt;		/* romaji convert count */
	UCHAR	chr;
	SBUFF	work;	/*	UCHAR	work [ 9 ]; */	/* working for convert */
	SBUFF	cnv_work;		/* working for cnv_data */
	short	j;

	chr = (UCHAR)(pbe->wVjeModeFlag2 & (KANA_BIT | KATA_BIT | ZENKAKU_BIT));
/*WIN95:ϥ⡼ */
	if (pbe->wVjeModeFlag2 & KANA_BIT ) {
		if ( pbe->wVjeModeLimit & C_KATA_HAN )
			chr &= ~(ZENKAKU_BIT);
		else if ( pbe->wVjeModeLimit & C_KATA_ZEN )
			chr |= ZENKAKU_BIT;
	}
	Length(pbe->atr_data) = 0;
	for ( i = 1; i < 9; i++ ) {
		pbe->atr_data [ i ] = chr;
/*BUGFIX(95/12/18):n. AUTO_HOSEI ga kikanai */
		if (pbe->wCharSave == 0xff)
			pbe->atr_data[ i ] |= C_AUTO_HOSEI ;
	}
	chr = (UCHAR)pbe->key_data [ Length(pbe->key_data) ];
	if ( chr == 0xde || chr == 0xdf )			/* ??? */
		return ( 0 );
	length = getlength ( pbe );
	len = pbe->key_pos - length;
	Length(pbe->key_data) = (UCHAR)(length + 1);
	for ( i = 1; i <= length; i++ )
		pbe->key_data [ i ] = pbe->key_buf_Q.str[ len + i ];
	pbe->key_data [ i ] = chr;
	cnv_cnt = romahenkan ( pbe, pbe->key_data, pbe->cnv_data, pbe->atr_data );
	if ( cnv_cnt != 0 ) {  /* ޻Ѵ줿 */
/*WIN95:ϥ⡼ */
		if (pbe->wVjeModeFlag2 & KANA_BIT ) {
			if ( pbe->wVjeModeLimit & C_KATA_HAN )
				goto HAN100;
			else if ( pbe->wVjeModeLimit & C_KATA_ZEN )
				goto ZEN100;
		}
		if ( pbe->wVjeModeFlag2 & ZENKAKU_BIT ) {		/* ѥ⡼ */
ZEN100:
			if ( !(pbe->wVjeModeFlag2 & KANA_BIT) ) {	/* Ҥ餬ʥ⡼ */
/*				kata_hira ( pbe->cnv_data, work );
mk3*/				Copylng(pbe->cnv_data, cnv_work.str, Length(pbe->cnv_data)+1);
				cnv_work.len = Length(pbe->cnv_data);
				kata_hira ( (BUFF *)&cnv_work, (BUFF *)&work );/*991210 WRN*/		/* Ҥ餬Ѵ */

				for ( i = 1; i <= (short)SLength(work); i++ )
					pbe->cnv_data [ i ] = work.str[ i ];
			}
			for ( i = 1; i <= (short)Length(pbe->cnv_data); i++ ) {
				if ( VjeKanji(pbe->cnv_data[i]) ) {
					pbe->atr_data [ i ] |= F_ZEN_L;
					pbe->atr_data [i+1] |= F_ZEN_R;
					i++;
				} else
					pbe->atr_data [i] |= F_HANK;
/*BUGFIX-961210			if ( (i & 0x01) != 0 ) */
/*					pbe->atr_data [ i ] |= F_ZEN_L; */
/*				else */
/*BUGFIX-961210					pbe->atr_data [ i ] |= F_ZEN_R; */
			}
		}
		else {							/* Ⱦѥ⡼ */
HAN100:
			if ( !(pbe->wVjeModeFlag2 & KANA_BIT) ) {	/* Ҥ餬ʥ⡼ */
/*				kata_hira ( pbe->cnv_data, work );
mk3*/				Copylng(pbe->cnv_data, cnv_work.str, Length(pbe->cnv_data)+1);
				cnv_work.len = Length(pbe->cnv_data);
				kata_hira ( (BUFF *)&cnv_work, (BUFF *)&work );/*991210 WRN*/		/* Ҥ餬Ѵ */

				for ( i = 1; i <= (short)SLength(work); i++ )
					pbe->cnv_data [ i ] = work.str[ i ];
				for ( i = 1; i <= (short)Length(pbe->cnv_data); i++ ) {
					if (VjeKanji(pbe->cnv_data[ i ])) {
						pbe->atr_data [ i ]     |= F_ZEN_L;
						pbe->atr_data [ i + 1 ] |= F_ZEN_R;
						i++;
					}
				}
			}
			else {
				if ( cnv_cnt == 2 && 
					(pbe->key_data[ 1 ] & 0xDF) == 'N' &&
					chk_nn2(pbe,pbe->key_data [ 2 ] ) == YES ) { /*n+? */
					Length(pbe->cnv_data) = 2;
/*					zen_han ( pbe->cnv_data, work ) ;
					work[Length(work)+1] = pbe->cnv_data[3];
					Length(work)++;
mk3*/
					Copylng(pbe->cnv_data, cnv_work.str, Length(pbe->cnv_data)+1);
					cnv_work.len = Length(pbe->cnv_data);
					zen_han ( (BUFF *)&cnv_work, (BUFF *)&work ) ;/*991210 WRN*/
					work.str[SLength(work)+1] = cnv_work.str[3];
					SLength(work)++;
				} else {
/*					zen_han ( pbe->cnv_data, work ) ;
mk3*/					Copylng(pbe->cnv_data, cnv_work.str, Length(pbe->cnv_data)+1);
					cnv_work.len = Length(pbe->cnv_data);
					zen_han ( (BUFF *)&cnv_work, (BUFF *)&work ) ;/*991210 WRN*/

				}
				len = SLength(work);
				if ( len >= 3 && pbe->kihon_pos >= 0x9f )   /* ??? 88/9/16 */
					return ( -2 );
				Length(pbe->cnv_data) = (UCHAR)len;
				for ( i = 1; i <= len; i++ ) 
					pbe->cnv_data [ i ]	= work.str[ i ];
				for ( i = 1,j = 1; i <= len; i++ ) {
					if (pbe->atr_data[ j ] & (F_ZEN_L | F_ZEN_R)) {
						pbe->atr_data[i] = (pbe->atr_data[j] & ~(F_ZEN_L | F_ZEN_R));
						pbe->atr_data[i] = (pbe->atr_data[j] | F_HANK) ;
						j += 2;
					} else {
						pbe->atr_data[i] = (pbe->atr_data[j] & ~(F_ZEN_L | F_ZEN_R));
						pbe->atr_data[i] = (pbe->atr_data[j] | F_HANK) ;
						j ++;
					}
				}
				Length(pbe->atr_data) = (UCHAR)len;
			}
		}
		Length(pbe->atr_data) = Length(pbe->cnv_data);
	}
	return ( cnv_cnt );
}

static	short FTYPE	romahenkan (pbe, pin, pout, patr )
PBEBUF	pbe;
UCHAR PWIN *pin ;
UCHAR PWIN *pout ;
/*UCHAR PWIN *patr ; */
USHORT PWIN *patr ;
{
	short	i;
	short	cnv_cnt;		/* romaji convert count */
/**/	UCHAR	work [ 9 ]; 	/* working for convert */

	if ( Length(pin) == 4 ) {						   /* 4 */
		if ( !(cnv_cnt = cnvdel_roma ( pbe,pin )) ) {
			for ( i = 1; i < (short)Length(pin); i++ )
				pin [ i ] = pin [ i + 1 ];
			Length(pin) = (UCHAR)(Length(pin) - 1);   /* 3 */
#if NX
			if ( !(cnv_cnt = cnv_roma ( pbe,pin )) ) {
				if ( !(cnv_cnt = cnvdel_roma ( pbe,pin )) ) {
					for ( i = 1; i <= pin [ 0 ] - 1; i++ )
						pin [ i ] = pin [ i + 1 ];
					pin [ 0 ] = (UCHAR)(pin [ 0 ] - 1);   /* 2 */
					if ( !(cnv_cnt = cnv_roma ( pbe,pin )) ) {
						pin [ 1 ] = pin [ 2 ];
						pin [ 0 ] = (UCHAR)1;				   /* 1 */
						if ( cnv_cnt = cnv_roma ( pbe,pin ) )
							patr [ 1 ] |= 1;
					}
					else
						patr [ 1 ] |= 2;
				}
				else {
/*					if ( pbe->wVjeModeFlag2 & ZENKAKU_BIT )			/ * ѥ⡼ * / */
/*						patr [ 3 ] |= 2; */
/*					else */
/*						patr [ 2 ] |= 2; */
/*					patr [ 1 ] |= 1; */
/*BUGFIX:960920 */
					patr [ 1 ] |= cnv_cnt;
				}
			}
			else
				patr [ 1 ] |= 3;
#else
			if ( cnv_cnt = cnv_roma ( pbe,pin ) ) {
				if ( pbe->wVjeModeFlag2 & ZENKAKU_BIT )			/* ѥ⡼ */
					patr [ 3 ] |= cnv_cnt - 1;
				else
					patr [ 2 ] |= cnv_cnt - 1;
				patr [ 1 ] |= 1;
			}
#endif	/* if NX end */
		}
		else {
			if ( VjeKanji(pout[1]) )
				patr [ 3 ] |= 3;
			else
				patr [ 2 ] |= 3;
			patr [ 1 ] |= 1;
		}
	}
	else if ( Length(pin) == 3 ) {					   /* 3 char */
		if ( !(cnv_cnt = cnv_roma ( pbe,pin )) ) {
			if ( !(cnv_cnt = cnvdel_roma ( pbe,pin )) ) {
				for ( i = 1; i <= pin [ 0 ] - 1; i++ )
					pin [ i ] = pin [ i + 1 ];
				pin [ 0 ] = (UCHAR)(pin [ 0 ] - 1);   /* 2 */
				if ( !(cnv_cnt = cnv_roma ( pbe,pin )) ) {
					pin [ 1 ] = pin [ 2 ];
					pin [ 0 ] = (UCHAR)1;				   /* 1 */
					if ( cnv_cnt = cnv_roma ( pbe,pin ) )
						patr [ 1 ] |= 1;
				}
				else
					patr [ 1 ] |= 2;
			}
			else {
				if ((pin[1] & 0xDF) != (UCHAR)'N' )
/*BUG ppo*/				patr [ 1 ] |= cnv_cnt;
				else {
#if 0
/*** /					if ( pbe->wVjeModeFlag2 & ZENKAKU_BIT )			/ * ѥ⡼ * / */
/*** /						patr [ 3 ] |= cnv_cnt - 1; */
/*** /					else */
/*** /						patr [ 2 ] |= cnv_cnt - 1; */
/*** /					patr [ 1 ] |= 1; */
/*:951120*/				patr [ 1 ] |= cnv_cnt;
#endif
					if (pbe->wVjeModeFlag2 & KANA_BIT ) {
						if ( pbe->wVjeModeFlag2 & ZENKAKU_BIT )
							patr [ 3 ] |= cnv_cnt - 1;
						else
							patr [ 2 ] |= cnv_cnt - 1;
					} else
						patr [ 3 ] |= cnv_cnt - 1;
					patr [ 1 ] |= 1;
				}
			}
		}
		else
			patr [ 1 ] |= cnv_cnt;
	}
#if NX
	else if ( Length(pin) == 2 ) {					   /* N + X */
		if ( cnv_cnt = cnv_roma ( pbe,pin ) )
			patr [ 1 ] |= cnv_cnt;
		else {
/*#if 0 */
			if ( (pin [ 1 ] & 0xDF) == 'N' &&
/*BUG*/			     chk_nn2(pbe,(short)pin[2]) == YES) {
				cnv_cnt = 2;
				pout [ 0 ] = 4;
				pout [ 1 ] = 0x83;
				pout [ 2 ] = 0x93;
				if ( pbe->wVjeModeFlag2 & ZENKAKU_BIT ) {		/* ѥ⡼ */
					if ( !(pbe->wVjeModeFlag2 & KANA_BIT) ) {	/* Ҥ餬ʥ⡼ */
						pout [ 1 ] = 0x82;
						pout [ 2 ] = 0xF1;
					}
					patr [ 1 ] |= F_ZEN_L | 1;
					patr [ 2 ] |= F_ZEN_R;
					patr [ 3 ] |= F_ZEN_L | 1;
					patr [ 4 ] |= F_ZEN_R;
				}
				else {										/* Ⱦѥ⡼ */
					if ( !(pbe->wVjeModeFlag2 & KANA_BIT) ) {	/* Ҥ餬ʥ⡼ */
						pout [ 1 ] = 0x82;
						pout [ 2 ] = 0xF1;
						patr [ 1 ] |= F_ZEN_L | 1;
						patr [ 2 ] |= F_ZEN_R;
					}
					else {
						patr [ 1 ] |= F_ZEN_L | 1;
						patr [ 2 ] |= F_ZEN_R;
					}
					patr [ 3 ] |= F_ZEN_L | 1;
					patr [ 4 ] |= F_ZEN_R;
				}
/*WIN95:Jissj 95 */
				if (CheckInpMode(pbe,pin[2]) == 1) {
					pout [ 3 ] = pin[2];
					patr [ 3 ] &= ~(F_ZEN_L | F_ZEN_R);
					patr [ 3 ] |= F_HANK | 1;
					Length(patr) = Length(pout) = 3;
				} else {
					Jissj ( (UCHAR)pin [ 2 ], work, (short)0 );
					pout [ 3 ] = work [ 1 ];
					pout [ 4 ] = work [ 2 ];
					Length(patr) = Length(pout);
				}
			} else {
				/* BUGFIX:970711 ATOK CO */
				for ( i = 1; i <= pin [ 0 ] - 1; i++ )
					pin [ i ] = pin [ i + 1 ];
				pin [ 0 ] = (UCHAR)(pin [ 0 ] - 1);
				if ( (cnv_cnt = cnv_roma ( pbe,pin )) )
					patr [ 1 ] |= 1;
			}
		}
	}
#endif
	else {													/* 1 char */
		if ( cnv_cnt = cnv_roma ( pbe,pin ) )
			patr [ 1 ] |= cnv_cnt;
	}
	return cnv_cnt;
}

static	short FTYPE getlength ( pbe )
PBEBUF	pbe;
{
	UCHAR	chrh;
	UCHAR	chrl;
	short	i;
	short	pos;
	short	length = 0;
	short	mode ; /*bug*/
	short	kana;

	pos = pbe->kihon_pos - 6;
	if ( pos < 0 )
		pos = 0;
	mode = pbe->wVjeModeFlag2 & (KANA_BIT | KATA_BIT | ZENKAKU_BIT); /*bug*/
	for ( i = pbe->kihon_pos; i > 0; ) {
		if ( i <= pos )
			break;	/* character is count to 4 character */
		/*991014*/
		if (i == pbe->kihon_cnv && (UCHAR)pbe->kihon_cnv /*==*/> SLength(pbe->kihon_buf_Q))
			break ;
		if ( pbe->kihon_atr_Q [ i ] & ZENKAKU_BIT ) {
			if (!(pbe->kihon_atr_Q[i] & 0xc0)) {
				chrl = pbe->kihon_buf_Q.str[ i ];
				kana = (pbe->kihon_atr_Q [ i ] & (KANA_BIT | KATA_BIT | ZENKAKU_BIT) ) ;
				if (mode == kana && chrl >= 0x41 && chrl <= 0x5a)
					i--;
				else if (mode == kana && chrl >= 0x61 && chrl <= 0x7a)
					i--;
				else
					break ;
			} else {
				chrh = pbe->kihon_buf_Q.str[ i - 1 ];
				chrl = pbe->kihon_buf_Q.str[ i	   ];
				if ( chrh == 0x81 && chrl == 0x5B ) 				/*  */
					break;
				if (chrh == 0x82 && chrl >= 0x60 && chrl <= 0x9a &&
					mode == (pbe->kihon_atr_Q[i-1] & (KANA_BIT | KATA_BIT | ZENKAKU_BIT)))
						i -= 2;
				else
					break ;
			}
		}
		else {
			if ((pbe->kihon_atr_Q[i] & 0xc0)) {
				chrh = pbe->kihon_buf_Q.str[ i - 1 ];
				chrl = pbe->kihon_buf_Q.str[ i ];
				kana = (pbe->kihon_atr_Q [ i - 1 ] & (KANA_BIT | KATA_BIT | ZENKAKU_BIT) ) ;
				if ( chrh == 0x81 && chrl == 0x5B ) 				/*  */
					break;
				if (chrh == 0x82 && chrl >= 0x60 && chrl <= 0x9a && mode == kana)
					i -= 2;
				else
					break ;
			} else {
				if ( (chrl = pbe->kihon_buf_Q.str[ i ]) >= 0x41 && chrl <= 0x5a &&
					mode == (pbe->kihon_atr_Q[i] & (KANA_BIT | KATA_BIT | ZENKAKU_BIT)))
					i--;
				else if ( (chrl = pbe->kihon_buf_Q.str[ i ]) >= 0x61 && chrl <= 0x7a &&
					mode == (pbe->kihon_atr_Q[i] & (KANA_BIT | KATA_BIT | ZENKAKU_BIT)))
					i--;
				else
					break;
			}
		}
		++length;
	}
	if (length > 3)	length = 3;
	return length;
}

/*
*       int ret = cnv_roma()    return intformation
*			 0	= error (no converted)
*		 not 0	= converted byte count
*/
short	cnv_roma ( PBEBUF pbe, UCHAR PWIN *keydata )
{
	short	ret;
/*WIN95 */
	UCHAR	Omoji[10];
	UCHAR	Komoji[10];
	short   i;

	Copylng(keydata, Komoji, Length(keydata) + 1);
	Copylng(keydata, Omoji, Length(keydata) + 1);
	for (i=0;(UCHAR)i<Length(Komoji);i++) {
		if (Komoji[i+1] >= 'A' && Komoji[i+1] <= 'Z')
			Komoji[i+1] |= ~(0xdf) ; /* komoji */
		if (Omoji[i+1] >= 'a' && Omoji[i+1] <= 'z')
			Omoji[i+1] &= 0xdf ;     /* oomoji */
	}
/*WIN95:޻Ѵ */
	if ( (ret = roomaji_hen ( keydata, &pbe->cnv_data [ 1 ] )) != 0 ) {
		pbe->cnv_data [ 0 ] = (UCHAR)ret;
		return ( Length(keydata) );
	}
	if ((ret = roomaji_hen (Omoji, &pbe->cnv_data[1])) != 0) {
		pbe->cnv_data [ 0 ] = (UCHAR)ret;
		return ( Length(keydata) );
	}
	if ((ret = roomaji_hen (Komoji, &pbe->cnv_data[1])) != 0) {
		pbe->cnv_data [ 0 ] = (UCHAR)ret;
		return ( Length(keydata) );
	}
	return 0;
}

/*
 *		1993/4/22 Y.Mogi add for roomaji input
 */
short	cnvdel_roma ( PBEBUF pbe, UCHAR PWIN *keybuf )
{
	short	i;
	short	cnv_cnt ;							/* romaji convert count */
	UCHAR	chr;
	UCHAR	buffer [ 4 ];

	cnv_cnt = keybuf [ 0 ] - 1;
	buffer [ 0 ] = (UCHAR)cnv_cnt;
	for ( i = 1; i <= cnv_cnt; i++ )
		buffer [ i ] = keybuf [ i + 1 ];

	if ( cnv_cnt = cnv_roma ( pbe, buffer ) ) {
		if ( (chr = keybuf [ 1 ]) == keybuf [ 2 ] ) {
			for ( i = pbe->cnv_data [ 0 ]; i > 0; i-- )
				pbe->cnv_data [ i + 2 ] = pbe->cnv_data [ i ];
			pbe->cnv_data [ 0 ] += 2;
			pbe->cnv_data [ 1 ]	= 0x83; 			/*  */
			pbe->cnv_data [ 2 ]	= 0x62;
			++cnv_cnt;
		}
		else if ( chr == 'N' || chr == 'n' ) {
			for ( i = pbe->cnv_data [ 0 ]; i > 0; i-- )
				pbe->cnv_data [ i + 2 ] = pbe->cnv_data [ i ];
			pbe->cnv_data [ 0 ] += 2;
			pbe->cnv_data [ 1 ]	= 0x83; 			/*  */
			pbe->cnv_data [ 2 ]	= 0x93;
			++cnv_cnt;
		}
		else
			cnv_cnt = 0;
	}
	else
		cnv_cnt = 0;
	return cnv_cnt;
}

short	CheckInpMode(PBEBUF pbe,UCHAR ch)
{
	short	i;

	ch &= 0xff;
	if ('0' <= ch && ch <= '9') {
		if ( pbe->wVjeModeLimit & C_EISU_HAN )
			return 1;	/*HAN */
		else if ( pbe->wVjeModeLimit & C_EISU_ZEN )
			return 2;	/*ZEN */
		else if ( pbe->wVjeModeFlag3 & ZENKAKU_BIT )
			return 2;	/*Mode */
		else
			return 1;	/*Mode */
	}
	if ('a' <= ch && ch <= 'z') {
		if ( pbe->wVjeModeLimit & C_EISU_HAN )
			return 1;	/*HAN */
		else if ( pbe->wVjeModeLimit & C_EISU_ZEN )
			return 2;	/*ZEN */
		else if ( pbe->wVjeModeFlag3 & ZENKAKU_BIT )
			return 2;	/*Mode */
		else
			return 1;	/*Mode */
	}
	if ('A' <= ch && ch <= 'Z') {
		if ( pbe->wVjeModeLimit & C_EISU_HAN )
			return 1;	/*HAN */
		else if ( pbe->wVjeModeLimit & C_EISU_ZEN )
			return 2;	/*ZEN */
		else if ( pbe->wVjeModeFlag3 & ZENKAKU_BIT )
			return 2;	/*Mode */
		else
			return 1;	/*Mode */
	}
/*Check KIGO */
	for (i=0;i < pbe->wKigoTBL.cnt;i++) {
		if (ch == pbe->wKigoTBL.kigo[i].moji) {
			if (pbe->wKigoTBL.kigo[i].flg == 0) {
				if ( pbe->wVjeModeFlag3 & ZENKAKU_BIT )
					return 2;	/*Mode */
				else {
/*ȾλΤߤʵ */
/*ȾȾϤ٤Ⱦ */
					if ((pbe->wVjeModeFlag3 & (KANA_BIT | EISUU_BIT)) == 0) {
						if (ch == 0xa1 || ch == 0xa4 ||
						    ch == 0xa5 || ch == 0xa2 ||
						    ch == 0xa3 )
							return 2;
					}
					return 1;	/*Mode */
				}
			}
			return (pbe->wKigoTBL.kigo[i].flg) ;
		}
	}
/*BUGFIX:951114:Not Found */
	if ( pbe->wVjeModeFlag3 & ZENKAKU_BIT ) {
/*KANA-HANKAKU Chouon*/
		if (ch == 0xb0 && (pbe->wVjeModeLimit & C_KATA_HAN) &&
			(pbe->wVjeModeFlag3 & KANA_BIT))
			return 1;
		return 2;	/*Mode */
	} else {
		if ((pbe->wVjeModeFlag3 & (KANA_BIT | EISUU_BIT)) == 0) {
/*BUGFIX:951119		if (ch == 0xb0) */
			if (ch >= 0x80)
				return 2;
			return 1;	/*Mode */
		}
		return 1;
	}
}

/*
*       int ret = inp_kana()    return information
*            -1 = error charctar
*             0 = not romaji converted charctar ( )
*             1 = end normally
*/
static	short FTYPE	inp_kana ( pbe )
PBEBUF	pbe;
{
	short	i;
	short	char_typ;	/* chatcter type  0:normal 1:dakuten 2:handakuten 3:illigal */
	SBUFF	work;		/*	UCHAR	work [ 5 ];	*/
	SBUFF	cnv_work;
	USHORT	k;

	k = (USHORT)pbe->key_data [ Length(pbe->key_data) ];
	for ( i = 0; i < 3; i++ ) {
		pbe->cnv_data [ i ] = 0;
		pbe->atr_data [ i ] = 0;
	}
/*BUGFIX:970430 ѿϤǣƣȥʤˤʤ */
	if ((pbe->wVjeModeFlag3 & EISUU_BIT) == 0)
		pbe->atr_data[1] = pbe->atr_data[2] = (UCHAR)(pbe->wVjeModeFlag2 & (KANA_BIT /*| KATA_BIT*/ | ZENKAKU_BIT) );
	else
		pbe->atr_data[1] = pbe->atr_data[2] = (UCHAR)(pbe->wVjeModeFlag2 & (KANA_BIT | KATA_BIT | ZENKAKU_BIT) );

/*WIN95:ʸμư */
/*	ưƤ褤ʸʤ°ꤹ */
	if (pbe->wCharSave == 0xff) {
		pbe->atr_data[0] = 2;
		pbe->atr_data[1] |= C_AUTO_HOSEI ;
		pbe->atr_data[2] |= C_AUTO_HOSEI ;
/*ưʸƬϤȤDefault() */
/*BUGFIX:951114:EISU */
		if (pbe->kihon_pos == 0 && 
		   (pbe->wVjeModeFlag3 & EISUU_BIT) == 0) {
			if (k == 0x2d)
				k = 0xb0;
			else if (k == 0x2c)
				k = 0xa4;
			else if (k == 0x2e)
				k = 0xa1;
			else if (k == 0x2f)
				k = 0xa5;
		}
	} else {
/*ѿ⡼ɤλ϶˴طʤԥꥪɥޤȤ */
		if ((pbe->wVjeModeFlag3 & EISUU_BIT) != 0) {
			if (k == 0xb0)
				k = 0x2d;
			else if (k == 0xa4)
				k = 0x2c;
			else if (k == 0xa1)
				k = 0x2e;
			else if (k == 0xa5)
				k = 0x2f;
		}
	}
/*WIN95:ϥ⡼ */
	if ((i = CheckInpMode(pbe, (UCHAR)k)) == 1 )
		goto HAN;
	else if ( i == 2 )
		goto ZEN;

	if ( pbe->wVjeModeFlag2 & ZENKAKU_BIT ) {			/* zenkaku mode */
ZEN:
		char_typ = Jissj ( (UCHAR)k, work.str, (short)0 );
		work.len = work.str[ 0 ] = 2;
		if ( char_typ < 3 ) {						/* normal end ? */
			if ( char_typ == 1 || char_typ == 2 ) {
				if ( cnv_dakhan ( pbe, k ) == OK )
					return ( 0 );
			}
			/* normal charcter */
			pbe->cnv_data [ 0 ] = 2;
			pbe->atr_data [ 0 ] = 2;
			pbe->atr_data [ 1 ] |= (F_ZEN_L | C_ROMA_1);
			pbe->atr_data [ 2 ] |= F_ZEN_R;
			if ( (pbe->wVjeModeFlag2 & KANA_BIT) == 0 ) {	/* if KATAKANA mode */
				kata_hira ( (BUFF *)&work, (BUFF *)&cnv_work );/*991210 WRN*/		/* kata --> hira */
				Copylng(cnv_work.str, pbe->cnv_data, cnv_work.len + 1);
			}
			else {
				pbe->cnv_data [ 1 ] = work.str[ 1 ];
				pbe->cnv_data [ 2 ] = work.str[ 2 ];
			}
			pbe->cnv_data [ 0 ] = 2;
		}
		else
			return ( -1 );		/* illigal code */
	} else	{						/* henkaku mode */
HAN:
		if ( k == 0xde || k == 0xdf ) {
			char_typ = Jissj ( (UCHAR)k, work.str, (short)0 );
			work.len = work.str[ 0 ] = 2;
			if ( char_typ < 3 ) {	/* normal end ? */
				if ( char_typ == 1 || char_typ == 2 ) {
					if ( cnv_dakhan ( pbe, k ) == OK )
						return ( 0 );
				}
			}
		}
		pbe->cnv_data [ 0 ]	= 1;
		pbe->cnv_data [ 1 ]	= (UCHAR)k;
		pbe->atr_data [ 1 ] |= (F_HANK | C_ROMA_1);
	}
	return ( 1 );
}

global void FTYPE move_cur ( pbe, func )
PBEBUF	pbe;
short	func;		/* function */
{
	pbe->kihon_pos = get_cur ( pbe,((func & 0x3f) == F_LEFT) ? -1 : 1 );
	pbe->key_pos   = get_pos1 ( pbe,pbe->kihon_pos );
}

global void FTYPE edt_char ( pbe,func )
PBEBUF	pbe;
short	func;		/* function */
{
	short	hani;
	short	skptr;
	short	ekptr;
	short	sptr1, eptr1;

	if ( func == F_BS ) {
		if ( pbe->kihon_pos == 0 )
			return;
		move_cur (pbe, F_LEFT );
	}
	else {
		if ( pbe->kihon_pos == SLength(pbe->kihon_buf_Q) )
			return;
	}
	hani = 1;
	if ( (pbe->kihon_atr_Q [ pbe->kihon_pos + 1 ] & M_ZEN_HAN) != F_HANK )
		hani++;
	pbe->kihon_max += hani;
	pbe->key_max   += hani;
	chk_blk ( pbe,pbe->kihon_pos );
	pbe->kihon_max -= hani;
	pbe->key_max   -= hani;
	ekptr = get_kpos (pbe,0);
	skptr = get_kpos (pbe,1);
	eptr1 = get_pos1 (pbe,ekptr);
	sptr1 = get_pos1 (pbe,skptr);
	buf_move ( (BUFF *)&pbe->key_buf_Q,pbe->key_max,   sptr1, eptr1 );/*991210 WRN*/
	buf_move ( &pbe->kihon_buf_Q,pbe->kihon_max, skptr, ekptr );
	buf_move2 ( pbe->kihon_atr_Q,pbe->kihon_max, skptr, ekptr );
	SLength(pbe->key_buf_Q)	-= (sptr1 - eptr1);
	SLength(pbe->kihon_buf_Q) -= (UCHAR)hani;
	Length(pbe->kihon_atr_Q) -= (UCHAR)hani;
}

global void FTYPE set_pos ( pbe,pos )
PBEBUF	pbe;
short  pos;
{
	pbe->kihon_pos = pos;
	pbe->key_pos   = get_pos1(pbe, pos );
}

global void FTYPE set_cnv ( pbe,cnv_pos )
PBEBUF	pbe;
short  cnv_pos;
{
	pbe->kihon_cnv = cnv_pos;
	pbe->key_cnv   = get_pos1 ( pbe,cnv_pos );
}

global short FTYPE cnv_nn ( pbe )
PBEBUF	pbe;
{
	UCHAR	code [ 5 ];
/*	UCHAR	attr [ 5 ]; */
	USHORT	attr [ 5 ];
	short	ptr ;

	if ( pbe->key_pos == 0 )
		return(NO);
	if ( chk_nn ( pbe, (short)pbe->key_buf_Q.str[ pbe->key_pos ] ) == NO )
		return(NO);
	get_kihon_code (pbe, -1, code, attr );
	if ( (attr [ 1 ] & KATA_BIT) != 0 )
		return(NO);
	if ( (attr [ 1 ] & M_ROMA_CNT) == C_ROMA_1 ) {
		if ( Length(code) == 1 ) {				/* Hankaku */
			if ( (attr[1] & KANA_BIT) != 0 && (attr[1] & ZENKAKU_BIT) == 0) {
				code [ 1 ] = HATSUON;
				set_kihon_code (pbe, -1, code, attr );
			} else {
				code [ 0 ] = 2;
				code [ 1 ] = (UCHAR)0x83;
				code [ 2 ] = (UCHAR)0x93;
				if ( (attr[1] & KANA_BIT) == 0 ) {
					/* Zenkaku hiragana */
					code [ 1 ] = (UCHAR)0x82;
					code [ 2 ] = (UCHAR)0xf1;
				}
				attr [ 0 ] = 2;
				attr [ 2 ] = (attr [ 1 ] & ~(M_ROMA_CNT));
				attr [ 1 ] |= F_ZEN_L ;
				attr [ 2 ] |= F_ZEN_R ;
				SLength(pbe->kihon_buf_Q) += 1;
				Length(pbe->kihon_atr_Q) += 1;
/*BUGFIX:->أ */
				ptr = (get_cur(pbe,-1)) + 1;
				buf_move ( &pbe->kihon_buf_Q,pbe->kihon_max, ptr, ptr+1 );
				buf_move2 ( pbe->kihon_atr_Q,pbe->kihon_max, ptr, ptr+1 );
				set_kihon_code (pbe, -1, code, attr );
				if (ptr <= pbe->kihon_pos )
					pbe->kihon_pos += 1;
			}
		} else {									/* Zenkaku */
			code [ 1 ] = (UCHAR)0x83;
			code [ 2 ] = (UCHAR)0x93;
			if ( (attr[1] & KANA_BIT) == 0 ) {	/* Zenkaku hiragana */
				code [ 1 ] = (UCHAR)0x82;
				code [ 2 ] = (UCHAR)0xf1;
			}
			set_kihon_code (pbe, -1, code, attr );
		}
		return(YES);
	}
	return(NO);
}

/*
 *	Check nn code
 *		rc = chk_nn(keydat);
 */
FLAG FTYPE chk_nn ( pbe,code )
PBEBUF	pbe;
short	code;
{
	UCHAR	c;
	USHORT	c1;

	c = (UCHAR)code;
	if ( chk_shin ( c ) == YES ||
		 0x20 <= c && c <= 0x41 || 0x5b <= c && c <= 0x5f ||
		 0x7b <= c && c <= 0x7e || 0xa1 <= c && c <= 0xa5 ) {
		if ( pbe->key_pos - pbe->key_cnv < 1 )
			return ( NO );
		if ( (pbe->key_buf_Q.str[ pbe->key_pos ] & 0xdf) == 'N' ) {
			c1 = pbe->kihon_atr_Q [ get_cur (pbe, -1 ) + 1 ];
			if ( (c1 & M_ROMA_CNT) == C_ROMA_1 && (c1 & KATA_BIT) == 0 )
				return ( YES );
		}
	}
	return ( NO );
}

/*
 *	Check shin code
 *	rc = chk_shin(code);
 */
FLAG FTYPE chk_shin ( code )
short	code;
{
	UCHAR	inbuf [ 8 ];
	UCHAR	outbuf [ 8 ];
	UCHAR	inbuf2 [ 8 ];
/*BUG*/	short	c;

	inbuf [ 0 ] = 1;
	inbuf2 [ 0 ] = 1;
	inbuf [ 1 ] = (UCHAR)code;
/*BUG*/	c = code & 0xdf;
	inbuf2 [1] = (UCHAR)c;
/*BUG*/	if ('A' <= c && c <= 'Z') {	/* if Alpha code */
		if ( roomaji_hen ( inbuf, outbuf ) )
			return ( NO );
		if ( roomaji_hen ( inbuf2, outbuf ) )
			return ( NO );
		return ( YES );
/*BUG*/	}
/*BUG*/	return (NO);
}

global void FTYPE cnv_del ( pbe,kpos )
PBEBUF	pbe;
short  kpos;
{
	REG1 short	pos1;

	chk_blk ( pbe,kpos );
	pos1 = get_pos1 ( pbe,kpos );
	buf_move ( (BUFF *)&pbe->key_buf_Q, pbe->key_max, pos1, 0 );/*991210 WRN*/
	SLength(pbe->key_buf_Q) -= pos1;
	buf_move ( &pbe->kihon_buf_Q, pbe->kihon_max, kpos, 0 );
	buf_move2 ( pbe->kihon_atr_Q, pbe->kihon_max, kpos, 0 );
	Length(pbe->kihon_atr_Q) = SLength(pbe->kihon_buf_Q) -= (UCHAR)kpos;
}

/*
 *	Check nn code
 *		rc = chk_nn2(keydat);
 */
FLAG FTYPE chk_nn2 ( pbe,code )
PBEBUF	pbe;
short	code;
{
	UCHAR	c;
	USHORT	c1;

	c = (UCHAR)code;
	if ( 	 0x20 <= c && c <= 0x40 || 0x5b <= c && c <= 0x5f ||
		 0x7b <= c && c <= 0x7e || 0xa1 <= c && c <= 0xa5 ) {
		if ( pbe->key_pos - pbe->key_cnv < 1 )
			return ( NO );
		if ( (pbe->key_buf_Q.str[ pbe->key_pos ] & 0xdf) == 'N' ) {
			c1 = pbe->kihon_atr_Q [ get_cur (pbe, -1 ) + 1 ];
			if ( (c1 & M_ROMA_CNT) == C_ROMA_1 && (c1 & KATA_BIT) == 0 )
				return ( YES );
		}
	}
	return ( NO );
}
