

/*
**	VJE Delta
**
**			wsetsub.c
**
*/

#include	"common.h"
/*#include	"vje.h"
#include	"wvje.h"
#include	"wbebuf.h"*/
#include	"basicedt.h"
#include	"vjestr.h"
#include	"wfncdef.h"
#include	"vjelib.h"
#include	"vfzk.h"
#include	"vfncdef.h"

extern char     dakuon_table[];

/*
 *	Check ROMAJI Convert mode
 *	rc = chk_roma_mod(ptr);
 *	(I) short   ptr ... current charcter point (kihon_pos)
 *	          = 0 ... current point
 *	          > 0 ... behind  current point
 *	          < 0 ..  before  current point
 *	(O) short rc = return information
 *	         0 = ..... romaji mode data && not converted
 *	         1 = ..... not romaji mode code or not same mode
 *	         2 = ..... already converted
 *	        -1 = ..... para error
 */
global short FTYPE	chk_roma_mod(pbe,ptr)
PBEBUF	pbe;
short	ptr;		/* offset from current kihon_pos (/1 char) */
{
	REG3 short	j;
	short	kptr;		/* kihon pos pointer */
	REG1 short	i;
	REG2 short	rc;

	rc = -1;
	if ((ptr + pbe->key_pos) >= 0 && (ptr + pbe->key_pos) < SLength(pbe->key_buf_Q)) {
		kptr = get_kpos(pbe,ptr);
		if (kptr < 0)
			return (-1);
		i = pbe->kihon_atr_Q[kptr + 1] & (KANA_BIT | KATA_BIT | ZENKAKU_BIT);
		j = pbe->wVjeModeFlag2 & (KANA_BIT | KATA_BIT | ZENKAKU_BIT);
		if (i != j)
			return (1);
		if (chk_n_cnv(pbe,ptr) != 0)
			return (rc); /* return 1 if n */
		if ((pbe->kihon_atr_Q[kptr + 1] & KATA_BIT) == 0) { /* romaji mode */
#if	PENWIN
			if (chk_shin(pbe->key_buf_Q[(pbe->key_pos + ptr + 1)*2-1]) == YES) {
#else
			if (chk_shin(pbe->key_buf_Q.str[pbe->key_pos + ptr + 1]) == YES) {
#endif
				i = pbe->kihon_atr_Q[kptr + 1] & M_ROMA_CNT;
				if (i == C_ROMA_1)
					rc = 0;
				else
					rc = 2;
			}
			else
				rc = 2;
		}
		else
			rc = 1;
	}
	else
		rc = -1;
	return (rc);
}


/*
 *	Get kihon_buf_Q point
 *	rc = get_kpos(&ptr)
 *	(I) short   ptr ... current charcter point (kihon_pos)
 *	          = 0 ... current point
 *	          > 0 ... behind  current point
 *	          < 0 ..  before  current point
 *	(O) short rc = kihon bufer point
 *	           = -1 ... Para. error end
 */
global short FTYPE	get_kpos(pbe,ptr)
PBEBUF	pbe;
short	ptr;		/* current charcter point */
{
	short	k;
	short	chr_c;		/* ccharcter count */
	REG1 short	i;
	REG2 short	kptr;

	chr_c = 0;
	kptr = pbe->kihon_pos;
	i = ptr + pbe->key_pos;
	if (i < 0)
		return (-1);
	else if (i == 0)
		return (0);
	if (i > SLength(pbe->key_buf_Q))
		return (SLength(pbe->key_buf_Q));
	for (;;) {
		if (ptr > 0) {
#if	PENWIN
			k = pbe->kihon_atr_Q[kptr + 1] & F_ZEN_L;
#else
			k = pbe->kihon_atr_Q[kptr + 1] & M_ZEN_HAN;
#endif
			i = (pbe->kihon_atr_Q[++kptr] & M_ROMA_CNT);
			if (k == F_ZEN_L)
				i += (pbe->kihon_atr_Q[++kptr] & M_ROMA_CNT);
			chr_c += i;
			if (chr_c >= ptr)
				break;
		}
		else if (ptr < 0) {
			k = pbe->kihon_atr_Q[kptr] & M_ZEN_HAN;
			i = (pbe->kihon_atr_Q[kptr--] & M_ROMA_CNT);
			if (k == F_ZEN_R)
				i += (pbe->kihon_atr_Q[kptr--] & M_ROMA_CNT);
			chr_c -= i;
			if (chr_c <= ptr)
				break;
		}
		else {
			kptr = pbe->kihon_pos;
			break;
		}
	}
	return (kptr);
}

#if 0/*wsetbuf*/
/*
 *	Check boin code
 *	rc = chk_boin(code);
 */
global FLAG FTYPE	chk_boin(code)
short	code;		/* 1 byte code */
{
	REG1 short	c;
#if	PENWIN
	if (code == 0x80) return(NO);
#endif
	c = code & 0xdf;
	if ('A' <= c && c <= 'Z') {	/* if Alpha code */
/*		if ((*romjistb[c - 'A'] & 0x7f) == 0) */
		if (c == 'A' || c == 'I' || c == 'U' || c == 'E' ||c == 'O')
			return (YES);
	}
	return (NO);
}


/*
 *	Check shin code
 *	rc = chk_shin(code);
 */
global FLAG FTYPE	chk_shin(code)
short	code;
{
	REG1 short	c;
#if	PENWIN
	if (code == 0x80) return(NO);
#endif
	c = code & 0xdf;
	if ('A' <= c && c <= 'Z') {	/* if Alpha code */
/*		if ((*romjistb[c - 'A'] & 0x7f) != 0) */
		if (c == 'A' || c == 'I' || c == 'U' || c == 'E' ||c == 'O')
			return (YES);
	}
	return (NO);
}


/*
 *	Check nn code
 *		rc = chk_nn(pbe,keydat);
 */
global FLAG FTYPE	chk_nn(pbe,code)
PBEBUF	pbe;
short	code;
{
	REG2 short	i;
	UCHAR	c;

	c = (UCHAR)code;
#if	PENWIN
	if (c == 0x80) return(NO) ;
#endif
	if (chk_shin(c) == YES ||
	    0x20 <= c && c <= 0x41 || 0x5b <= c && c <= 0x5f ||
	    0x7b <= c && c <= 0x7e || 0xa1 <= c && c <= 0xa5) {
		if (pbe->key_pos - pbe->key_cnv < 1)
			return (NO);
#if	PENWIN
		if (chk_zenn(&pbe->key_buf_Q[pbe->key_pos*2-1]) == YES) {
#else
		if ((pbe->key_buf_Q.str[pbe->key_pos] & 0xdf) == 'N') {
#endif
			i = get_cur(pbe,-1) + 1;
			if ((pbe->kihon_atr_Q[i] & M_ROMA_CNT) == C_ROMA_1
			     && (pbe->kihon_atr_Q[i] & KATA_BIT) == 0)
				return (YES);
		}
	}
	return (NO);
}
#endif

/*
 *	Move buffer
 *		rc = buf_move(buf, kmax, start, end)
 *		(I) UCHAR buf[0] ....    count(/byte)
 *		             [1] ....    1.st charcter
 *		              |
 *		             [n].....    end  charcter
 *		     satrt ...........    move start
 *		     end   ...........    end
 *		(O) short rc = return information
 *		           =
 */
#if	PENWIN
global short FTYPE	buf_move( buf, kmax, start, end, type)
UCHAR	buf[];		/* move buffer */
short	kmax;
short	start;
short	end;
short	type;
#else
global short FTYPE	buf_move( buf, kmax, start, end)
/*UCHAR	buf[];	*/	/* move buffer */
BUFF	PWIN *buf;	/* mk3 */
short	kmax;
short	start;
short	end;
#endif
{
	REG1 short	i;
	REG2 short	len;

	if (PLength(buf) == 0)
		return (0);
	if (end >= start) {		/* shift down */
		len = end - start;
		if (kmax <= PLength(buf) + len)
			return (2);	/* moji over*/
		for (i = PLength(buf); i > start; i--) {
#if	PENWIN
			if (type == 1) {
				buf[(i + len)*2-1] = buf[i*2-1];
				buf[(i + len)*2] = buf[i*2];
			} else
#endif
				buf->str[i + len] = buf->str[i];
		}
	}
	else {				/* shift up */
		len = start - end;
		if (PLength(buf) <= (UCHAR)len)
			return (2);
		for (i = end + 1; i <= PLength(buf) - len; i++) {
#if	PENWIN
			if (type == 1) {
				buf[i*2-1] = buf[(i + len)*2-1];
				buf[i*2] = buf[(i + len)*2];
			} else
#endif
				buf->str[i] = buf->str[i + len];
		}
	}
	return (0);
}

global short FTYPE	buf_move2( buf, kmax, start, end)
USHORT	buf[];		/* move buffer */
short	kmax;
short	start;
short	end;
{
	REG1 short	i;
	REG2 short	len;

	if (Length(buf) == 0)
		return (0);
	if (end >= start) {		/* shift down */
		len = end - start;
		if (kmax <= Length(buf) + len)
			return (2);	/* moji over*/
		for (i = Length(buf); i > start; i--)
				buf[i + len] = buf[i];
	}
	else {				/* shift up */
		len = start - end;
		if (Length(buf) <= (UCHAR)len)
			return (2);
		for (i = end + 1; i <= Length(buf) - len; i++)
				buf[i] = buf[i + len];
	}
	return (0);
}


/*
 *	Convert dakuten handakuten
 *		rc = cnv_dakhan(pbe,func)
 */
global short FTYPE	cnv_dakhan(pbe,func)
PBEBUF	pbe;
short	func;		/* function */
{
	UCHAR	code[3];	/* chacter code */
/*	UCHAR	attr[3];	/ * attribute * / */
	USHORT	attr[3];	/* attribute */
	UCHAR	work[3];	/* hankaku code */
	SBUFF	Bcode,	Bwork;
	REG2 short	rc;		/* return information */
	REG1 short	i;

	if (func != DAKUTEN && func != HANDAKUTEN)
		return (ERR);	/* illigal function */
	else {
		if (pbe->kihon_pos - pbe->kihon_cnv <= 0)
			return (ERR);
		(void)chk_blk(pbe,i = get_cur(pbe,-1));
		get_kihon_code(pbe, -1, code, attr);
		if (code[0] != 2)
			return (ERR);
		Copylng(code, Bcode.str, 3);		/* mk3 */
		SLength(Bcode) = Length(code);		/* mk3 */
		hira_kata((BUFF *)&Bcode, (BUFF *)&Bwork);/*991210 WRN*/
		Copylng(Bcode.str, code, 3);		/* mk3 */
		Length(code) = (UCHAR)SLength(Bcode);	/* mk3 */
		for (i = 0; i < 3; i++)
			/*991018*/
			code[i] = /*work[i]*/Bwork.str[i];
		if(code[1] != 0x83 || (rc = chkdak(code[2],func)) == NORMAL_TYP)
			return (ERR);
		else {
			get_kihon_code(pbe,-1, code, attr);
			if (rc != V_TYP)
				code[2] += (UCHAR)rc;
			else {
				code[1] = 0x83;
				code[2] = 0x94;
			}
			attr[1]++;
			set_kihon_code(pbe,-1, code, attr);
			return (OK);
		}
	}
}


global void FTYPE	get_kihon_code(pbe, point, code, attr)
PBEBUF	pbe;
short	point;			/* kihon buffer point */
UCHAR PWIN	*code;		/* outpuyt code */
/*UCHAR PWIN	*attr;		/ * output attribute * / */
USHORT PWIN	*attr;		/* output attribute */
{
	REG1 short	kptr;		/* kihon buffer point */

	kptr = get_cur(pbe,point);
	get_kpos_code(pbe,kptr, code, attr);
}


static void FTYPE	get_kpos_code(pbe,pos, code, attr)
PBEBUF	pbe;
short	pos;		/* kihon buffer point */
UCHAR PWIN	*code;		/* outpuyt code */
/*UCHAR PWIN	*attr;		/ * output attribute * / */
USHORT PWIN	*attr;		/* output attribute */
{
	code[0] = 1;
	code[1] = pbe->kihon_buf_Q.str[pos + 1];
	attr[1] = pbe->kihon_atr_Q[pos + 1];
	if ((attr[1] & M_ZEN_HAN) != F_HANK) {
		code[0]++;
		code[2] = pbe->kihon_buf_Q.str[pos + 1 + 1];
		attr[2] = pbe->kihon_atr_Q[pos + 1 + 1];
	}
	attr[0] = code[0];
}


global void FTYPE	set_kihon_code(pbe,point, code, attr)
PBEBUF	pbe;
short	point;		/* kihon buffer point */
UCHAR PWIN	*code;		/* outpuyt code */
/*UCHAR PWIN	*attr;		/ * output attribute * / */
USHORT PWIN	*attr;		/* output attribute */
{
	REG1 short	kptr;		/* kihon buffer point */

	kptr = get_cur(pbe,point);
	if (code[0] >= 1) {
		pbe->kihon_buf_Q.str[kptr + 1] = code[1];
		pbe->kihon_atr_Q[kptr + 1] = attr[1];
	}
	if ((attr[1] & M_ZEN_HAN) != F_HANK && code[0] == 2) {
		pbe->kihon_buf_Q.str[kptr + 1 + 1] = code[2];
		pbe->kihon_atr_Q[kptr + 1 + 1] = attr[2];
	}
}


global short FTYPE	get_cur(pbe,point)
PBEBUF	pbe;
short	point;
{
	REG2 short	kptr;
	REG1 short	i;

	i = point;
	if (point >= 0) {
		for (kptr = pbe->kihon_pos;
		 (UCHAR)kptr < Length(pbe->kihon_atr_Q) && i != 0; kptr++, i--) {
			if ((pbe->kihon_atr_Q[kptr + 1] & M_ZEN_HAN) != F_HANK)
				kptr++;
		}
	}
	else {
		for (kptr = pbe->kihon_pos; kptr > 0 && i != 0; kptr--, i++) {
			if ((pbe->kihon_atr_Q[kptr - 1 + 1] & M_ZEN_HAN) != F_HANK)
				kptr--;
		}
	}
	return (kptr);
}


global short FTYPE	get_pos1(pbe,n)
PBEBUF	pbe;
REG2 short	n;
{
	REG1 short	sum;

	sum = 0;
	for (; n > 0; n--)
		sum += pbe->kihon_atr_Q[n] & M_ROMA_CNT;
	return (sum);
}


global short FTYPE	chk_blk(pbe,kpos)
PBEBUF	pbe;
short	kpos;		/* kihon_buf_Q postion */
{
	SBUFF	code;		/*	UCHAR	code[9];*/
	SBUFF	code_1;		/*	UCHAR	code_1[9];*/
/*	UCHAR	attr[9]; */
	USHORT	attr[9];
	short	ecnt1;
	short	bptr1;		/* base key_buf_Q */
	short	sptr1;		/* start key_buf_Q */
	short	eptr1;		/* end key_buf_Q */
	short	skptr;		/* stop kihon_ptr */
	short	skcnt;		/* kihon block count */
	REG2 short	bkptr;		/* base kihon_ptr */
	REG1 short	i;

	if (kpos >= SLength(pbe->kihon_buf_Q))
		goto exit;
	i = pbe->kihon_atr_Q[kpos + 1] & M_ROMA_CNT;
	if (i == 1)
		goto exit;
	if (i == 2) {
		if ((pbe->kihon_atr_Q[kpos + 1] & M_ZEN_HAN) != F_HANK)
			i++;
		if ((pbe->kihon_atr_Q[kpos + i] & M_ROMA_CNT) != 0
		     || (UCHAR)(pbe->kihon_pos + i) > SLength(pbe->kihon_buf_Q))
			goto exit;

	}
	for (bkptr = kpos; bkptr >= 0; bkptr--) {
		if ((pbe->kihon_atr_Q[bkptr + 1] & M_ROMA_CNT) != 0)
			break;
	}
	i = bkptr + 1;
	for (skptr = i; (UCHAR)skptr < SLength(pbe->kihon_buf_Q); skptr++) {
		if ((pbe->kihon_atr_Q[skptr + 1] & M_ROMA_CNT) != 0)
			break;
	}
	skcnt = skptr - bkptr;

/*	get_kpos_code(pbe,bkptr, code, attr);
mk3*/	get_kpos_code(pbe,bkptr, code.str, attr);

	bptr1 = get_pos1(pbe,bkptr);
	sptr1 = get_pos1(pbe,skptr);
	/* convert key_buf_Q data */
	code.len = code.str[0] = (UCHAR)skcnt;
	for (i = 1; i <= skcnt; i++)
		code.str[i] = pbe->kihon_buf_Q.str[bkptr + i];
	if ((pbe->kihon_atr_Q[kpos + 1] & KANA_BIT) == 0) {

		hira_kata((BUFF *)&code, (BUFF *)&code_1);/*991210 WRN*/
		code_1.str[0] = (UCHAR)code_1.len;
		for (i = 1; (UCHAR)i <= SLength(code); i++)
			code.str[i] = code_1.str[i];
/* Ⱦ [issho] BS BS [tyo] comment out by K.H. 97/4/20 */
		pbe->kihon_atr_Q[kpos + 1] |= ZENKAKU_BIT;
	}
	if ((pbe->kihon_atr_Q[kpos + 1] & ZENKAKU_BIT) != 0)
		(void)zen_han((BUFF *)&code, (BUFF *)&code_1);/*991210 WRN*/
	else
		CopyKb((BUFF *)&code, (BUFF *)&code_1);/*991210 WRN*/
	code_1.str[0] = (UCHAR)code_1.len;
	ecnt1 = SLength(code_1);
	eptr1 = bptr1 + ecnt1;

	for (i = bkptr; i < skptr; i++) {
		if ((pbe->kihon_atr_Q[i + 1] & M_ZEN_HAN) != F_ZEN_R)
			pbe->kihon_atr_Q[i + 1] = (UCHAR)((pbe->kihon_atr_Q[i + 1] & ~M_ROMA_CNT) + C_ROMA_1);
#if	PENWIN
		if (((pbe->kihon_atr_Q[i + 1] & F_ZEN_L) == F_ZEN_L)
#else
		if (((pbe->kihon_atr_Q[i + 1] & M_ZEN_HAN) == F_ZEN_L)
#endif
		     && (code.str[i - bkptr + 1] == 0x83))
			if (chk_dakhan(code.str[i - bkptr + 2]) != NORMAL_TYP)
				pbe->kihon_atr_Q[i + 1]++;
	}
#if	PENWIN
	if ( (i = buf_move(pbe->key_buf_Q, pbe->key_max, sptr1, eptr1,1)) == 2)
#else
	if ( (i = buf_move((BUFF *)&pbe->key_buf_Q, pbe->key_max, sptr1, eptr1)) == 2)/*991210 WRN*/
#endif
		return (i);
	SLength(pbe->key_buf_Q) += (eptr1 - sptr1);
	for (i = 1; (UCHAR)i <= SLength(code_1); i++)
#if	PENWIN
		pbe->key_buf_Q[(bptr1 +i)*2-1] = code_1[i];
#else
		pbe->key_buf_Q.str[bptr1 +i] = code_1.str[i];
#endif
	pbe->key_cnv = get_pos1(pbe,pbe->kihon_cnv);
	pbe->key_pos = get_pos1(pbe,pbe->kihon_pos);
exit:
	return (0);
}


/*
 *	Check dakuon
 */
global short FTYPE	chkdak(c0, c1)
short	c0, c1;
{
	REG1	short	i;
	REG2	short	j;

	i = c0 - OFFSET;
	if (0 <= i && i < MAX_TABLE) {
		i = dakuon_table[i];
		j = c1;
		if (j == DAKUTEN) {
			if (i & A_V)
				return (V_TYP);
			else if (i & A_D)
				return (DAKU_TYP);
		}
		else if (j == HANDAKUTEN) {
			if (i & A_H)
				return (HANDAKU_TYP);
		}
	}
	return (NORMAL_TYP);
}


/*
 *	Check N convert to HATSUON
 */
global short FTYPE	chk_n_cnv2(pbe,ptr)
PBEBUF	pbe;
REG1 short	ptr;
{
	UCHAR	code[4];
/*	UCHAR	attr[4]; */
	USHORT	attr[4];

	get_kpos_code(pbe,ptr, code, attr);
	if ((attr[1] & M_ROMA_CNT) != C_ROMA_1)
		return (0);
	if ((attr[1] & ZENKAKU_BIT) != 0) {
		if (code[1] == 0x82 && code[2] == 0xf1)
			return (1);
		else if (code[1] == 0x83 && code[2] == 0x93)
			return (1);
		else
			return (0);
	}
	else if (code[1] == HATSUON)
		return (1);
	else
		return (0);
}


/*
 *	Check N convert to HATSUON
 */
global short FTYPE	chk_n_cnv(pbe,pos)
PBEBUF	pbe;
short	pos;
{
	return (chk_n_cnv2(pbe,get_cur(pbe,pos)));
}

/*
 *	ѻϻ
 *	ѻʸѿλϥϥե
 *	ѻʸҤ顦λĹ
 */
short	set_hosei_code(pbe, kp, code1, code2, attr2)
PBEBUF	pbe;
short	kp;		/* kihon buffer point */
UCHAR PWIN	*code1;		/* outpuyt code */
UCHAR PWIN	*code2;		/* outpuyt code */
/*UCHAR PWIN	*attr2;		/ * output attribute * / */
USHORT	PWIN	*attr2;		/* output attribute */
{
	static	USHORT	HanCode[9] = {0x2ea1,0x2ca4,0x2fa5,0x2db0,
				      0xa12e,0xa42c,0xa52f,0xb02d,0xffff};
	static	USHORT	ZenCode[9] = {0x4442,0x4341,0x5e45,0x7c5b,
				      0x4244,0x4143,0x455e,0x5b7c,0xffff};
	short	i;
	short	flag = -1;
	short	hira = 0;
	short	pos  = -1;
	short	ptr ;
BUFF	work, work2;
short	dst;

	if (Length(code2) == 1) {
		for (i=0; HanCode[i] != (USHORT)0xffff; i++) {
			if ((attr2[1] & C_AUTO_HOSEI) && 
			    code2[1] == (UCHAR)((HanCode[i] >>8) & 0xff)) {
/*BUGFIX:951114 */
				if ((pbe->wVjeModeFlag3 & EISUU_BIT) != 0)
					;
				else
					code2[1] = (UCHAR)(HanCode[i] & 0xff);
				flag = i / 4 ;
				pos  = i;
				break;
			}
		}
	} else {
		if (code2[1] != (UCHAR)0x81)
			return 0;
		for (i=0; ZenCode[i] != (USHORT)0xffff; i++) {
			if ((attr2[2] & C_AUTO_HOSEI) &&
			    code2[2] == (UCHAR)((ZenCode[i] >>8) & 0xff)) {
/*BUGFIX:951114 */
				if ((pbe->wVjeModeFlag3 & EISUU_BIT) != 0)
					;
				else
					code2[2] = (UCHAR)(ZenCode[i] & 0xff);
				flag = i / 4 ;
				pos  = i;
				break;
			}
		}
	}
	if (flag == -1)
		return 0;

	if (Length(code1) == 1) {
		if (code1[1] > (UCHAR)0x80)
			hira = 1;
	} else {
		if (code1[1] == (UCHAR)0x82 && 
		((UCHAR)0x9f <= code1[2] && code1[2] <= (UCHAR)0xf1 ))
			hira = 1;
		else if (code1[1] == (UCHAR)0x83 && 
		((UCHAR)0x40 <= code1[2] && code1[2] <= (UCHAR)0x96 ))
			hira = 1;
		else if (code1[1] == (UCHAR)0x81 && code1[2] == (UCHAR)0x42 )
			hira = 1;
		else if (code1[1] == (UCHAR)0x81 && code1[2] == (UCHAR)0x41 )
			hira = 1;
		else if (code1[1] == (UCHAR)0x81 && code1[2] == (UCHAR)0x45 )
			hira = 1;
		else if (code1[1] == (UCHAR)0x81 && code1[2] == (UCHAR)0x5b )
			hira = 1;
	}
#if 1
	ptr = (get_cur(pbe, kp)) + 1;
	if (flag == 0 && hira == 1) {
		dst = 2;
/*Ĵ */
#if 1
		dst = CheckInpMode(pbe,(UCHAR)(HanCode[pos] & 0xff));
#else
		if ((pbe->wVjeModeFlag3 & KANA_BIT) &&
		    (pbe->wVjeModeFlag3 & EISUU_BIT) == 0 &&
		    (pbe->wVjeModeFlag3 & ZENKAKU_BIT) == 0)
			dst = 1;
/*BUGFIX:951114 */
		if ((pbe->wVjeModeFlag3 & EISUU_BIT) != 0 &&
		    (pbe->wVjeModeFlag3 & ZENKAKU_BIT) == 0)
			dst = 1;
#endif
		if (dst != Length(code2)) {
/*mk3*/			Copylng(code2, work2.str, Length(code2)+1);
/*mk3*/			work2.len = Length(code2);

			if (dst == 1) {
				/*HAN */
/*				zen_han(code2,work);
mk3*/				zen_han(&work2, &work);

				attr2[1] &= ~M_ZEN_HAN;
				attr2[1] |= C_ROMA_1 ;
				buf_move ( &pbe->kihon_buf_Q,pbe->kihon_max, ptr+1, ptr );
				buf_move2 ( pbe->kihon_atr_Q,pbe->kihon_max, ptr+1, ptr );
				SLength(pbe->kihon_buf_Q) -= 1;
				Length(pbe->kihon_atr_Q) -= 1;
				if (ptr < pbe->kihon_pos)
					pbe->kihon_pos -= 1;
			} else {
				/*ZEN */
/*				han_zen(code2,work);
mk3*/				/*zen_han*/han_zen(&work2, &work);//991126

				attr2[1] &= ~M_ZEN_HAN;
				attr2[2] = attr2[1] ;
				attr2[1] |= F_ZEN_L ;
				attr2[2] |= F_ZEN_R  ;
				attr2[2] &= ~(M_ROMA_CNT);
				buf_move ( &pbe->kihon_buf_Q,pbe->kihon_max, ptr, ptr+1 );
				buf_move2 ( pbe->kihon_atr_Q,pbe->kihon_max, ptr, ptr+1 );
				SLength(pbe->kihon_buf_Q) += 1;
				Length(pbe->kihon_atr_Q) += 1;
				if (ptr <= pbe->kihon_pos )
					pbe->kihon_pos += 1;
			}
			Copylng(&work.str[1],&code2[1],SLength(work));
			Length(code2) = (UCHAR)SLength(work);
			Length(attr2) = SLength(work);
		}
		if (code2[0] >= 1) {
			pbe->kihon_buf_Q.str[ptr] = code2[1];
			pbe->kihon_atr_Q[ptr] = attr2[1];
		}
		if ((attr2[1] & M_ZEN_HAN) != F_HANK && code2[0] == 2) {
			pbe->kihon_buf_Q.str[ptr + 1] = code2[2];
			pbe->kihon_atr_Q[ptr + 1] = attr2[2];
		}
/*ttt		set_kihon_code(pbe, kp, code2, attr2); */
		return (HanCode[pos]);
/*		set_kihon_code(pbe, kp, code2, attr2); */
/*		return (HanCode[pos]); */
	} else if (flag == 1 && hira == 0) {
		dst = CheckInpMode(pbe,(UCHAR)(HanCode[pos] & 0xff));
		if (dst != Length(code2)) {
/*mk3*/			Copylng(code2, work2.str, Length(code2)+1);
/*mk3*/			work2.len = Length(code2);

			if (dst == 1) {
				/*HAN */
/*				zen_han(code2,work);
mk3*/				zen_han(&work2, &work);

				attr2[1] &= ~M_ZEN_HAN;
				attr2[1] |= C_ROMA_1 ;
				buf_move ( &pbe->kihon_buf_Q,pbe->kihon_max, ptr+1, ptr );
				buf_move2 ( pbe->kihon_atr_Q,pbe->kihon_max, ptr+1, ptr );
				SLength(pbe->kihon_buf_Q) -= 1;
				Length(pbe->kihon_atr_Q) -= 1;
				if (ptr < pbe->kihon_pos )
					pbe->kihon_pos -= 1;
			} else {
				/*ZEN */
/*				han_zen(code2,work);
mk3*/				zen_han(&work2, &work);

				attr2[1] &= ~M_ZEN_HAN;
				attr2[2] = attr2[1] ;
				attr2[1] |= F_ZEN_L ;
				attr2[2] |= F_ZEN_R  ;
				attr2[2] &= ~(M_ROMA_CNT);
				buf_move ( &pbe->kihon_buf_Q,pbe->kihon_max, ptr, ptr+1 );
				buf_move2 ( pbe->kihon_atr_Q,pbe->kihon_max, ptr, ptr+1 );
				SLength(pbe->kihon_buf_Q) += 1;
				Length(pbe->kihon_atr_Q) += 1;
				if (ptr <= pbe->kihon_pos )
					pbe->kihon_pos += 1;
			}
			Copylng(&work.str[1],&code2[1],SLength(work));
			Length(code2) = (UCHAR)SLength(work);
			Length(attr2) = SLength(work);
		}
		if (code2[0] >= 1) {
			pbe->kihon_buf_Q.str[ptr] = code2[1];
			pbe->kihon_atr_Q[ptr] = attr2[1];
		}
		if ((attr2[1] & M_ZEN_HAN) != F_HANK && code2[0] == 2) {
			pbe->kihon_buf_Q.str[ptr + 1] = code2[2];
			pbe->kihon_atr_Q[ptr + 1] = attr2[2];
		}
/*ttt		set_kihon_code(pbe, kp, code2, attr2); */
		return (HanCode[pos]);
	} else
		return 0;
#else
	if (flag == 0 && hira == 1) {
		set_kihon_code(pbe, kp, code2, attr2);
		return (HanCode[pos] );
	} else if (flag == 1 && hira == 0) {
		set_kihon_code(pbe, kp, code2, attr2);
		return (HanCode[pos] );
	} else
		return 0;
#endif
}
/*
 *	ѻϻ
 *	ѻʸѿλϥϥե
 *	ѻʸҤ顦λĹ
 */
global short FTYPE	set_hosei(pbe,kpos)
PBEBUF	pbe;
SHORT	kpos;
{
	UCHAR	code1[4];
	UCHAR	code2[4];
	USHORT	attr1[4];
	USHORT	attr2[4];
	short	s1,s2,s3;
	short	flag ,ret;

	flag = 0;
	ret = 0;
	s1 = get_cur(pbe,-2);
	s2 = get_cur(pbe,-1);
	s3 = get_cur(pbe,0);
	if ( s1 < s2 )
		flag |= 0x01;
	if ( s3 < SLength(pbe->kihon_buf_Q))
		flag |= 0x02;
	if (flag & 0x01) {
		get_kpos_code(pbe, s1, code1, attr1);
		get_kpos_code(pbe, s2, code2, attr2);
		ret = set_hosei_code(pbe, -1, code1, code2, attr2);
	}
	if (flag & 0x02){
		get_kpos_code(pbe, s2, code1, attr1);
		get_kpos_code(pbe, s3, code2, attr2);
		ret = set_hosei_code(pbe, 0, code1, code2, attr2);
	}
	return (ret) ;
}
