/******************************************************************************
	wunicode.c
******************************************************************************/
#include	<stdio.h>		/* for sprintf */
#include	"common.h"
#include	"basicedt.h"
#include	"wfncdef.h"

/*=============================================================================
	local function
=============================================================================*/
static	void	make_result (PBEBUF pbe,PBD bdata,ULONG uCode,ULONG uOffset);
static	void	make_display(PBEBUF pbe,PBD bdata,ULONG uCode,ULONG uOffset);
static	ULONG	get_code(UCHAR* ptr,ULONG mod);
static	ULONG	asc_code(UCHAR* ptr);
static	ULONG	hex_code(UCHAR* ptr);
static	int	is_jis  (ULONG jis);
static	int	is_sjis (ULONG sjis);
static	int	is_kuten(ULONG kuten);
static	int	is_ucs  (ULONG ucs);
static	ULONG	inc_jis(ULONG jis,ULONG max_jis);
static	ULONG	dec_jis(ULONG jis,ULONG max_jis);
static	ULONG	add_jis(ULONG jis,ULONG max_jis,ULONG ofs);
static	ULONG	sub_jis(ULONG jis,ULONG max_jis,ULONG ofs);
static	ULONG	inc_ucs(ULONG ucs,ULONG max_ucs);
static	ULONG	dec_ucs(ULONG ucs,ULONG max_ucs);
static	ULONG	add_ucs(ULONG ucs,ULONG max_ucs,ULONG ofs);
static	ULONG	sub_ucs(ULONG ucs,ULONG max_ucs,ULONG ofs);
static	ULONG	cnv_kuten_jis(ULONG kuten);
static	ULONG	cnv_jis_kuten(ULONG jis);
static	ULONG	set_jis(PBEBUF,UCHAR* ptr,ULONG jis);
static	ULONG	set_ucs(UCHAR* ptr,ULONG ucs);
static	ULONG	list_jis(PBEBUF,UCHAR* ptr,ULONG jis,ULONG max_jis,ULONG cnt);
static	ULONG	list_ucs(UCHAR *ptr,ULONG ucs,ULONG max_ucs,ULONG cnt);
#if PCUNIX/*990826*/
static	ULONG	cnv_euc_jis(ULONG kuten);
static	ULONG	cnv_jis_euc(ULONG jis);
#endif
/*=============================================================================
	kuten
=============================================================================*/
global	short	kuten(PBEBUF pbe,PBD bdata)
{
#define	GO_NONE	0
#define	GO_EMP	1
#define	GO_INP	2
#if 0/*990615*/
static	short	first	= 1;
#endif
	short	go;
	ULONG	uCode;
	ULONG	uOffset;
	int	numMax,numMax9;
	ULONG	uUniMax;
	int	i;

	go	= GO_NONE;
	/*---------------------------------------------------------------------
		initial proc
	---------------------------------------------------------------------*/
#if 1 /* 990615 */
	if	( !pbe->first ) {
		pbe->first	= 1;
		pbe->uCodeJ	= 0x2121;
		pbe->uCodeU	= 0x0020;
	}
#else
	if	( first ) {
		first		= 0;
		pbe->uCodeJ	= 0x2121;
		pbe->uCodeU	= 0x0020;
	}
#endif
	if	(pbe->wUniMode == 0) {
		i			= SLength(pbe->key_buf_Q);
		pbe->key_buf_Q.str[i + 1]	= 0;
		if	((pbe->main_stg & PRC_INPUT) && (i != 0)) {
			uCode	= get_code(&pbe->key_buf_Q.str[1],pbe->codmd);
			if	( pbe->codmd != 3 ) {	/* !UCS	*//*990826*/
				if	( uCode < 0x2121
				||	  uCode > bdata->wCodeMax ) {
					return	RC_EATEN;
				}
				pbe->uCodeJ	= uCode;
			}
			else	{			/* UCS	*/
				uUniMax	= bdata->wCodeMax;
				if	( uUniMax == 0 ) {	/* UCS4 */
					uUniMax	= 0x7fffffff;
				}
				if	( uCode < 0x0020
				||	  uCode > uUniMax ) {
					return	RC_EATEN;
				}
				pbe->uCodeU	= uCode;
			}
			pbe->uOffset	= 0;
		}
		if	( bdata->wVkey == F_CODE_CNT ) {
			pbe->kaku_req	= 0;
			clear(pbe->hVjeLib);
			clear_buf(pbe,bdata);
		}
		pbe->wUniMode	= bdata->wVkey;
		bdata->wVkey	= F_KOHOMAX;
		pbe->main_stg	= PRC_CODE;
	}
	/*---------------------------------------------------------------------
		main proc
	---------------------------------------------------------------------*/
	if	( pbe->codmd != 3 ) {	/* !UCS	*//*990826*/
		uCode	= pbe->uCodeJ;
	}
	else	{			/* UCS	*/
		uCode	= pbe->uCodeU;
	}
	uOffset	= pbe->uOffset;
	numMax	= bdata->cLBItemNumMax;
	numMax9	= ( numMax > 9 ) ? 9 : numMax;
	switch	(bdata->wVkey) {
	case	F_CHR:
		if	( bdata->wCharCode >= '1'
		&&	  bdata->wCharCode <= '0' + numMax9 ) {
			uOffset	= bdata->wCharCode - '1';
			make_result(pbe,bdata,uCode,uOffset);
			if	( pbe->wUniMode != F_CODE_CNT ) {
				go	= GO_EMP;
			}
		}
		else {
			if	( pbe->wUniMode != F_CODE_CNT ) {
				make_result(pbe,bdata,uCode,uOffset);
				if	( bdata->wCharCode != 0x20 ) {
					pbe->fUnget	= 1;
				}
				go		= GO_EMP;
			}
		}
		break;
	case	F_CTRL:
		if	( bdata->wCharCode != 0x0d ) {
			break;
		}
		/* nobreak */
	case	F_SPACE:
	case	F_NO_CNV:
	case	F_NO_CNV2: /*for atok */
		make_result(pbe,bdata,uCode,uOffset);
		if	( pbe->wUniMode != F_CODE_CNT ) {
			go	= GO_EMP;
		}
		break;
	case	F_SCRN:
		make_result(pbe,bdata,uCode,uOffset);
		pbe->fUnget	= 1;
		go		= GO_EMP;
		break;
	case	F_ATOK_MODE:
	case	F_CODE_CNT: 	/* Kigou Code */
	case	F_CANCEL: 	/* Esc Code */
		if	( SLength(pbe->key_buf_Q) != 0 ) {
			go	= GO_INP;
		}
		else	{
			go	= GO_EMP;
		}
		break;
	case	F_CANALL:
		go	= GO_EMP;
		break;
	case	F_CNV_BKOHO:
	case	F_CNV_BCNV:
/**/	case	F_LEFT: 		/* Cursor Backward WX2*/
/**/	case	F_CNV_BUNS:		/* for atok binding */
/**/	case	F_CNV_BCNV1:		/* for WX2 Delta 94/4/16*/
/**/	case	F_CNV_BCNV_ATK:		/* for ATOK8 Delta 94/4/16*/
		if	( uOffset > 0 ) {
			uOffset	= uOffset - 1;
			break;
		}
		uOffset	= numMax - 1;
		/* nobreak */
	case	F_CNV_BBLK: 		/* Cursor Up */
	case	F_CNV_BBLK1:		/* for WX2 Delta 94/4/16*/
	case	F_CNV_BBLK_ATK:		/* for ATOK8 Delta 94/4/16*/
		if	( pbe->codmd != 3 ) {/*990826*/
			uCode	= sub_jis(uCode,bdata->wCodeMax,numMax);
		}
		else	{
			uCode	= sub_ucs(uCode,bdata->wCodeMax,numMax);
		}
		break;
	case	F_CNV_NKOHO:
	case	F_CNV:
	case	F_CODE:
	case	F_CNV_NCNV:		/*94/3/1 bug*/
/**/	case	F_RIGHT: 		/* Cursor Forward */
/**/	case	F_CNV_BUNL:		/* for atok binding */
/**/	case	F_CNV_NCNV1:		/* for WX2 Delta 94/4/16*/
/**/	case	F_CNV_NCNV_ATK:		/* for ATOK8 Delta 94/4/16*/
		if	( (int)uOffset < (numMax - 1) ) {
			uOffset	= uOffset + 1;
			break;
		}
		uOffset	= 0;
		/* nobreak */
	case	F_CNV_NBLK: 		/* Cursor Down */
/**/	case	F_ATOK_KAKU:		/* for atok binding */
/**/	case	F_CNV_NBLK1:		/* for WX2 Delta 94/4/16*/
/**/	case	F_CNV_NBLK_ATK:		/* for ATOK8 Delta 94/4/16*/
		if	( pbe->codmd != 3 ) {/*990826*/
			uCode	= add_jis(uCode,bdata->wCodeMax,numMax);
		}
		else	{
			uCode	= add_ucs(uCode,bdata->wCodeMax,numMax);
		}
		break;
	case	F_KOHOMAX:
		break;
#if 1 /* 990929 */
	case	F_LB_SEL2:
		uOffset	= bdata->wCharCode;
		if (uOffset < 0) {
			uOffset	= 0;
		} else if ((int)uOffset >= numMax) {
			uOffset	= numMax - 1;
		}
		break;
#endif
	}
	if	( go == GO_NONE ) {
		make_display(pbe,bdata,uCode,uOffset);
	}
	else	{
		pbe->wUniMode		= 0;
		bdata->wDataStatus	&= ~VJE_LBDATA;
		bdata->wDataUpdate	|=  VJE_LBDATA;
		if	( go == GO_EMP ) {
			clear(pbe->hVjeLib);
			clear_buf(pbe,bdata);
			pbe->kaku_req		= 0;
			pbe->main_stg		= PRC_EMP;
		}
		else { /* go == GO_INP */
			disp_koho(pbe,0, 0, bdata);
			pbe->main_stg = PRC_INPUT;
		}
	}
	if	( pbe->codmd != 3 ) {/*990826*/
		pbe->uCodeJ	= uCode;
	}
	else	{
		pbe->uCodeU	= uCode;
	}
	pbe->uOffset	= uOffset;
	return	RC_EATEN;
}

/*=============================================================================
	make_result
=============================================================================*/
static	void	make_result(PBEBUF pbe,PBD bdata,ULONG uCode,ULONG uOffset)
{
	ULONG	uCurr;
	int	i;

	clr_result_buf(pbe);
	if	( pbe->codmd != 3 ) {/*990826*/
		uCurr	= add_jis(uCode,bdata->wCodeMax,uOffset);
		i	= set_jis(pbe,bdata->lpchResult,uCurr);
	}
	else {
		uCurr	= add_ucs(uCode,bdata->wCodeMax,uOffset);
		i	= set_ucs(bdata->lpchResult,uCurr);
	}
	bdata->cchResult	= i;
	bdata->wDataStatus	|= VJE_RESULT;
	bdata->wDataUpdate	|= VJE_RESULT;
	return;
}

/*=============================================================================
	make_display
=============================================================================*/
static	void	make_display(PBEBUF pbe,PBD bdata,ULONG uCode,ULONG uOffset)
{
	ULONG	uCurr;
	int	i,j,n;
	ULONG	uOut;
	UCHAR*	fmt;

	n	= bdata->cLBItemNumMax;
	if	( pbe->codmd != 3 ) {/*990826*/
		uCurr	= add_jis(uCode,bdata->wCodeMax,uOffset);
		i 	= set_jis(pbe,bdata->lpchDisplay,uCurr);
		j	= list_jis(pbe,bdata->lpchLBList,
					uCode,bdata->wCodeMax,n);
	}
	else {
		uCurr	= add_ucs(uCode,bdata->wCodeMax,uOffset);
		i	= set_ucs(bdata->lpchDisplay,uCurr);
		j	= list_ucs(bdata->lpchLBList,uCode,bdata->wCodeMax,n);
	}
	bdata->cchDisplay	= i;
	bdata->cchLBListLen	= j;
	bdata->cLBItemNum	= (USHORT)uOffset + 1;
	for	( i = 0 ; i < bdata->cchDisplay ; i++ ) {
		bdata->lpattrDisplay[i]	= CL_CSR;
	}
	bdata->lpattrDisplay[i]	 = 0;
	bdata->wDataStatus	|= VJE_LBDATA|VJE_DISPLAYDATA;
	bdata->wDataUpdate	|= VJE_LBDATA|VJE_DISPLAYDATA;
	switch	(pbe->codmd) {
	case	0:	/* KUTEN */
		uOut	= cnv_jis_kuten(uCurr);
		fmt	= ( (uOut / 100) <= 99 ) ? "%04d" : "%05d";
		break;
	case	2:	/* SJIS */
		uOut	= cnv_jis_sjis(uCurr);
		fmt	= "%04X";
		break;
	case	1:	/* JIS */
		uOut	= uCurr;
		fmt	= "%04X";
		break;
	case	3:	/* UCS */
		uOut	= uCurr;
		fmt	= ( uOut <= 0xffff ) ? "%04X" : "%08X";
		break;
#if PCUNIX/*990826*/
	case	4:	/* EUC */
		uOut	= cnv_jis_euc(uCurr);
		fmt	= "%04X";
		break;
#endif
	default:
		uOut	= uCurr;
		fmt	= "%X";
	}
	sprintf(bdata->lpchLBTitle,fmt,uOut);
	return;
}

/*=============================================================================
	get_code
=============================================================================*/
static	ULONG	get_code(UCHAR* ptr,ULONG codmd)
{
	ULONG	ret;

	switch	(codmd) {
	case	0:	/* KUTEN */
		ret	= asc_code(ptr);
		if	( !is_kuten(ret) ) {
			ret	= 0;
			break;
		}
		ret	= cnv_kuten_jis(ret);
		break;
	case	1:	/* JIS */
		ret	= hex_code(ptr);
		if	( !is_jis(ret) ) {
			ret	= 0;
			break;
		}
		break;
	case	2:	/* SJIS */
		ret	= hex_code(ptr);
		if	( !is_sjis(ret) ) {
			ret	= 0;
			break;
		}
		ret	= cnv_sjis_jis(ret);
		break;
	case	3:	/* UCS */
		ret	= hex_code(ptr);
		if	( !is_ucs(ret) ) {
			ret	= 0;
			break;
		}
		break;
#if PCUNIX/*990826*/
	case	4:	/* EUC */
		ret	= hex_code(ptr);
		if	( !is_jis((ret & ~0x8080)) ) {
			ret	= 0;
			break;
		}
		ret = cnv_euc_jis(ret);
		break;
#endif
	}
	return	ret;
}

/*=============================================================================
	asc_code	(Dec) Ascii code -> integer
=============================================================================*/
static	ULONG	asc_code(UCHAR *ptr)
{
	ULONG	ret;
	UCHAR	c;

	ret	= 0;
	while	( *ptr ) {
		c	= *ptr++;
		if	('0' <= c && c <= '9' ) {
			ret	*= 10;
			ret	+= c - '0';
		}
		else	{
			ret	= 0;
			break;
		}
	}
	return	ret;
}

/*=============================================================================
	hex_code	(Hex) Ascii code -> integer
=============================================================================*/
static	ULONG	hex_code(UCHAR *ptr)
{
	ULONG	ret;
	UCHAR	c;

	ret	= 0;
	while	( *ptr ) {
		c	= *ptr++;
		if	('0' <= c && c <= '9') {
			ret	*= 16;
			ret	+= c - '0';
		}
		else if	('a' <= c && c <= 'f') {
			ret	*= 16;
			ret	+= c - 'a' + 10;
		}
		else if	('A' <= c && c <= 'F') {
			ret	*= 16;
			ret	+= c - 'A' + 10;
		}
		else	{
			ret	= 0;
			break;
		}
	}
	return	ret;
}

/*=============================================================================
	is_jis
=============================================================================*/
static	int	is_jis(ULONG jis)
{
	ULONG	low,high;

	low	= jis % 256;
	high	= jis / 256;
	return	(0x21 <= high && high <= 0x98)
	&&	(0x21 <= low  && low  <= 0x7e);
}

/*=============================================================================
	is_sjis
=============================================================================*/
static	int	is_sjis(ULONG sjis)
{
	ULONG	low,high;

	low	= sjis % 256;
	high	= sjis / 256;
	return	((0x81<=high && high<=0x9f) || (0xe0<=high && high<=0xfc))
	&&	((0x40<=low  && low <=0xfc) && (              low !=0x7f));
}

/*=============================================================================
	is_kuten
=============================================================================*/
static	int	is_kuten(ULONG kuten)
{
	ULONG	low,high;

	low	= kuten % 100;
	high	= kuten / 100;
	return	(1 <= high && high <= 120)
	&&	(1 <= low  && low  <= 94 );
}

/*=============================================================================
	is_ucs
=============================================================================*/
static	int	is_ucs(ULONG ucs)
{
	return	(ucs >= 0x20);
}

/*=============================================================================
	inc_jis
=============================================================================*/
static	ULONG	inc_jis(ULONG jis,ULONG max_jis)
{
	jis	= jis + 1;
	if	( jis > max_jis ) {
		jis	= 0x2121;
	}
	else if	( jis % 256 == 0x007f ) {
		jis	+= 0x0100;
		jis	-= 0x005e;
	}
	return	jis;
}

/*=============================================================================
	dec_jis
=============================================================================*/
static	ULONG	dec_jis(ULONG jis,ULONG max_jis)
{
	jis	= jis - 1;
	if	( jis < 0x2121 ) {
		jis	= max_jis;
	}
	else if	( jis % 256 == 0x0020 ) {
		jis	-= 0x0100;
		jis	+= 0x005e;
	}
	return	jis;
}

/*=============================================================================
	add_jis
=============================================================================*/
static	ULONG	add_jis(ULONG jis,ULONG max_jis,ULONG ofs)
{
	while	( ofs-- ) {
		jis	= inc_jis(jis,max_jis);
	}
	return	jis;
}

/*=============================================================================
	sub_jis
=============================================================================*/
static	ULONG	sub_jis(ULONG jis,ULONG max_jis,ULONG ofs)
{
	while	( ofs-- ) {
		jis	= dec_jis(jis,max_jis);
	}
	return	jis;
}

/*=============================================================================
	inc_ucs
=============================================================================*/
static	ULONG	inc_ucs(ULONG ucs,ULONG max_ucs)
{
	ucs	= ucs + 1;
	if	( max_ucs == 0 ) {	/* UCS4 */
		max_ucs	= 0x7fffffff;
	}
	if	( ucs > max_ucs ) {
		ucs	= 0x20;
	}
	return	ucs;
}

/*=============================================================================
	dec_ucs
=============================================================================*/
static	ULONG	dec_ucs(ULONG ucs,ULONG max_ucs)
{
	ucs	= ucs - 1;
	if	( max_ucs == 0 ) {	/* UCS4 */
		max_ucs	= 0x7fffffff;
	}
	if	( ucs < 0x20 ) {
		ucs	= max_ucs;
	}
	return	ucs;
}

/*=============================================================================
	add_ucs
=============================================================================*/
static	ULONG	add_ucs(ULONG ucs,ULONG max_ucs,ULONG ofs)
{
	while	( ofs-- ) {
		ucs	= inc_ucs(ucs,max_ucs);
	}
	return	ucs;
}

/*=============================================================================
	sub_ucs
=============================================================================*/
static	ULONG	sub_ucs(ULONG ucs,ULONG max_ucs,ULONG ofs)
{
	while	( ofs-- ) {
		ucs	= dec_ucs(ucs,max_ucs);
	}
	return	ucs;
}

/*=============================================================================
	cnv_kuten_jis
=============================================================================*/
static	ULONG	cnv_kuten_jis(ULONG kuten)
{
	return	((kuten / 100) + 0x20) * 256 + ((kuten % 100) + 0x20);
}

/*=============================================================================
	cnv_jis_kuten
=============================================================================*/
static	ULONG	cnv_jis_kuten(ULONG jis)
{
	return	((jis   / 256) - 0x20) * 100 + ((jis   % 256) - 0x20);
}

/*=============================================================================
	cnv_sjis_jis
=============================================================================*/
global	ULONG	cnv_sjis_jis(ULONG sjis)
{
	ULONG	low,high;

	low	= sjis % 256;
	high	= sjis / 256;
	if	( high >= 0xa0 ) {
		high	= high - 0x40;
	}
	high	= ((high - 0x81) * 2) + 0x21;
	if	( low < 0x9f ) {
		low	= low  - ( (low > 0x7e) ? 0x20 : 0x1f );
	}
	else	{
		high	= high + 0x01;
		low	= low  - 0x7e;
	}
	return	high * 256 + low;
}

/*=============================================================================
	cnv_jis_sjis
=============================================================================*/
global	ULONG	cnv_jis_sjis(ULONG jis)
{
	ULONG	low,high;

	low	= jis % 256;
	high	= jis / 256;

	if	(high & 0x01) {
		low	= low  + ( (low > 0x5f) ? 0x20 : 0x1f );
	}
	else	{
		low	= low + 0x7e;
	}
	high	= ((high - 0x21) / 2) + 0x81;
	if	( high >= 0xa0 ) {
		high	= high + 0x40;
	}
	return	high * 256 + low;
}
#if PCUNIX/*990826*/
/*=====================================================================
	cnv_jis_euc
=======================================================================*/
static		ULONG	cnv_jis_euc(ULONG jis)
{
	return ((ULONG)(jis | 0x8080));
}
/*=====================================================================
	cnv_euc_jis
=======================================================================*/
static		ULONG	cnv_euc_jis(ULONG euc)
{
	return ((ULONG)(euc & ~0x8080));
}
#endif

/*=============================================================================
	set_jis
=============================================================================*/
static	ULONG	set_jis(PBEBUF pbe,UCHAR* ptr,ULONG jis)
{
	ULONG	sjis;
	UCHAR*	top;

	top	= ptr;
#if 1	/*+Delta2.5 */
	if (pbe->wLimitMode & M_JIS)
		jis = ChkJISCodeRange(jis);
#endif
	sjis	= cnv_jis_sjis(jis);
	*ptr++	= (UCHAR)(sjis / 256);
	*ptr++	= (UCHAR)(sjis % 256);
	*ptr	= (UCHAR) 0;
	return	(ULONG)(ptr - top);
}

/*=============================================================================
	set_ucs
=============================================================================*/
static	ULONG	set_ucs(UCHAR* ptr,ULONG ucs)
{
	UCHAR*	top;

	top	= ptr;
	*ptr++	= 0x81;
	if	( ucs <= 0xffff ) {
		switch	( ucs & 0x8000 ) {
		case	0x0000:
			*ptr++	= 0x3f;
			break;
		case	0x8000:
			*ptr++	= 0x3e;
			break;
		}
		*ptr++	= (UCHAR)(((ucs /      256) % 256) | 0x80);
		*ptr++	= (UCHAR)(((ucs           ) % 256)       );
	}
	else	{
		switch	( ucs & 0x80008000 ) {
		case	0x00000000:
			*ptr++	= 0x3d;
			break;
		case	0x00008000:
			*ptr++	= 0x3c;
			break;
		case	0x80000000:
			*ptr++	= 0x3b;
			break;
		case	0x80008000:
			*ptr++	= 0x3a;
			break;
		}
		*ptr++	= (UCHAR)(((ucs / 16777216) % 256) | 0x80);
		*ptr++	= (UCHAR)(((ucs /    65536) % 256)       );
		*ptr++	= (UCHAR)(((ucs /      256) % 256) | 0x80);
		*ptr++	= (UCHAR)(((ucs           ) % 256)       );
	}
	*ptr	= (UCHAR) 0;
	return	(ULONG)(ptr - top);
}

/*=============================================================================
	list_jis
=============================================================================*/
static	ULONG	list_jis(PBEBUF pbe,UCHAR* ptr,
				ULONG jis,ULONG max_jis,ULONG cnt)
{
	ULONG	len,sum,i;

	sum	= 0;
	for	( i = 0 ; i < cnt ; i++ ) {
		len	= set_jis(pbe,ptr,jis) + 1;
		ptr	= ptr + len;
		sum	= sum + len;
		jis	= inc_jis(jis,max_jis);
	}
	return	sum;
}

/*=============================================================================
	list_ucs
=============================================================================*/
static	ULONG	list_ucs(UCHAR* ptr,ULONG ucs,ULONG max_ucs,ULONG cnt)
{
	ULONG	len,sum,i;

	sum	= 0;
	for	( i = 0 ; i < cnt ; i++ ) {
		len	= set_ucs(ptr,ucs) + 1;
		ptr	= ptr + len;
		sum	= sum + len;
		ucs	= inc_ucs(ucs,max_ucs);
	}
	return	sum;
}
