/*
 * եȤΥɡ
 * եåƥȤΥɡ
 * ƥʸ
 */
#include <malloc.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>
#include "xim.h"
#include <X11/Xresource.h>
#include <X11/Xatom.h>


#define KANA14 "-misc-fixed-medium-r-normal--14-130-75-75-c-70-jisx0201.1976-0"
#define K14    "-misc-fixed-medium-r-normal--14-130-75-75-c-140-jisx0208.1983-0"

#define FSM_BLOCK_NO      10
#define FSM_START_INDEX    1

typedef struct _Fsm {
    XrmQuark    qname;
    XrmQuark    qname2;
    XFontStruct *fs;
    int         link;
} Fsm_t;

int			 fsm_free = 1;
Static Fsm_t		*fsm_head;
Static int		 fsm_max_ind = 0;

#define REG_ASCII	1
#define REG_KANA	2
#define REG_ASCII_KANA	3
#define REG_KANJI	4
#define REG_GAIJI	8

typedef struct _cahrset_registry {
    char	*name;
    int		cahrset;
} Fcr;

#if DIGITAL/*DIGITAL-UX*/
Static Fcr	cahrset_tbl[] = {
    {"JISX0201.1976-0",	REG_ASCII_KANA	},
    {"JISX0208.1983-0",	REG_KANJI	},
    {"ISO8859",		REG_ASCII	},
};
#else
Static Fcr	cahrset_tbl[] = {
    {"JISX0201.1976",	REG_ASCII_KANA	},
    {"JISX0208.1983",	REG_KANJI	},
    {"ISO8859",		REG_ASCII	},
};
#endif
#define MAX_CARSET	sizeof(cahrset_tbl)/sizeof(Fcr)

/*
 * ΥեȤΥեȤ򸡺̤֤
 * REG_ASCII_KANA :Ⱦѥʥե
 * REG_KANJI      :ե
 */
int
CheckBaseCahrasetRegistry(font_name)
    char	*font_name;
{
    register int i;
    char	*charsetName, *str;

    for (i = 0, str = font_name; *str; str++) {
	if (!(str = strchr(str, '-')))
	    return( 0 );

	i++;
	if (i == 13) {
	    str++;
	    break;
	}
    }

    if (!(*str))
	return( 0 );

    charsetName = str;
    for(; *str; str++ ) {
	if( islower(*str) ) *str = toupper( *str );
    }

    for(i=0;i<MAX_CARSET;i++) {
	if( strncmp( cahrset_tbl[i].name, charsetName,
				strlen(cahrset_tbl[i].name) ) == 0 )
	    return( cahrset_tbl[i].cahrset );
    }
    return( 0 );
}

int
CheckCahrasetRegistry(font_struct)
    XFontStruct *font_struct;
{
    int		i;
    unsigned long charsetAtom;
    char	*charsetName, *str;
    Atom	XA_CHARSET_REGISTRY;

    XA_CHARSET_REGISTRY = XInternAtom( display, "CHARSET_REGISTRY", False);
    if( XGetFontProperty( font_struct, XA_CHARSET_REGISTRY, &charsetAtom ) ) {
	charsetName = XGetAtomName(display, charsetAtom);
    } else {
	return( 0 );
    }
    for( str = charsetName; *str; str++ ) {
	if( islower(*str) ) *str = toupper( *str );
    }
    for(i=0;i<MAX_CARSET;i++) {
	if( strcmp( cahrset_tbl[i].name, charsetName ) == 0 ) {
	    XFree( charsetName );
	    return( cahrset_tbl[i].cahrset );
	}
    }
    XFree( charsetName );
    return( 0 );
}

Fsm_t *
_EmptyFsm()
{
    int		ix;
    Fsm_t	*fsmp;
    char	*new;

    ix = FSM_START_INDEX;
    if( fsm_head == (Fsm_t *)NULL) {
        new = (char *)malloc( FSM_BLOCK_NO*sizeof(Fsm_t));
    } else {
        for( fsmp = &fsm_head[FSM_START_INDEX];
		ix < fsm_max_ind; ix++, fsmp++) {
	    if (fsmp->qname == 0) {
    	        return( &fsm_head[ix]);
	    }
        }
	new = (char *)realloc( fsm_head, (FSM_BLOCK_NO+fsm_max_ind)*sizeof(Fsm_t));
    }
    if( new == NULL ) return( (Fsm_t *)NULL);
    fsm_head = (Fsm_t *)new;
    bzero( &fsm_head[fsm_max_ind], FSM_BLOCK_NO*sizeof(Fsm_t));
    fsm_max_ind += FSM_BLOCK_NO;
    return( &fsm_head[ix]);
}

/*
 * ΥեȤɤ
 */
XFontStruct *
_FXLoadQueryFont( display, name )
    Display     *display;
    char	*name;
{
    XFontStruct *font_struct;
    XrmQuark	qname;
    int		ix;
    Fsm_t	*fsmp;
    unsigned int fontAtom;
    char	*fontName;

    qname = XrmStringToQuark( name);
    for( ix=FSM_START_INDEX, fsmp = &fsm_head[FSM_START_INDEX];
		ix < fsm_max_ind; ix++, fsmp++) {
	if( fsmp->qname == qname
	 || fsmp->qname2 == qname) {
	    fsmp->link++;
	    return( fsmp->fs);
	}
    }

    font_struct = XLoadQueryFont( display, XrmQuarkToString(qname));
    if( font_struct ) {
	fontName = 0;
        fsmp = _EmptyFsm();
        if( fsmp ) {
	    fsmp->fs = font_struct;
            fsmp->qname = qname;
            fsmp->link++;
	    if( XGetFontProperty( font_struct, XA_FONT, (unsigned long *)&fontAtom ) ) {
		fontName = XGetAtomName(display, fontAtom);
		}
	    fsmp->qname2 = fontName ? XrmStringToQuark( fontName ) : qname ;
        }
	if( fontName ) XFree( fontName );
        return( font_struct);
    }
    return( (XFontStruct *)NULL);
}

/*
 * ΥեȤ
 */
int
_FXFreeFont( display, font_struct )
    Display     *display;
    XFontStruct *font_struct;
{
    int		ix;
    Fsm_t	*fsmp;

    for( ix=FSM_START_INDEX, fsmp = &fsm_head[FSM_START_INDEX];
		ix < fsm_max_ind; ix++, fsmp++) {
	if( fsmp->fs == font_struct) {
	    fsmp->link--;
	    if( fsm_free && fsmp->link <= 0) {
		fsmp->link = 0;
		fsmp->qname = 0;
		fsmp->qname2 = 0;
		if (fsmp->fs) {
		    XFreeFont( display, fsmp->fs);
		    fsmp->fs = NULL;
		}
	    }
            return(0);
	}
    }
    return(-1);
}

/*
 * ١եȤΥɤԤ
 * VJEưVJEŪ˻ѤեȤΥɤԤ
 * ޤУ̤Υե̾Τä׵եȤ
 * ɤԤ
 */
int
FXLoadQueryBaseFont( display, load_font, base_font_name )
    Display	*display;
    FXimFont	*load_font;
    char	*base_font_name;
{
    	XFontStruct *ascii_kana_font_struct=0, *kanji_font_struct=0,
		    *gaiji_font_struct=0;
    	char	    *ascii_kana_font_name=0, *kanji_font_name=0,
		    *gaiji_font_name=0;
    	int		wfont_h, no = 0, ii;
    	int		error = 0;
    	char	    *cfn, cc, *none, *none2, null=0;
    	XFontStruct *font_struct, *font_struct_tbl[4];
    	char	    *cfnt[10], work[768];
    	int	    charset;

    	load_font->fixe_width = 1;
    	if( !base_font_name || !*base_font_name ) {
		return( -2);
    	}
	/*
	 * Υե̾ʬ򤹤
	 * cfnt[]ˤϳƥե̾Ƭɥ쥹ꤹ
	 */
	cfn = work;
	cfnt[no++] = cfn;
	while ( (cc = *base_font_name++) != '\0' ) {
		if ( cc == ',' ) {
			*cfn++ = '\0';
			cfnt[no++] = cfn;
		}
		else
			*cfn++ = cc;
	}
	*cfn = '\0';

    	none  = &null;
    	none2 = &null;
    	error = 0;
    	for( ii=0; ii<no; ii++ ) {
		if( cfnt[ii] == 0 || *cfnt[ii] == 0 )
		    continue;
		/*
		 * FontSet ˤ®٤ä٤ʤΤ
		 * FontStruct Ȥ롣
		 *
		 * ʤߤFontSetX11R5о줷եȳǰǤ
		 * FontStruct:X11R4
		 * FontSet:X11R5ʹ
		 * 
                 * FontSetưˤäեȤʣޤȤƽ
		 * ǤΤݲ줿ɽؿѤǤ
		 * åȤ⤢뤬󤻤®٤٤
		 * եȥСʤΤǶᤤϲɤȤϻפ
		 */
		font_struct = _FXLoadQueryFont( display, cfnt[ii] );
        	if( !font_struct ) {
		    ErrorMessage( 30, cfnt[ii] );
		    continue;
        	}
		if (!(charset = CheckBaseCahrasetRegistry( cfnt[ii] )))
		    charset = CheckCahrasetRegistry( font_struct );
		switch( charset ) {
		case REG_ASCII_KANA :
			if (ascii_kana_font_struct)
				_FXFreeFont(display, ascii_kana_font_struct );
	    		ascii_kana_font_struct = font_struct;
	    		ascii_kana_font_name   = cfnt[ii];
	    		break;
		case REG_KANJI :
			if (kanji_font_struct)
				_FXFreeFont(display, kanji_font_struct );
	    		kanji_font_struct = font_struct;
	    		kanji_font_name   = cfnt[ii];
	    		break;
		case REG_GAIJI :
			if (gaiji_font_struct)
				_FXFreeFont(display, gaiji_font_struct );
	    		gaiji_font_struct = font_struct;
	    		gaiji_font_name   = cfnt[ii];
	    		break;
		case REG_ASCII :
		case REG_KANA :
	    		none = cfnt[ii];
	    		_FXFreeFont( display, font_struct );
	    		break;
		}
    	}

    	if( !ascii_kana_font_struct ) {
		ErrorMessage( 32 );
		error = 1;
    	}
    	if( !kanji_font_struct ) {
		ErrorMessage( 34 );
		error = 1;
   	 }	
    	if( error ) {
		if( ascii_kana_font_struct )
		    _FXFreeFont( display, ascii_kana_font_struct );
		if( kanji_font_struct )
		    _FXFreeFont( display, kanji_font_struct );
		if( gaiji_font_struct )
		    _FXFreeFont( display, gaiji_font_struct );
		return( -1 );
    	}

    	if( ascii_kana_font_struct->per_char )
		load_font->fixe_width = 0;
    	if( kanji_font_struct->per_char )
		load_font->fixe_width = 0;
    	if( gaiji_font_struct && gaiji_font_struct->per_char )
		load_font->fixe_width = 0;

    	load_font->ascii_kana_font_struct = ascii_kana_font_struct;
    	load_font->status = FF_FONT_LOAD;
    	load_font->kanji_font_struct = kanji_font_struct;
    	load_font->gaiji_font_struct = gaiji_font_struct;
    	load_font->ascii_kana_font_width
    	  = ascii_kana_font_struct->max_bounds.width;
    	load_font->max_font_ascent
    	  = (ascii_kana_font_struct->ascent > kanji_font_struct->ascent)?
		 ascii_kana_font_struct->ascent : kanji_font_struct->ascent;
    	load_font->max_font_descent
    	  = (ascii_kana_font_struct->descent > kanji_font_struct->descent)?
		 ascii_kana_font_struct->descent : kanji_font_struct->descent;
    	load_font->max_font_height
    	  = ascii_kana_font_struct->ascent + ascii_kana_font_struct->descent;
    		wfont_h = kanji_font_struct->ascent + kanji_font_struct->descent;
    	if( load_font->max_font_height < wfont_h )
		load_font->max_font_height = wfont_h;
    	load_font->kanji_font_width = kanji_font_struct->max_bounds.width;
    	return( 0);
}

/*
 * ١եȤβԤ
 */
int
FXFreeFont( display, load_font )
    Display	*display;
    FXimFont	*load_font;
{
    	if( !(load_font->status & FF_FONT_LOAD) )
		return( 0 );
    	if (load_font->ascii_kana_font_struct) {
		_FXFreeFont(display, load_font->ascii_kana_font_struct );
		load_font->ascii_kana_font_struct = 0;
	}
    	if (load_font->kanji_font_struct) {
		_FXFreeFont(display, load_font->kanji_font_struct );
		load_font->kanji_font_struct = 0;
	}
    	if (load_font->gaiji_font_struct) {
		_FXFreeFont(display, load_font->gaiji_font_struct );
		load_font->gaiji_font_struct = 0;
	}
    	return( 0 );
}

/*
 * եåƥȤԤ
 */
int
FXCreateGC( display, window, load_font,
		foreground_pixel, background_pixel )
    Display	*display;
    Window	window;
    FXimFont	*load_font;
    unsigned long  foreground_pixel, background_pixel;
{
    unsigned long  gcmask;
    XGCValues      gcvalues, reverse_gcvalues;

    gcmask  = GCBackground | GCForeground | GCFont;
    gcvalues.foreground = foreground_pixel;
    gcvalues.background = background_pixel;
    reverse_gcvalues.foreground = background_pixel;
    reverse_gcvalues.background = foreground_pixel;

    gcvalues.font         = load_font->ascii_kana_font_struct->fid;
    reverse_gcvalues.font = load_font->ascii_kana_font_struct->fid;
    load_font->normal_gc
      = XCreateGC( display, window, gcmask, &gcvalues);
    load_font->reverse_gc
      = XCreateGC( display, window, gcmask, &reverse_gcvalues);


    gcvalues.function = GXxor;
    gcvalues.foreground = background_pixel ^ foreground_pixel;
    gcvalues.plane_mask = background_pixel ^ foreground_pixel;
    gcmask  = GCForeground | GCFunction | GCPlaneMask;
    load_font->invert_gc
      = XCreateGC( display, window, gcmask, &gcvalues);
    load_font->status |= FF_CREATE_GC;
    return( 0);
}

/*
 * եåƥȤβԤ
 */
int
FXFreeGC( display, load_font )
    Display	*display;
    FXimFont	*load_font;
{
    if( load_font->status & FF_CREATE_GC ) {
#define M_FreeGC( gc ) if( gc ) { XFreeGC( display, gc ); gc = 0; }

        M_FreeGC( load_font->normal_gc );
        M_FreeGC( load_font->reverse_gc );
        M_FreeGC( load_font->invert_gc );
#undef  M_FreeGC
    }
    return( 0);
}

/*
 * եåƥȤѹԤ
 */
int
FXChangeGC( display, window, load_font,
		foreground_pixel, background_pixel )
    Display	*display;
    Window	window;
    FXimFont	*load_font;
    unsigned long  foreground_pixel, background_pixel;
{
    unsigned long  gcmask;
    XGCValues      gcvalues, reverse_gcvalues;
    if( (load_font->status & FF_CREATE_GC) == (unsigned char)0 ) {
	return FXCreateGC( display, window, load_font,
	   			foreground_pixel, background_pixel );
	}
    gcmask  = GCBackground | GCForeground | GCFont;
    gcvalues.foreground = foreground_pixel;
    gcvalues.background = background_pixel;
    reverse_gcvalues.foreground = background_pixel;
    reverse_gcvalues.background = foreground_pixel;

    gcvalues.font         = load_font->ascii_kana_font_struct->fid;
    reverse_gcvalues.font = load_font->ascii_kana_font_struct->fid;
    XChangeGC( display, load_font->normal_gc, gcmask, &gcvalues);
    XChangeGC( display, load_font->reverse_gc, gcmask,
	&reverse_gcvalues);

    gcvalues.function = GXxor;
    gcvalues.foreground = background_pixel ^ foreground_pixel;
    gcvalues.plane_mask = background_pixel ^ foreground_pixel;
    gcmask  = GCForeground | GCFunction | GCPlaneMask;
    XChangeGC( display, load_font->invert_gc, gcmask, &gcvalues);
    return( 0);
}

/*
 * Υȥ󥰤ɽ
 * ȥ󥰤 USHORT Ǥդɬס
 * 0x0020  0x007f Ⱦʸ
 * ʸEUC
 * Ⱦѥʸ EUC_kanashift + 
 */
int
FXTextWidth( load_font, input_data, length)
    FXimFont	*load_font;
    ushort	*input_data;
    int		length;
{
    int	j, width=0;

    for( j=length; j>0; j--, input_data++) {
	if ((*input_data >> 8) == EUC_kanashift) {
		width += load_font->ascii_kana_font_width ;
		continue ;
	}
	switch(*input_data & 0x8080) {
	case 0x0000:
	case 0x0080:
	    width += load_font->ascii_kana_font_width;
	    break;
	case 0x8080:
	case 0x8000:
	    width += load_font->kanji_font_width;
	    break;
	}
    }
    return( width );
}

/*
 * Υȥ󥰤ɽ
 * ȥ󥰤 UCHAR Ǥդɬס
 * 0x0020  0x007f Ⱦʸ
 * ʸEUC
 * Ⱦѥʸ EUC_kanashift + 
 */
int	FXChTextWidth
(
	FXimFont	*font,
	unsigned char	*data,
	int		len
)
{
	int	i, w;

	w = 0;
	for (i=0; i < len; i++) {
		if (*(data + i) == EUC_kanashift) {
			w += font->ascii_kana_font_width;
			i++;
		} else if (*(data + i) & 0x80) {
			w += font->kanji_font_width;
			i++;
		} else {
			w += font->ascii_kana_font_width;
		}
	}
	return (w);
}

/*
 * ̤ʸºݤɽΥꥢλС
 * ºݤΣУ¦ɽΰ١ˣԤޤǤޤ֤θ
 * PREROOT=1
 *   ̤ʸɽɥοƤϣңϣϣԤΥɥ
 * PREROOT=0
 *   ̤ʸɽɥοƤϣУ̤Υɥ
 */
int
FXTextExtentsArea( load_font, preedit, input_data, length,
			ret_area, ret_len, ret_lineno)
    FXimFont	*load_font;
    Xim_PreeditPropRec	*preedit;
    ushort	*input_data;
    int		length;
    XRectangle	*ret_area;
    short	*ret_len;
    int		*ret_lineno;
{
    int		j, x2, y2;
    int		sy, over = 0;
    int		area_no = 0;
    int		x, y, width, height;
    int		max_x2;
    int		edit_x1, edit_y1, edit_x2, edit_y2;
    ushort	save, *savep;
    int		i;

    savep = &input_data[length];
    save  = *savep;
/* NCI Dummy Spacing Cutting !!! */
    if (length == 0) {
    	*savep = 0x0020;
        length = 1;
    }
#if PREROOT
{        Window r_win;
         int    Startx, Starty;
unsigned int    width,height; 
unsigned int    b_width,depth; 

    XGetGeometry(display,RootWindow(display,0),
                        &r_win,(int *)&Startx,(int *)&Starty,
                        (unsigned int *)&width,(unsigned int *)&height,
                        (unsigned int *)&b_width,(unsigned int *)&depth) ;
    preedit->Area.height = height;/* RootWindow Height */
}
#endif

    edit_x1 = preedit->Area.x;
    edit_y1 = preedit->Area.y;
#if PCUNIX
/*990920
    if (preedit->Area.width == 0)
*/
    if (preedit->Area.width <= load_font->kanji_font_width)
        preedit->Area.width = width ;
#endif
    edit_x2 = edit_x1 + preedit->Area.width ;
    edit_y2 = edit_y1 + preedit->Area.height;

    width = 0;
    max_x2 = 0;
    height = load_font->max_font_height;
#if LINESPACE 
    height = 0;
#endif
    /*990928*/
    if (load_font->max_font_height > preedit->LineSpacing)
	preedit->LineSpacing = load_font->max_font_height;

    x = preedit->SpotLocation.x;
    y = preedit->SpotLocation.y - load_font->max_font_ascent;
    if( x < edit_x1 )
	x = edit_x1;
    if( x > edit_x2 ) {
	x = edit_x1;
	y = y + height + preedit->LineSpacing;/* 970408 */
    }
    if( y < edit_y1 )
	y = edit_y1;
#if LINESPACE
    edit_y2 = y + (preedit->LineSpacing * PREEDIT_MAX);
#else
    edit_y2 = y + (height * PREEDIT_MAX);
#endif

    sy = y;
    x2 = x;
#if LINESPACE 
    y2 = y + preedit->LineSpacing;
#else
    y2 = y + height;
#endif

    for (i=0; i < PREEDIT_MAX ; i++)
	ret_len[i] = 0;

    *ret_lineno = 0;
    for( j=length/*+1*/; j>0; j--, input_data++) {
	width = FXTextWidth( load_font, input_data, 1);
	if( (x2 + width) <= edit_x2 ) {
	    x2 = x2 + width;
        } else {
	    if( *ret_len )  {
		(*ret_lineno)++;
		area_no++;
    		ret_area->x = x;
    		ret_area->y = y;
/*---- Coordinates ---*/
#if PREROOT 
{	        Window	r_win;
	        int	Startx, Starty;
		if (current_client->style & XIMPreeditNothing) {
			XTranslateCoordinates (display,
				root_client->preedit_window,
				RootWindow (display, 0),
				(int )x, (int )y,
				&Startx, &Starty, &r_win);
		} else {
			XTranslateCoordinates (display,
				current_client->focus_window,
				RootWindow (display, 0),
				(int )x, (int )y,
				&Startx, &Starty, &r_win);
		}
		ret_area->x = Startx;
		ret_area->y = Starty;
}
#endif
/*--- Coordinates ---*/
   		ret_area->width  = x2 - x;
		ret_area->height = y2 - y;
		ret_area++;
		if (area_no >= PREEDIT_MAX) {
    		    *savep = save;
		    return( area_no );
		}
		ret_len++;
	    }
	    x = edit_x1;

#if LINESPACE 
	    y = y2 ;
#else
	    y = y2 + preedit->LineSpacing;
#endif

	    x2 = x + width;
	    y2 = y2 + height + preedit->LineSpacing;
	    if( y2 > edit_y2 ) {
	        y = edit_y1;
#if LINESPACE 
    	        y2 = y + preedit->LineSpacing;
#else
    	        y2 = y + height;
#endif

		return ( area_no );
	    }
        }
    	(*ret_len)++;
    }

    if( *ret_len ) {
    	(*ret_lineno)++;
	area_no++;
    	ret_area->x = x;
    	ret_area->y = y;
/*---- Coordinates ---*/
#if PREROOT
{       Window  r_win;
        int     Startx, Starty;
	if (current_client->style & XIMPreeditNothing) {
		XTranslateCoordinates (display,
			root_client->preedit_window,
			RootWindow (display, 0),
			(int )x, (int )y,
			&Startx, &Starty, &r_win);
	} else {
		XTranslateCoordinates (display,
			current_client->focus_window,
			RootWindow (display, 0),
			(int )x, (int )y,
			&Startx, &Starty, &r_win);
	}
        ret_area->x = Startx;
        ret_area->y = Starty;
}
#endif
/*--- Coordinates ---*/
   	ret_area->width  = x2 - x;
	ret_area->height = y2 - y;
    }
    *savep = save;
    return( area_no );
}

/*
 * 顼ɽ
 */
int FXDefaultError( display, event)
    Display	*display;
    XErrorEvent	*event;
{
#define	MSG_SIZE	64
    char	xerr_msg[MSG_SIZE];
    if(verbose_flag) {
        XGetErrorText( display, event->error_code, xerr_msg, MSG_SIZE );
        fprintf( stderr, "%s: X Error: %s\n", command_name, xerr_msg );
        fprintf( stderr, "  req.: %d - %d, res.ID: %#x, error #%d - #%d\n",
		event->request_code, event->minor_code,
		event->resourceid, event->serial, NextRequest(display) - 1);
    }
}

/*
 * ɣϥ顼ɽ
 */
int FXDefaultIOError( display )
    Display	*display;
{
#ifdef linux
#if MKLINUX || LIBC6
    extern const char *const sys_errlist[];
#else
    extern char *sys_errlist[];
#endif
#else
#if DIGITAL
    extern char *sys_errlist[];
#else
    extern __const char *__const sys_errlist[];
#endif
#endif
    extern int sys_nerr;
    char *SysErrorMsg;
    SysErrorMsg = (errno >= 0 && errno < sys_nerr) ?
			(char *)sys_errlist[errno] : (char *)"unknown error";
    SysErrorMsg = SysErrorMsg ? SysErrorMsg : "no such error";

    fprintf (stderr, "XIO:  fatal IO error %d (%s) on X server \"%s\"\r\n",
		errno, SysErrorMsg, DisplayString (display));
    fprintf (stderr, "      after %lu requests (%lu known processed) with %d events remaining.\r\n",
		NextRequest(display) - 1, LastKnownRequestProcessed(display),
		QLength(display));
}
