/*
 * أɣͳĥ٥Ȥν
 * ֣ʣŤϳĥ٥Ȥ̤ݡȡ
 */
#include "xim.h"
#include <X11/keysym.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#ifndef NEED_EVENTS
#define NEED_EVENTS
#endif
#include <X11/Xproto.h>
#undef NEED_EVENTS

typedef struct	_XimQueryExtRec {
    BITMASK32	 mask;
    BITMASK32	 support_flag;
    char	*ext_name;
    INT16	 ext_name_len;
    CARD8	 major_opcode;
    CARD8	 minor_opcode;
} XimQueryExtRec;

/*
 * bitmask for support_flag of XimQueryExtRec
 */
#define	SERVER_SUPPORT		(1L << 0)
#define	CLIENT_SUPPORT		(1L << 1)

/*
 * Extension major_opcode
 */
#define XIM_EXTENSION			128

/*
 * Extension minor_opcode
 */
#define	XIM_EXT_SET_EVENT_MASK		1

static XimQueryExtRec	 extension_list[] = {
  {XIM_EXTENSION_SET_EVENT_MASK, True,
	"XIM_EXT_SET_EVENT_MASK", 0, XIM_EXTENSION, XIM_EXT_SET_EVENT_MASK},
  {0, False, NULL, 0, 0, 0}
};

void
InitializeExtension()
{
    register int	i;

    for (i = 0; extension_list[i].ext_name; i++) {
	extension_list[i].ext_name_len = strlen(extension_list[i].ext_name);
	switch (extension_list[i].minor_opcode) {
	case XIM_EXT_SET_EVENT_MASK:
	    if (use_ext_set_event_mask)
		extension_list[i].support_flag |= SERVER_SUPPORT;
	    break;

	}
    }
    return;
}

Static int
XimSearchExtindex(code)
    int		 code;
{
    register int i;

    for (i = 0; extension_list[i].ext_name; i++) {
	if (extension_list[i].minor_opcode == code) {
	    if (extension_list[i].support_flag & CLIENT_SUPPORT)
		return i;
	    else
		return -1;
	}
    }
    return -1;
}

Static BITMASK32
XimGetAllExtMask()
{
    BITMASK32		mask = 0;
    register int	i;

    for (i = 0; extension_list[i].ext_name; i++) {
	if (extension_list[i].support_flag & SERVER_SUPPORT) {
	    mask |= extension_list[i].mask;
	    extension_list[i].support_flag |= CLIENT_SUPPORT;
	}
    }
    return mask;
}

Static BITMASK32
XimGetExtMask(client_list, list_len)
    char 	*client_list;
    INT16	 list_len;
{
    BITMASK32		 mask = 0;
    BYTE		 len;
    register char	*p = client_list;
    register int	 i;

    while (list_len > 0) {
	len = p[0];
	if (!len)
	    break;

	for (i = 0; extension_list[i].ext_name; i++) {
	    if (!(extension_list[i].support_flag & SERVER_SUPPORT))
		continue;

	    if ((len == extension_list[i].ext_name_len)
	     && (!strncmp(&p[1], extension_list[i].ext_name, len))) {
		mask |= extension_list[i].mask;
		extension_list[i].support_flag |= CLIENT_SUPPORT;
		break;
	    }
	}
	list_len -= len + 1;
	p += len + 1;
    }
    return mask;
}

void
XimGetExtension(buf)
    CARD16	*buf;
{
    INT16	 len = XvCard16(buf[0]);
    BITMASK32	 mask;

    if (!len)
	mask = XimGetAllExtMask();
    mask = XimGetExtMask((char *)&buf[1], len);

    current_imrec->extension_flag = mask;
    return;
}

INT16
XimSetExtension(buf)
    CARD8	*buf;
{
    INT16	 total = 0;
    INT16	 len;
    register int i;

    for (i = 0; extension_list[i].ext_name; i++) {
	if (!(current_imrec->extension_flag & extension_list[i].mask))
	    continue;

	len = extension_list[i].ext_name_len;
	buf[0] = extension_list[i].major_opcode;/* major_opecode */
	buf[1] = extension_list[i].minor_opcode;/* minor_opecode */
	*((CARD16 *)&buf[2]) = XvCard16(len);	/* length of extension name */
	memcpy((char *)&buf[4], (char *)extension_list[i].ext_name, (int)len);
						/* extension name */
	XIM_SET_PAD(&buf[4], len);
	len  += sizeof(CARD8)		/* sizeof major_opecode */
	      + sizeof(CARD8) 		/* sizeof minor_opecode */
	      + sizeof(INT16); 		/* sizeof length of extension name */

	total += len;
	buf += len;
    }
    return total;
}

Bool
XimExtSetEventMaskSend(buf, filter_event_mask, intercept_event_mask, select_event_mask, forward_event_mask, synchronous_event_mask)
    CARD8	*buf;
    EVENTMASK	 filter_event_mask;
    EVENTMASK	 intercept_event_mask;
    EVENTMASK	 select_event_mask;
    EVENTMASK	 forward_event_mask;
    EVENTMASK	 synchronous_event_mask;
{
    CARD16	*buf_s = (CARD16 *)((void  *)&buf[XIM_HEADER_SIZE]);
    EVENTMASK	*buf_l;
    INT16	 len;
    int		 idx;

    if ((idx = XimSearchExtindex(XIM_EXT_SET_EVENT_MASK)) < 0)
	return False;

    buf_s[0] = XvCard16(current_client->imid);	/* imid */
    buf_s[1] = XvCard16(current_client->icid);	/* icid */

    buf_l = (EVENTMASK *)((void  *)&buf_s[2]);
    buf_l[0] = XvCard32(filter_event_mask);	/* filter_event_mask */
    buf_l[1] = XvCard32(intercept_event_mask);	/* intercept_event_mask */
    buf_l[2] = XvCard32(select_event_mask);	/* select_event_mask */
    buf_l[3] = XvCard32(forward_event_mask);	/* forward_event_mask */
    buf_l[4] = XvCard32(synchronous_event_mask);
						/* synchronous_event_mask */

    len = sizeof(CARD16)		/* sizeof imid */
	+ sizeof(CARD16)		/* sizeof icid */
	+ sizeof(EVENTMASK)		/* sizeof filter_event_mask */
	+ sizeof(EVENTMASK)		/* sizeof intercept_event_mask */
	+ sizeof(EVENTMASK)		/* sizeof select_event_mask */
	+ sizeof(EVENTMASK)		/* sizeof forward_event_mask */
	+ sizeof(EVENTMASK);		/* sizeof synchronous_event_mask */

    XimSetHeader((XPointer)buf, extension_list[idx].major_opcode,
				extension_list[idx].minor_opcode, &len);
    if (!current_connect->trans->method.send_client(buf, len))
	return False;

    current_client->sync = True;
    return True;
}

Bool
XimExtensionDispatch(recv, is_free)
    Xv_Recv		 recv;
    Bool		*is_free;
{
	return False;
}

int
XimExtensionErrorno(pkt)
    XimProtoHdr		*pkt;
{
    return 0;
}

Bool
XimCheckExtension(pkt)
    XimProtoHdr		*pkt;
{
    if (pkt->major_opcode == XIM_EXTENSION)
	return True;
    else
	return False;
}
