/******************************************************************************
	Xmouce.C
******************************************************************************/
#define		XGRAB_SERVER		1
#define		XGRAB_POINTER		1
#include	<X11/Intrinsic.h>
#include	"typedef.h"
#include	"xim.h"
#include	"xui.h"
#include	"macro.h"
#include	"fileio.h"
#include	"env.h"
#include	"getstr.h"
#include	"strutl.h"
#include	"getvcode.h"

/*=============================================================================
	Define
=============================================================================*/
#define		POPUP_HELP_START_TIME	( 500)
#define		POPUP_HELP_END_TIME	(2000)
#if 0 /* 20000217 MOVE-WINDOW */
#define		MOVE_TIME		( 350)
#endif
#define		VSCR_TIME_FIRST		( 350)
#define		VSCR_TIME_NEXT		(  50)
#define		HSCR_TIME_FIRST		( 350)
#define		HSCR_TIME_NEXT		( 200)
#if 1 /* 20000217 MOVE-WINDOW */
#define		MOVE_MIN		(   2)
#endif

/*=============================================================================
	Extern
=============================================================================*/
extern	XtAppContext	appContext;

/*=============================================================================
	Local	Data
=============================================================================*/
static	XtIntervalId	PopUpStartTimeID	= 0;
static	XtIntervalId	PopUpEndTimeID		= 0;
#if 0 /* 20000217 MOVE-WINDOW */
static	XtIntervalId	MoveTimeID		= 0;
#endif
static	XtIntervalId	ScrTimeID		= 0;


/*=============================================================================
	VJEGetPositionStatus
	⡼ɽɥλΥޥ֤ɣֹ
=============================================================================*/
int	VJEGetPositionStatus
(
	LPVWIN		lpVWin,
	int		x,
	int		y
)
{
	LPVSPLT		lpVSplt;
	int		tmp_x, tmp_y;
	int		tmp_w, tmp_h;
	int		i;

	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);
	tmp_x	= lpVWin->StatusM.x;
	tmp_y	= lpVWin->StatusM.y;
	tmp_w	= lpVWin->StatusR.width;
	tmp_h	= lpVWin->StatusR.height;

	if (y < DRAW_STATUS_WINDOW_BORDER) {
		if (x < DRAW_STATUS_WINDOW_BORDER) {
			return (WIN_UPPER_LEFT);
		} else if (x >= tmp_w - DRAW_STATUS_WINDOW_BORDER) {
			return (WIN_UPPER_RIGHT);
		} else {
			return (WIN_TOP);
		}
	} else if (y >= tmp_h - DRAW_STATUS_WINDOW_BORDER) {
		if (x < DRAW_STATUS_WINDOW_BORDER) {
			return (WIN_LOWER_LEFT);
		} else if (x >= tmp_w - DRAW_STATUS_WINDOW_BORDER) {
			return (WIN_LOWER_RIGHT);
		} else {
			return (WIN_BOTTOM);
		}
	} else {
		if (x < DRAW_STATUS_WINDOW_BORDER) {
			return (WIN_LEFT);
		} else if (x >= tmp_w - DRAW_STATUS_WINDOW_BORDER) {
			return (WIN_RIGHT);
		}
	}
	x	= x - tmp_x;
	y	= y - tmp_y;
	for (i=0; i < lpVSplt->wBtnCount; i++) {
		if (x >= lpVSplt->wBtnX[i]
		 && x <  lpVSplt->wBtnX[i] + lpVSplt->wBtnSize
		 && y >= lpVSplt->wBtnY[i]
		 && y <  lpVSplt->wBtnY[i] + lpVSplt->wBtnSize) {
			return (i);
		}
	}
	return (WIN_NONE);
}

/*=============================================================================
	VJEGetPositionPreeditRoot
	ңϣϣ̤ʸϥɥλΥޥ֤
	ɣֹ
=============================================================================*/
int	VJEGetPositionPreeditRoot
(
	LPVWIN		lpVWin,
	int		x,
	int		y
)
{
	LPVSPLT		lpVSplt;
	int		tmp_w, tmp_h;
	int		tmp_x, tmp_y;
	int		i;

	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);
	tmp_x	= lpVWin->PreeditR.x;
	tmp_y	= lpVWin->PreeditR.y;
	tmp_w	= lpVWin->PreeditR.width;
	tmp_h	= lpVWin->PreeditR.height;

	if (y < DRAW_PREEDIT_ROOT_WINDOW_BORDER) {
		if (x < DRAW_PREEDIT_ROOT_WINDOW_BORDER) {
			return (WIN_UPPER_LEFT);
		} else if (x >= tmp_w - DRAW_PREEDIT_ROOT_WINDOW_BORDER) {
			return (WIN_UPPER_RIGHT);
		} else {
			return (WIN_TOP);
		}
	} else if (y >= tmp_h - DRAW_PREEDIT_ROOT_WINDOW_BORDER) {
		if (x < DRAW_PREEDIT_ROOT_WINDOW_BORDER) {
			return (WIN_LOWER_LEFT);
		} else if (x >= tmp_w - DRAW_PREEDIT_ROOT_WINDOW_BORDER) {
			return (WIN_LOWER_RIGHT);
		} else {
			return (WIN_BOTTOM);
		}
	} else {
		if (x < DRAW_PREEDIT_ROOT_WINDOW_BORDER) {
			return (WIN_LEFT);
		} else if (x >= tmp_w - DRAW_PREEDIT_ROOT_WINDOW_BORDER) {
			return (WIN_RIGHT);
		}
	}
	return (WIN_NONE);
}

/*=============================================================================
	VJEGetPositionKoho
	䥦ɥλΥޥ֤ɣֹ
=============================================================================*/
int	VJEGetPositionKoho
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	int		x,
	int		y
)
{
	PBD		bdata;
	LPVKP		lpVKp;
	LPVSPLT		lpVSplt;
	LPVKPLT		lpVKplt;
	int		tmp_x, tmp_y;
	int		tmp_w, tmp_h;
	int		col, row, len;
	int		i, j, pos;

	bdata		= (PBD     )GetBDATA (client);
	lpVKp		= (LPVKP   )GetVKp (client);
	lpVSplt		= (LPVSPLT )GetVSplt (lpVWin);
	lpVKplt		= (LPVKPLT )GetVKplt (lpVWin);

	GetVKpCanRMtx (client, &col, &row, &len);

	if (lpVKp->Mtx == NO
	 || lpVKp->Mtx == AUTO) {
		;
	} else {
		tmp_w	= lpVKp->Win.width;
		tmp_h	= lpVKp->Win.height;

		if (y < DRAW_KOHO_WINDOW_BORDER) {
			if (lpVKp->Direction != 1) {
				return (WIN_NONE);
			}
			if (x < DRAW_KOHO_WINDOW_BORDER) {
				return (WIN_UPPER_LEFT);
			} else if (x >= tmp_w - DRAW_KOHO_WINDOW_BORDER) {
				return (WIN_UPPER_RIGHT);
			} else {
				return (WIN_TOP);
			}
		} else if (y >= tmp_h - DRAW_KOHO_WINDOW_BORDER) {
			if (lpVKp->Direction == 1) {
				return (WIN_NONE);
			}
			if (x < DRAW_KOHO_WINDOW_BORDER) {
				return (WIN_LOWER_LEFT);
			} else if (x >= tmp_w - DRAW_KOHO_WINDOW_BORDER) {
				return (WIN_LOWER_RIGHT);
			} else {
				return (WIN_BOTTOM);
			}
		} else {
			if (x < DRAW_KOHO_WINDOW_BORDER) {
				return (WIN_LEFT);
			} else if (x >= tmp_w - DRAW_KOHO_WINDOW_BORDER) {
				return (WIN_RIGHT);
			}
		}
	}

	if (ChKohoHist (client)) {
		tmp_x	= lpVKp->Hist.x
			+ lpVKp->Hist.width
			- lpVKp->Hist.height;
		tmp_y	= lpVKp->Hist.y;
		tmp_w	= lpVKp->Hist.height;
		tmp_h	= lpVKp->Hist.height;
		if ((tmp_x <= x && x < tmp_x + tmp_w)
		 && (tmp_y <= y && y < tmp_y + tmp_h)) {
			return (WIN_KOHO_HISTORY);
		}
	}
	if (ChKohoVScr (client)) {
		tmp_x	= lpVKp->VScr.x;
		tmp_y	= lpVKp->VScr.y;
		tmp_w	= lpVKp->VScr.width;
		tmp_h	= lpVKp->VScr.width;
		if ((tmp_x <= x && x < tmp_x + tmp_w)
		 && (tmp_y <= y && y < tmp_y + tmp_h)) {
			return (WIN_KOHO_VSCR_ARW_PREV);
		}
		tmp_x	= lpVKp->VScr.x;
		tmp_y	= lpVKp->VScr.y
			+ lpVKp->VScr.height
			- lpVKp->VScr.width;
		tmp_w	= lpVKp->VScr.width;
		tmp_h	= lpVKp->VScr.width;
		if ((tmp_x <= x && x < tmp_x + tmp_w)
		 && (tmp_y <= y && y < tmp_y + tmp_h)) {
			return (WIN_KOHO_VSCR_ARW_NEXT);
		}
		tmp_x	= lpVKp->VScr.x;
		tmp_y	= lpVKp->VScr.y
			+ lpVKp->VScr.width;
		tmp_w	= lpVKp->VScr.width;
		tmp_h	= lpVKp->VScr.height
			- lpVKp->VScr.width * 2;
		if ((tmp_x <= x && x < tmp_x + tmp_w)
		 && (tmp_y <= y && y < tmp_y + tmp_h)) {
			GetKohoVScrPtr (client, &tmp_y, &tmp_h);
			if (y < tmp_y) {
				return (WIN_KOHO_VSCR_BAR_PREV);
			} else if (y > tmp_y + tmp_h) {
				return (WIN_KOHO_VSCR_BAR_NEXT);
			} else {
				return (WIN_KOHO_VSCR_PTR);
			}
		}
	}
	if (ChKohoHScr (client)) {
		tmp_x	= lpVKp->HScr.x;
		tmp_y	= lpVKp->HScr.y;
		tmp_w	= lpVKp->HScr.height;
		tmp_h	= lpVKp->HScr.height;
		if ((tmp_x <= x && x < tmp_x + tmp_w)
		 && (tmp_y <= y && y < tmp_y + tmp_h)) {
			return (WIN_KOHO_HSCR_ARW_LEFT);
		}
		tmp_x	= lpVKp->HScr.x
			+ lpVKp->HScr.width
			- lpVKp->HScr.height;
		tmp_y	= lpVKp->HScr.y;
		tmp_w	= lpVKp->HScr.height;
		tmp_h	= lpVKp->HScr.height;
		if ((tmp_x <= x && x < tmp_x + tmp_w)
		 && (tmp_y <= y && y < tmp_y + tmp_h)) {
			return (WIN_KOHO_HSCR_ARW_RIGHT);
		}
		tmp_x	= lpVKp->HScr.x
			+ lpVKp->HScr.height;
		tmp_y	= lpVKp->HScr.y;
		tmp_w	= lpVKp->HScr.width
			- lpVKp->HScr.height * 2;
		tmp_h	= lpVKp->HScr.height;
		if ((tmp_x <= x && x < tmp_x + tmp_w)
		 && (tmp_y <= y && y < tmp_y + tmp_h)) {
			GetKohoHScrPtr (client, &tmp_x, &tmp_w);
			if (x < tmp_x) {
				return (WIN_KOHO_HSCR_BAR_LEFT);
			} else if (x > tmp_x + tmp_w) {
				return (WIN_KOHO_HSCR_BAR_RIGHT);
			} else {
				return (WIN_KOHO_HSCR_PTR);
			}
		}
	}

	for (i=0; i < lpVKplt->wBtnCount; i++) {
		tmp_x	= lpVKp->Btn[i].x;
		tmp_y	= lpVKp->Btn[i].y;
		tmp_w	= lpVKp->Btn[i].width;
		tmp_h	= lpVKp->Btn[i].height;
		if ((tmp_x <= x && x < tmp_x + tmp_w)
		 && (tmp_y <= y && y < tmp_y + tmp_h)) {
			return (WIN_KOHO_BTN_BASE + i);
		}
	}

	tmp_x	= x - lpVKp->Don.x;
	tmp_y	= y - lpVKp->Don.y;

	tmp_w	= lpVKp->Don.width  * col;
	tmp_h	= lpVKp->Don.height * row;
	if (!((0 <= tmp_x && tmp_x < tmp_w)
	 &&   (0 <= tmp_y && tmp_y < tmp_h))) {
		return (WIN_NONE);
	}

	tmp_w	= lpVKp->Don.width;
	tmp_h	= lpVKp->Don.height;
	i	= (tmp_y / tmp_h) + 1;
	j	= (tmp_x / tmp_w) + 1;

	if (lpVKp->Dir == YOKO) {
		pos	= i * col - (col - j) - 1;
	} else {
		pos	= j * row - (row - i) - 1;
	}
	pos	+= WIN_KOHO_ITEM_BASE;

	return (pos);
}

/*=============================================================================
	PopUpHelpDisplay
	ݥåץåץåɽ
=============================================================================*/
void	PopUpHelpDisplay
(
	Window		window,
	LPVWIN		lpVWin
)
{
static	TCHAR	msg[MAX_LONG_STR + MAX_LONG_STR + 1];
	LPVSPLT	lpVSplt;
	LPVKPLT	lpVKplt;
	WORD	func;
	int	attr;
	int	pos;

	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);
	lpVKplt	= (LPVKPLT )GetVKplt (lpVWin);

	if (lpVWin->PopUpHelpFlg == PH_ON_KOHO) {
		if (lpVKplt->wPopHelp != YES) {
			return;
		}
		pos	= lpVWin->PopUpHelpPos
			- WIN_KOHO_BTN_BASE;
		func	= lpVKplt->wBtnFunc[pos];
	} else {
		if (lpVSplt->wPopHelp != YES) {
			return;
		}
		pos	= lpVWin->PopUpHelpPos
			- WIN_STS_BTN_BASE;
		func	= lpVSplt->wBtnFunc[pos];
	}

	attr	= CL_EX_POPHELP;

	SetVclrAttr (
		display,
		lpVWin->BaseFont.normal_gc,
		attr,
		1
	);
	XFillRectangle (
		display,
		window,
		lpVWin->BaseFont.normal_gc,
		0,
		0,
		lpVWin->PopUpHelp.width,
		lpVWin->PopUpHelp.height
	);
	SetVclrAttr (
		display,
		lpVWin->BaseFont.normal_gc,
		attr,
		0
	);

	GetFuncState (current_client, func, msg);

	DrawEucTextAttrString (
			display,
			window,
			&lpVWin->BaseFont,
			0,
			lpVWin->BaseFont.max_font_height - 1,
			msg,
			attr,
			lstrlen (msg)
	);

	XMapRaised (display, window);

	XFlush (display);
}

/*=============================================================================
	RedisplayPopUpHelp
	ݥåץåץåκɽ
=============================================================================*/
void	RedisplayPopUpHelp ()
{
	PopUpHelpDisplay (WPopUpHelp, (LPVWIN )GetVWin ());
}

/*=============================================================================
	PopUpHelpOpen
	ݥåץåץåΥץ
=============================================================================*/
void	PopUpHelpOpen
(
	Window		window,
	LPVWIN		lpVWin
)
{
static	TCHAR	msg[MAX_LONG_STR + MAX_LONG_STR + 1];
	LPVKP	lpVKp;
	LPVSPLT	lpVSplt;
	LPVKPLT	lpVKplt;
	WORD	func;
	Window	root;
	int	start_x, start_y;
	UINT	width, height, border_width, depth;
	short	btn_x, btn_y, btn_w, btn_h;
	short	tmp_x, tmp_y, tmp_w, tmp_h;
	short	root_w, root_h;
	short	border;
	int	pos;

	lpVKp	= (LPVKP   )GetVKp (current_client);
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);
	lpVKplt	= (LPVKPLT )GetVKplt (lpVWin);

	root_w	= DisplayWidth  (display, screen);
	root_h	= DisplayHeight (display, screen);

	if (lpVWin->PopUpHelpFlg == PH_ON_KOHO) {
		XGetGeometry (
			display,
			current_client->koho_window,
			&root,
			&start_x, &start_y,
			&width, &height,
			&border_width,
			&depth
		);
		pos	= lpVWin->PopUpHelpPos
			- WIN_KOHO_BTN_BASE;
		func	= lpVKplt->wBtnFunc[pos];
		btn_x	= lpVKp->Btn[pos].x
			+ start_x;
		btn_y	= lpVKp->Btn[pos].y
			+ start_y;
		btn_w	= lpVKp->Btn[pos].width;
		btn_h	= lpVKp->Btn[pos].height;
		border	= 0;
	} else {
		pos	= lpVWin->PopUpHelpPos
			- WIN_STS_BTN_BASE;
		func	= lpVSplt->wBtnFunc[pos];
		btn_x	= lpVWin->StatusR.x
			+ DRAW_STATUS_WINDOW_BORDER
			+ lpVSplt->wBtnX[pos];
		btn_y	= lpVWin->StatusR.y
			+ DRAW_STATUS_WINDOW_BORDER
			+ lpVSplt->wBtnY[pos];
		btn_w	= lpVSplt->wBtnSize;
		btn_h	= lpVSplt->wBtnSize;
		border	= DRAW_STATUS_WINDOW_BUTTON_BORDER;
	}

	GetFuncState (current_client, func, msg);

	lpVWin->PopUpHelp.width		= FXChTextWidth (
						&lpVWin->BaseFont,
						msg,
						lstrlen (msg)
					);
	lpVWin->PopUpHelp.height	= lpVWin->BaseFont.max_font_height
					+ 2;

	if (btn_x < root_w / 2) {
		lpVWin->PopUpHelp.x	= btn_x
					- border;
	} else {
		lpVWin->PopUpHelp.x	= btn_x
					+ btn_w
					- lpVWin->PopUpHelp.width
					+ border
					- 2;
	}
	if (btn_y < root_h / 2) {
		lpVWin->PopUpHelp.y	= btn_y
					+ btn_h
					+ border
					+ 1;
	} else { 
		lpVWin->PopUpHelp.y	= btn_y
					- lpVWin->PopUpHelp.height
					- border
					- 3;
	}

	XMoveResizeWindow (
		display,
		window,
		lpVWin->PopUpHelp.x,
		lpVWin->PopUpHelp.y,
		lpVWin->PopUpHelp.width,
		lpVWin->PopUpHelp.height
	);

	PopUpHelpDisplay (window, lpVWin);
}

/*=============================================================================
	PopUpHelpStart
=============================================================================*/
void	PopUpHelpStart
(
	int	pos
)
{
	LPVWIN	lpVWin;
	void	PopUpHelpEnd (LPVWIN);
	void	PopUpHelpTimeOut (LPVWIN);

	lpVWin	= (LPVWIN  )GetVWin ();

	PopUpHelpEnd (lpVWin);

	if (pos >= WIN_KOHO_BASE) {
		lpVWin->PopUpHelpFlg	= PH_ON_KOHO;
	} else {
		lpVWin->PopUpHelpFlg	= PH_ON_STS;
	}
	lpVWin->PopUpHelpPos	= pos;

	PopUpHelpOpen (WPopUpHelp, lpVWin);

	PopUpEndTimeID	= XtAppAddTimeOut (
				appContext,
				POPUP_HELP_END_TIME,
				(XtTimerCallbackProc )PopUpHelpTimeOut,
				(XPointer )lpVWin
			);
}

/*=============================================================================
	PopUpHelpClose
	ݥåץåץåΥ
=============================================================================*/
void	PopUpHelpClose
(
	Window	window
)
{
	XUnmapWindow (display, window);
}

/*=============================================================================
	PopUpHelpEnd
=============================================================================*/
void	PopUpHelpEnd
(
	LPVWIN	lpVWin
)
{
	if (PopUpStartTimeID != 0) {
		XtRemoveTimeOut (PopUpStartTimeID);
	}
	if (PopUpEndTimeID != 0) {
		XtRemoveTimeOut (PopUpEndTimeID);
	}
	PopUpHelpClose (WPopUpHelp);
	lpVWin->PopUpHelpPos = -1;
	lpVWin->PopUpHelpFlg =  PH_OFF;
}

/*=============================================================================
	PopUpHelpTimeOut
	ݥåץåץåɽॢȽ
=============================================================================*/
void	PopUpHelpTimeOut
(
	LPVWIN	lpVWin
)
{
	int	pos;
	if (PopUpStartTimeID != 0) {
		XtRemoveTimeOut (PopUpStartTimeID);
	}
	if (PopUpEndTimeID != 0) {
		XtRemoveTimeOut (PopUpEndTimeID);
	}
	pos = lpVWin->PopUpHelpPos;
	PopUpHelpClose (WPopUpHelp);
	lpVWin->PopUpHelpPos = pos;
	lpVWin->PopUpHelpFlg =   PH_OFF;
}

/*=============================================================================
	PopUpMenu
	ݥåץåץ˥塼ɽå
=============================================================================*/
static	VPM	PopUpMenu_0[] = {
	/* keyword, check, visible, child, text, func */
	PM_KWD_NON, 0, 1, 1, "ɽ",			0,
	PM_KWD_BDR, 0, 1, 0, "*",			0,
	PM_KWD_ACC, 0, 1, 0, "꣱",		F_EX_ACC1,
	PM_KWD_ACC, 0, 1, 0, "ꣲ",		F_EX_ACC2,
	PM_KWD_ACC, 0, 1, 0, "ꣳ",		F_EX_ACC3,
	PM_KWD_ACC, 0, 1, 0, "ꣴ",		F_EX_ACC4,
	PM_KWD_ACC, 0, 1, 0, "ꣵ",		F_EX_ACC5,
	PM_KWD_ACC, 0, 1, 0, "ꣶ",		F_EX_ACC6,
	PM_KWD_ACC, 0, 1, 0, "ꣷ",		F_EX_ACC7,
	PM_KWD_ACC, 0, 1, 0, "꣸",		F_EX_ACC8,
	PM_KWD_ACC, 0, 1, 0, "꣹",		F_EX_ACC9,
	PM_KWD_ACC, 0, 1, 0, "꣱",		F_EX_ACC10,
	PM_KWD_BDR, 0, 1, 0, "*",			0,
#if 0
	PM_KWD_NON, 0, 1, 2, "¾...",		0,
	PM_KWD_CMD, 0, 1, 0, "С",		F_EX_VERSION,
	PM_KWD_BDR, 0, 1, 0, "*",			0,
#endif
	PM_KWD_NON, 0, 1, 3, "ġСγ",	0,
#if 1
	PM_KWD_BDR, 0, 1, 0, "*",			0,
	PM_KWD_PRC, 0, 1, 0, "ߤξ֤¸",	F_EX_ENV_SAVE,
#endif
};
static	VPM	PopUpMenu_1[] = {
	/* keyword, check, visible, child, text, func */
	PM_KWD_CHK, 1, 1, 0, "ɽ",		F_EX_BTN_OFF_NORMAL,
	PM_KWD_CHK, 0, 1, 0, "դλǾ",		F_EX_BTN_OFF_MINIMIZE,
	PM_KWD_CHK, 0, 1, 0, "դλɽ",		F_EX_BTN_OFF_HIDE,
};
static	VPM	PopUpMenu_2[] = {
	/* keyword, check, visible, child, text, func */
	PM_KWD_CMD, 0, 1, 0, "Ķ...",		F_EX_ENV,
	PM_KWD_BDR, 0, 1, 0, "*",			0,
	PM_KWD_PRC, 0, 1, 0, "ߤξ֤¸",	F_EX_ENV_SAVE,
};
static	VPM	PopUpMenu_3[] = {
	/* keyword, check, visible, child, text, func */
	PM_KWD_PRC, 0, 1, 0, "Υ()",		F_EX_BTN_MONO_SMALL,
	PM_KWD_PRC, 0, 1, 0, "Υ()",		F_EX_BTN_MONO_BIG,
	PM_KWD_PRC, 0, 1, 0, "顼()",		F_EX_BTN_COLOR_SMALL,
	PM_KWD_PRC, 0, 1, 0, "顼()",		F_EX_BTN_COLOR_BIG,
};

static	VPML	PopUpMenuAll[] = {
  /* count, menu */
  {sizeof(PopUpMenu_0)/sizeof(PopUpMenu_0[0]), PopUpMenu_0},
  {sizeof(PopUpMenu_1)/sizeof(PopUpMenu_1[0]), PopUpMenu_1},
  {sizeof(PopUpMenu_2)/sizeof(PopUpMenu_2[0]), PopUpMenu_2},
  {sizeof(PopUpMenu_3)/sizeof(PopUpMenu_3[0]), PopUpMenu_3}
};

static VPML	PopUpMenuList[PM_WIN_MAX];
static int	PopUpMenuListIndex;

/*=============================================================================
	PopUpMenu Macro
=============================================================================*/
#define		GetPopUpMenuCount() \
			(PopUpMenuList[PopUpMenuListIndex].wCount)
#define		GetPopUpMenuKeyword(i) \
			(PopUpMenuList[PopUpMenuListIndex].vMenu[i].wKeyword)
#define		GetPopUpMenuCheck(i) \
			(PopUpMenuList[PopUpMenuListIndex].vMenu[i].wCheck)
#define		GetPopUpMenuVisible(i) \
			(PopUpMenuList[PopUpMenuListIndex].vMenu[i].wVisible)
#define		GetPopUpMenuChild(i) \
			(PopUpMenuList[PopUpMenuListIndex].vMenu[i].wChild)
#define		GetPopUpMenuText(i) \
			(PopUpMenuList[PopUpMenuListIndex].vMenu[i].lptText)
#define		GetPopUpMenuFunc(i) \
			(PopUpMenuList[PopUpMenuListIndex].vMenu[i].wFunc)

/*=============================================================================
	SetPopUpMenuCheck
=============================================================================*/
void	SetPopUpMenuCheck (int i)
	{ PopUpMenuList[PopUpMenuListIndex].vMenu[i].wCheck = 1; }

/*=============================================================================
	ResetPopUpMenuCheck
=============================================================================*/
void	ResetPopUpMenuCheck (int i)
	{ PopUpMenuList[PopUpMenuListIndex].vMenu[i].wCheck = 0; }

/*=============================================================================
	SetPopUpMenuVisible
=============================================================================*/
void	SetPopUpMenuVisible (int i)
	{ PopUpMenuList[PopUpMenuListIndex].vMenu[i].wVisible = 1; }

/*=============================================================================
	ResetPopUpMenuVisible
=============================================================================*/
void	ResetPopUpMenuVisible (int i)
	{ PopUpMenuList[PopUpMenuListIndex].vMenu[i].wVisible = 0; }

/*=============================================================================
	SetPopUpMenuKeyword
=============================================================================*/
void	SetPopUpMenuKeyword (int i, WORD keyword)
	{ PopUpMenuList[PopUpMenuListIndex].vMenu[i].wKeyword = keyword; }

/*=============================================================================
	SetPopUpMenuText
=============================================================================*/
void	SetPopUpMenuText (int i, LPTSTR lptText)
	{ PopUpMenuList[PopUpMenuListIndex].vMenu[i].lptText = lptText; }

/*=============================================================================
	CurPopUpMenu
=============================================================================*/
int	CurPopUpMenu (LPVWIN lpVWin)
	{ PopUpMenuListIndex = lpVWin->PopUpMenuIdx; }

/*=============================================================================
	StackPopUpMenu
=============================================================================*/
int	StackPopUpMenu (LPVWIN lpVWin, int no)
{
	int	idx;
	idx	= lpVWin->PopUpMenuIdx;
	PopUpMenuList[idx].wCount = PopUpMenuAll[no].wCount;
	PopUpMenuList[idx].vMenu  = (VPM *)PopUpMenuAll[no].vMenu;
	CurPopUpMenu (lpVWin);
}

/*=============================================================================
	GetMaxPopUpMenuMessageWidth
	ݥåץåץ˥塼Υåκ
=============================================================================*/
int	GetMaxPopUpMenuMessageWidth
(
	LPVWIN		lpVWin
)
{
	int		max = 0;
	FXimFont	*font;
	char		*msg;
	WORD		key;
	int		width;
	int		cnt;
	int		i;

	cnt	= GetPopUpMenuCount ();
	font	= &lpVWin->BaseFont;
	for (i=0; i < cnt; i++) {
		key	= GetPopUpMenuKeyword (i);
		if (key == PM_KWD_SKP) {
			;
		} else {
			msg	= GetPopUpMenuText (i);
			width	= FXChTextWidth (font, msg, lstrlen (msg));
			if (max < width) {
				max	= width;
			}
		}
	}
	return (max);
}

/*=============================================================================
	GetPopUpMenuWindowWidth
	ݥåץåץ˥塼
=============================================================================*/
int	GetPopUpMenuWindowWidth
(
	LPVWIN		lpVWin
)
{
	return (
		GetMaxPopUpMenuMessageWidth (lpVWin)
		+ DRAW_POPUP_MENU_CHECK_MARK
		+ DRAW_POPUP_MENU_CHILD_MARK
		+ DRAW_POPUP_MENU_FONT_BORDER * 2
		+ DRAW_POPUP_MENU_BORDER * 2
	);
}

/*=============================================================================
	GetPopUpMenuWindowHeight
	ݥåץåץ˥塼ι⤵
=============================================================================*/
int	GetPopUpMenuWindowHeight
(
	LPVWIN		lpVWin
)
{
	int	height= 0;
	int	m_cnt = 0;
	int	s_cnt = 0;
	int	b_cnt = 0;
	WORD	key;
	int	cnt;
	int	i;

	cnt	= GetPopUpMenuCount ();
	for (i=0; i < cnt; i++) {
		key	= GetPopUpMenuKeyword (i);
		if (key == PM_KWD_SKP) {
			s_cnt++;
		} else if (key == PM_KWD_BDR) {
			b_cnt++;
		}
	}
	m_cnt	= cnt - s_cnt - b_cnt;
	height	= m_cnt * (lpVWin->BaseFont.max_font_height
			+  DRAW_POPUP_MENU_FONT_BORDER * 2)
		+ b_cnt * (DRAW_POPUP_MENU_MESSAGE_BORDER
			+  DRAW_POPUP_MENU_FONT_BORDER * 2)
		+ DRAW_POPUP_MENU_BORDER * 2;

	return (height);
}

/*=============================================================================
	CalcPopUpMenuPosition
	ݥåץåץ˥塼ɽ֤׻
==============================================================================*/
void	CalcPopUpMenuPosition
(
	LPVWIN		lpVWin,
	int		*r_x,
	int		*d_y,
	int		*l_x,
	int		*u_y
)
{
	WORD	key;
	int	i, tmp_w;

	lpVWin->PopUpMenuIdx	-= 1;
	CurPopUpMenu (lpVWin);

	*r_x	= lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].x
		+ lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].width
		- DRAW_POPUP_MENU_BORDER;

	*d_y	= lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].y;
	for (i=0; i < lpVWin->PopUpMenuPos[lpVWin->PopUpMenuIdx]; i++) {
		key	= GetPopUpMenuKeyword (i);
		if (key == PM_KWD_SKP) {
			;
		} else if (key == PM_KWD_BDR) {
			*d_y	+= DRAW_POPUP_MENU_FONT_BORDER * 2
				 + DRAW_POPUP_MENU_MESSAGE_BORDER;
		} else {
			*d_y	+= DRAW_POPUP_MENU_FONT_BORDER * 2
				 + lpVWin->BaseFont.max_font_height;
		}
	}
	tmp_w	= lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].width;

	lpVWin->PopUpMenuIdx	+= 1;
	CurPopUpMenu (lpVWin);

	*l_x	= *r_x
		- tmp_w
		- GetPopUpMenuWindowWidth (lpVWin)
		+ DRAW_POPUP_MENU_BORDER * 2;

	*u_y	= *d_y
		- GetPopUpMenuWindowHeight (lpVWin)
		+ DRAW_POPUP_MENU_FONT_BORDER * 2
		+ lpVWin->BaseFont.max_font_height
		+ DRAW_POPUP_MENU_BORDER * 2;
}

/*=============================================================================
	PopUpMenuPosSize
	ݥåץåץ˥塼ɽ֤ȥ׻
=============================================================================*/
void	PopUpMenuPosSize
(
	Window		window[],
	LPVWIN		lpVWin
)
{
#define	RIGHT		0x01
#define	LEFT		0x02
#define	DOWN		0x04
#define	UP		0x08
static	int		direction;
	Window		root, child;
	int		root_x, root_y;
	int		root_w, root_h;
	int		win_x, win_y;
	UINT		keys_buttons;
	WORD		key;
	int		tmp_x, tmp_y;
	int		tmp_w, tmp_h;
	int		r_x, d_y, l_x, u_y;
	int		i;

	root_w	= DisplayWidth  (display, screen);
	root_h	= DisplayHeight (display, screen);

	if (lpVWin->PopUpMenuIdx < 1) {
		tmp_w	= GetPopUpMenuWindowWidth (lpVWin);
		tmp_h	= GetPopUpMenuWindowHeight (lpVWin);
		XQueryPointer (
			display,
			window[lpVWin->PopUpMenuIdx],
			&root, &child,
			&root_x, &root_y,
			&win_x, &win_y,
			&keys_buttons
		);
		if (root_x + tmp_w < root_w) {
			tmp_x	= root_x;
		} else if (root_x - tmp_w > 0) {
			tmp_x	= root_x - tmp_w;
		} else {
			tmp_x	= 0;
		}
		if (root_y + tmp_h < root_h) {
			tmp_y	= root_y;
		} else if (root_y - tmp_h > 0) {
			tmp_y	= root_y - tmp_h;
		} else {
			tmp_y	= 0;
		}
		/* direction */
		if (tmp_x <= root_w /2) {
			direction	= RIGHT;
		} else {
			direction	= LEFT;
		}
		if (tmp_y <= root_h /2) {
			direction	|= DOWN;
		} else {
			direction	|= UP;
		}
	} else {
		CalcPopUpMenuPosition (lpVWin, &r_x, &d_y, &l_x, &u_y);
		tmp_w	= GetPopUpMenuWindowWidth (lpVWin);
		tmp_h	= GetPopUpMenuWindowHeight (lpVWin);
		if (direction & RIGHT) {
			if (r_x + tmp_w < root_w) {
				tmp_x	= r_x;
			} else if (l_x >= 0) {
				tmp_x	= l_x;
			} else {
				tmp_x	= 0;
			}
		} else {
			if (l_x >= 0) {
				tmp_x	= l_x;
			} else if (r_x + tmp_w < root_w) {
				tmp_x	= r_x;
			} else {
				tmp_x	= 0;
			}
		}
		if (direction & UP) {
			if (d_y + tmp_h < root_h) {
				tmp_y	= d_y;
			} else if (u_y >= 0) {
				tmp_y	= u_y;
			} else {
				tmp_y	= 0;
			}
		} else {
			if (u_y >= 0) {
				tmp_y	= u_y;
			} else if (d_y + tmp_h < root_h) {
				tmp_y	= d_y;
			} else {
				tmp_y	= 0;
			}
		}
	}
	lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].x	= tmp_x;
	lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].y	= tmp_y;
	lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].width	= tmp_w;
	lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].height	= tmp_h;
}

/*=============================================================================
	PopUpMenuDisplay
	ݥåץåץ˥塼ɽ
=============================================================================*/
void	PopUpMenuDisplay
(
	Window		window[],
	LPVWIN		lpVWin
)
{
	FXimFont	*font;
	GC		*gc;
	ULONG		fore, back;
	char		*msg;
	WORD		key;
	int		descent;
	int		bd_x, bd_w, bd_h;
	int		xx, yy, msg_w, msg_h;
	int		area_x, area_w, area_h;
	int		cnt, chk, cld;
	int		i;

	cnt	= GetPopUpMenuCount ();
	font	= &lpVWin->BaseFont;
	gc	= lpVWin->GCList;
	fore	= lpVWin->WinForePixel;
	back	= lpVWin->WinBackPixel;

	descent	= font->max_font_descent;

	msg_w	= GetMaxPopUpMenuMessageWidth (lpVWin);
	msg_h	= font->max_font_height;

	bd_w	= msg_w
		+ DRAW_POPUP_MENU_CHECK_MARK
		+ DRAW_POPUP_MENU_CHILD_MARK
		+ DRAW_POPUP_MENU_FONT_BORDER * 2;
	bd_h	= DRAW_POPUP_MENU_MESSAGE_BORDER;
	bd_x	= DRAW_POPUP_MENU_BORDER;
	area_w	= msg_w
		+ DRAW_POPUP_MENU_CHECK_MARK
		+ DRAW_POPUP_MENU_CHILD_MARK
		+ DRAW_POPUP_MENU_FONT_BORDER * 2;
	area_h	= msg_h
		+ DRAW_POPUP_MENU_FONT_BORDER * 2;
	area_x	= DRAW_POPUP_MENU_BORDER;

	xx	= DRAW_POPUP_MENU_BORDER
		+ DRAW_POPUP_MENU_FONT_BORDER
		+ DRAW_POPUP_MENU_CHECK_MARK;
	yy	= DRAW_POPUP_MENU_BORDER;

#if 1 /* 991217:First-Display */
	XMapRaised (display, window[lpVWin->PopUpMenuIdx]);
#endif
	DrawPopUpMenu (
		window[lpVWin->PopUpMenuIdx],
		gc,
		lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].width,
		lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].height
	);

	for (i=0; i < cnt; i++) {
		key	= GetPopUpMenuKeyword (i);
		if (key == PM_KWD_SKP) {
			;
		} else if (key == PM_KWD_BDR) {
			yy	+= DRAW_POPUP_MENU_FONT_BORDER;
			DrawPopUpMenuMessageBorder (
				window[lpVWin->PopUpMenuIdx],
				gc,
				bd_x,
				yy,
				bd_w,
				bd_h
			);
			yy	+= DRAW_POPUP_MENU_MESSAGE_BORDER
				 + DRAW_POPUP_MENU_FONT_BORDER;
		} else {
			msg	= GetPopUpMenuText (i);
			chk	= GetPopUpMenuCheck (i);
			cld	= GetPopUpMenuChild (i);
			DrawPopUpMenuMessageArea (
				window[lpVWin->PopUpMenuIdx],
				gc,
				0,
				chk,
				cld,
				area_x,
				yy,
				area_w,
				area_h
			);
			yy	+= DRAW_POPUP_MENU_FONT_BORDER
				 + msg_h;
			XSetForeground (display, gc[5], fore);
			XSetBackground (display, gc[5], back);
			DrawEucTextAttrGcString (
				display,
				window[lpVWin->PopUpMenuIdx],
				font,
				xx,
				yy
				- descent,
				msg,
				gc[5],
				lstrlen (msg)
			);
			yy	+= DRAW_POPUP_MENU_FONT_BORDER;
		}
	}

	XMapRaised (display, window[lpVWin->PopUpMenuIdx]);

	XFlush (display);
}

/*=============================================================================
	PopUpMenuSelect
	ݥåץåץ˥塼
=============================================================================*/
void	PopUpMenuSelect
(
	Window		window[],
	LPVWIN		lpVWin
)
{
	Window		root, child;
	int		root_x, root_y;
	int		win_x, win_y;
	UINT		keys_buttons;
	FXimFont	*font;
	GC		*gc;
	ULONG		fore, back;
	char		*msg;
	WORD		key;
	int		descent;
	int		tmp_pos = -1;
	int		xx, yy, x1, x2, y1, y2;
	int		msg_w, msg_h, area_x, area_w, area_h;
	int		i, cnt, focus, win, prev_y, chk, cld;
	int		pos, w, h;

	pos	= lpVWin->PopUpMenuPos[lpVWin->PopUpMenuIdx];
	w	= lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].width;
	h	= lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].height;

	XQueryPointer (
		display,
		window[lpVWin->PopUpMenuIdx],
		&root, &child,
		&root_x, &root_y,
		&win_x, &win_y,
		&keys_buttons
	);
	if ((0 <= win_x && win_x < w)
	 && (0 <= win_y && win_y < h)){
		win	= True;
	} else {
		win	= False;
	}

	cnt	= GetPopUpMenuCount ();
	font	= &lpVWin->BaseFont;
	gc	= lpVWin->GCList;
	fore	= lpVWin->WinForePixel;
	back	= lpVWin->WinBackPixel;

	descent	= font->max_font_descent;

	msg_w	= GetMaxPopUpMenuMessageWidth (lpVWin);
	msg_h	= font->max_font_height;
	area_w	= msg_w
		+ DRAW_POPUP_MENU_CHECK_MARK
		+ DRAW_POPUP_MENU_CHILD_MARK
		+ DRAW_POPUP_MENU_FONT_BORDER * 2;
	area_h	= msg_h
		+ DRAW_POPUP_MENU_FONT_BORDER * 2;
	area_x	= DRAW_POPUP_MENU_BORDER;
	x1	= 0;
	x2	= area_w
		+ DRAW_POPUP_MENU_BORDER * 2;
	xx	= DRAW_POPUP_MENU_BORDER
		+ DRAW_POPUP_MENU_FONT_BORDER
		+ DRAW_POPUP_MENU_CHECK_MARK;
	yy	= DRAW_POPUP_MENU_BORDER;

#if 1 /* 991217:First-Display */
	DrawPopUpMenuFrame (
		window[lpVWin->PopUpMenuIdx],
		gc,
		lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].width,
		lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].height
	);
#endif

	for (i=0; i < cnt; i++) {
		key	= GetPopUpMenuKeyword (i);
		if (key == PM_KWD_SKP) {
			;
		} else if (key == PM_KWD_BDR) {
			yy	+= DRAW_POPUP_MENU_FONT_BORDER * 2
				 + DRAW_POPUP_MENU_MESSAGE_BORDER;
		} else {
			msg	= GetPopUpMenuText (i);
			y1	= yy;
			yy	+= DRAW_POPUP_MENU_FONT_BORDER
				 + msg_h;
			y2	= yy
				+ DRAW_POPUP_MENU_FONT_BORDER;
			focus	= -1;
			if ((x1 <= win_x && win_x < x2)
			 && (y1 <= win_y && win_y < y2)) {
				focus	= 1;
				tmp_pos	= i;
				if (i == pos) {
					break;
				}
			} else if (i == pos) {
				focus	= 0;
			}
			if (focus != -1) {
				chk	= GetPopUpMenuCheck (i);
				cld	= GetPopUpMenuChild (i);
				DrawPopUpMenuMessageArea (
					window[lpVWin->PopUpMenuIdx],
					gc,
					focus,
					chk,
					cld,
					area_x,
					y1,
					area_w,
					area_h
				);
				XSetForeground (display, gc[5], fore);
				XSetBackground (display, gc[5], back);
				DrawEucTextAttrGcString (
					display,
					window[lpVWin->PopUpMenuIdx],
					font,
					xx,
					yy
					- descent,
					msg,
					gc[5],
					lstrlen (msg)
				);
				if (focus == 0) {
					if (win == False
					 || tmp_pos != -1) {
						break;
					}
				}
			}
			yy	+= DRAW_POPUP_MENU_FONT_BORDER;
		}
	}
	lpVWin->PopUpMenuPos[lpVWin->PopUpMenuIdx]	= tmp_pos;

	XFlush (display);
}

/*=============================================================================
	PopUpMenuOpen
	ݥåץåץ˥塼Υץ
=============================================================================*/
void	PopUpMenuOpen
(
	Window		window[],
	LPVWIN		lpVWin
)
{
	XMoveResizeWindow (
		display,
		window[lpVWin->PopUpMenuIdx],
		lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].x,
		lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].y,
		lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].width,
		lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].height
	);
	PopUpMenuDisplay (window, lpVWin);
}

/*=============================================================================
	PopUpMenuClose
	ݥåץåץ˥塼Υ
=============================================================================*/
void	PopUpMenuClose
(
	Window		window[],
	LPVWIN		lpVWin
)
{
	XUnmapWindow (display, window[lpVWin->PopUpMenuIdx]);
	lpVWin->PopUpMenuPos[lpVWin->PopUpMenuIdx]	= -1;
}

/*=============================================================================
	CheckPopUpMenuMode
	ݥåץåץ˥塼ɽ椫ݤ򸡺
=============================================================================*/
BOOL	CheckPopUpMenuMode
(
	LPVWIN	lpVWin
)
{
	if (lpVWin->PopUpMenuFlg != PM_OFF) {
		return (TRUE);
	}
	return (FALSE);
}

/*=============================================================================
	PopUpMenuStart
=============================================================================*/
void	PopUpMenuStart
(
	LPVWIN		lpVWin
)
{
	LPENV		lpEnv;
	LPVSPLT		lpVSplt;
	WORD		key;
	WORD		func;
	WORD		status;
	LPTSTR		lptLong;
	int		i, j, jcnt;

	lpEnv	= (LPENV   )GetEnv (0);
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);

	lpVWin->PopUpMenuFlg	= PM_ON;
	lpVWin->PopUpMenuIdx	= 0;
	for (i=0; i < PM_WIN_MAX; i++) {
		lpVWin->PopUpMenuPos[i]	= -1;
	}

	for (i=0; i < recof (PopUpMenuAll); i++) {
		StackPopUpMenu (lpVWin, i);
		jcnt	= GetPopUpMenuCount ();
		for (j=0; j < jcnt; j++) {
			key	= GetPopUpMenuKeyword (j);
			switch (key) {
			case PM_KWD_ACC:
				func	= GetPopUpMenuFunc (j)
					- F_EX_ACC1;
				if (func < lpEnv->aci.wAccCount) {
					lptLong	= lpEnv->acc[func].sztAccLong;
					SetPopUpMenuText (j, lptLong);
				} else {
					SetPopUpMenuKeyword (j, PM_KWD_SKP);
				}
				break;
			case PM_KWD_CHK:
				func	= GetPopUpMenuFunc (j);
				status	= lpVSplt->wOffStatus;
				ResetPopUpMenuCheck (j);
				if (func   == F_EX_BTN_OFF_NORMAL
				 && status == STS_BTN_OFF_NML) {
					SetPopUpMenuCheck (j);
				} else if (func   == F_EX_BTN_OFF_MINIMIZE
					&& status == STS_BTN_OFF_MIN) {
					SetPopUpMenuCheck (j);
				} else if (func   == F_EX_BTN_OFF_HIDE
					&& status == STS_BTN_OFF_HID) {
					SetPopUpMenuCheck (j);
				}
				break;
			}
		}
	}
	StackPopUpMenu (lpVWin, 0);
}

/*=============================================================================
	PopUpMenuEnd
=============================================================================*/
void	PopUpMenuEnd
(
	LPVWIN		lpVWin
)
{
	int		i;
	for (i=lpVWin->PopUpMenuIdx; i >= 0; i--) {
		lpVWin->PopUpMenuIdx	= i;
		PopUpMenuClose (WPopUpMenu, lpVWin);
	}
	lpVWin->PopUpMenuIdx	= 0;
	lpVWin->PopUpMenuFlg	= PM_OFF;
}

/*=============================================================================
	GetNewPopUpMenuIdx
=============================================================================*/
int	GetNewPopUpMenuIdx
(
	Window	window[],
	LPVWIN	lpVWin
)
{
	Window	root, child;
	int	root_x, root_y;
	int	win_x, win_y;
	UINT	keys_buttons;
	int	x, y, w, h;
	int	i;

	for (i=lpVWin->PopUpMenuIdx; i >= 0; i--) {
		XQueryPointer (
			display,
			window[i],
			&root, &child,
			&root_x, &root_y,
			&win_x, &win_y,
			&keys_buttons
		);
		x	= lpVWin->PopUpMenu[i].x;
		y	= lpVWin->PopUpMenu[i].y;
		w	= x
			+ lpVWin->PopUpMenu[i].width;
		h	= y
			+ lpVWin->PopUpMenu[i].height;
		if ((x <= root_x && root_x < w) &&
		    (y <= root_y && root_y < h)) {
			break;
		}
	}
	return (i);
}

/*=============================================================================
	PopUpMenuMotion
	ݥåץåץ˥塼
	ޥưν
=============================================================================*/
void	PopUpMenuMotion
(
	XEvent		*event,
	LPVWIN		lpVWin
)
{
	Window		root, child;
	int		root_x, root_y;
	int		win_x, win_y;
	UINT		keys_buttons;
	int		x, y, w, h;
	int		pos, old_pos, new_pos;
	int		i, idx, max, num, cld;

	max	= lpVWin->PopUpMenuIdx;
	idx	= GetNewPopUpMenuIdx (WPopUpMenu, lpVWin);

	if (idx < 0) {
		lpVWin->PopUpMenuIdx	= max;
		CurPopUpMenu (lpVWin);
		PopUpMenuSelect (WPopUpMenu, lpVWin);
		return;
	}
	if (idx + 1 < max) {
		for (i=max; i > idx + 1; i--) {
			lpVWin->PopUpMenuIdx	= i;
			PopUpMenuClose (WPopUpMenu, lpVWin);
		}
		max	= idx + 1;
	}
	if (idx + 1 == max) {
		lpVWin->PopUpMenuIdx	= idx + 1;
		CurPopUpMenu (lpVWin);
		PopUpMenuSelect (WPopUpMenu, lpVWin);
	}

	lpVWin->PopUpMenuIdx	= idx;
	CurPopUpMenu (lpVWin);

	old_pos	= lpVWin->PopUpMenuPos[lpVWin->PopUpMenuIdx];
	PopUpMenuSelect (WPopUpMenu, lpVWin);
	new_pos	= lpVWin->PopUpMenuPos[lpVWin->PopUpMenuIdx];

	if (old_pos == new_pos) {
		lpVWin->PopUpMenuIdx	= max;
		return;
	}
	if (old_pos >= 0) {
		/* Close */
		cld	= GetPopUpMenuChild (old_pos);
		if (cld != 0) {
			lpVWin->PopUpMenuIdx	= idx + 1;
			PopUpMenuClose (WPopUpMenu, lpVWin);
#if 1 /* 991217:First-Display, ReDisplay */
			lpVWin->PopUpMenuIdx	= idx;
			PopUpMenuSelect (WPopUpMenu, lpVWin);
#endif
		}
	}
	if (new_pos >= 0) {
		/* Open */
		cld	= GetPopUpMenuChild (new_pos);
		if (cld != 0) {
			lpVWin->PopUpMenuIdx	= idx + 1;
			StackPopUpMenu (lpVWin, cld);
			PopUpMenuPosSize (WPopUpMenu, lpVWin);
			PopUpMenuOpen (WPopUpMenu, lpVWin);
		}
	}
}

/*=============================================================================
	PrePopUpMenuProc
=============================================================================*/
void	PrePopUpMenuProc
(
	XEvent		*event,
	LPVWIN		lpVWin
)
{
	WORD	key;
	WORD	func;
	int	pos;
	int	i, min, max;
	int	chk, start, end;

	CurPopUpMenu (lpVWin);

	pos	= lpVWin->PopUpMenuPos[lpVWin->PopUpMenuIdx];
	key	= GetPopUpMenuKeyword (pos);
	func	= GetPopUpMenuFunc (pos);

	switch (key) {
	case PM_KWD_CHK:
		start	= min	= 0;
		end	= max	= GetPopUpMenuCount () - 1;
		for (i=pos-1; i >= min; i--) {
			key	= GetPopUpMenuKeyword (i);
			if (key != PM_KWD_CHK) {
				start	= i + 1;
				break;
			}
			ResetPopUpMenuCheck (i);
		}
		for (i=pos+1; i <= max; i++) {
			key	= GetPopUpMenuKeyword (i);
			if (key != PM_KWD_CHK) {
				end	= i - 1;
				break;
			}
			ResetPopUpMenuCheck (i);
		}
		if (start < end) {
			SetPopUpMenuCheck (pos);
		} else {
			chk	= GetPopUpMenuCheck (pos);
			if (chk != 0) {
				ResetPopUpMenuCheck (pos);
			} else {
				SetPopUpMenuCheck (pos);
			}
		}
		break;
	default:
		break;
	}
}

/*=============================================================================
	PopUpMenuProc
=============================================================================*/
void	PopUpMenuProc
(
	XEvent		*event,
	LPVWIN		lpVWin
)
{
	KD	kd;
	WORD	key;
	WORD	func;
	int	pos;

	CurPopUpMenu (lpVWin);

	pos	= lpVWin->PopUpMenuPos[lpVWin->PopUpMenuIdx];
	key	= GetPopUpMenuKeyword (pos);
	func	= GetPopUpMenuFunc (pos);

	InitKD (&kd);
	switch (key) {
	case PM_KWD_CHK:
	case PM_KWD_ACC:
	case PM_KWD_CMD:
	case PM_KWD_PRC:
		switch (func) {
		case	F_EX_ENV_SAVE:
			CallSaveVjeEnv (current_client, ENV_ALL, 0);
			break;
		default:
			kd.wFunc	= func;
			FuncHandler (current_client, &kd);
			break;
		}
		break;
	default:
		return;
	}
}

/*=============================================================================
	CheckPopUpMenuProc
=============================================================================*/
BOOL	CheckPopUpMenuProc
(
	XEvent		*event,
	LPVWIN		lpVWin
)
{
	Window		root, child;
	int		root_x, root_y;
	int		win_x, win_y;
	UINT		keys_buttons;
	int		x, y, w, h;

	XQueryPointer (
		display,
		WPopUpMenu[lpVWin->PopUpMenuIdx],
		&root, &child,
		&root_x, &root_y,
		&win_x, &win_y,
		&keys_buttons
	);
	x	= lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].x;
	y	= lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].y;
	w	= x
		+ lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].width;
	h	= y
		+ lpVWin->PopUpMenu[lpVWin->PopUpMenuIdx].height;
	if ((x <= root_x && root_x < w)
	 && (y <= root_y && root_y < h)) {
		if (lpVWin->PopUpMenuPos[lpVWin->PopUpMenuIdx] >= 0) {
			return (TRUE);
		}
	}
	return (FALSE);
}

/*=============================================================================
	PopUpMenuReleaseStart
=============================================================================*/
BOOL	PopUpMenuReleaseStart
(
	XEvent		*event,
	LPVWIN		lpVWin
)
{
	int		i, rc;

	XRaiseWindow (display, root_client->window);

	if (event->xbutton.button != Button3) {
		return (FALSE);
	}
	PopUpHelpEnd (lpVWin);
#if XGRAB_POINTER
	XSync (display, 0);
	rc	= XGrabPointer (
			display,
			root_client->window,
			False,
			ButtonPressMask
			| ButtonReleaseMask
			| PointerMotionMask,
			GrabModeAsync,
			GrabModeAsync,
			None,
			GetVcurVal (CUR_NM),
			CurrentTime
		);
	XSync (display, 0);
	if (rc != GrabSuccess) {
		return (FALSE);
	}
#endif
	PopUpMenuStart (lpVWin);
	PopUpMenuPosSize (WPopUpMenu, lpVWin);
	PopUpMenuOpen (WPopUpMenu, lpVWin);

	return (TRUE);
}

/*=============================================================================
	PopUpMenuReleaseEnd
=============================================================================*/
BOOL	PopUpMenuReleaseEnd
(
	XEvent		*event,
	LPVWIN		lpVWin
)
{
	BOOL	rc;
#if XGRAB_POINTER
	XSync (display, 0);
	XUngrabPointer (display, CurrentTime);
	XSync (display, 0);
#endif
	if (event->xbutton.button == Button1) {
		rc	= CheckPopUpMenuProc (event, lpVWin);
		if (rc) {
			PrePopUpMenuProc (event, lpVWin);
			PopUpMenuProc (event, lpVWin);
		}
	}
	PopUpMenuEnd (lpVWin);

#if XGRAB_POINTER
	XSync (display, 0);
#endif
	return (TRUE);
}

/*=============================================================================
	PopUpMenuCancel
=============================================================================*/
BOOL	PopUpMenuCancel
(
	LPVWIN		lpVWin
)
{
	Window	root, child;
	int	root_x, root_y;
	int	win_x, win_y;
	UINT	keys_buttons;
	int	x, y, w, h;
	short	i;

#if XGRAB_POINTER
	XSync (display, 0);
	XUngrabPointer (display, CurrentTime);
	XSync (display, 0);
#endif
	for (i=lpVWin->PopUpMenuIdx; i >= 0; i--) {
		lpVWin->PopUpMenuIdx	= i;
		PopUpMenuClose (WPopUpMenu, lpVWin);
	}
	lpVWin->PopUpMenuIdx	= 0;
	lpVWin->PopUpMenuFlg	= 0;

#if XGRAB_POINTER
	XSync (display, 0);
#endif
	return (TRUE);
}

/*=============================================================================
	PopUpMenuPress
	ݥåץåץ˥塼
	ޥ줿ν
=============================================================================*/
void	PopUpMenuPress
(
	XEvent	*event
)
{
}

/*=============================================================================
	CalcWindowSize
	ɥΥꥵ
	ɥ x,y ɸ,⤵׻
=============================================================================*/
void	CalcWindowSize
(
	LPVCWI	info,
	int	grab,
	int	*x,
	int	*y,
	int	*w,
	int	*h
)
{
	int	root_w, root_h;
	int	pos_x, pos_y;
	int	base_x, base_y;
	int	win_x, win_y, win_w, win_h;
	int	tmp_x, tmp_y, tmp_w, tmp_h;

	tmp_x	= *x;
	tmp_y	= *y;
	tmp_w	= *w;
	tmp_h	= *h;

	root_w	= DisplayWidth  (display, screen);
	root_h	= DisplayHeight (display, screen);

	if (grab == WIN_TOP
	 || grab == WIN_LEFT
	 || grab == WIN_UPPER_LEFT
	 || grab == WIN_LOWER_LEFT) {
		base_x	= info->wRootX
			+ info->wRootW;
	} else {
		base_x	= info->wRootX;
	}
	if (grab == WIN_TOP
	 || grab == WIN_RIGHT
	 || grab == WIN_UPPER_LEFT
	 || grab == WIN_UPPER_RIGHT) {
		base_y	= info->wRootY
			+ info->wRootH;
	} else {
		base_y	= info->wRootY;
	}

	if (grab == WIN_TOP) {
		pos_x	= info->wRootX;
	} else if (grab == WIN_BOTTOM) {
		pos_x	= info->wRootX
			+ info->wRootW;
	} else if (grab == WIN_LEFT
	        || grab == WIN_UPPER_LEFT
	        || grab == WIN_LOWER_LEFT) {
		pos_x	= tmp_x
			- info->wWinX;
	} else {
		pos_x	= tmp_x
			- info->wWinX
			+ info->wRootW;
	}
	if (grab == WIN_RIGHT) {
		pos_y	= info->wRootY;
	} else if (grab == WIN_LEFT) {
		pos_y	= info->wRootY
			+ info->wRootH;
	} else if (grab == WIN_TOP
	        || grab == WIN_UPPER_LEFT
	        || grab == WIN_UPPER_RIGHT) {
		pos_y	= tmp_y
			- info->wWinY;
	} else {
		pos_y	= tmp_y
			- info->wWinY
			+ info->wRootH;
	}

	if (pos_x < 0) {
		pos_x	= 0;
	} else if (pos_x > root_w) {
		pos_x	= root_w;
	}
	if (pos_y < 0) {
		pos_y	= 0;
	} else if (pos_y > root_h) {
		pos_y	= root_h;
	}

	if (grab == WIN_TOP
	 || grab == WIN_LEFT
	 || grab == WIN_UPPER_LEFT
	 || grab == WIN_LOWER_LEFT) {
		win_x	= pos_x;
		win_w	= base_x
			- pos_x;
		if (win_w <= info->wMinW) {
			win_x	= base_x
				- info->wMinW;
			win_w	= info->wMinW;
		}
	} else {
		win_x	= base_x;
		win_w	= pos_x
			- base_x;
		if (win_w <= info->wMinW) {
			win_w	= info->wMinW;
		}
	}
	if (grab == WIN_TOP
	 || grab == WIN_RIGHT
	 || grab == WIN_UPPER_LEFT
	 || grab == WIN_UPPER_RIGHT) {
		win_y	= pos_y;
		win_h	= base_y
			- pos_y;
		if (win_h <= info->wMinH) {
			win_y	= base_y
				- info->wMinH;
			win_h	= info->wMinH;
		}
	} else {
		win_y	= base_y;
		win_h	= pos_y - base_y;
		if (win_h <= info->wMinH) {
			win_h	= info->wMinH;
		}
	}

	if (info->wStepW > 1
	 || info->wStepH > 1) {
		win_w  -= info->wMinW;
		win_h  -= info->wMinH;
		if (grab == WIN_LEFT
		 || grab == WIN_UPPER_LEFT
		 || grab == WIN_LOWER_LEFT) {
			win_x  += win_w
				% info->wStepW;
		}
		if (grab == WIN_TOP
		 || grab == WIN_UPPER_LEFT
		 || grab == WIN_UPPER_RIGHT) {
			win_y  += win_h
				% info->wStepH;
		}
		win_w	= win_w
			/ info->wStepW
			* info->wStepW;
		win_h	= win_h
			/ info->wStepH
			* info->wStepH;
		win_w  += info->wMinW;
		win_h  += info->wMinH;
	}

	*x	= win_x;
	*y	= win_y;
	*w	= win_w;
	*h	= win_h;
}

/*=============================================================================
	CalcStatusWindowSize
	ơɥΥꥵ
	ơɥ x,y ɸ,⤵׻
=============================================================================*/
void	CalcStatusWindowSize
(
	LPVSPLT	lpVSplt,
	LPVCWI	info,
	int	grab,
	int	*x,
	int	*y,
	int	*w,
	int	*h
)
{
static	short	prev_x, prev_y, prev_w, prev_h;
	short	tmp_x, tmp_y, tmp_w, tmp_h;
	short	root_w, root_h;
	short	wrk_w, wrk_h;
	short	wstart, wend, wstep;
	short	hstart, hend, hstep;
	BOOL	rc;

	tmp_x	= *x;
	tmp_y	= *y;
	tmp_w	= *w;
	tmp_h	= *h;

	root_w	= DisplayWidth  (display, screen);
	root_h	= DisplayHeight (display, screen);

	if (grab == WIN_LEFT
	 || grab == WIN_RIGHT) {
		hstart	= root_h;
		hend	= info->wMinH;
		hstep	= info->wStepH;
		wstart	= tmp_w;
		wend	= tmp_w;
		wstep	= tmp_w;
		rc	= CalcVSpltBtnItr (
				lpVSplt, ITR_HD,
				wstart, wend, wstep,
				hstart, hend, hstep,
				&tmp_w, &tmp_h
			);
		if (!rc) {
			wstart	= info->wMinW;
			wend	= root_w;
			wstep	= info->wStepW;
			hstart	= root_h;
			hend	= info->wMinH;
			hstep	= info->wStepH;
			rc	= CalcVSpltBtnItr (
					lpVSplt, ITR_WIHD,
					wstart, wend, wstep,
					hstart, hend, hstep,
					&tmp_w, &tmp_h
				);
		}
	} else {
		wstart	= info->wMinW;
		wend	= root_w;
		wstep	= info->wStepW;
		hstart	= tmp_h;
		hend	= tmp_h;
		hstep	= tmp_h;
		rc	= CalcVSpltBtnItr (
				lpVSplt, ITR_WI,
				wstart, wend, wstep,
				hstart, hend, hstep,
				&tmp_w, &tmp_h
			);
		if (!rc) {
			hstart	= info->wMinH;
			hend	= root_h;
			hstep	= info->wStepH;
			wstart	= root_w - info->wMinW;
			wend	= info->wMinW;
			wstep	= info->wStepW;
			rc	= CalcVSpltBtnItr (
					lpVSplt, ITR_HIWD,
					wstart, wend, wstep,
					hstart, hend, hstep,
					&tmp_w, &tmp_h
				);
		}
	}
	if (!rc) {
		*x	= prev_x;
		*y	= prev_y;
		*w	= prev_w;
		*h	= prev_h;
		return;
	}

	if (grab == WIN_TOP
	 || grab == WIN_BOTTOM) {
		if (info->wRootX >= root_w - (info->wRootX + info->wRootW)) {
			tmp_x	= info->wRootX
				+ info->wRootW
				- tmp_w;
		}
	} else if (grab == WIN_LEFT) {
		tmp_x	= info->wRootX
			+ info->wRootW
			- tmp_w;
	}

	if (grab == WIN_LEFT
	 || grab == WIN_RIGHT) {
		if (info->wRootY >= root_h - (info->wRootY + info->wRootH)) {
			tmp_y	= info->wRootY
				+ info->wRootH
				- tmp_h;
		}
	} else if (grab == WIN_TOP) {
		tmp_y	= info->wRootY
			+ info->wRootH
			- tmp_h;
	}

	if (tmp_x + tmp_w > root_w) {
		tmp_x	= root_w - tmp_w;
	} else if (tmp_x < 0) {
		tmp_x	= 0;
	}
	if (tmp_y + tmp_h > root_h) {
		tmp_y	= root_h - tmp_h;
	} else if (tmp_y < 0) {
		tmp_y	= 0;
	}

	*x	= prev_x	= tmp_x;
	*y	= prev_y	= tmp_y;
	*w	= prev_w	= tmp_w;
	*h	= prev_h	= tmp_h;

	return;
}

/*=============================================================================
	CalcWindowPosition
	ɥΰư
	ɥ x,y ɸ׻
=============================================================================*/
void	CalcWindowPosition
(
	LPVCWI	info,
	int	*x,
	int	*y
)
{
	int	root_w, root_h;
	int	tmp_x, tmp_y;

	tmp_x	= *x;
	tmp_y	= *y;

	root_w	= DisplayWidth  (display, screen) - info->wRootW;
	root_h	= DisplayHeight (display, screen) - info->wRootH;

	tmp_x	-= info->wWinX;
	tmp_y	-= info->wWinY;

	if (tmp_x < 0) {
		tmp_x	= 0;
	} else if (tmp_x > root_w) {
		tmp_x	= root_w;
	}
	if (tmp_y < 0) {
		tmp_y	= 0;
	} else if (tmp_y > root_h) {
		tmp_y	= root_h;
	}

	*x	= tmp_x;
	*y	= tmp_y;
}

/*=============================================================================
	ResizeOutline
	ɥ(ե졼)Υꥵ
=============================================================================*/
void	ResizeOutline
(
	Window		window,
	GC		gc,
	int		grab,
	short		*x,
	short		*y,
	short		*w,
	short		*h,
	short		step_w,
	short		step_h,
	short		min_w,
	short		min_h
)
{
	VCWI		info;
	XEvent		event;
	Window		root, child;
	int		root_x, root_y;
	int		win_x, win_y;
	UINT		keys_buttons;
	int		prev_x, prev_y;
	int		root_w, root_h;
	int		prev_w, prev_h;

#if XGRAB_SERVER
	XSync (display, 0);
	XGrabServer (display);
	XSync (display, 0);
#endif
	XQueryPointer (
		display, window, &root, &child,
		&root_x, &root_y, &win_x, &win_y,
		&keys_buttons
	);

	prev_x		= root_x	= *x;
	prev_y		= root_y	= *y;
	prev_w		= root_w	= *w;
	prev_h		= root_h	= *h;

	info.wWinX	= win_x;
	info.wWinY	= win_y;
	info.wRootX	= root_x;
	info.wRootY	= root_y;
	info.wRootW	= root_w;
	info.wRootH	= root_h;
	info.wStepW	= step_w;
	info.wStepH	= step_h;
	info.wMinW	= min_w;
	info.wMinH	= min_h;

	DrawOutline (root, gc, prev_x, prev_y, prev_w, prev_h);
	for (;;) {
		XMaskEvent (
			display,
			ButtonReleaseMask
			| PointerMotionMask,
			&event
		);
		if (event.type != MotionNotify) {
			break;
		}
		XQueryPointer (
			display, window, &root, &child,
			&root_x, &root_y, &win_x, &win_y,
			&keys_buttons
		);
		CalcWindowSize (
			&info, grab,
			&root_x, &root_y,
			&root_w, &root_h
		);
		if (prev_x != root_x
		 || prev_y != root_y
		 || prev_w != root_w
		 || prev_h != root_h) {
			DrawOutline (
				root, gc,
				prev_x, prev_y, prev_w, prev_h
			);
			DrawOutline (
				root, gc,
				root_x, root_y, root_w, root_h
			);
			prev_x	= root_x;
			prev_y	= root_y;
			prev_w	= root_w;
			prev_h	= root_h;
		}
	}
	DrawOutline (root, gc, prev_x, prev_y, prev_w, prev_h);

	*x	= (short )prev_x;
	*y	= (short )prev_y;
	*w	= (short )prev_w;
	*h	= (short )prev_h;

#if XGRAB_SERVER
	XSync (display, 0);
	XUngrabServer (display);
	XSync (display, 0);
#endif
	return;
}

/*=============================================================================
	ResizeStatusOutline
	ơɥ(ե졼)Υꥵ
=============================================================================*/
void	ResizeStatusOutline
(
	LPVSPLT		lpVSplt,
	Window		window,
	GC		gc,
	int		grab,
	short		*x,
	short		*y,
	short		*w,
	short		*h,
	short		step_w,
	short		step_h,
	short		min_w,
	short		min_h
)
{
	VCWI		info;
	XEvent		event;
	Window		root, child;
	int		root_x, root_y;
	int		win_x, win_y;
	UINT		keys_buttons;
	int		prev_x, prev_y;
	int		root_w, root_h;
	int		prev_w, prev_h;
	BOOL		rc;

#if XGRAB_SERVER
	XSync (display, 0);
	XGrabServer (display);
	XSync (display, 0);
#endif
	XQueryPointer (
		display, window, &root, &child,
		&root_x, &root_y, &win_x, &win_y,
		&keys_buttons
	);

	prev_x		= root_x	= *x;
	prev_y		= root_y	= *y;
	prev_w		= root_w	= *w;
	prev_h		= root_h	= *h;

	info.wWinX	= win_x;
	info.wWinY	= win_y;
	info.wRootX	= root_x;
	info.wRootY	= root_y;
	info.wRootW	= root_w;
	info.wRootH	= root_h;
	info.wStepW	= step_w;
	info.wStepH	= step_h;
	info.wMinW	= min_w;
	info.wMinH	= min_h;

	DrawOutline (root, gc, prev_x, prev_y, prev_w, prev_h);
	for (;;) {
		XMaskEvent (
			display,
			ButtonReleaseMask
			| PointerMotionMask,
			&event
		);
		if (event.type != MotionNotify) {
			break;
		}
		XQueryPointer (
			display, window, &root, &child,
			&root_x, &root_y, &win_x, &win_y,
			&keys_buttons
		);
		CalcWindowSize (
			&info, grab,
			&root_x, &root_y, &root_w, &root_h
		);
		CalcStatusWindowSize (
			lpVSplt, &info, grab,
			&root_x, &root_y, &root_w, &root_h
		);
		if (prev_x != root_x
		 || prev_y != root_y
		 || prev_w != root_w
		 || prev_h != root_h) {
			DrawOutline (
				root, gc,
				prev_x, prev_y, prev_w, prev_h
			);
			DrawOutline (
				root, gc,
				root_x, root_y, root_w, root_h
			);
			prev_x	= root_x;
			prev_y	= root_y;
			prev_w	= root_w;
			prev_h	= root_h;
		}
	}
	DrawOutline (root, gc, prev_x, prev_y, prev_w, prev_h);

	*x	= (short )prev_x;
	*y	= (short )prev_y;
	*w	= (short )prev_w;
	*h	= (short )prev_h;

#if XGRAB_SERVER
	XSync (display, 0);
	XUngrabServer (display);
	XSync (display, 0);
#endif
	return;
}

/*=============================================================================
	ResizeKohoOutline
	䥦ɥ(ե졼)Υꥵ
=============================================================================*/
void	ResizeKohoOutline
(
	Window		window,
	GC		gc,
	int		grab,
	short		*x,
	short		*y,
	short		*w,
	short		*h,
	short		start_w,
	short		start_h,
	short		step_w,
	short		step_h,
	short		min_w,
	short		min_h
)
{
	VCWI		info;
	XEvent		event;
	Window		root, child;
	int		root_x, root_y;
	int		win_x, win_y;
	UINT		keys_buttons;
	int		prev_x, prev_y;
	int		root_w, root_h;
	int		prev_w, prev_h;
	int		xx;
	BOOL		rc;

#if XGRAB_SERVER
	XSync (display, 0);
	XGrabServer (display);
	XSync (display, 0);
#endif
	XQueryPointer (
		display, window, &root, &child,
		&root_x, &root_y, &win_x, &win_y,
		&keys_buttons
	);

	prev_x		= root_x	= *x;
	prev_y		= root_y	= *y;
	prev_w		= root_w	= *w;
	prev_h		= root_h	= *h;

	info.wWinX	= win_x;
	info.wWinY	= win_y;
	info.wRootX	= root_x;
	info.wRootY	= root_y;
	info.wRootW	= root_w;
	info.wRootH	= root_h;
	info.wStepW	= step_w;
	info.wStepH	= step_h;
	info.wMinW	= min_w;
	info.wMinH	= min_h;

	DrawOutline (root, gc, prev_x, prev_y, prev_w, prev_h);
	for (xx=prev_x+start_w; xx<prev_x+prev_w; xx+=step_w) {
		XDrawLine (
			display, root, gc,
			xx, prev_y, xx, prev_y+prev_h
		);
	}
	for (;;) {
		XMaskEvent (
			display,
			ButtonReleaseMask
			| PointerMotionMask,
			&event
		);
		if (event.type != MotionNotify) {
			break;
		}
		XQueryPointer (
			display, window, &root, &child,
			&root_x, &root_y, &win_x, &win_y,
			&keys_buttons
		);
		CalcWindowSize (
			&info, grab,
			&root_x, &root_y, &root_w, &root_h
		);
		if (prev_x != root_x
		 || prev_y != root_y
		 || prev_w != root_w
		 || prev_h != root_h) {
			DrawOutline (
				root, gc,
				prev_x, prev_y, prev_w, prev_h
			);
			DrawOutline (
				root, gc,
				root_x, root_y, root_w, root_h
			);
			for (xx=prev_x+start_w; xx<prev_x+prev_w; xx+=step_w) {
				XDrawLine (
					display, root, gc,
					xx, prev_y, xx, prev_y+prev_h
				);
			}
			for (xx=root_x+start_w; xx<root_x+root_w; xx+=step_w) {
				XDrawLine (
					display, root, gc,
					xx, root_y, xx, root_y+root_h
				);
			}
			prev_x	= root_x;
			prev_y	= root_y;
			prev_w	= root_w;
			prev_h	= root_h;
		}
	}
	DrawOutline (root, gc, prev_x, prev_y, prev_w, prev_h);
	for (xx=prev_x+start_w; xx<prev_x+prev_w; xx+=step_w) {
		XDrawLine (
			display, root, gc,
			xx, prev_y, xx, prev_y+prev_h
		);
	}

	*x	= (short )prev_x;
	*y	= (short )prev_y;
	*w	= (short )prev_w;
	*h	= (short )prev_h;

#if XGRAB_SERVER
	XSync (display, 0);
	XUngrabServer (display);
	XSync (display, 0);
#endif
	return;
}

/*=============================================================================
	MoveOutline
	ɥ(ե졼)ΰư
=============================================================================*/
void	MoveOutline
(
	Window		window,
	GC		gc,
	short		*x,
	short		*y,
	short		w,
	short		h
)
{
	VCWI		info;
	XEvent		event;
	Window		root, child;
	int		root_x, root_y;
	int		win_x, win_y;
	UINT		keys_buttons;
	int		prev_x, prev_y;

#if XGRAB_SERVER
	XSync (display, 0);
	XGrabServer (display);
	XSync (display, 0);
#endif
	XQueryPointer (
		display, window, &root, &child,
		&root_x, &root_y, &win_x, &win_y,
		&keys_buttons
	);

	prev_x		= root_x	= *x;
	prev_y		= root_y	= *y;

	info.wWinX	= win_x;
	info.wWinY	= win_y;
	info.wRootW	= w;
	info.wRootH	= h;

	DrawOutline (root, gc, prev_x, prev_y, w, h);
	for (;;) {
		XMaskEvent (
			display,
			ButtonReleaseMask
			| PointerMotionMask,
			&event
		);
		if (event.type != MotionNotify) {
			break;
		}
		XQueryPointer (
			display, window, &root, &child,
			&root_x, &root_y, &win_x, &win_y,
			&keys_buttons
		);
		CalcWindowPosition (&info, &root_x, &root_y);
		DrawOutline (root, gc, prev_x, prev_y, w, h);
		DrawOutline (root, gc, root_x, root_y, w, h);
		prev_x	= root_x;
		prev_y	= root_y;
	}
	DrawOutline (root, gc, prev_x, prev_y, w, h);

	*x	= (short )prev_x;
	*y	= (short )prev_y;

#if XGRAB_SERVER
	XSync (display, 0);
	XUngrabServer (display);
	XSync (display, 0);
#endif
	return;
}

/*=============================================================================
	DisplayStatusWindow
=============================================================================*/
void	DisplayStatusWindow
(
	FXim_Client	*client
)
{
	DrawStatusWindow (root_client->window, (LPVWIN )GetVWin ());
	DisplayStatus (client);
}

/*=============================================================================
	RedisplayStatusWindowFrame
=============================================================================*/
void	RedisplayStatusWindowFrame ()
{
	DrawStatusWindow (root_client->window, (LPVWIN )GetVWin ());
}

/*=============================================================================
	RedisplayStatusWindow
=============================================================================*/
void	RedisplayStatusWindow ()
{
	LPVWIN	lpVWin;
	LPVSPLT	lpVSplt;
	Window	root, child;
	int	root_x, root_y, win_x, win_y;
	UINT	keys_buttons;
	int	pos;

	lpVWin	= (LPVWIN  )GetVWin ();
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);

	XQueryPointer (
		display,
		root_client->window,
		&root, &child,
		&root_x, &root_y,
		&win_x, &win_y,
		&keys_buttons
	);
	if (!((0 <= win_x && win_x < lpVWin->StatusR.width)
	 &&   (0 <= win_y && win_y < lpVWin->StatusR.height))) {
		DisplayStatus (current_client);
		return;
	}

	pos	= VJEGetPositionStatus (
			lpVWin,
			win_x,
			win_y
		);

	if (lpVSplt->wBtnMode != STS_BTN_MODE_PSH) {
		DisplayStatus (current_client);
	}
	if (!IsScreenMode (current_client)) {
		if (pos != lpVSplt->wBtnPosRoot) {
			return;
		}
	}
	if (0 <= pos && pos < lpVSplt->wBtnCount) {
		lpVSplt->wBtnPos	= pos;
		DrawStatusPalette (current_client, lpVWin);
		DrawStatusButton  (current_client, lpVWin);
	}
}

/*=============================================================================
	ơɥΰư
=============================================================================*/
void	MoveStatusWindow
(
	LPVWIN		lpVWin
)
{
	LPVSPLT	lpVSplt;
	short	max_x1, max_y1, max_w1, max_h1;
	short	max_x2, max_y2, max_w2, max_h2;
	short	min_x1, min_y1, min_w1, min_h1;
	short	min_x2, min_y2, min_w2, min_h2;
	short	cur_x1, cur_y1, cur_w1, cur_h1;
	short	cur_x2, cur_y2, cur_w2, cur_h2;


#if 0 /* 20000217 MOVE-WINDOW */
	if (MoveTimeID != 0) {
		XtRemoveTimeOut (MoveTimeID);
	}
#endif
	XDefineCursor (display, root_client->window, GetVcurVal (CUR_GB));
	
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);

	PopUpHelpEnd (lpVWin);
	RedisplayStatusWindowFrame ();
	RedisplayStatusWindow ();

	GetMaxRect (
		&max_x1, &max_y1, &max_w1, &max_h1,
		&max_x2, &max_y2, &max_w2, &max_h2
	);
	GetMinRect (
		&min_x1, &min_y1, &min_w1, &min_h1,
		&min_x2, &min_y2, &min_w2, &min_h2
	);
	GetCurRect (
		&cur_x1, &cur_y1, &cur_w1, &cur_h1,
		&cur_x2, &cur_y2, &cur_w2, &cur_h2
	);

	MoveOutline (
		root_client->window,
		lpVWin->XorGC,
		&cur_x1, &cur_y1, cur_w1, cur_h1
	);

	if (lpVWin->StatusWinType == STATUS_WINDOW_TYPE_MIN) {
		Locate (
			cur_x1, cur_y1, cur_w1, cur_h1,
			&max_x1, &max_y1, max_w1, max_h1
		);
		SetMinRect (
			cur_x1, cur_y1, cur_w1, cur_h1,
			min_x2, min_y2, min_w2, min_h2
		);
		SetMaxRect (
			max_x1, max_y1, max_w1, max_h1,
			max_x2, max_y2, max_w2, max_h2
		);
	} else {
		Locate (
			cur_x1, cur_y1, cur_w1, cur_h1,
			&min_x1, &min_y1, min_w1, min_h1
		);
		SetMaxRect (
			cur_x1, cur_y1, cur_w1, cur_h1,
			max_x2, max_y2, max_w2, max_h2
		);
		SetMinRect (
			min_x1, min_y1, min_w1, min_h1,
			min_x2, min_y2, min_w2, min_h2
		);
	}
	SetCurRect (
		cur_x1, cur_y1, cur_w1, cur_h1,
		cur_x2, cur_y2, cur_w2, cur_h2
	);

	XMoveWindow (display, root_client->window, cur_x1, cur_y1);

	lpVSplt->wBtnMode	= STS_BTN_MODE_POP;
	RedisplayStatusWindowFrame ();
	RedisplayStatusWindow ();

	CallSaveVjeEnv (current_client, ENV_POS, 0);

	XRaiseWindow (display, root_client->window);

	XDefineCursor (display, root_client->window, GetVcurVal (CUR_NM));
}

/*=============================================================================
	ơɥΥꥵ
=============================================================================*/
void	ResizeStatusWindow
(
	LPVWIN		lpVWin,
	int		pos
)
{
	LPVSPLT	lpVSplt;
	VSPLT	tmpVSplt;
	short	min_x1, min_y1, min_w1, min_h1;
	short	min_x2, min_y2, min_w2, min_h2;
	short	cur_x1, cur_y1, cur_w1, cur_h1;
	short	cur_x2, cur_y2, cur_w2, cur_h2;
	int	root_w, root_h;
	int	step_w, step_h;
	int	min_w, min_h;
	BOOL	rc;

#if 0 /* 20000217 MOVE-WINDOW */
	if (MoveTimeID != 0) {
		XtRemoveTimeOut (MoveTimeID);
	}
#endif
	XDefineCursor (display, root_client->window, GetVcurVal (CUR_GB));

	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);

	lmemcpy ((char *)&tmpVSplt, (char *)lpVSplt, sizeof (VSPLT));

	PopUpHelpEnd (lpVWin);
	RedisplayStatusWindowFrame ();
	RedisplayStatusWindow ();

	root_w	= DisplayWidth  (display, screen);
	root_h	= DisplayHeight (display, screen);

	GetCurRect (
		&cur_x1, &cur_y1, &cur_w1, &cur_h1,
		&cur_x2, &cur_y2, &cur_w2, &cur_h2
	);
	step_w	= tmpVSplt.wBtnSize
		+ DRAW_STATUS_WINDOW_BUTTON_BORDER;
	step_h	= tmpVSplt.wBtnSize
		+ DRAW_STATUS_WINDOW_BUTTON_BORDER;

	min_w	= tmpVSplt.wBtnSize
		+ DRAW_STATUS_WINDOW_BUTTON_BORDER * 2
		+ DRAW_STATUS_WINDOW_BORDER * 2
		+ DRAW_STATUS_WINDOW_TITLE_WIDTH;
	min_h	= tmpVSplt.wBtnSize
		+ DRAW_STATUS_WINDOW_BUTTON_BORDER * 2
		+ DRAW_STATUS_WINDOW_BORDER * 2;

	ResizeStatusOutline (
		&tmpVSplt,
		root_client->window,
		lpVWin->XorGC,
		pos,
		&cur_x1, &cur_y1, &cur_w1, &cur_h1,
		step_w, step_h, min_w, min_h
	);

	if (lpVWin->StatusWinType == STATUS_WINDOW_TYPE_MIN) {
		goto	RESIZE_STATUS_WINDOW;
	}

	rc	= CreateVSpltBtn (&tmpVSplt, &cur_w1, &cur_h1);
	if (!rc) {
		goto	RESIZE_STATUS_WINDOW;
	}

	rc	= CreateVSpltPixBtnBuff (&tmpVSplt, cur_w1, cur_h1);
	if (!rc) {
		goto	RESIZE_STATUS_WINDOW;
	}

	SaveVSpltMaxBtn (&tmpVSplt);

	cur_w2	= cur_w1
		- DRAW_STATUS_WINDOW_BORDER * 2
		- DRAW_STATUS_WINDOW_TITLE_WIDTH;
	cur_h2	= cur_h1
		- DRAW_STATUS_WINDOW_BORDER * 2;
	SetCurRect (
		cur_x1, cur_y1, cur_w1, cur_h1,
		cur_x2, cur_y2, cur_w2, cur_h2
	);
	SetMaxRect (
		cur_x1, cur_y1, cur_w1, cur_h1,
		cur_x2, cur_y2, cur_w2, cur_h2
	);

	GetMinRect (
		&min_x1, &min_y1, &min_w1, &min_h1,
		&min_x2, &min_y2, &min_w2, &min_h2
	);
	Locate (
		cur_x1, cur_y1, cur_w1, cur_h1,
		&min_x1, &min_y1, min_w1, min_h1
	);
	SetMinRect (
		min_x1, min_y1, min_w1, min_h1,
		min_x2, min_y2, min_w2, min_h2
	);

	XMoveResizeWindow (
		display,
		root_client->window,
		cur_x1, cur_y1, cur_w1, cur_h1
	);
	XMoveResizeWindow (
		display,
		root_client->status_window,
		cur_x2, cur_y2, cur_w2, cur_h2
	);

	lpVSplt->wBtnMode	= STS_BTN_MODE_POP;
	RedisplayStatusWindowFrame ();
	RedisplayStatusWindow ();

	lmemcpy ((char *)lpVSplt, (char *)&tmpVSplt, sizeof (VSPLT));

	CallSaveVjeEnv (current_client, ENV_POS, 0);

	XRaiseWindow (display, root_client->window);

RESIZE_STATUS_WINDOW:;
	XDefineCursor (display, root_client->window, GetVcurVal (CUR_NM));
}

/*=============================================================================
	ңϣϣ̤ʸϥɥΰư
=============================================================================*/
void	MovePreeditRootWindow
(
	LPVWIN		lpVWin
)
{
#if 0 /* 20000217 MOVE-WINDOW */
	if (MoveTimeID != 0) {
		XtRemoveTimeOut (MoveTimeID);
	}
#endif
	XDefineCursor (display, WPreeditR, GetVcurVal (CUR_GB));

	MoveOutline (
		WPreeditR,
		lpVWin->XorGC,
		&lpVWin->PreeditR.x,
		&lpVWin->PreeditR.y,
		lpVWin->PreeditR.width,
		lpVWin->PreeditR.height
	);

	RedisplayPreeditRootWindow ();

	CallSaveVjeEnv (current_client, ENV_POS, 0);

	XRaiseWindow (display, WPreeditR);

	XDefineCursor (display, WPreeditR, GetVcurVal (CUR_NM));
}

/*=============================================================================
	ңϣϣ̤ʸϥɥΥꥵ
=============================================================================*/
void	ResizePreeditRootWindow
(
	LPVWIN		lpVWin,
	int		pos
)
{
	int		min_w, min_h;
	int		kanji_w, kana_w;

#if 0 /* 20000217 MOVE-WINDOW */
	if (MoveTimeID != 0) {
		XtRemoveTimeOut (MoveTimeID);
	}
#endif
	XDefineCursor (display, WPreeditR, GetVcurVal (CUR_GB));

	if (current_client->style & XIMPreeditNothing) {
		kanji_w	= current_client->preedit_font->kanji_font_width;
		kana_w	= current_client->preedit_font->ascii_kana_font_width;
	} else {
		kanji_w	= root_client->preedit_font->kanji_font_width;
		kana_w	= root_client->preedit_font->ascii_kana_font_width;
	}

	min_w	= (((kanji_w > kana_w) ? kanji_w : kana_w)
		  * DRAW_PREEDIT_ROOT_WINDOW_MIN_LENGTH)
		+ DRAW_PREEDIT_ROOT_WINDOW_FONT_BORDER * 2
		+ DRAW_PREEDIT_ROOT_WINDOW_BORDER * 2
		+ DRAW_PREEDIT_ROOT_WINDOW_TITLE_WIDTH;
	min_h	= lpVWin->PreeditR.height;

	ResizeOutline (
		WPreeditR,
		lpVWin->XorGC,
		pos,
		&lpVWin->PreeditR.x,
		&lpVWin->PreeditR.y,
		&lpVWin->PreeditR.width,
		&lpVWin->PreeditR.height,
		1, 1, min_w, min_h
	);

	lpVWin->PreeditM.width	= lpVWin->PreeditR.width
				- DRAW_PREEDIT_ROOT_WINDOW_BORDER * 2
				- DRAW_PREEDIT_ROOT_WINDOW_TITLE_WIDTH;

	RedisplayPreeditRootWindow ();

	CallSaveVjeEnv (current_client, ENV_POS, 0);

	XRaiseWindow (display, WPreeditR);

	XDefineCursor (display, WPreeditR, GetVcurVal (CUR_NM));
}

/*=============================================================================
	䥦ɥΥꥵ
=============================================================================*/
void	ResizeKohoWindow
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	int		pos
)
{
	LPVKP		lpVKp;
	FXim_Client	*cur;
	Window		root_win;
	int		win_x, win_y;
	unsigned int	win_width, win_height;
	unsigned int	win_border_width, win_depth;
	int		col, row, len;
	short		x, y, width, height;
	short		start_w, start_h;
	short		step_w, step_h;
	short		min_w, min_h;
	short		i;

	if (client->bdata.wMainStage & PRC_CODE) {
		return;
	}

	lpVKp	= (LPVKP    )GetVKp (client);
	if (lpVKp->Mtx == NO
	 || lpVKp->Mtx == AUTO) {
		return;
	}
	XDefineCursor (display, client->koho_window, GetVcurVal (CUR_GB));

	GetVKpCanMtx (client, &col, &row, &len);

	x		= lpVKp->Win.x;
	y		= lpVKp->Win.y;
	width		= lpVKp->Win.width;
	height		= lpVKp->Win.height;
	start_w		= lpVKp->Don.x;
	start_h		= lpVKp->Don.y;
	step_w		= lpVKp->Don.width;
	step_h		= lpVKp->Don.height;
	min_w		= lpVKp->Win.width
			- lpVKp->Don.width  * (col - MIN_CAND_COL);
	min_h		= lpVKp->Win.height
			- lpVKp->Don.height * (row - MIN_CAND_ROW);

	ResizeKohoOutline (
		client->koho_window,
		lpVWin->XorGC,
		pos,
		&x, &y, &width, &height,
		start_w, start_h,
		step_w, step_h,
		min_w, min_h
	);

	i	= col + (width - lpVKp->Win.width) / step_w;
	if (i > MAX_CAND_COL) {
		col	= MAX_CAND_COL;
	} else if (i > 0) {
		col	= i;
	}
	i	= row + (height - lpVKp->Win.height) / step_h;
	if (i > MAX_CAND_ROW) {
		row	= MAX_CAND_ROW;
	} else if (i > 0) {
		row	= i;
	}

	SetVKpCanMtx (client, col, row, len);

	cur	= 0;
	while (cur	= GetClient (cur)) {
		if (cur->bdata.wMainStage & PRC_DON) {
			FuncKohoMax (cur, col, row);
		}
	}

	KohoWindowClose (client);
	KohoWindowOpen (client);
	KohoWindowDisplay (client);

	CallSaveVjeEnv (client, ENV_POS, 0);

	XDefineCursor (display, client->koho_window, GetVcurVal (CUR_NM));
}

/*=============================================================================
	StatusButtonClick
	ơɽɥǥޥå줿ν
	⡼ɽʬξϲ줿Υ⡼ɤѹ
=============================================================================*/
void	StatusButtonClick
(
	FXim_Client	*client,
	LPVWIN		lpVWin
)
{
	BOOL		rc	= FALSE;
	KD		kd;
	LPVSPLT		lpVSplt;
	int		pos;

	lpVSplt		= (LPVSPLT )GetVSplt (lpVWin);
	pos		= lpVSplt->wBtnPos;

	InitKD (&kd);
	kd.wFunc	= lpVSplt->wBtnFunc[pos];

	if (focus_in_client) {
		if (PreFuncHandler (client, &kd)) {
			FuncHandler (client, &kd);
			PostFuncHandler (client, &kd);
			VJEDisplayPut (client);
		}
	}

	if (pos != lpVSplt->wBtnPosRoot) {
		lpVSplt->wBtnMode	= STS_BTN_MODE_NML;
		lpVSplt->wBtnPos	= lpVSplt->wBtnPosRoot;
		DrawStatusPalette (client, lpVWin);
	}
	lpVSplt->wBtnMode	= STS_BTN_MODE_POP;
	lpVSplt->wBtnPos	= pos;
	DrawStatusPalette (client, lpVWin);
	DrawStatusButton  (client, lpVWin);

	if (pos == lpVSplt->wBtnPosRoot) {
		StatusWindowVisible (client);
	}

	if (GetSaveFuncID (client, kd.wFunc)) {
		CallSaveVjeEnv (client, ENV_MODE, kd.wFunc);
	}

	return;
}

/*=============================================================================
	StatusWindowMotion
	ơɽɥ
	ޥưν
=============================================================================*/
void	StatusWindowMotion
(
	XEvent	*event
)
{
	LPVWIN	lpVWin;
	LPVSPLT	lpVSplt;
	int	pos;
	BOOL	rc;

	lpVWin	= (LPVWIN  )GetVWin ();
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);

	rc	= CheckPopUpMenuMode (lpVWin);
	if (rc) {
		PopUpMenuMotion (event, lpVWin);
		return;
	}

	pos	= VJEGetPositionStatus (
			lpVWin,
			event->xmotion.x,
			event->xmotion.y
		);

	if (pos == WIN_TOP
	 || pos == WIN_BOTTOM) {
		XDefineCursor (
			display,
			root_client->window,
			GetVcurVal (CUR_TB)
		);
	} else if (pos == WIN_LEFT
	        || pos == WIN_RIGHT) {
		XDefineCursor (
			display,
			root_client->window,
			GetVcurVal (CUR_LR)
		);
	} else if (pos == WIN_UPPER_LEFT) {
		XDefineCursor (
			display,
			root_client->window,
			GetVcurVal (CUR_TL)
		);
	} else if (pos == WIN_LOWER_LEFT) {
		XDefineCursor (
			display,
			root_client->window,
			GetVcurVal (CUR_BL)
		);
	} else if (pos == WIN_UPPER_RIGHT) {
		XDefineCursor (
			display,
			root_client->window,
			GetVcurVal (CUR_TR)
		);
	} else if (pos == WIN_LOWER_RIGHT) {
		XDefineCursor (
			display,
			root_client->window,
			GetVcurVal (CUR_BR)
		);
	} else {
		XDefineCursor (
			display,
			root_client->window,
			GetVcurVal (CUR_NM)
		);
	}

#if 1 /* 991215:MOVE-WINDOW */
	if (event->xmotion.state & Button1Mask) {
		if (pos == WIN_TOP
		 || pos == WIN_BOTTOM
		 || pos == WIN_LEFT
		 || pos == WIN_RIGHT
		 || pos == WIN_UPPER_LEFT
		 || pos == WIN_LOWER_LEFT
		 || pos == WIN_UPPER_RIGHT
		 || pos == WIN_LOWER_RIGHT) {
			return;
		} else {
#if 1 /* 20000217 MOVE-WINDOW */
			if (abs (lpVSplt->XButton.x
				 - event->xmotion.x) > MOVE_MIN
			 || abs (lpVSplt->XButton.y
				 - event->xmotion.y) > MOVE_MIN) {
				MoveStatusWindow (lpVWin);
			}
#else
			MoveStatusWindow (lpVWin);
#endif
			return;
		}
	}
#endif

	if (!IsScreenMode (current_client)) {
		if (pos != lpVSplt->wBtnPosRoot) {
			PopUpHelpEnd (lpVWin);
			DrawStatusButtonInit  (current_client, lpVWin);
			return;
		}
	}

	if (!(0 <= pos && pos < lpVSplt->wBtnCount)) {
		PopUpHelpEnd (lpVWin);
		DrawStatusButtonInit  (current_client, lpVWin);
		return;
	}

#if 0 /* 991215:MOVE-WINDOW */
	if (event->xmotion.state & Button1Mask) {
		lpVSplt->wBtnMode	= STS_BTN_MODE_PSH;
		lpVSplt->wBtnPos	= pos;
		DrawStatusButton  (current_client, lpVWin);
		return;
	}
#endif

	lpVSplt->wBtnMode	= STS_BTN_MODE_POP;
	lpVSplt->wBtnPos	= pos;
	DrawStatusButton  (current_client, lpVWin);
	if (lpVWin->PopUpHelpPos == pos) {
		return;
	}

	PopUpHelpEnd (lpVWin);

	PopUpStartTimeID= XtAppAddTimeOut (
				appContext,
				POPUP_HELP_START_TIME,
				(XtTimerCallbackProc )PopUpHelpStart,
				(XPointer )pos
			);
}

/*=============================================================================
	StatusWindowRelease
	ơɽɥ
	ޥΥ줿ν
=============================================================================*/
void	StatusWindowRelease
(
	XEvent	*event
)
{
	LPVWIN	lpVWin;
	LPVSPLT	lpVSplt;
	int	pos;
	BOOL	rc;

	lpVWin	= (LPVWIN  )GetVWin ();
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);

	rc	= CheckPopUpMenuMode (lpVWin);
	if (rc) {
		PopUpMenuReleaseEnd (event, lpVWin);
		return;
	} else {
		rc	= PopUpMenuReleaseStart (event, lpVWin);
		if (rc) {
			return;
		}
	}

	XRaiseWindow (display, root_client->window);

	if (event->xbutton.button != Button1) {
		return;
	}

#if 0 /* 20000217 MOVE-WINDOW */
	if (MoveTimeID != 0) {
		XtRemoveTimeOut (MoveTimeID);
	}
#endif

	pos	= VJEGetPositionStatus (
			lpVWin,
			event->xbutton.x,
			event->xbutton.y
		);

	if (!IsScreenMode (current_client)) {
		if (pos != lpVSplt->wBtnPosRoot) {
			return;
		}
	}

	if (0 <= pos && pos < lpVSplt->wBtnCount) {
		lpVSplt->wBtnPos	= pos;
		StatusButtonClick (current_client, lpVWin);
	}
}

/*=============================================================================
	StatusWindowPress
	ơɽɥ
	ޥ줿ν
=============================================================================*/
void	StatusWindowPress
(
	XEvent	*event
)
{
	LPVWIN	lpVWin;
	LPVSPLT	lpVSplt;
	int	pos;
	BOOL	rc;

	lpVWin	= (LPVWIN  )GetVWin ();
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);

	rc	= CheckPopUpMenuMode (lpVWin);
	if (rc) {
		return;
	}

	if (event->xbutton.button != Button1) {
		return;
	}

	PopUpHelpEnd (lpVWin);

#if 0 /* 20000217 MOVE-WINDOW */
	if (MoveTimeID != 0) {
		XtRemoveTimeOut (MoveTimeID);
	}
	MoveTimeID	= XtAppAddTimeOut (
				appContext,
				MOVE_TIME,
				(XtTimerCallbackProc )MoveStatusWindow,
				(XPointer )lpVWin
			);
#endif

	pos	= VJEGetPositionStatus (
			lpVWin,
			event->xbutton.x,
			event->xbutton.y
		);

#if 1 /* 20000217 MOVE-WINDOW */
	lpVSplt->XButton.x	= event->xbutton.x;
	lpVSplt->XButton.y	= event->xbutton.y;
#endif

	if (pos == WIN_TOP
	 || pos == WIN_BOTTOM
	 || pos == WIN_LEFT
	 || pos == WIN_RIGHT
	 || pos == WIN_UPPER_LEFT
	 || pos == WIN_LOWER_LEFT
	 || pos == WIN_UPPER_RIGHT
	 || pos == WIN_LOWER_RIGHT) {
		if (pos == WIN_UPPER_LEFT
		 || pos == WIN_LOWER_LEFT) {
			pos	= WIN_LEFT;
		} else if (pos == WIN_UPPER_RIGHT
			|| pos == WIN_LOWER_RIGHT) {
			pos	= WIN_RIGHT;
		}
		ResizeStatusWindow (lpVWin, pos);
		return;
	}

	if (!IsScreenMode (current_client)) {
		if (pos != lpVSplt->wBtnPosRoot) {
			return;
		}
	}

	if (0 <= pos && pos < lpVSplt->wBtnCount) {
		lpVSplt->wBtnMode	= STS_BTN_MODE_PSH;
		lpVSplt->wBtnPos	= pos;
		DrawStatusPalette (current_client, lpVWin);
		DrawStatusButton  (current_client, lpVWin);
	}

}

/*=============================================================================
	StatusWindowLeave
	ơɽɥ
	ޥν
=============================================================================*/
void	StatusWindowLeave ()
{
	LPVWIN	lpVWin;
	LPVSPLT	lpVSplt;
	Window	root, child;
	int	root_x, root_y, win_x, win_y;
	UINT	keys_buttons;
	int	pos;

	lpVWin	= (LPVWIN  )GetVWin ();
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);

	XQueryPointer (
		display,
		root_client->window,
		&root, &child,
		&root_x, &root_y,
		&win_x, &win_y,
		&keys_buttons
	);
	if (!((0 <= win_x && win_x < lpVWin->StatusR.width)
	 &&   (0 <= win_y && win_y < lpVWin->StatusR.height))) {
		/* root_client->window Leave */
		lpVSplt->wBtnMode	= STS_BTN_MODE_NML;

		PopUpHelpEnd (lpVWin);
#if 0 /* 20000217 MOVE-WINDOW */
		if (MoveTimeID != 0) {
			XtRemoveTimeOut (MoveTimeID);
		}
#endif
	} else {
		/* root_client->window Release */
		lpVSplt->wBtnMode	= STS_BTN_MODE_POP;
	}

	RedisplayStatusWindowFrame ();
	RedisplayStatusWindow ();
}

/*=============================================================================
	PreeditWindowPress
	̤ʸϥɥ
	ޥ줿ν
=============================================================================*/
void	PreeditWindowPress
(
	XEvent	*event
)
{
}

/*=============================================================================
	PreeditRootWindowMotion
	ңϣϣ̤ʸϥɥ
	ޥưν
=============================================================================*/
void	PreeditRootWindowMotion
(
	XEvent	*event
)
{
	LPVWIN	lpVWin;
	int	pos;

	lpVWin	= (LPVWIN  )GetVWin ();

	pos	= VJEGetPositionPreeditRoot (
			lpVWin,
			event->xmotion.x,
			event->xmotion.y
		);

	if (pos == WIN_LEFT
	 || pos == WIN_RIGHT) {
		XDefineCursor (
			display,
			WPreeditR,
			GetVcurVal (CUR_LR)
		);
	} else {
		XDefineCursor (
			display,
			WPreeditR,
			GetVcurVal (CUR_NM)
		);
	}

#if 1 /* 991215:MOVE-WINDOW */
	if (event->xmotion.state & Button1Mask) {
		if (pos == WIN_LEFT
		 || pos == WIN_RIGHT) {
			return;
		} else {
			MovePreeditRootWindow (lpVWin);
			return;
		}
	}
#endif
}

/*=============================================================================
	PreeditRootWindowRelease
	ңϣϣ̤ʸϥɥ
	ޥΥ줿ν
=============================================================================*/
void	PreeditRootWindowRelease
(
	XEvent	*event
)
{
	XRaiseWindow (display, WPreeditR);

	if (event->xbutton.button != Button1) {
		return;
	}

#if 0 /* 20000217 MOVE-WINDOW */
	if (MoveTimeID != 0) {
		XtRemoveTimeOut (MoveTimeID);
	}
#endif
}

/*=============================================================================
	PreeditRootWindowPress
	ңϣϣ̤ʸϥɥ
	ޥ줿ν
=============================================================================*/
void	PreeditRootWindowPress
(
	XEvent	*event
)
{
	LPVWIN	lpVWin;
	int	pos;

	lpVWin	= (LPVWIN  )GetVWin ();

	if (!(current_client->bdata.wMainStage & PRC_EMP)) {
		return;
	}

	if (event->xbutton.button != Button1) {
		return;
	}

#if 0 /* 20000217 MOVE-WINDOW */
	if (MoveTimeID != 0) {
		XtRemoveTimeOut (MoveTimeID);
	}
	MoveTimeID	= XtAppAddTimeOut (
				appContext,
				MOVE_TIME,
				(XtTimerCallbackProc )MovePreeditRootWindow,
				(XPointer )lpVWin
			);
#endif

	pos	= VJEGetPositionPreeditRoot (
			lpVWin,
			event->xbutton.x,
			event->xbutton.y
		);

	if (pos == WIN_LEFT
	 || pos == WIN_RIGHT) {
		ResizePreeditRootWindow (lpVWin, pos);
		return;
	}
}

/*=============================================================================
	PreeditRootWindowLeave
	ңϣϣ̤ʸϥɥ
	ޥν
=============================================================================*/
void	PreeditRootWindowLeave ()
{
#if 0 /* 20000217 MOVE-WINDOW */
	if (MoveTimeID != 0) {
		XtRemoveTimeOut (MoveTimeID);
	}
#endif
}

/*=============================================================================
	KohoHScrPtrStart
=============================================================================*/
void	KohoHScrPtrStart
(
	FXim_Client	*client
)
{
	LPVWIN		lpVWin;
	LPVSPLT		lpVSplt;
	LPVKP		lpVKp;
	XEvent		event;
	KD		kd;
	Window		root, child;
	int		root_x, root_y;
	int		win_x, win_y;
	UINT		keys_buttons;
	int		tmp_x, tmp_y;
	int		tmp_w, tmp_h;
	int		pos;
	int		rc;

	lpVWin		= (LPVWIN  )GetVWin ();
	lpVSplt		= (LPVSPLT )GetVSplt (lpVWin);
	lpVKp		= (LPVKP   )GetVKp (client);

	tmp_x		= lpVKp->HScr.x
			+ lpVKp->HScr.height;
	tmp_w		= lpVKp->HScr.width
			- lpVKp->HScr.height * 2;

	InitKD (&kd);

	for (;;) {
		XMaskEvent (
			display,
			ButtonReleaseMask
			| PointerMotionMask,
			&event
		);
		if (event.type != MotionNotify) {
			break;
		}
		XQueryPointer (
			display, client->koho_window,
			&root, &child, &root_x, &root_y,
			&win_x, &win_y, &keys_buttons
		);
		pos	= VJEGetPositionKoho (client, lpVWin, win_x, win_y);
		if (win_x < tmp_x || tmp_x + tmp_w < win_x) {
			continue;
		}
		pos	= GetKohoHScrPageNo (client, tmp_x, tmp_w, win_x);
		if (pos == lpVKp->HScrCurPage
		 || pos  > lpVKp->HScrAllPage) {
			continue;
		} else {
			lpVKp->HScrCurPage	= pos;
		}
		lpVKp->DrawFlag	= VKP_DRAW_HSCR;
		VJEDisplayPut (client);
	}
}

/*=============================================================================
	KohoHScrBarStart
=============================================================================*/
void	KohoHScrBarStart
(
	FXim_Client	*client
)
{
	void		SetKohoHScrBarTimer (FXim_Client *, int);
	LPVWIN		lpVWin;
	LPVSPLT		lpVSplt;
	LPVKP		lpVKp;
	GC		*gc;
	int		x, y;
	int		pos;

	lpVWin		= (LPVWIN  )GetVWin ();
	lpVSplt		= (LPVSPLT )GetVSplt (lpVWin);
	lpVKp		= (LPVKP   )GetVKp (client);
	lpVKp->DrawFlag	= VKP_DRAW_HSCR;

	x		= lpVKp->XButton.x;
	y		= lpVKp->XButton.y;
	pos		= lpVKp->PressPos;
	gc		= lpVWin->GCList;

	if (pos == WIN_KOHO_HSCR_ARW_LEFT
	 || pos == WIN_KOHO_HSCR_ARW_RIGHT) {
		if (pos == WIN_KOHO_HSCR_ARW_LEFT) {
			if (lpVKp->HScrCurPage > 1) {
				lpVKp->HScrCurPage--;
			}
		} else {
			if (lpVKp->HScrCurPage < lpVKp->HScrAllPage) {
				lpVKp->HScrCurPage++;
			}
		}
		VJEDisplayPut (client);
		if (!ChKohoHScr (client)) {
			if (ScrTimeID != 0) {
				XtRemoveTimeOut (ScrTimeID);
			}
			return;
		}
		DrawKohoHScrArw (client, lpVWin, pos);
		SetKohoHScrBarTimer (client, HSCR_TIME_NEXT);
		return;
	}

	if (pos == WIN_KOHO_HSCR_BAR_LEFT
	 || pos == WIN_KOHO_HSCR_BAR_RIGHT) {
		pos	= VJEGetPositionKoho (client, lpVWin, x, y);
		if (pos == WIN_KOHO_HSCR_BAR_LEFT) {
			if (lpVKp->HScrCurPage > 1) {
				lpVKp->HScrCurPage--;
			}
		} else if (pos == WIN_KOHO_HSCR_BAR_RIGHT) {
			if (lpVKp->HScrCurPage < lpVKp->HScrAllPage) {
				lpVKp->HScrCurPage++;
			}
		} else {
			if (ScrTimeID != 0) {
				XtRemoveTimeOut (ScrTimeID);
			}
			return;
		}
		VJEDisplayPut (client);
		SetKohoHScrBarTimer (client, HSCR_TIME_NEXT);
		return;
	}
}

/*=============================================================================
	SetKohoHScrBarTimer
=============================================================================*/
void	SetKohoHScrBarTimer
(
	FXim_Client	*client,
	int		timer
)
{
	if (ScrTimeID != 0) {
		XtRemoveTimeOut (ScrTimeID);
	}
	ScrTimeID	= XtAppAddTimeOut (
				appContext,
				timer,
				(XtTimerCallbackProc )KohoHScrBarStart,
				(XPointer )client
			);
}

/*=============================================================================
	KohoVScrPtrStart
=============================================================================*/
void	KohoVScrPtrStart
(
	FXim_Client	*client
)
{
	LPVWIN		lpVWin;
	LPVSPLT		lpVSplt;
	LPVKP		lpVKp;
	XEvent		event;
	KD		kd;
	Window		root, child;
	int		root_x, root_y;
	int		win_x, win_y;
	UINT		keys_buttons;
	int		tmp_x, tmp_y;
	int		tmp_w, tmp_h;
	int		pos;
	int		rc;

	lpVWin		= (LPVWIN  )GetVWin ();
	lpVSplt		= (LPVSPLT )GetVSplt (lpVWin);
	lpVKp		= (LPVKP   )GetVKp (client);

	tmp_y		= lpVKp->VScr.y
			+ lpVKp->VScr.width;
	tmp_h		= lpVKp->VScr.height
			- lpVKp->VScr.width * 2;

	InitKD (&kd);

	for (;;) {
		XMaskEvent (
			display,
			ButtonReleaseMask
			| PointerMotionMask,
			&event
		);
		if (event.type != MotionNotify) {
			break;
		}
		XQueryPointer (
			display, client->koho_window,
			&root, &child, &root_x, &root_y,
			&win_x, &win_y, &keys_buttons
		);
		pos	= VJEGetPositionKoho (client, lpVWin, win_x, win_y);
		if (win_y < tmp_y || tmp_y + tmp_h < win_y) {
			continue;
		}
		pos	= GetKohoVScrPageNo (client, tmp_y, tmp_h, win_y);
		if (pos == lpVKp->VScrCurPage
		 || pos  > lpVKp->VScrAllPage) {
			continue;
		} else if (pos < lpVKp->VScrCurPage) {
			kd.lFuncOption	= lpVKp->VScrCurPage - pos;
			kd.wFunc	= F_EX_CNV_BBLK;
		} else {
			kd.lFuncOption	= pos - lpVKp->VScrCurPage;
			kd.wFunc	= F_EX_CNV_NBLK;
		}
		lpVKp->DrawFlag	= VKP_DRAW_VSCR;
		FuncHandler (client, &kd);
		VJEDisplayPut (client);
	}
}

/*=============================================================================
	KohoVScrBarStart
=============================================================================*/
void	KohoVScrBarStart
(
	FXim_Client	*client
)
{
	void		SetKohoVScrBarTimer (FXim_Client *, int);
	LPVWIN		lpVWin;
	LPVSPLT		lpVSplt;
	LPVKP		lpVKp;
	KD		kd;
	GC		*gc;
	int		tmp_x, tmp_y;
	int		tmp_w, tmp_h;
	int		x, y;
	int		pos;


	lpVWin		= (LPVWIN  )GetVWin ();
	lpVSplt		= (LPVSPLT )GetVSplt (lpVWin);
	lpVKp		= (LPVKP   )GetVKp (client);
	lpVKp->DrawFlag	= VKP_DRAW_VSCR;

	x		= lpVKp->XButton.x;
	y		= lpVKp->XButton.y;
	pos		= lpVKp->PressPos;
	gc		= lpVWin->GCList;

	InitKD (&kd);
	if (pos == WIN_KOHO_VSCR_ARW_PREV
	 || pos == WIN_KOHO_VSCR_ARW_NEXT) {
		if (pos == WIN_KOHO_VSCR_ARW_PREV) {
			kd.wFunc	= F_CNV_BBLK;
		} else {
			kd.wFunc	= F_CNV_NBLK;
		}
		FuncHandler (client, &kd);
		VJEDisplayPut (client);
		if (!ChKohoVScr (client)) {
			if (ScrTimeID != 0) {
				XtRemoveTimeOut (ScrTimeID);
			}
			return;
		}
		DrawKohoVScrArw (client, lpVWin, pos);
		SetKohoVScrBarTimer (client, VSCR_TIME_NEXT);
		return;
	}

	if (pos == WIN_KOHO_VSCR_BAR_PREV
	 || pos == WIN_KOHO_VSCR_BAR_NEXT) {
		pos	= VJEGetPositionKoho (client, lpVWin, x, y);
		if (pos == WIN_KOHO_VSCR_BAR_PREV) {
			kd.wFunc	= F_CNV_BBLK;
		} else if (pos == WIN_KOHO_VSCR_BAR_NEXT) {
			kd.wFunc	= F_CNV_NBLK;
		} else {
			if (ScrTimeID != 0) {
				XtRemoveTimeOut (ScrTimeID);
			}
			return;
		}
		FuncHandler (client, &kd);
		VJEDisplayPut (client);
		SetKohoVScrBarTimer (client, VSCR_TIME_NEXT);
		return;
	}
}

/*=============================================================================
	SetKohoVScrBarTimer
=============================================================================*/
void	SetKohoVScrBarTimer
(
	FXim_Client	*client,
	int		timer
)
{
	if (ScrTimeID != 0) {
		XtRemoveTimeOut (ScrTimeID);
	}
	ScrTimeID	= XtAppAddTimeOut (
				appContext,
				timer,
				(XtTimerCallbackProc )KohoVScrBarStart,
				(XPointer )client
			);
}

/*=============================================================================
	KohoRelease
=============================================================================*/
void	KohoRelease
(
	FXim_Client	*client,
	LPVWIN		lpVWin
)
{
	LPVKP		lpVKp;
	LPVKPLT		lpVKplt;
	int		i;

	lpVKp		= (LPVKP   )GetVKp (client);
	lpVKplt		= (LPVKPLT )GetVKplt (lpVWin);

	/* Press */
	if (lpVKp->PressPos == WIN_KOHO_VSCR_ARW_PREV
	 || lpVKp->PressPos == WIN_KOHO_VSCR_ARW_NEXT) {
		if (ChKohoVScr (client)) {
			DrawKohoVScrArw (client, lpVWin, -1);
		}
	} else if (lpVKp->PressPos == WIN_KOHO_HSCR_ARW_LEFT
		|| lpVKp->PressPos == WIN_KOHO_HSCR_ARW_RIGHT) {
		if (ChKohoHScr (client)) {
			DrawKohoHScrArw (client, lpVWin, -1);
		}
	}

	/* Release */
	if (lpVKp->ReleasePos >= WIN_KOHO_ITEM_BASE) {
		;
	} else if (lpVKp->ReleasePos >= WIN_KOHO_BTN_BASE) {
		lpVKplt->wBtnPos	= lpVKp->ReleasePos
					- WIN_KOHO_BTN_BASE;
		switch (lpVKplt->wBtnFunc[lpVKplt->wBtnPos]) {
		case	F_EX_KOHO_SORT_TOP:
			DrawKohoBtn (client, lpVWin);
			for (i=0; i < lpVKplt->wBtnCount; i++) {
				if (lpVKplt->wBtnFunc[i] == F_EX_KOHO_SORT_END){
					lpVKplt->wBtnPos	= i;
					DrawKohoBtn (client, lpVWin);
					break;
				}
			}
			break;
		case	F_EX_KOHO_SORT_END:
			DrawKohoBtn (client, lpVWin);
			for (i=0; i < lpVKplt->wBtnCount; i++) {
				if (lpVKplt->wBtnFunc[i] == F_EX_KOHO_SORT_TOP){
					lpVKplt->wBtnPos	= i;
					DrawKohoBtn (client, lpVWin);
					break;
				}
			}
			break;
		default:
			DrawKohoBtn (client, lpVWin);
			break;
		}
	}
}

/*=============================================================================
	KohoPress
=============================================================================*/
void	KohoPress
(
	FXim_Client	*client,
	LPVWIN		lpVWin
)
{
	LPVKP		lpVKp;

	lpVKp		= (LPVKP   )GetVKp (client);

	/* Press */
	if (lpVKp->PressPos == WIN_KOHO_VSCR_ARW_PREV
	 || lpVKp->PressPos == WIN_KOHO_VSCR_ARW_NEXT) {
		SetKohoVScrBarTimer (client, VSCR_TIME_FIRST);
		if (ChKohoVScr (client)) {
			DrawKohoVScrArw (client, lpVWin, lpVKp->PressPos);
		}
	} else if (lpVKp->PressPos == WIN_KOHO_HSCR_ARW_LEFT
		|| lpVKp->PressPos == WIN_KOHO_HSCR_ARW_RIGHT) {
		SetKohoHScrBarTimer (client, HSCR_TIME_FIRST);
		if (ChKohoHScr (client)) {
			DrawKohoHScrArw (client, lpVWin, lpVKp->PressPos);
		}
	} else if (lpVKp->PressPos == WIN_KOHO_VSCR_BAR_PREV
		|| lpVKp->PressPos == WIN_KOHO_VSCR_BAR_NEXT) {
		SetKohoVScrBarTimer (client, VSCR_TIME_FIRST);
	} else if (lpVKp->PressPos == WIN_KOHO_HSCR_BAR_LEFT
		|| lpVKp->PressPos == WIN_KOHO_HSCR_BAR_RIGHT) {
		SetKohoHScrBarTimer (client, HSCR_TIME_FIRST);
	} else if (lpVKp->PressPos == WIN_KOHO_VSCR_PTR) {
		KohoVScrPtrStart (client);
	} else if (lpVKp->PressPos == WIN_KOHO_HSCR_PTR) {
		KohoHScrPtrStart (client);
	}
}

/*=============================================================================
	KohoWindowMotion
	ɽɥ
	ޥưν
=============================================================================*/
void	KohoWindowMotion
(
	XEvent	*event
)
{
	LPVKP	lpVKp;
	LPVWIN	lpVWin;
	LPVSPLT	lpVSplt;
	int	pos;

	lpVKp	= (LPVKP   )GetVKp (current_client);
	lpVWin	= (LPVWIN  )GetVWin ();
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);

	if (lpVKp->DrawFlag != VKP_DRAW_NONE) {
		return;
	}

	pos	= VJEGetPositionKoho (
			current_client,
			lpVWin,
			event->xmotion.x,
			event->xmotion.y
		);

	if (pos != WIN_KOHO_VSCR_ARW_PREV
	 && pos != WIN_KOHO_VSCR_BAR_PREV
	 && pos != WIN_KOHO_VSCR_ARW_NEXT
	 && pos != WIN_KOHO_VSCR_BAR_NEXT
	 && pos != WIN_KOHO_VSCR_PTR
	 && pos != WIN_KOHO_HSCR_ARW_LEFT
	 && pos != WIN_KOHO_HSCR_BAR_LEFT
	 && pos != WIN_KOHO_HSCR_ARW_RIGHT
	 && pos != WIN_KOHO_HSCR_BAR_RIGHT
	 && pos != WIN_KOHO_HSCR_PTR) {
		if (ScrTimeID != 0) {
			XtRemoveTimeOut (ScrTimeID);
		}
	}

	if (pos == WIN_TOP
	 || pos == WIN_BOTTOM) {
		XDefineCursor (
			display,
			current_client->koho_window,
			GetVcurVal (CUR_TB)
		);
	} else if (pos == WIN_LEFT
	        || pos == WIN_RIGHT) {
		XDefineCursor (
			display,
			current_client->koho_window,
			GetVcurVal (CUR_LR)
		);
	} else if (pos == WIN_UPPER_LEFT) {
		XDefineCursor (
			display,
			current_client->koho_window,
			GetVcurVal (CUR_TL)
		);
	} else if (pos == WIN_LOWER_LEFT) {
		XDefineCursor (
			display,
			current_client->koho_window,
			GetVcurVal (CUR_BL)
		);
	} else if (pos == WIN_UPPER_RIGHT) {
		XDefineCursor (
			display,
			current_client->koho_window,
			GetVcurVal (CUR_TR)
		);
	} else if (pos == WIN_LOWER_RIGHT) {
		XDefineCursor (
			display,
			current_client->koho_window,
			GetVcurVal (CUR_BR)
		);
	} else {
		XDefineCursor (
			display,
			current_client->koho_window,
			GetVcurVal (CUR_NM)
		);
	}

	if (pos < WIN_KOHO_BTN_BASE) {
		PopUpHelpEnd (lpVWin);
		return;
	}
	if (pos >= WIN_KOHO_ITEM_BASE) {
		PopUpHelpEnd (lpVWin);
		return;
	}
	if (lpVWin->PopUpHelpPos == pos) {
		return;
	}
	PopUpHelpEnd (lpVWin);

	PopUpStartTimeID= XtAppAddTimeOut (
				appContext,
				POPUP_HELP_START_TIME,
				(XtTimerCallbackProc )PopUpHelpStart,
				(XPointer )pos
			);
}

/*=============================================================================
	KohoWindowRelease
	ɽɥ
	ޥΥ줿ν
=============================================================================*/
void	KohoWindowRelease
(
	XEvent	*event
)
{
	PBD	bdata;
	LPVKP	lpVKp;
	LPVWIN	lpVWin;
	LPVSPLT	lpVSplt;
	LPVKPLT	lpVKplt;
	KD	kd;
	int	pos;

	if (event->xbutton.button != Button1
	 && event->xbutton.button != Button3) {
		return;
	}

	bdata	= (PBD     )GetBDATA (current_client);
	lpVKp	= (LPVKP   )GetVKp (current_client);
	lpVWin	= (LPVWIN  )GetVWin ();
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);
	lpVKplt	= (LPVKPLT )GetVKplt (lpVWin);

	if (lpVKp->DrawFlag != VKP_DRAW_NONE) {
		lpVKp->DrawFlag	= VKP_DRAW_NONE;
		KohoRelease (current_client, lpVWin);
		return;
	}

	if (ScrTimeID != 0) {
		XtRemoveTimeOut (ScrTimeID);
	}

	InitKD (&kd);

	if (event->xbutton.button == Button3) {
		kd.wFunc	= F_RIGHT;
		FuncHandler (current_client, &kd);
		VJEDisplayPut (current_client);
		return;
	}

	pos	= VJEGetPositionKoho (
			current_client,
			lpVWin,
			event->xbutton.x,
			event->xbutton.y
		);

	lpVKp->XButton.x	= event->xbutton.x;
	lpVKp->XButton.y	= event->xbutton.y;
	lpVKp->ReleasePos	= pos;
	lpVKp->DrawFlag		= VKP_DRAW_NONE;

	if (pos == WIN_NONE) {
		KohoRelease (current_client, lpVWin);
		return;
	}

	if (pos == WIN_TOP
	 || pos == WIN_BOTTOM
	 || pos == WIN_LEFT
	 || pos == WIN_RIGHT
	 || pos == WIN_UPPER_LEFT
	 || pos == WIN_LOWER_LEFT
	 || pos == WIN_UPPER_RIGHT
	 || pos == WIN_LOWER_RIGHT) {
		KohoRelease (current_client, lpVWin);
		return;
	}

	if (pos == WIN_KOHO_HSCR_ARW_LEFT
	 || pos == WIN_KOHO_HSCR_BAR_LEFT) {
		if (lpVKp->HScrCurPage > 1) {
			lpVKp->HScrCurPage--;
		}
		lpVKp->DrawFlag	= VKP_DRAW_HSCR;
		VJEDisplayPut (current_client);
		KohoRelease (current_client, lpVWin);
		return;
	}

	if (pos == WIN_KOHO_HSCR_ARW_RIGHT
	 || pos == WIN_KOHO_HSCR_BAR_RIGHT) {
		if (lpVKp->HScrCurPage < lpVKp->HScrAllPage) {
			lpVKp->HScrCurPage++;
		}
		lpVKp->DrawFlag	= VKP_DRAW_HSCR;
		VJEDisplayPut (current_client);
		KohoRelease (current_client, lpVWin);
		return;
	}

	if (pos == WIN_KOHO_HISTORY) {
		;
	} else if (pos == WIN_KOHO_VSCR_ARW_PREV
		|| pos == WIN_KOHO_VSCR_BAR_PREV) {
		kd.wFunc	= F_CNV_BBLK;
	} else if (pos == WIN_KOHO_VSCR_ARW_NEXT
		|| pos == WIN_KOHO_VSCR_BAR_NEXT) {
		kd.wFunc	= F_CNV_NBLK;
	} else if (pos >= WIN_KOHO_ITEM_BASE) {
		kd.wFunc	= F_LB_SEL2;
		kd.wOrgChar	= pos
				- WIN_KOHO_ITEM_BASE
				+ bdata->cLBItemPageFirst;
	} else if (pos >= WIN_KOHO_BTN_BASE) {
		kd.wFunc	= lpVKplt->wBtnFunc[pos - WIN_KOHO_BTN_BASE];
		lpVKp->DrawFlag	= VKP_DRAW_DON_ALL;
	} else {
		KohoRelease (current_client, lpVWin);
		return;
	}

	FuncHandler (current_client, &kd);
	VJEDisplayPut (current_client);
	KohoRelease (current_client, lpVWin);
}

/*=============================================================================
	KohoWindowPress
	ɽɥ
	ޥ줿Ȥν
=============================================================================*/
void	KohoWindowPress
(
	XEvent	*event
)
{
	LPVWIN	lpVWin;
	LPVSPLT	lpVSplt;
	LPVKP	lpVKp;
	int	pos;

	if (event->xbutton.button != Button1) {
		return;
	}

	lpVWin	= (LPVWIN  )GetVWin ();
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);
	lpVKp	= (LPVKP   )GetVKp (current_client);

	PopUpHelpEnd (lpVWin);

	pos	= VJEGetPositionKoho (
			current_client,
			lpVWin,
			event->xbutton.x,
			event->xbutton.y
		);

	lpVKp->XButton.x	= event->xbutton.x;
	lpVKp->XButton.y	= event->xbutton.y;
	lpVKp->PressPos		= pos;
	lpVKp->DrawFlag		= VKP_DRAW_NONE;

	if (pos == WIN_NONE) {
		return;
	}

	if (pos == WIN_TOP
	 || pos == WIN_BOTTOM
	 || pos == WIN_LEFT
	 || pos == WIN_RIGHT
	 || pos == WIN_UPPER_LEFT
	 || pos == WIN_LOWER_LEFT
	 || pos == WIN_UPPER_RIGHT
	 || pos == WIN_LOWER_RIGHT) {
		ResizeKohoWindow (current_client, lpVWin, pos);
		return;
	}

	KohoPress (current_client, lpVWin);
}

/*=============================================================================
	KohoWindowLeave
	ɽɥ
	ޥν
=============================================================================*/
void	KohoWindowLeave ()
{
	LPVWIN	lpVWin;

	lpVWin	= (LPVWIN  )GetVWin ();

	PopUpHelpEnd (lpVWin);
}

