/******************************************************************************
	Xstatus.C
******************************************************************************/
#include	"typedef.h"
#include	"xvje.h"
#include	"xim.h"
#include	"xui.h"
#include	"macro.h"
#include	"fileio.h"
#include	"env.h"
#include	"getstr.h"
#include	"strutl.h"

/*=============================================================================
	VjeHenkanReset
=============================================================================*/
int	VjeHenkanReset ()
{
	current_client->reverse_colums = current_client->last_colums;
#if 0
	current_client->convert_count = 1;
#endif
	if (current_client != root_client
	 && current_client->prot_type == FPRT_XIM) {
		XimResetSendBuffByLength (
			current_client->window,
			current_client->output_buff,
			current_client->reverse_colums);
		sleep (0);
	}
	current_client->last_colums = 0;
	current_client->reverse_colums = 0;
	current_client->current_colums = 0;
	current_client->input_flag = FINF_MODY;

	DisplayOutputBuff ();

	return (0);
}

/*=============================================================================
	VjeChangeMode
=============================================================================*/
int	VjeChangeMode
(
	int	key_type
)
{
	int	changeMode = 0;

#if 1 /* 20000301:OPEN-VJE */
	OpenVJE (current_client);
#endif

	switch (key_type) {
	case VJE_ONOFF:
		ChangeHenkanMode ((current_client->henkan_mode == 0)? 1: 0);
		current_client->bdata.wVkey = F_SCRN;
		BasicEdit (current_client->v_data, &current_client->bdata);
		changeMode = 1;
		break;
	case VJE_ON:
		if (current_client->henkan_mode == 0) {
			current_client->henkan_mode = 1;
			current_client->bdata.wVkey = F_SCRN;
			BasicEdit (current_client->v_data,
				&current_client->bdata);
			changeMode = 1;
		}
		break;
	case VJE_OFF:
		if (current_client->henkan_mode == 1) {
			current_client->henkan_mode = 0;
			current_client->bdata.wVkey = F_SCRN;
			BasicEdit (current_client->v_data,
				&current_client->bdata);
			changeMode = 1;
		}
		break;
	case VJE_HIDE:
		if (current_client->henkan_mode == 1) {
			current_client->henkan_mode = 0;
			current_client->bdata.wVkey = F_SCRN;
			BasicEdit (current_client->v_data,
				&current_client->bdata);
			current_client->henkan_mode2 = 1;
			changeMode = 1;
		} else {
			current_client->henkan_mode2 = 0;
		}
		break;
	case VJE_RECOVER:
		if (current_client->henkan_mode !=
			current_client->henkan_mode2) { 
			ChangeHenkanMode (
				(current_client->henkan_mode == 0)? 1: 0);
			current_client->bdata.wVkey = F_SCRN;
			BasicEdit (current_client->v_data,
				&current_client->bdata);
			current_client->henkan_mode2 =
				current_client->henkan_mode;
			changeMode = 1;
		}
		break;
	case VJE_ROMA:
		if (current_client->bdata.wVjeModeFlag & KATA_BIT) {
			current_client->bdata.wVkey = F_ROM;
			BasicEdit (current_client->v_data,
				&current_client->bdata);
			changeMode = 1;
		}
		break;
	case VJE_KANA:
		if (!(current_client->bdata.wVjeModeFlag & KATA_BIT)) {
			current_client->bdata.wVkey = F_ROM;
			BasicEdit (current_client->v_data,
				&current_client->bdata);
			changeMode = 1;
		}
		break;
	case VJE_HIRAGANA:
		current_client->bdata.wVkey = F_HIRA;
		BasicEdit(current_client->v_data,&current_client->bdata);
		changeMode = 1;
		break;
	case VJE_KATAKANA:
		current_client->bdata.wVkey = F_KATA;
		BasicEdit(current_client->v_data,&current_client->bdata);
		changeMode = 1;
		break;
	case VJE_EISUU:
		current_client->bdata.wVkey = F_EISUU;
		BasicEdit(current_client->v_data,&current_client->bdata);
		changeMode = 1;
		break;
	}
	if (changeMode) {
		DisplayStatus (current_client);
	}
	return (0);
}

/*=============================================================================
	ChangeHenkanMode
=============================================================================*/
int	ChangeHenkanMode
(
	int	mode
)
{
	if (mode == 0) {
		current_client->henkan_mode = 0;
		UnsetFocusClient (1);
	} else {
		current_client->henkan_mode = 1;
		SetFocusClient (1);
	}
	return (0);
}

/*=============================================================================
	GetMaxStatusMessageLength
=============================================================================*/
#if PCUNIX
#define MAX_STATUS_MSG   8
#else
#define MAX_STATUS_MSG  12
#endif
int	GetMaxStatusMessageLength
(
	FXim_Client	*work_client
)
{
	return (MAX_STATUS_MSG);
}

/*=============================================================================
	GetStatusMessage
=============================================================================*/
int	GetStatusMessage
(
	FXim_Client	*work_client,
	char		*status_message,
	char		*status_attrib/*990222 OnTheSpot:StatusWithAttributes*/
)
{
	UCHAR	*sf_msg;
	char	work_msg[STATUS_MESSAGE_LENGTH];/*990222*/
	char	work_msg2[STATUS_MESSAGE_LENGTH];/*990222*/
	char	*work;
	int	i;

	if (((focus_in_client == work_client) ||
	     (work_client->style & XIMStatusArea))
	 && (work_client->henkan_mode != 0)) {
		work_client->bdata.lpchMode[work_client->bdata.cchMode] = 0;
		strcpy (work_msg2, work_client->bdata.lpchMode);
		sf_msg = (UCHAR *)work_msg2;
		/*990222 OnTheSpot:StatusWithAttributes*/
		for (i=0;i<strlen(sf_msg);i++)
			status_attrib[i] = work_client->bdata.lpattrMode[i];
	} else {
		sf_msg = (UCHAR *)"VJE-OFF ";
		/*990222 OnTheSpot:StatusWithAttributes*/
		for (i=0;i<strlen(sf_msg);i++)
			status_attrib[i] = 0;
	}
	sprintf (work_msg, "%s", sf_msg);
	strcpy (status_message, work_msg);
	return (strlen (work_msg));
}

/*=============================================================================
	SetMaxRect
=============================================================================*/
BOOL	SetMaxRect
(
	short	x1,
	short	y1,
	short	w1,
	short	h1,
	short	x2,
	short	y2,
	short	w2,
	short	h2
)
{
	LPVWIN	lpVWin;

	lpVWin				= (LPVWIN  )GetVWin ();
	lpVWin->StatusRMax.x		= x1;
	lpVWin->StatusRMax.y		= y1;
	lpVWin->StatusRMax.width	= w1;
	lpVWin->StatusRMax.height	= h1;
	lpVWin->StatusMMax.x		= x2;
	lpVWin->StatusMMax.y		= y2;
	lpVWin->StatusMMax.width	= w2;
	lpVWin->StatusMMax.height	= h2;
}

/*=============================================================================
	SetMinRect
=============================================================================*/
BOOL	SetMinRect
(
	short	x1,
	short	y1,
	short	w1,
	short	h1,
	short	x2,
	short	y2,
	short	w2,
	short	h2
)
{
	LPVWIN	lpVWin;

	lpVWin				= (LPVWIN  )GetVWin ();
	lpVWin->StatusRMin.x		= x1;
	lpVWin->StatusRMin.y		= y1;
	lpVWin->StatusRMin.width	= w1;
	lpVWin->StatusRMin.height	= h1;
	lpVWin->StatusMMin.x		= x2;
	lpVWin->StatusMMin.y		= y2;
	lpVWin->StatusMMin.width	= w2;
	lpVWin->StatusMMin.height	= h2;
}

/*=============================================================================
	SetCurRect
=============================================================================*/
BOOL	SetCurRect
(
	short	x1,
	short	y1,
	short	w1,
	short	h1,
	short	x2,
	short	y2,
	short	w2,
	short	h2
)
{
	LPVWIN	lpVWin;

	lpVWin				= (LPVWIN  )GetVWin ();
	lpVWin->StatusR.x		= x1;
	lpVWin->StatusR.y		= y1;
	lpVWin->StatusR.width		= w1;
	lpVWin->StatusR.height		= h1;
	lpVWin->StatusM.x		= x2;
	lpVWin->StatusM.y		= y2;
	lpVWin->StatusM.width		= w2;
	lpVWin->StatusM.height		= h2;
}

/*=============================================================================
	GetMaxRect
=============================================================================*/
BOOL	GetMaxRect
(
	short	*x1,
	short	*y1,
	short	*w1,
	short	*h1,
	short	*x2,
	short	*y2,
	short	*w2,
	short	*h2
)
{
	LPVWIN	lpVWin;

	lpVWin	= (LPVWIN  )GetVWin ();
	*x1	= lpVWin->StatusRMax.x;
	*y1	= lpVWin->StatusRMax.y;
	*w1	= lpVWin->StatusRMax.width;
	*h1	= lpVWin->StatusRMax.height;
	*x2	= lpVWin->StatusMMax.x;
	*y2	= lpVWin->StatusMMax.y;
	*w2	= lpVWin->StatusMMax.width;
	*h2	= lpVWin->StatusMMax.height;
}

/*=============================================================================
	GetMinRect
=============================================================================*/
BOOL	GetMinRect
(
	short	*x1,
	short	*y1,
	short	*w1,
	short	*h1,
	short	*x2,
	short	*y2,
	short	*w2,
	short	*h2
)
{
	LPVWIN	lpVWin;

	lpVWin	= (LPVWIN  )GetVWin ();
	*x1	= lpVWin->StatusRMin.x;
	*y1	= lpVWin->StatusRMin.y;
	*w1	= lpVWin->StatusRMin.width;
	*h1	= lpVWin->StatusRMin.height;
	*x2	= lpVWin->StatusMMin.x;
	*y2	= lpVWin->StatusMMin.y;
	*w2	= lpVWin->StatusMMin.width;
	*h2	= lpVWin->StatusMMin.height;
}

/*=============================================================================
	GetCurRect
=============================================================================*/
BOOL	GetCurRect
(
	short	*x1,
	short	*y1,
	short	*w1,
	short	*h1,
	short	*x2,
	short	*y2,
	short	*w2,
	short	*h2
)
{
	LPVWIN	lpVWin;

	lpVWin	= (LPVWIN  )GetVWin ();
	*x1	= lpVWin->StatusR.x;
	*y1	= lpVWin->StatusR.y;
	*w1	= lpVWin->StatusR.width;
	*h1	= lpVWin->StatusR.height;
	*x2	= lpVWin->StatusM.x;
	*y2	= lpVWin->StatusM.y;
	*w2	= lpVWin->StatusM.width;
	*h2	= lpVWin->StatusM.height;
}

/*=============================================================================
	Locate
=============================================================================*/
BOOL	Locate
(
	short	org_x,
	short	org_y,
	short	org_w,
	short	org_h,
	short	*new_x,
	short	*new_y,
	short	new_w,
	short	new_h
)
{
	short	root_w, root_h;

	root_w	= DisplayWidth  (display, screen);
	root_h	= DisplayHeight (display, screen);

	if (org_x < root_w - (org_x + org_w)) {
		if (org_x + new_w > root_w) {
			*new_x	= root_w
				- new_w;
		} else {
			*new_x	= org_x;
		}
	} else {
		*new_x	= org_x
			+ org_w
			- new_w;
		if (*new_x < 0) {
			*new_x	= 0;
		}
	}
	if (org_y < root_h - (org_y + org_h)) {
		if (org_y + new_h > root_h) {
			*new_y	= root_h
				- new_h;
		} else {
			*new_y	= org_y;
		}
	} else {
		*new_y	= org_y
			+ org_h
			- new_h;
		if (*new_y < 0) {
			*new_y	= 0;
		}
	}
}

/*=============================================================================
	CalcRect
=============================================================================*/
BOOL	CalcRect
(
	LPVSPLT	lpVSpltNew,
	short	*x1,
	short	*y1,
	short	*w1,
	short	*h1,
	short	*x2,
	short	*y2,
	short	*w2,
	short	*h2
)
{
	short	root_w, root_h;
	short	org_x, org_y, org_w, org_h;
	short	tmp_x, tmp_y, tmp_w, tmp_h;
	short	wstart, wend, wstep;
	short	hstart, hend, hstep;
	BOOL	rc;

	root_w	= DisplayWidth  (display, screen);
	root_h	= DisplayHeight (display, screen);

	org_x	= tmp_x = *x1;
	org_y	= tmp_y = *y1;
	org_w	= tmp_w = *w1;
	org_h	= tmp_h	= *h1;

	tmp_w	= lpVSpltNew->wBtnCol
		* (lpVSpltNew->wBtnSize + DRAW_STATUS_WINDOW_BUTTON_BORDER)
		+ DRAW_STATUS_WINDOW_BUTTON_BORDER
		+ DRAW_STATUS_WINDOW_BORDER * 2
		+ DRAW_STATUS_WINDOW_TITLE_WIDTH;
	tmp_h	= lpVSpltNew->wBtnRow
		* (lpVSpltNew->wBtnSize + DRAW_STATUS_WINDOW_BUTTON_BORDER)
		+ DRAW_STATUS_WINDOW_BUTTON_BORDER
		+ DRAW_STATUS_WINDOW_BORDER * 2;
	if (tmp_w > root_w) {
		tmp_w	= root_w;
		tmp_h	= root_h;
	}

	rc	= CalcVSpltBtn (lpVSpltNew, &tmp_w, &tmp_h);
	if (!rc) {
		wstart	= tmp_w
			+ lpVSpltNew->wBtnSize
			+ DRAW_STATUS_WINDOW_BUTTON_BORDER;
		wend	= root_w;
		wstep	= lpVSpltNew->wBtnSize
			+ DRAW_STATUS_WINDOW_BUTTON_BORDER;
		hstart	= root_h;
		hend	= root_h;
		hstep	= root_h;
		rc	= CalcVSpltBtnItr (
				lpVSpltNew, ITR_WI,
				wstart, wend, wstep,
				hstart, hend, hstep,
				&tmp_w, &tmp_h
			);
		if (!rc) {
			return (FALSE);
		}
	}

	rc	= CreateVSpltBtn (lpVSpltNew, &tmp_w, &tmp_h);
	if (!rc) {
		return (FALSE);
	}

	Locate (
		org_x, org_y, org_w, org_h,
		&tmp_x, &tmp_y, tmp_w, tmp_h
	);

	*x1	= tmp_x;
	*y1	= tmp_y;
	*w1	= tmp_w;
	*h1	= tmp_h;

	*w2	= tmp_w
		- DRAW_STATUS_WINDOW_BORDER * 2
		- DRAW_STATUS_WINDOW_TITLE_WIDTH;
	*h2	= tmp_h
		- DRAW_STATUS_WINDOW_BORDER * 2;

	return (TRUE);
}

/*=============================================================================
	MaximizeStatusWindow
=============================================================================*/
BOOL	MaximizeStatusWindow
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	LPVSPLT		lpVSplt
)
{
	VSPLT	tmpVSplt;
	short	max_x1, max_y1, max_w1, max_h1;
	short	max_x2, max_y2, max_w2, max_h2;
	short	min_x1, min_y1, min_w1, min_h1;
	short	min_x2, min_y2, min_w2, min_h2;
	int	i, rc;


	lmemcpy ((char *)&tmpVSplt, (char *)lpVSplt, sizeof (VSPLT));

	GetMaxRect (
		&max_x1, &max_y1, &max_w1, &max_h1,
		&max_x2, &max_y2, &max_w2, &max_h2
	);

	ToVSpltMaxBtn (lpVSplt);

	rc = CreateVSpltPixBtnBuff (lpVSplt, max_w1, max_h1);
	if (!rc) {
		lmemcpy ((char *)lpVSplt, (char *)&tmpVSplt, sizeof (VSPLT));
		return (FALSE);
	}

	SetCurRect (
		max_x1, max_y1, max_w1, max_h1,
		max_x2, max_y2, max_w2, max_h2
	);

	XMoveResizeWindow (
		display,
		root_client->window,
		max_x1, max_y1, max_w1, max_h1
	);
	XMoveResizeWindow (
		display,
		root_client->status_window,
		max_x2, max_y2, max_w2, max_h2
	);

	DisplayStatusWindow (client);

	lpVWin->StatusWinType = STATUS_WINDOW_TYPE_MAX;

	/**/
	GetMinRect (
		&min_x1, &min_y1, &min_w1, &min_h1,
		&min_x2, &min_y2, &min_w2, &min_h2
	);
	if ((max_x1 == min_x1 || max_x1 + max_w1 == min_x1 + min_w1)
	 && (max_y1 == min_y1 || max_y1 + max_h1 == min_y1 + min_h1)) {
		;
	} else {
		Locate (
			max_x1, max_y1, max_w1, max_h1,
			&min_x1, &min_y1, min_w1, min_h1
		);
		SetMinRect (
			min_x1, min_y1, min_w1, min_h1,
			min_x2, min_y2, min_w2, min_h2
		);
	}
	/**/

	return (TRUE);
}

/*=============================================================================
	MinimizeStatusWindow
=============================================================================*/
BOOL	MinimizeStatusWindow
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	LPVSPLT		lpVSplt
)
{
	VSPLT	tmpVSplt;
	short	min_x1, min_y1, min_w1, min_h1;
	short	min_x2, min_y2, min_w2, min_h2;
	int	rc;

	lmemcpy ((char *)&tmpVSplt, (char *)lpVSplt, sizeof (VSPLT));

	GetMinRect (
		&min_x1, &min_y1, &min_w1, &min_h1,
		&min_x2, &min_y2, &min_w2, &min_h2
	);

	ToVSpltMinBtn (lpVSplt);

	rc = CreateVSpltPixBtnBuff (lpVSplt, min_w1, min_h1);
	if (!rc) {
		lmemcpy ((char *)lpVSplt, (char *)&tmpVSplt, sizeof (VSPLT));
		return (FALSE);
	}

	SetCurRect (
		min_x1, min_y1, min_w1, min_h1,
		min_x2, min_y2, min_w2, min_h2
	);

	XMoveResizeWindow (
		display,
		root_client->window,
		min_x1, min_y1, min_w1, min_h1
	);
	XMoveResizeWindow (
		display,
		root_client->status_window,
		min_x2, min_y2, min_w2, min_h2
	);

	DisplayStatusWindow (client);

	lpVWin->StatusWinType = STATUS_WINDOW_TYPE_MIN;

	return (TRUE);
}

/*=============================================================================
	StatusWindowVisible
=============================================================================*/
void	StatusWindowVisible
(
	FXim_Client	*client
)
{
	LPVWIN	lpVWin;
	LPVSPLT	lpVSplt;
	BOOL	rc;
	
	lpVWin	= (LPVWIN  )GetVWin ();
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);

	if (IsScreenMode (client)
	 || lpVSplt->wOffStatus == STS_BTN_OFF_NML) {
		if (lpVWin->StatusWinType != STATUS_WINDOW_TYPE_MAX) {
			MaximizeStatusWindow (client, lpVWin, lpVSplt);
		}
	} else if (lpVSplt->wOffStatus == STS_BTN_OFF_MIN) {
		if (lpVWin->StatusWinType != STATUS_WINDOW_TYPE_MIN) {
			MinimizeStatusWindow (client, lpVWin, lpVSplt);
		}
	}

	DisplayStatus (client);

	if (IsScreenMode (client)
	 || lpVSplt->wOffStatus != STS_BTN_OFF_HID) {
		XMapWindow (display, root_client->window);
		XMapRaised (display, root_client->status_window);
		client->status_visible = 1;
	} else {
		XUnmapWindow (display, root_client->window);
		XUnmapWindow (display, root_client->status_window);
		client->status_visible = 0;
	}

	/*990520:StatusArea Raise up*/
	if (client->style & XIMStatusArea) {
		XMapRaised (display, client->status_window);
	}
}

/*=============================================================================
	ChangeStatusWindowVisible
=============================================================================*/
void	ChangeStatusWindowVisible
(
	FXim_Client	*client,
	short		sOffSts
)
{
	LPVWIN	lpVWin;
	LPVSPLT	lpVSplt;
	
	lpVWin	= (LPVWIN  )GetVWin ();
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);

	lpVSplt->wOffStatus = sOffSts;

	StatusWindowVisible (client);

	CallSaveVjeEnv (client, ENV_POS, 0);

	return;
}

/*=============================================================================
	ChangeStatusWindowButton
=============================================================================*/
void	ChangeStatusWindowButton
(
	FXim_Client	*client,
	short		size,
	short		color
)
{
	LPVWIN	lpVWin;
	LPVSPLT	lpVSplt;
	VSPLT	tmpVSpltOld;
	VSPLT	tmpVSpltMin;
	VSPLT	tmpVSpltMax;
	short	org_max_x1, org_max_y1, org_max_w1, org_max_h1;
	short	org_max_x2, org_max_y2, org_max_w2, org_max_h2;
	short	org_min_x1, org_min_y1, org_min_w1, org_min_h1;
	short	org_min_x2, org_min_y2, org_min_w2, org_min_h2;
	short	new_max_x1, new_max_y1, new_max_w1, new_max_h1;
	short	new_max_x2, new_max_y2, new_max_w2, new_max_h2;
	short	new_min_x1, new_min_y1, new_min_w1, new_min_h1;
	short	new_min_x2, new_min_y2, new_min_w2, new_min_h2;
	BOOL	rc;

	lpVWin	= (LPVWIN  )GetVWin ();
	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);

	lmemcpy ((char *)&tmpVSpltOld, (char *)lpVSplt, sizeof (VSPLT));

	lpVSplt->wBtnSize = size;
	lpVSplt->wBtnType = color;

	lmemcpy ((char *)&tmpVSpltMin, (char *)lpVSplt, sizeof (VSPLT));
	lmemcpy ((char *)&tmpVSpltMax, (char *)lpVSplt, sizeof (VSPLT));

	GetMaxRect (
		&org_max_x1, &org_max_y1, &org_max_w1, &org_max_h1,
		&org_max_x2, &org_max_y2, &org_max_w2, &org_max_h2
	);
	GetMaxRect (
		&new_max_x1, &new_max_y1, &new_max_w1, &new_max_h1,
		&new_max_x2, &new_max_y2, &new_max_w2, &new_max_h2
	);
	ToVSpltMaxBtn (&tmpVSpltMax);
	CalcRect (
		&tmpVSpltMax,
		&new_max_x1, &new_max_y1, &new_max_w1, &new_max_h1,
		&new_max_x2, &new_max_y2, &new_max_w2, &new_max_h2
	);
	SaveVSpltMaxBtn (&tmpVSpltMax);
	GetMinRect (
		&org_min_x1, &org_min_y1, &org_min_w1, &org_min_h1,
		&org_min_x2, &org_min_y2, &org_min_w2, &org_min_h2
	);
	GetMinRect (
		&new_min_x1, &new_min_y1, &new_min_w1, &new_min_h1,
		&new_min_x2, &new_min_y2, &new_min_w2, &new_min_h2
	);
	ToVSpltMinBtn (&tmpVSpltMin);
	CalcRect (
		&tmpVSpltMin,
		&new_min_x1, &new_min_y1, &new_min_w1, &new_min_h1,
		&new_min_x2, &new_min_y2, &new_min_w2, &new_min_h2
	);

	if (lpVWin->StatusWinType == STATUS_WINDOW_TYPE_MIN) {
		Locate (
			new_min_x1, new_min_y1, new_min_w1, new_min_h1,
			&new_max_x1, &new_max_y1, new_max_w1, new_max_h1
		);
	} else {
		Locate (
			new_max_x1, new_max_y1, new_max_w1, new_max_h1,
			&new_min_x1, &new_min_y1, new_min_w1, new_min_h1
		);
	}

	rc	= CreateVSpltPixBtnList (&tmpVSpltMax);
	if (!rc) {
		lmemcpy ((char *)lpVSplt, (char *)&tmpVSpltOld, sizeof (VSPLT));
		return;
	}

	SetMaxRect (
		new_max_x1, new_max_y1, new_max_w1, new_max_h1,
		new_max_x2, new_max_y2, new_max_w2, new_max_h2
	);
	SetMinRect (
		new_min_x1, new_min_y1, new_min_w1, new_min_h1,
		new_min_x2, new_min_y2, new_min_w2, new_min_h2
	);

	if (lpVWin->StatusWinType == STATUS_WINDOW_TYPE_MIN) {
		rc	= MinimizeStatusWindow (client, lpVWin, &tmpVSpltMax);
	} else {
		rc	= MaximizeStatusWindow (client, lpVWin, &tmpVSpltMax);
	}

	if (!rc) {
		SetMaxRect (
			org_max_x1, org_max_y1, org_max_w1, org_max_h1,
			org_max_x2, org_max_y2, org_max_w2, org_max_h2
		);
		SetMinRect (
			org_min_x1, org_min_y1, org_min_w1, org_min_h1,
			org_min_x2, org_min_y2, org_min_w2, org_min_h2
		);
		lmemcpy ((char *)lpVSplt, (char *)&tmpVSpltOld, sizeof (VSPLT));
		return;
	}

	lmemcpy ((char *)lpVSplt, (char *)&tmpVSpltMax, sizeof (VSPLT));

	CallSaveVjeEnv (client, ENV_POS, 0);

	return;
}

/*=============================================================================
	InitStatusWindow
=============================================================================*/
BOOL	InitStatusWindow
(
	LPVSPLT	lpVSplt,
	LPENV	lpEnv
)
{
	short	root_w, root_h, min_w;
	short	org_x, org_y, org_w, org_h;
	short	max_x1, max_y1, max_w1, max_h1;
	short	max_x2, max_y2, max_w2, max_h2;
	short	min_x1, min_y1, min_w1, min_h1;
	short	min_x2, min_y2, min_w2, min_h2;
	BOOL	rc;


	root_w	= DisplayWidth  (display, screen);
	root_h	= DisplayHeight (display, screen);

	/*---------------------------------------------------------------------
		StatusR
	---------------------------------------------------------------------*/
	org_x	= max_x1	= lpEnv->win[0].rStatus.x;
	org_y	= max_y1	= lpEnv->win[0].rStatus.y;
	org_w	= max_w1	= lpEnv->win[0].rStatus.w;
	org_h	= max_h1	= lpEnv->win[0].rStatus.h;

	rc	= CreateVSpltPixBtnList (lpVSplt);
	if (!rc) {
		return (FALSE);
	}

	rc	= CalcVSpltBtn (lpVSplt, &max_w1, &max_h1);
	if (!rc) {
		/* retry */
		max_w1 = root_w;
		max_h1 = root_h;
		rc	= CalcVSpltBtn (lpVSplt, &max_w1, &max_h1);
		if (!rc) {
			return (FALSE);
		}
	}

	rc	= CreateVSpltBtn (lpVSplt, &max_w1, &max_h1);
	if (!rc) {
		return (FALSE);
	}

	rc	= CreateVSpltPixBtnBuff (lpVSplt, max_w1, max_h1);
	if (!rc) {
		return (FALSE);
	}

	SaveVSpltMaxBtn (lpVSplt);

	if (org_w <= 0) {
		max_x1	= root_w - max_w1;
	} else if (org_x >= 0 && org_x + max_w1 <= root_w) {
		max_x1	= org_x;
	} else {
		max_x1	= root_w - max_w1;
	}
	if (org_h <= 0) {
		max_y1	= root_h - max_h1;
	} else if (org_y >= 0 && org_y + max_h1 <= root_h) {
		max_y1	= org_y;
	} else {
		max_y1	= root_h - max_h1;
	}

	max_h2			= max_h1
				- DRAW_STATUS_WINDOW_BORDER * 2;
	max_w2			= max_w1
				- DRAW_STATUS_WINDOW_BORDER * 2
				- DRAW_STATUS_WINDOW_TITLE_WIDTH;
	max_y2			= DRAW_STATUS_WINDOW_BORDER;
	max_x2			= DRAW_STATUS_WINDOW_BORDER;

	min_w1	= min_h1	= lpVSplt->wBtnSize
				+ DRAW_STATUS_WINDOW_BUTTON_BORDER * 2
				+ DRAW_STATUS_WINDOW_BORDER * 2
				+ DRAW_STATUS_WINDOW_TITLE_WIDTH;
	min_x1			= max_x1;
	min_y1			= max_y1;

	min_w2	= min_h2	= lpVSplt->wBtnSize
				+ DRAW_STATUS_WINDOW_BUTTON_BORDER * 2;
	min_x2			= DRAW_STATUS_WINDOW_BORDER;
	min_y2			= DRAW_STATUS_WINDOW_BORDER;

	SetCurRect (
		max_x1, max_y1, max_w1, max_h1,
		max_x2, max_y2, max_w2, max_h2
	);

	SetMaxRect (
		max_x1, max_y1, max_w1, max_h1,
		max_x2, max_y2, max_w2, max_h2
	);
	Locate (
		max_x1, max_y1, max_w1, max_h1,
		&min_x1, &min_y1, min_w1, min_h1
	);
	SetMinRect (
		min_x1, min_y1, min_w1, min_h1,
		min_x2, min_y2, min_w2, min_h2
	);

	return (TRUE);
}

