/******************************************************************************
	Xui.C
******************************************************************************/
#define		XGRAB_SERVER	1
#define		XK_KATAKANA
#include	<X11/keysym.h>
#include	<X11/cursorfont.h>
#include	"typedef.h"
#include	"xim.h"
#include	"xui.h"
#if !USE_XPM
#include	"xpixmap.h"
#else
#include	<X11/xpm.h>
#endif
#include	"macro.h"
#include	"fileio.h"
#include	"env.h"
#include	"getstr.h"
#include	"strutl.h"
#include	"getvcode.h"


/*=============================================================================
	Global	Data
=============================================================================*/
int	C_Key_Count	= 0;
ULONG	C_Key[3 * KANJI_KEY_MAX];
ULONG	C_Key_Status[MAX_FCASE] =
{
	0,
	ShiftMask,
	ControlMask,
	AlterMask,
	ControlMask | ShiftMask,
	ControlMask | AlterMask,
	AlterMask   | ShiftMask,
	ControlMask | AlterMask   | ShiftMask
};

/*=============================================================================
	Local	Data
=============================================================================*/
#include	"cbtnxo.h"
#include	"c20btnxo.xpm"
#include	"c12btnxo.xpm"
#include	"m20btnxo.xpm"
#include	"m12btnxo.xpm"
#include	"candbtn.xpm"

static	VCLR	VClr[] =
{
/*00*/	{NO, {0L,255,128,128,(char )0,(char )0}},
	{NO, {0L,255,255,232,(char )0,(char )0}}, /* light yellow ? */
	{NO, {0L,128,255,128,(char )0,(char )0}},
	{NO, {0L,  0,255,128,(char )0,(char )0}},
	{NO, {0L,128,255,255,(char )0,(char )0}},
	{NO, {0L,  0,128,255,(char )0,(char )0}},
	{NO, {0L,255,128,192,(char )0,(char )0}},
	{NO, {0L,255,128,255,(char )0,(char )0}},
/*08*/	{NO, {0L,255,  0,  0,(char )0,(char )0}}, /* red     */
	{NO, {0L,255,255,128,(char )0,(char )0}},
	{NO, {0L,128,255,  0,(char )0,(char )0}},
	{NO, {0L,  0,255, 64,(char )0,(char )0}},
	{NO, {0L,  0,255,255,(char )0,(char )0}}, /* cyan    */
	{NO, {0L,  0,128,192,(char )0,(char )0}},
	{NO, {0L,128,128,192,(char )0,(char )0}},
	{NO, {0L,255,  0,255,(char )0,(char )0}}, /* mazenta */
/*10*/	{NO, {0L,128, 64, 64,(char )0,(char )0}},
	{NO, {0L,255,255,  0,(char )0,(char )0}}, /* yellow  */
	{NO, {0L,  0,255,  0,(char )0,(char )0}}, /* green   */
	{NO, {0L,  0,128,128,(char )0,(char )0}},
	{NO, {0L,  0, 64,128,(char )0,(char )0}},
	{NO, {0L,128,128,255,(char )0,(char )0}},
	{NO, {0L,128,  0, 64,(char )0,(char )0}},
	{NO, {0L,255,  0,128,(char )0,(char )0}},
/*18*/	{NO, {0L,128,  0,  0,(char )0,(char )0}},
	{NO, {0L,255,128,  0,(char )0,(char )0}},
	{NO, {0L,  0,128,  0,(char )0,(char )0}},
	{NO, {0L,  0,128, 64,(char )0,(char )0}},
	{NO, {0L,  0,  0,255,(char )0,(char )0}}, /* blue    */
	{NO, {0L,  0,  0,160,(char )0,(char )0}},
	{NO, {0L,128,  0,128,(char )0,(char )0}},
	{NO, {0L,128,  0,255,(char )0,(char )0}},
/*20*/	{NO, {0L, 64,  0,  0,(char )0,(char )0}},
	{NO, {0L,128, 64,  0,(char )0,(char )0}},
	{NO, {0L,  0, 64,  0,(char )0,(char )0}},
	{NO, {0L,  0, 64, 64,(char )0,(char )0}},
	{NO, {0L,  0,  0,128,(char )0,(char )0}},
	{NO, {0L,  0,  0, 64,(char )0,(char )0}},
	{NO, {0L, 64,  0, 64,(char )0,(char )0}},
	{NO, {0L, 64,  0,128,(char )0,(char )0}},
/*28*/	{NO, {0L,  0,  0,  0,(char )0,(char )0}}, /* black   */
	{NO, {0L,128,128,  0,(char )0,(char )0}},
	{NO, {0L,128,128, 64,(char )0,(char )0}},
	{NO, {0L,128,128,128,(char )0,(char )0}},
	{NO, {0L, 64,128,128,(char )0,(char )0}},
	{NO, {0L,192,192,192,(char )0,(char )0}}, /* gray          */
	{NO, {0L,130,130,130,(char )0,(char )0}}, /* ticker_gray ? */
	{NO, {0L,255,255,255,(char )0,(char )0}}, /* white         */
};

static	VCUR	VCur[] =
{
	{NO, (Cursor )0, XC_top_left_arrow	},
	{NO, (Cursor )0, XC_fleur		},
	{NO, (Cursor )0, XC_sb_v_double_arrow	},
	{NO, (Cursor )0, XC_sb_h_double_arrow	},
	{NO, (Cursor )0, XC_top_left_corner	},
	{NO, (Cursor )0, XC_top_right_corner	},
	{NO, (Cursor )0, XC_bottom_left_corner	},
	{NO, (Cursor )0, XC_bottom_right_corner	},
};

static	VCMD	VCmd[] =
{
	/* func, file */
#if 1
#else
	{F_EX_HELP,	"vjehelp"	},
	{F_EX_UTY,	"vjeuty"	},
	{F_EX_VERSION,	"vjeversion"	},
	{F_EX_REGWORD,	"vjeregword"	},
	{F_EX_DELWORD,	"vjedelword"	},
	{F_EX_ENV,	"vjeenv"	},
#endif
};


/*=============================================================================
	Exec
=============================================================================*/
int	Exec
(
	char *command
)
{
extern	char	**environ;
	char	*argv[4];
	int	i, len, pid;
	int	rc;

	if (!command || !*command) {
		return (-1);
	}
#if 0
	rc = system (command);
	if (rc != 0) {
		return (-1);
	}
#else
	pid = fork ();
	if (pid == -1) {
		return (-1);
	}
	if (pid == 0) {
		i = 0;
		argv[i++] = "sh";
		argv[i++] = "-c";
		argv[i++] = command;
		argv[i++] = 0;
		execve ("/bin/sh", argv, environ);
		exit (127);
	}
#endif
	return (0);
}

/*=============================================================================
	SetTriggerKey
=============================================================================*/
void	SetTriggerKey ()
{
	LPENV	lpEnv;
	int	i, j, k;

	lpEnv	= (LPENV )GetEnv (0);
	
	C_Key_Count = 0;
	for (i=0; i < MAX_VK;    i++) {
	for (j=0; j < MAX_FCASE; j++) {
	for (k=0; k < MAX_STAGE; k++) {
		if (lpEnv->kbd.wVirtTable[i][j][k] == F_SCRN
		 || lpEnv->kbd.wVirtTable[i][j][k] == F_EX_KANJI_ON
		 || lpEnv->kbd.wVirtTable[i][j][k] == F_EX_KANJI_OFF
		 || lpEnv->kbd.wVirtTable[i][j][k] == F_EX_KANJI_OFF2) {
			C_Key[3 * C_Key_Count + 0]	= C_Key_Status[j];
			C_Key[3 * C_Key_Count + 1]	= ControlMask
							| AlterMask
							| ShiftMask;
			C_Key[3 * C_Key_Count + 2]	= ConvVK (i);
			if (++C_Key_Count >= KANJI_KEY_MAX) {
				return;
			}
		}
	}
	}
	}
}

/*=============================================================================
	IsStatusFontTypeAPL
=============================================================================*/
BOOL	IsStatusFontTypeAPL ()
{
	return (TRUE);
}

/*=============================================================================
	IsPreeditFontTypeAPL
=============================================================================*/
BOOL	IsPreeditFontTypeAPL ()
{
	LPENV	lpEnv;

	lpEnv	= (LPENV )GetEnv (0);
	return ((BOOL )((lpEnv->fnt[0].lf.wFontType == APP) ? TRUE : FALSE));
}

/*=============================================================================
	IsKohoFontTypeAPL
=============================================================================*/
BOOL	IsKohoFontTypeAPL ()
{
	LPENV	lpEnv;

	lpEnv	= (LPENV )GetEnv (0);
	return ((BOOL )((lpEnv->fnt[1].lf.wFontType == APP) ? TRUE : FALSE));
}

/*=============================================================================
	CheckVisual
=============================================================================*/
USHORT	CheckVisual ()
{
	USHORT		rc = VC_COLOR;
	Visual		*visual;
	int		depth;

	visual	= DefaultVisual (display, screen);
	depth	= DefaultDepth (display, screen);

	if (depth == 1) {
		rc	= VC_MONO;
	} else {
		switch (visual->class) {
		case GrayScale:
		case StaticGray:
			rc	= VC_GRAY;
			break;
		default:
			rc	= VC_COLOR;
			break;
		}
	}

	return (rc);
}

/*=============================================================================
	MakeBaseFontName
=============================================================================*/
char	*MakeBaseFontName
(
	char	*font_name1,
	char	*font_name2,
	char	*font_name3
)
{
	int	len = 0, no = 0;
	char	*base_font_name;
	char	*form, *name[3];

#define SET_NAME(font_name) \
	if (font_name && *font_name) { \
		len += strlen(font_name) + 1; \
		name[no++] = font_name; \
	}
	SET_NAME (font_name1);
	SET_NAME (font_name2);
	SET_NAME (font_name3);
#undef SET_NAME

	switch (no) {
	case 1: form = "%s";		break;
	case 2: form = "%s,%s";		break;
	case 3: form = "%s,%s,%s";	break;
	default:
		return (char *)0;
	}

	if (!(base_font_name = (char *)malloc(len))) {
		return (char *)0;
	}
	(void)sprintf (base_font_name, form, name[0], name[1], name[2]);

	return (base_font_name);
}

/*=============================================================================
	AllocSHColor
=============================================================================*/
int	AllocSHColor
(
	Display		*display,
	int		screen,
	Colormap	cmap,
	ULONG		base_pixel,
	ULONG		*shadow_pixel,
	ULONG		*higlight_pixel
)
{
	XColor		base, color;
	ULONG		rc;

	base.pixel	= base_pixel;
	XQueryColor (display, cmap, &base);

#define	Shadow(a)	(a / 2)
	color.red	= Shadow (base.red);
	color.green	= Shadow (base.green);
	color.blue	= Shadow (base.blue);
	color.flags	= DoRed | DoGreen | DoBlue;
	rc	= XAllocColor (display, cmap, &color);
	if (rc) {
		*shadow_pixel	= color.pixel;
	} else {
		*shadow_pixel	= BlackPixel (display, screen);
	}
#undef	Shadow
#define	Higlight(a)	(a + ((int)((65535 - a) * 2) / 3))
	color.red	= Higlight (base.red);
	color.green	= Higlight (base.green);
	color.blue	= Higlight (base.blue);
	color.flags	= DoRed | DoGreen | DoBlue;
	rc	= XAllocColor (display, cmap, &color);
	if (rc) {
		*higlight_pixel	= color.pixel;
	} else {
		*higlight_pixel	= WhitePixel (display, screen);
	}
#undef	Higlight
	return (0);
}

/*=============================================================================
	QueryColorDepth8
=============================================================================*/
BOOL	QueryColorDepth8
(
	Display		*display,
	int		screen,
	Colormap	cmap,
	XColor		*clr
)
{
	XColor		qc_tbl[MAX_CELLS];
	ULONG		qc_num;
	ULONG		qc_cel;
	ULONG		max_val, val;
	long		red, green, blue;
	int		i, index;

	qc_cel	= DisplayCells (display, screen);
	qc_num	= ((qc_cel > MAX_CELLS) ? MAX_CELLS : qc_cel);
	for (i=0; i < qc_num; i++) {
		qc_tbl[i].pixel	= (ULONG )i;
	}
	XQueryColors (display, cmap, qc_tbl, qc_num);

	index	= -1;
	max_val	= (MAX_CELLS - 1) * (MAX_CELLS - 1) * 3 + 1;
	for (i=0; i < qc_num; i++) {
		red	= (clr->red   / 257) - (qc_tbl[i].red   / 257);
		green	= (clr->green / 257) - (qc_tbl[i].green / 257);
		blue	= (clr->blue  / 257) - (qc_tbl[i].blue  / 257);
		val	= (red * red) + (green * green) + (blue * blue);
		if (val < max_val) {
			index	= i;
			max_val	= val;
		}
	}
	if (index == -1) {
		return (FALSE);
	}

	clr->red	= qc_tbl[index].red;
	clr->green	= qc_tbl[index].green;
	clr->blue	= qc_tbl[index].blue;
	clr->pixel	= qc_tbl[index].pixel;

	return (TRUE);
}

/*****************************************************************************/

/*=============================================================================
	GetVclrUse
=============================================================================*/
USHORT	GetVclrUse
(
	int	i
)
{
	return ((USHORT )VClr[i].usUse);
}

/*=============================================================================
	GetVclrPixel
=============================================================================*/
ULONG	GetVclrPixel
(
	int	i
)
{
	return ((ULONG )VClr[i].xColor.pixel);
}

/*=============================================================================
	SetVclrAttr
=============================================================================*/
void	SetVclrAttr
(
	Display		*d,
	GC		gc,
	unsigned int	attr,
	int		rev	/* 0=normal ,1=revers */
)
{
	LPENV	lpEnv;
	ULONG	ulForePixel,ulBackPixel;
	BYTE	bFore,bBack;

	lpEnv	= (LPENV )GetEnv (0);

	switch	(attr) {
	case	CL_INPUT:
		bFore	= LOBYTE (lpEnv->clr.wColChar);
		bBack	= HIBYTE (lpEnv->clr.wColChar);
		break;
	case	CL_HENKAN_1:
		bFore	= LOBYTE (lpEnv->clr.wColConvCur);
		bBack	= HIBYTE (lpEnv->clr.wColConvCur);
		break;
	case	CL_HENKAN_2:
		bFore	= LOBYTE (lpEnv->clr.wColConv);
		bBack	= HIBYTE (lpEnv->clr.wColConv);
		break;
	case	CL_EDIT:
		bFore	= LOBYTE (lpEnv->clr.wColEdit);
		bBack	= HIBYTE (lpEnv->clr.wColEdit);
		break;
	case	CL_HENKAN_3:
		bFore	= LOBYTE (lpEnv->clr.wColConvTemp);
		bBack	= HIBYTE (lpEnv->clr.wColConvTemp);
		break;
	case	CL_CSR:
	case	CL_CSR2:
		bFore	= LOBYTE (lpEnv->clr.wColCursor);
		bBack	= HIBYTE (lpEnv->clr.wColCursor);
		break;
	case	CL_EX_LIST:
		bFore	= LOBYTE (lpEnv->clr.wColList);
		bBack	= HIBYTE (lpEnv->clr.wColList);
		break;
	case	CL_EX_LISTCUR:
		bFore	= LOBYTE (lpEnv->clr.wColListCur);
		bBack	= HIBYTE (lpEnv->clr.wColListCur);
		break;
	case	CL_EX_POPHELP:
		bFore	= LOBYTE (lpEnv->clr.wColPopHelp);
		bBack	= HIBYTE (lpEnv->clr.wColPopHelp);
		break;
	case	CL_EX_BTN:
		bFore	= LOBYTE (lpEnv->clr.wColBtn);
		bBack	= HIBYTE (lpEnv->clr.wColBtn);
		break;
	case	CL_EX_KBD:
		bFore	= LOBYTE (lpEnv->clr.wColKbd);
		bBack	= HIBYTE (lpEnv->clr.wColKbd);
		break;
	case	CL_EX_FNC:
		bFore	= LOBYTE (lpEnv->clr.wColFnc);
		bBack	= HIBYTE (lpEnv->clr.wColFnc);
		break;
#if !PCUNIX
	case	CL_EX_BOX:
		bFore	= LOBYTE (lpEnv->clr.wColBox);
		bBack	= HIBYTE (lpEnv->clr.wColBox);
		break;
#endif /* !PCUNIX */
	default:
		bFore	= CLR_WHITE;				/*WHITE*/
		bBack	= CLR_BLACK;				/*BLACK*/
		break;
	}
	
	ulForePixel = GetVclrPixel (bFore);
	ulBackPixel = GetVclrPixel (bBack);

	if(rev) {/* revers */
		XSetForeground (d, gc, ulBackPixel);
		XSetBackground (d, gc, ulForePixel);
	} else {/* normal */
		XSetForeground (d, gc, ulForePixel);
		XSetBackground (d, gc, ulBackPixel);
	}
}

/*=============================================================================
	MakeVClr
=============================================================================*/
BOOL	MakeVClr
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	LPENV		lpEnv,
	LPENV		lpEnvO
)
{
static	USHORT		usUse[recof (VClr)];
	Colormap	cmap;
	int		depth;
	ULONG		white;
	ULONG		black;
	ULONG		rc;
	int		i;

#if XGRAB_SERVER
	XSync (display, 0);
	XGrabServer (display);
	XSync (display, 0);
#endif
	cmap	= DefaultColormap (display, screen);
	white	= WhitePixel (display, screen);
	black	= BlackPixel (display, screen);

	for (i=0; i < recof (VClr); i++) {
		usUse[i]	= NO;
	}

	usUse[CLR_WHITE]			= YES;
	usUse[CLR_BLACK]			= YES;

	usUse[CLR_WFORE]			= YES;
	usUse[CLR_WBACK]			= YES;
	usUse[CLR_WBDR ]			= YES;
	usUse[CLR_TFORE]			= YES;
	usUse[CLR_TBACK]			= YES;

	usUse[LOBYTE (lpEnv->clr.wColChar)]	= YES;
	usUse[HIBYTE (lpEnv->clr.wColChar)]	= YES;
	usUse[LOBYTE (lpEnv->clr.wColConvCur)]	= YES;
	usUse[HIBYTE (lpEnv->clr.wColConvCur)]	= YES;
	usUse[LOBYTE (lpEnv->clr.wColConv)]	= YES;
	usUse[HIBYTE (lpEnv->clr.wColConv)]	= YES;
	usUse[LOBYTE (lpEnv->clr.wColEdit)]	= YES;
	usUse[HIBYTE (lpEnv->clr.wColEdit)]	= YES;
	usUse[LOBYTE (lpEnv->clr.wColConvTemp)]	= YES;
	usUse[HIBYTE (lpEnv->clr.wColConvTemp)]	= YES;
	usUse[LOBYTE (lpEnv->clr.wColCursor)]	= YES;
	usUse[HIBYTE (lpEnv->clr.wColCursor)]	= YES;
	usUse[LOBYTE (lpEnv->clr.wColList)]	= YES;
	usUse[HIBYTE (lpEnv->clr.wColList)]	= YES;
	usUse[LOBYTE (lpEnv->clr.wColListCur)]	= YES;
	usUse[HIBYTE (lpEnv->clr.wColListCur)]	= YES;
	usUse[LOBYTE (lpEnv->clr.wColPopHelp)]	= YES;
	usUse[HIBYTE (lpEnv->clr.wColPopHelp)]	= YES;
	usUse[LOBYTE (lpEnv->clr.wColBtn)]	= YES;
	usUse[HIBYTE (lpEnv->clr.wColBtn)]	= YES;
	usUse[LOBYTE (lpEnv->clr.wColKbd)]	= YES;
	usUse[HIBYTE (lpEnv->clr.wColKbd)]	= YES;
	usUse[LOBYTE (lpEnv->clr.wColFnc)]	= YES;
	usUse[HIBYTE (lpEnv->clr.wColFnc)]	= YES;
#if !PCUNIX
	usUse[LOBYTE (lpEnv->clr.wColBox)]	= YES;
	usUse[HIBYTE (lpEnv->clr.wColBox)]	= YES;
#endif /* !PCUNIX */

	for (i=0; i < recof (VClr); i++) {
		if (usUse[i] == VClr[i].usUse) {
			;
		} else if (usUse[i] == YES) {
			VClr[i].usUse		= YES;
			VClr[i].xColor.red	*= 257; /* 65535/255 */
			VClr[i].xColor.green	*= 257;
			VClr[i].xColor.blue	*= 257;
			rc	= XAllocColor (
					display,
					cmap,
					&VClr[i].xColor
				);
			if (rc) {
				continue;
			}
			depth	= DefaultDepth (display, screen);
			if (depth > 8) {
				VClr[i].usUse		= NO;
				VClr[i].xColor.pixel	= white;
				continue;
			}
			rc	= QueryColorDepth8 (
					display,
					screen,
					cmap,
					&VClr[i].xColor
				);
			if (!rc) {
				VClr[i].usUse		= NO;
				VClr[i].xColor.pixel	= white;
				continue;
			}
			rc	= XAllocColor (
					display,
					cmap,
					&VClr[i].xColor
				);
			if (!rc) {
				VClr[i].usUse		= NO;
				VClr[i].xColor.pixel	= white;
				continue;
			}
		} else {
			VClr[i].usUse	= NO;
			XFreeColors (
				display,
				cmap,
				&VClr[i].xColor.pixel,
				1, 0
			);
		}
	}

#if XGRAB_SERVER
	XSync (display, 0);
	XUngrabServer (display);
	XSync (display, 0);
#endif
	return (TRUE);
}

/*=============================================================================
	GetVcurUse
=============================================================================*/
USHORT	GetVcurUse
(
	int	i
)
{
	return ((USHORT )VCur[i].usUse);
}

/*=============================================================================
	GetVcurVal
=============================================================================*/
Cursor	GetVcurVal
(
	SHORT	i
)
{
	return ((Cursor )VCur[i].cCursor);
}

/*=============================================================================
	MakeVCur
=============================================================================*/
BOOL	MakeVCur
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	LPENV		lpEnv,
	LPENV		lpEnvO
)
{
static	USHORT		usUse[recof (VCur)];
	short		i;

	for (i=0; i < recof (VCur); i++) {
		usUse[i]	= YES;
	}

	for (i=0; i < recof (VCur); i++) {
		if (usUse[i] == VCur[i].usUse) {
			;
		} else if (usUse[i] == YES) {
			VCur[i].usUse	= YES;
			VCur[i].cCursor	= XCreateFontCursor (
						display,
						VCur[i].usSymbol
					);
		} else {
			VCur[i].usUse	= NO;
			XFreeCursor (display, VCur[i].usSymbol);
		}
	}
	return (TRUE);
}

/*=============================================================================
	MakeVFnt
=============================================================================*/
BOOL	MakeVFnt
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	LPENV		lpEnv,
	LPENV		lpEnvO
)
{
	char	*status_font_name;
	char	*preedit_font_name;
	char	*koho_font_name;
	char	*base_font_name;
	ULONG	fore, back;
	int	rc;

	fore	= lpVWin->TextForePixel;
	back	= lpVWin->TextBackPixel;

	/*---------------------------------------------------------------------
		status	font
	---------------------------------------------------------------------*/
	status_font_name	=
		(char *)MakeBaseFontName (
			KANA14,
			KANJI14,
			(char *)0
		);
	if (!status_font_name) {
		return (FALSE);
	}

	if (client->status->FontName
	 && 0 == lstrcmp (status_font_name, client->status->FontName)) {
		XFree (status_font_name);
	} else {
		FXFreeFont (display, client->status_font);
		if (client->status->FontName) {
			XFree (client->status->FontName);
			client->status->FontName	= (char *)0;
		}
		rc	= FXLoadQueryBaseFont (
				display,
				client->status_font,
				status_font_name
			);
		if (rc < 0) {
			XFree (status_font_name);
			return (FALSE);
		}
		client->status->FontName	= status_font_name;
	}

	/*---------------------------------------------------------------------
		preedit	font
	---------------------------------------------------------------------*/
	preedit_font_name	=
		(char *)MakeBaseFontName (
			lpEnvO->fnt[0].lf.sztKanaName,
			lpEnvO->fnt[0].lf.sztKanjiName,
			(char *)0
		);
	if (!preedit_font_name) {
		return (FALSE);
	}

	if (client->preedit->FontName
	 && 0 == lstrcmp (preedit_font_name, client->preedit->FontName)) {
		XFree (preedit_font_name);
	} else {
		FXFreeFont (display, client->preedit_font);
		if (client->preedit->FontName) {
			XFree (client->preedit->FontName);
			client->preedit->FontName	= (char *)0;
		}
		rc	= FXLoadQueryBaseFont (
				display,
				client->preedit_font,
				preedit_font_name
			);
		if (rc < 0) {
			XFree (preedit_font_name);
			return (FALSE);
		}
		client->preedit->FontName	= preedit_font_name;
	}

	/*---------------------------------------------------------------------
		koho	font
	---------------------------------------------------------------------*/
	koho_font_name	=
		(char *)MakeBaseFontName (
			lpEnvO->fnt[1].lf.sztKanaName,
			lpEnvO->fnt[1].lf.sztKanjiName,
			(char *)0
		);
	if (!koho_font_name) {
		return (FALSE);
	}

	if (client->koho->FontName
	 && 0 == lstrcmp (koho_font_name, client->koho->FontName)) {
		XFree (koho_font_name);
	} else {
		FXFreeFont (display, client->koho_font);
		if (client->koho->FontName) {
			XFree (client->koho->FontName);
			client->koho->FontName	= (char *)0;
		}
		rc	= FXLoadQueryBaseFont (
				display,
				client->koho_font,
				koho_font_name
			);
		if (rc < 0) {
			XFree (koho_font_name);
			return (FALSE);
		}
		client->koho->FontName	= koho_font_name;
	}

	/*---------------------------------------------------------------------
		default	font
	---------------------------------------------------------------------*/
	base_font_name	=
		(char *)MakeBaseFontName (
			lpEnvO->fnt[2].lf.sztKanaName,
			lpEnvO->fnt[2].lf.sztKanjiName,
			(char *)0
		);
	if (!base_font_name) {
		return (FALSE);
	}

	if (lpVWin->BaseFontName
	 && 0 == lstrcmp (base_font_name, lpVWin->BaseFontName)) {
		XFree (base_font_name);
	} else {
		FXFreeFont (display, &lpVWin->BaseFont);
		if (lpVWin->BaseFontName) {
			XFree (lpVWin->BaseFontName);
			lpVWin->BaseFontName	= (char *)0;
		}
		rc	= FXLoadQueryBaseFont (
				display,
				&lpVWin->BaseFont,
				base_font_name
			);
		if (rc < 0) {
			XFree (base_font_name);
			return (FALSE);
		}
		lpVWin->BaseFontName	= base_font_name;
	}

	/*---------------------------------------------------------------------
		status	gc
	---------------------------------------------------------------------*/
	FXFreeGC (display, client->status_font);
	FXCreateGC (display, root, client->status_font, fore, back);

	/*---------------------------------------------------------------------
		preedit	gc
	---------------------------------------------------------------------*/
	FXFreeGC (display, client->preedit_font);
	FXCreateGC (display, root, client->preedit_font, fore, back);

	/*---------------------------------------------------------------------
		koho	gc
	---------------------------------------------------------------------*/
	FXFreeGC (display, client->koho_font);
	FXCreateGC (display, root, client->koho_font, fore, back);

	/*---------------------------------------------------------------------
		default	gc
	---------------------------------------------------------------------*/
	FXFreeGC (display, &lpVWin->BaseFont);
	FXCreateGC (display, root, &lpVWin->BaseFont, fore, back);

	return (TRUE);
}

/*=============================================================================
	GetVCmdFile
=============================================================================*/
LPTSTR	GetVCmdFile
(
	SHORT	i
)
{
	return ((LPTSTR )VCmd[i].lptFile);
}

/*=============================================================================
	GetVCmdFunc
=============================================================================*/
WORD	GetVCmdFunc
(
	SHORT	i
)
{
	return ((WORD )VCmd[i].wFunc);
}

/*=============================================================================
	VCmdFuncToIndex
=============================================================================*/
SHORT	VCmdFuncToIndex
(
	WORD	wFunc
)
{
	SHORT	i, j;

	for (i=0; i < recof (VCmd); i++) {
		if ((j = GetVCmdFunc (i)) == wFunc) {
			return ((SHORT )i);
		}
	}
	return ((SHORT )-1);
}

/*=============================================================================
	GetVWin
=============================================================================*/
LPVWIN	GetVWin ()
{
static	VWIN	vwin;
	return ((LPVWIN )&vwin);
}

/*=============================================================================
	GetVSplt
=============================================================================*/
LPVSPLT	GetVSplt
(
	LPVWIN	lpVWin
)
{
	return ((LPVSPLT )&lpVWin->vsplt);
}

/*=============================================================================
	GetVKplt
=============================================================================*/
LPVKPLT	GetVKplt
(
	LPVWIN	lpVWin
)
{
	return ((LPVKPLT )&lpVWin->vkplt);
}

/*=============================================================================
	GetVKbd
=============================================================================*/
LPVKBD	GetVKbd
(
	LPVWIN	lpVWin
)
{
	return ((LPVKBD )&lpVWin->vkbd);
}

/*=============================================================================
	EnvToVWin
=============================================================================*/
void	EnvToVWin
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	LPENV		lpEnv
)
{
	LPVSPLT		lpVSplt;
	LPVKPLT		lpVKplt;
	LPVKBD		lpVKbd;
	LPTSTR		lptStr;
	BOOL		bFlg;
	WORD		fc;
	USHORT		i, pos;
	WORD		wFlag;
	WORD		wFunc;
	WORD		wID;

	lpVSplt		= (LPVSPLT )GetVSplt (lpVWin);
	lpVKplt		= (LPVKPLT )GetVKplt (lpVWin);
	lpVKbd		= (LPVKBD  )GetVKbd  (lpVWin);

	wFlag		= LOWORD (lpVWin->Param);
	wFunc		= HIWORD (lpVWin->Param);
	wID		= GetSaveFuncID (client, wFunc);

	if (wFlag & (ENV_ALL|ENV_POS)) {
		if (lpEnv->wii.wOffHide == YES) {
			lpVSplt->wOffStatus	= STS_BTN_OFF_HID;
		} else if (lpEnv->wii.wMinimize == YES) {
			lpVSplt->wOffStatus	= STS_BTN_OFF_MIN;
		} else {
			lpVSplt->wOffStatus	= STS_BTN_OFF_NML;
		}
		lpVSplt->wBtnType	= lpEnv->btn.wBtnType;
		pos			= 1;
		bFlg			= FALSE;
		for (i=0; i < lpEnv->btn.wBtnCount; i++) {
			fc	= lpEnv->btn.wBtnFunc[i];
			if (fc == F_SCRN) {
				bFlg	= TRUE;
			} else {
				lptStr	= GetStr (GS_FKBUTTON, fc, 0);
				lpVSplt->wBtnFunc[pos]	= fc;
				lpVSplt->wBtnIndex[pos]	= latoi (lptStr);
				pos++;
			}
		}
		if (bFlg == FALSE) {
			lpVSplt->wBtnCount	= lpEnv->btn.wBtnCount + 1;
		} else {
			lpVSplt->wBtnCount	= lpEnv->btn.wBtnCount;
		}
		pos			= 0;
		lptStr			= GetStr (GS_FKBUTTON, F_SCRN, 0);
		lpVSplt->wBtnFunc[pos]	= F_SCRN;
		lpVSplt->wBtnIndex[pos]	= latoi (lptStr);

		lpVSplt->wBtnPosRoot	= pos;
		lpVSplt->wBtnSize	= lpEnv->btn.wBtnSize
					- DRAW_STATUS_WINDOW_BUTTON_BORDER * 2;
		lpVSplt->wPopHelp	= lpEnv->btn.wPopHelp;
		lpVSplt->wPixBtnBgClr	= lpEnv->clr.wColBtn;
/* lpVKplt */
		pos			= 0;
		fc			= F_EX_KOHO_SORT_TOP;
		lptStr			= GetStr (GS_FKBUTTON, fc, 0);
		lpVKplt->wBtnFunc[pos]	= fc;
		lpVKplt->wBtnIndex[pos]	= latoi (lptStr);
		pos			= 1;
		fc			= F_EX_KOHO_SORT_END;
		lptStr			= GetStr (GS_FKBUTTON, fc, 0);
		lpVKplt->wBtnFunc[pos]	= fc;
		lpVKplt->wBtnIndex[pos]	= latoi (lptStr);
		lpVKplt->wBtnCount	= pos + 1;

		lpVKplt->wPopHelp	= lpEnv->btn.wPopHelp;
		lpVKplt->wPixBtnBgClr	= (CLR_BLACK | (CLR_WBACK << 8));
	}
	if (wFlag & (ENV_ALL|ENV_MODE)) {
/* lpVKbd */
		if (wFlag & ENV_MODE && wID != FC_16)	;
		else
			lpVKbd->wComma		= lpEnv->kbd.wComma;
		if (wFlag & ENV_MODE && wID != FC_17)	;
		else
			lpVKbd->wPeriod		= lpEnv->kbd.wPeriod;
		if (wFlag & ENV_MODE && wID != FC_18)	;
		else
			lpVKbd->wSlash		= lpEnv->kbd.wSlash;
		if (wFlag & ENV_MODE && wID != FC_19)	;
		else
			lpVKbd->wHyphen		= lpEnv->kbd.wHyphen;
		if (wFlag & ENV_MODE && wID != FC_20)	;
		else
			lpVKbd->wBracket	= lpEnv->kbd.wBracket;
		if (wFlag & ENV_MODE && wID != FC_21)	;
		else
			lpVKbd->wTen		= lpEnv->kbd.wTen;
		if (wFlag & ENV_MODE && wID != FC_22)	;
		else
			lpVKbd->wMaru		= lpEnv->kbd.wMaru;
	}
	return;
}

/*=============================================================================
	VWinToEnv
=============================================================================*/
void	VWinToEnv
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	LPENV		lpEnv
)
{
	LPVSPLT		lpVSplt;
	LPVKPLT		lpVKplt;
	LPVKBD		lpVKbd;
	LPTSTR		lptStr;
	USHORT		i;
	WORD		wFlag;
	WORD		wFunc;
	WORD		wID;

	lpVSplt		= (LPVSPLT )GetVSplt (lpVWin);
	lpVKplt		= (LPVKPLT )GetVKplt (lpVWin);
	lpVKbd		= (LPVKBD  )GetVKbd  (lpVWin);

	wFlag		= LOWORD (lpVWin->Param);
	wFunc		= HIWORD (lpVWin->Param);
	wID		= GetSaveFuncID (client, wFunc);

	if (wFlag & (ENV_ALL|ENV_POS)) {
/* lpVWin */
		lpEnv->win[0].rStatus.x		= lpVWin->StatusRMax.x;
		lpEnv->win[0].rStatus.y		= lpVWin->StatusRMax.y;
		lpEnv->win[0].rStatus.w		= lpVWin->StatusRMax.width;
		lpEnv->win[0].rStatus.h		= lpVWin->StatusRMax.height;
		lpEnv->win[0].rPreeditRoot.x	= lpVWin->PreeditR.x;
		lpEnv->win[0].rPreeditRoot.y	= lpVWin->PreeditR.y;
		lpEnv->win[0].rPreeditRoot.w	= lpVWin->PreeditR.width;
		lpEnv->win[0].rPreeditRoot.h	= lpVWin->PreeditR.height;
/* lpVSplt */
		lpEnv->wii.wOffHide	= NO;
		lpEnv->wii.wMinimize	= NO;
		if (lpVSplt->wOffStatus == STS_BTN_OFF_HID) {
			lpEnv->wii.wOffHide	= YES;
		} else if (lpVSplt->wOffStatus == STS_BTN_OFF_MIN) {
			lpEnv->wii.wMinimize	= YES;
		}
		lpEnv->btn.wBtnType	= lpVSplt->wBtnType;
		lpEnv->btn.wBtnCount	= lpVSplt->wMaxBtnCount;
		for (i=0; i < lpVSplt->wBtnCount; i++) {
			lpEnv->btn.wBtnFunc[i]	= lpVSplt->wMaxBtnFunc[i];
		}
		lpEnv->btn.wBtnSize	= lpVSplt->wBtnSize
					+ DRAW_STATUS_WINDOW_BUTTON_BORDER * 2;
		lpEnv->btn.wPopHelp	= lpVSplt->wPopHelp;
/* lpVKplt */
	}
	if (wFlag & (ENV_ALL|ENV_MODE)) {
/* lpVKbd */
		if (wFlag & ENV_MODE && wID != FC_16)	;
		else
			lpEnv->kbd.wComma	= lpVKbd->wComma;
		if (wFlag & ENV_MODE && wID != FC_17)	;
		else
			lpEnv->kbd.wPeriod	= lpVKbd->wPeriod;
		if (wFlag & ENV_MODE && wID != FC_18)	;
		else
			lpEnv->kbd.wSlash	= lpVKbd->wSlash;
		if (wFlag & ENV_MODE && wID != FC_19)	;
		else
			lpEnv->kbd.wHyphen	= lpVKbd->wHyphen;
		if (wFlag & ENV_MODE && wID != FC_20)	;
		else
			lpEnv->kbd.wBracket	= lpVKbd->wBracket;
		if (wFlag & ENV_MODE && wID != FC_21)	;
		else
			lpEnv->kbd.wTen		= lpVKbd->wTen;
		if (wFlag & ENV_MODE && wID != FC_22)	;
		else
			lpEnv->kbd.wMaru	= lpVKbd->wMaru;
	}
	return;
}

/*=============================================================================
	InitVWin
=============================================================================*/
void	InitVWin
(
	LPVWIN		lpVWin
)
{
	LPVSPLT		lpVSplt;
	LPVKPLT		lpVKplt;
	LPVKBD		lpVKbd;

	lpVSplt		= (LPVSPLT )GetVSplt (lpVWin);
	lpVKplt		= (LPVKPLT )GetVKplt (lpVWin);
	lpVKbd		= (LPVKBD  )GetVKbd  (lpVWin);

/* lpVWin */
	lpVWin->First			= 1;
	lpVWin->Param			= MAKELONG ((WORD )ENV_ALL, (WORD )0);
	lpVWin->BaseFontName		= (char *)0;
/* lpVSplt */
	lpVSplt->wOffStatus		= STS_BTN_OFF_NML;
	lpVSplt->wBtnMode		= STS_BTN_MODE_NML;
	lpVSplt->wBtnPos		= 0;
	lpVSplt->wBtnPosPrev		= 0;
	lpVSplt->wBtnPosRoot		= 0;
	lpVSplt->wBtnType		= IDP_BTN12C;
	lpVSplt->wBtnCount		= 0;
	lpVSplt->wBtnSize		= STS_BTN_SIZE_SMALL;
	lpVSplt->wBtnRow		= 0;
	lpVSplt->wBtnCol		= 0;
	lpVSplt->pPixBtn		= 0;
	lpVSplt->pPixBtnOn		= 0;
	lpVSplt->pPixBtnOff		= 0;
	lpVSplt->wPixBtnSize		= 0;
	lpVSplt->wPixBtnBgClr		= 0;
	lpVSplt->wPopHelp		= YES;
	lpVSplt->wMaxBtnCount		= 0;
/* lpVKplt */
	lpVKplt->wBtnPos		= 0;
	lpVKplt->wBtnCount		= 0;
	lpVKplt->pPixBtn		= 0;
	lpVKplt->wPixBtnSize		= 0;
	lpVKplt->wPixBtnBgClr		= 0;
/* lpVKbd */
	lpVKbd->wComma			= AUTO;
	lpVKbd->wPeriod			= AUTO;
	lpVKbd->wSlash			= AUTO;
	lpVKbd->wHyphen			= AUTO;
	lpVKbd->wBracket		= YES;
	lpVKbd->wTen			= NO;
	lpVKbd->wMaru			= NO;
}

/*=============================================================================
	FirstVWin
=============================================================================*/
void	FirstVWin
(
	LPVWIN		lpVWin
)
{
	XGCValues	gcvalues;

	lpVWin->WinForePixel		= GetVclrPixel (CLR_WFORE);
	lpVWin->WinBackPixel		= GetVclrPixel (CLR_WBACK);
	lpVWin->WinBorderPixel		= GetVclrPixel (CLR_WBDR );
	lpVWin->TextForePixel		= GetVclrPixel (CLR_TFORE);
	lpVWin->TextBackPixel		= GetVclrPixel (CLR_TBACK);

	AllocSHColor (
		display,
		screen,
		DefaultColormap (display, screen),
		lpVWin->WinBackPixel,
		&lpVWin->WinShadowPixel,
		&lpVWin->WinHiglightPixel
	);

	/* normal */
	gcvalues.foreground		= lpVWin->WinBackPixel;
	lpVWin->GCList[0]		= XCreateGC (
						display,
						root,
						GCForeground,
						&gcvalues
					);
	/* higlight */
	gcvalues.foreground		= lpVWin->WinHiglightPixel;
	lpVWin->GCList[1]		= XCreateGC (
						display,
						root,
						GCForeground,
						&gcvalues
					);
	/* shadow */
	gcvalues.foreground		= lpVWin->WinShadowPixel;
	lpVWin->GCList[2]		= XCreateGC (
						display,
						root,
						GCForeground,
						&gcvalues
					);
	/* white */
	gcvalues.foreground		= GetVclrPixel (CLR_WHITE);
	lpVWin->GCList[3]		= XCreateGC (
						display,
						root,
						GCForeground,
						&gcvalues
					);
	/* black */
	gcvalues.foreground		= GetVclrPixel (CLR_BLACK);
	lpVWin->GCList[4]		= XCreateGC (
						display,
						root,
						GCForeground,
						&gcvalues
					);
	/* work */
	gcvalues.foreground		= GetVclrPixel (CLR_WHITE);
	lpVWin->GCList[5]		= XCreateGC (
						display,
						root,
						GCForeground,
						&gcvalues
					);
	/* rubberband */
	lpVWin->MoveGCV.foreground	= GetVclrPixel (CLR_BLACK)
					^ GetVclrPixel (CLR_WHITE);
	lpVWin->MoveGCV.background	= GetVclrPixel (CLR_WHITE);
	lpVWin->MoveGCV.function	= GXxor;
	lpVWin->XorGC			= XCreateGC (
						display,
						root,
						GCForeground
						| GCBackground
						| GCFunction,
						&lpVWin->MoveGCV
					);
	XSetSubwindowMode (display, lpVWin->XorGC, IncludeInferiors);

	lpVWin->First		= 0;
}

/*=============================================================================
	MakeVWin
=============================================================================*/
BOOL	MakeVWin
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	LPENV		lpEnv,
	LPENV		lpEnvO
)
{
	LPVSPLT		lpVSplt;
	LPVKPLT		lpVKplt;
	SHORT		root_w, root_h, min_w;
	SHORT		org_x, org_y, org_w, org_h;
	SHORT		tmp_x, tmp_y, tmp_w, tmp_h;
	SHORT		kanji, kana;
	BOOL		rc;
	int		i;

	lpVSplt	= (LPVSPLT )GetVSplt (lpVWin);
	lpVKplt	= (LPVKPLT )GetVKplt (lpVWin);
	root_w	= DisplayWidth  (display, screen);
	root_h	= DisplayHeight (display, screen);

	if (lpVWin->First) {
		FirstVWin (lpVWin);
	}
	EnvToVWin (client, lpVWin, lpEnv);

	/*---------------------------------------------------------------------
		StatusR, StatusM
	---------------------------------------------------------------------*/
	rc	= InitStatusWindow (lpVSplt, lpEnv);
	if (!rc) {
		return (FALSE);
	}
	lpVWin->StatusWinType	= STATUS_WINDOW_TYPE_MAX;

	/*---------------------------------------------------------------------
		koho_window
	---------------------------------------------------------------------*/
	rc	= InitKohoWindow (lpVKplt, lpEnv);
	if (!rc) {
		return (FALSE);
	}

	/*---------------------------------------------------------------------
		PopUpMenu
	---------------------------------------------------------------------*/
	for (i=0; i < PM_WIN_MAX; i++) {
		lpVWin->PopUpMenu[i].height	= 10;
		lpVWin->PopUpMenu[i].width	= 10;
		lpVWin->PopUpMenu[i].x		=  0;
		lpVWin->PopUpMenu[i].y		=  0;
		lpVWin->PopUpMenuPos[i]		= -1;
	}
		lpVWin->PopUpMenuIdx		=  0;
		lpVWin->PopUpMenuFlg		=  PM_OFF;

	/*---------------------------------------------------------------------
		PopUpHelp
	---------------------------------------------------------------------*/
	lpVWin->PopUpHelp.height	=  4;
	lpVWin->PopUpHelp.width		=  4;
	lpVWin->PopUpHelp.x		=  0;
	lpVWin->PopUpHelp.y		=  0;
	lpVWin->PopUpHelpPos		= -1;
	lpVWin->PopUpHelpFlg		=  PH_OFF;

	/*---------------------------------------------------------------------
		PreeditR
	---------------------------------------------------------------------*/
	org_x	= tmp_x	= lpEnv->win[0].rPreeditRoot.x;
	org_y	= tmp_y	= lpEnv->win[0].rPreeditRoot.y;
	org_w	= tmp_w	= lpEnv->win[0].rPreeditRoot.w;
	org_h	= tmp_h	= lpEnv->win[0].rPreeditRoot.h;

	tmp_h	= client->preedit_font->max_font_height
		+ DRAW_PREEDIT_ROOT_WINDOW_FONT_BORDER * 2
		+ DRAW_PREEDIT_ROOT_WINDOW_BORDER * 2;
	tmp_w	= root_w / 4 * 3;
	if (org_w > 0) {
		kanji	= client->preedit_font->kanji_font_width;
		kana	= client->preedit_font->ascii_kana_font_width;
		min_w	= (((kanji > kana) ? kanji : kana)
			  * DRAW_PREEDIT_ROOT_WINDOW_MIN_LENGTH)
			+ DRAW_PREEDIT_ROOT_WINDOW_FONT_BORDER * 2
			+ DRAW_PREEDIT_ROOT_WINDOW_BORDER * 2
			+ DRAW_PREEDIT_ROOT_WINDOW_TITLE_WIDTH;
		if (org_w > root_w
		 || min_w > root_w) {
			tmp_w	= root_w;
		} else if (org_w < min_w) {
			tmp_w	= min_w;
		} else {
			tmp_w	= org_w;
		}
	}
	if (org_w <= 0) {
		tmp_x	= 0;
	} else if (org_x >= 0 && org_x + tmp_w <= root_w) {
		tmp_x	= org_x;
	} else {
		tmp_x	= 0;
	}
	if (org_h <= 0) {
		tmp_y	= root_h - tmp_h;
	} else if (org_y >= 0 && org_y + tmp_h <= root_h) {
		tmp_y	= org_y;
	} else {
		tmp_y	= root_h - tmp_h;
	}
	lpVWin->PreeditR.height		= tmp_h;
	lpVWin->PreeditR.width		= tmp_w;
	lpVWin->PreeditR.y		= tmp_y;
	lpVWin->PreeditR.x		= tmp_x;

	/*---------------------------------------------------------------------
		preedit
	---------------------------------------------------------------------*/
	lpVWin->PreeditM.height= client->preedit_font->max_font_height;
	lpVWin->PreeditM.width	= lpVWin->PreeditR.width
				- DRAW_PREEDIT_ROOT_WINDOW_BORDER * 2
				- DRAW_PREEDIT_ROOT_WINDOW_TITLE_WIDTH;
	lpVWin->PreeditM.x	= DRAW_PREEDIT_ROOT_WINDOW_BORDER_ALL;
	lpVWin->PreeditM.y	= DRAW_PREEDIT_ROOT_WINDOW_BORDER_ALL;

	/*---------------------------------------------------------------------
		etc
	---------------------------------------------------------------------*/
	kanji			= client->status_font->kanji_font_width;
	kana			= client->status_font->ascii_kana_font_width;
	lpVWin->StatusNW	= ((kanji > kana) ? kanji : kana)
				* GetMaxStatusMessageLength (client);
	lpVWin->StatusNH	= client->status_font->max_font_height;
	lpVWin->PreeditNW	= ((kanji > kana) ? kanji : kana) * 2;
	lpVWin->PreeditNH	= client->preedit_font->max_font_height;
	lpVWin->Gravity		= SouthEastGravity;

	return (TRUE);
}

/*=============================================================================
	EnvToClient
=============================================================================*/
BOOL	EnvToClient
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	LPENV		lpEnv
)
{
	int	i;

	if (client) {
		EnvToCore (client, lpVWin, lpEnv);
		EnvToVKp  (client, lpVWin, lpEnv);
		ChangePreeditRootFont (client);
	} else {
		for (i=0; client = GetClient (i); i = client->icid) {
			EnvToCore (client, lpVWin, lpEnv);
			EnvToVKp  (client, lpVWin, lpEnv);
			ChangePreeditRootFont (client);
		}
	}

}

/*=============================================================================
	InitVjeEnv
=============================================================================*/
BOOL	InitVjeEnv
(
	FXim_Client	*client
)
{
	LPENV		lpEnv;
	LPENV		lpEnvO;
	LPVWIN		lpVWin;
	BOOL		rc;

	lpEnv	= (LPENV  )GetEnv (0);
	lpEnvO	= (LPENV  )GetEnv (1);
	lpVWin	= (LPVWIN )GetVWin ();

	GetBasicInfo (lpEnv);
	CheckUserEnv (lpEnv);
	LoadEnv (lpEnv, lpEnvO);
#if 0 /* debug */
	DumpEnv (lpEnv, 0xffffffff);
	fflush (stdout);
#endif
	SetTriggerKey ();

	InitVWin (lpVWin);
	rc	= MakeVClr (client, lpVWin, lpEnv, lpEnvO);
	if (!rc) {
		return (FALSE);
	}
	rc	= MakeVCur (client, lpVWin, lpEnv, lpEnvO);
	if (!rc) {
		return (FALSE);
	}
	rc	= MakeVFnt (client, lpVWin, lpEnv, lpEnvO);
	if (!rc) {
		return (FALSE);
	}
	rc	= MakeVWin (client, lpVWin, lpEnv, lpEnvO);
	if (!rc) {
		return (FALSE);
	}
	return (TRUE);
}

/*=============================================================================
	LoadVjeEnv
=============================================================================*/
BOOL	LoadVjeEnv
(
	FXim_Client	*client
)
{
	LPENV		lpEnv;
	LPENV		lpEnvO;
	LPVWIN		lpVWin;

	lpEnv	= (LPENV  )GetEnv (0);
	lpEnvO	= (LPENV  )GetEnv (1);
	lpVWin	= (LPVWIN )GetVWin ();

	InitVjeEnv (client);
	EnvToClient ((FXim_Client *)0, lpVWin, lpEnv);
#if 1
	MoveResizeRoot (client);
#endif
}

/*=============================================================================
	SaveVjeEnv
=============================================================================*/
void	SaveVjeEnv
(
	FXim_Client	*client
)
{
	LPENV		lpEnv;
	LPENV		lpEnvO;
	LPVWIN		lpVWin;

	lpEnv	= (LPENV )GetEnv (0);
	lpEnvO	= (LPENV )GetEnv (1);
	lpVWin	= (LPVWIN  )GetVWin ();

	VWinToEnv (client, lpVWin, lpEnv);
	VKpToEnv  (client, lpVWin, lpEnv);
	CoreToEnv (client, lpVWin, lpEnv);

	SaveEnv (lpEnv, lpEnvO);

#if 0 /* 991102 */
	EnvToClient ((FXim_Client *)0, lpVWin, lpEnv);
#endif

	return;
}

/*=============================================================================
	CallLoadVjeEnv
=============================================================================*/
void	CallLoadVjeEnv
(
	FXim_Client	*client,
	WORD		wFlag,
	WORD		wFunc
)
{
	KD	kd;
	InitKD (&kd);
	kd.wFunc	= F_EX_ENV_LOAD;
	kd.lFuncOption	= MAKELONG ((WORD )wFlag, (WORD )wFunc);
	FuncHandler (client, &kd);
}

/*=============================================================================
	CallSaveVjeEnv
=============================================================================*/
void	CallSaveVjeEnv
(
	FXim_Client	*client,
	WORD		wFlag,
	WORD		wFunc
)
{
	KD	kd;
	InitKD (&kd);
	kd.wFunc	= F_EX_ENV_SAVE;
	kd.lFuncOption	= MAKELONG ((WORD )wFlag, (WORD )wFunc);
	FuncHandler (client, &kd);
}

#if !USE_XPM
/*=============================================================================
	CreateVSpltPixBtnList
=============================================================================*/
BOOL	CreateVSpltPixBtnList
(
	LPVSPLT		lpVSplt
)
{
	CPIXATTR		attr;
	int			vc;
	Colormap		cmap;
	Visual			*visual;
	int			depth;
	Pixmap			pPixBtnOn;
	Pixmap			pPixBtnOff;
	char			**btn_xpm;
	int			rc;

	vc	= CheckVisual ();

	if (lpVSplt->wBtnSize < STS_BTN_SIZE_MIN) {
		lpVSplt->wBtnSize	= STS_BTN_SIZE_MIN;
	} else if (lpVSplt->wBtnSize > STS_BTN_SIZE_MAX) {
		lpVSplt->wBtnSize	= STS_BTN_SIZE_MAX;
	}
CreateVSpltPixBtnList_Retry:;
	if (lpVSplt->wBtnSize >= STS_BTN_SIZE_BIG) {
		if (vc == VC_COLOR
		 && (lpVSplt->wBtnType == IDP_BTN12C ||
		     lpVSplt->wBtnType == IDP_BTN20C)) {
			btn_xpm	= c20btnxo_xpm;
			lmemcpy (
				(char *)btn_xpm,
				(char *)c20btnxo_on_xpm,
				 sizeof (c20btnxo_on_xpm)
			);
		} else {
			btn_xpm	= m20btnxo_xpm;
		}
	} else {
		if (vc == VC_COLOR
		 && (lpVSplt->wBtnType == IDP_BTN12C ||
		     lpVSplt->wBtnType == IDP_BTN20C)) {
			btn_xpm	= c12btnxo_xpm;
			lmemcpy (
				(char *)btn_xpm,
				(char *)c12btnxo_on_xpm,
				 sizeof (c12btnxo_on_xpm)
			);
		} else {
			btn_xpm	= m12btnxo_xpm;
		}
	}

	if (vc == VC_MONO) {
		attr.valuemask		 = 0;
		attr.valuemask		|= CPIX_BACKGROUND;
		attr.background		 = WhitePixel (display, screen);
		attr.valuemask		|= CPIX_COLOR_KEY;
		attr.color_key		 = VC_MONO;
	} else {
		attr.valuemask		 = 0;
		attr.valuemask		|= CPIX_BACKGROUND;
		attr.background		 = GetVclrPixel (
					HIBYTE (lpVSplt->wPixBtnBgClr)
					);
		attr.valuemask		|= CPIX_COLOR_KEY;
		if (vc == VC_COLOR) {
			attr.color_key	 = CPIX_COLOR;
		} else {
			attr.color_key	 = CPIX_GRAY;
		}
	}

	rc	= CreatePixmapFromXpmData (
			display, root,
			&pPixBtnOn, btn_xpm, &attr
		);
	if (rc != CPIX_SUCCESS) {
		if (vc == VC_COLOR) {
			vc	= VC_GRAY;
		} else if (vc == VC_GRAY) {
			vc	= VC_MONO;
		} else {
			return (FALSE);
		}
		goto	CreateVSpltPixBtnList_Retry;
	}

	if (vc == VC_COLOR
	 && (lpVSplt->wBtnType == IDP_BTN12C ||
	     lpVSplt->wBtnType == IDP_BTN20C)) {
		if (lpVSplt->wBtnSize >= STS_BTN_SIZE_BIG) {
			lmemcpy (
				(char *)btn_xpm,
				(char *)c20btnxo_off_xpm,
				 sizeof (c20btnxo_off_xpm)
			);
		} else {
			lmemcpy (
				(char *)btn_xpm,
				(char *)c12btnxo_off_xpm,
				 sizeof (c12btnxo_off_xpm)
			);
		}
		rc	= CreatePixmapFromXpmData (
				display, root,
				&pPixBtnOff, btn_xpm, &attr
			);
		if (rc != CPIX_SUCCESS) {
			XFreePixmap (display, pPixBtnOn);
			vc	= VC_GRAY;
			goto	CreateVSpltPixBtnList_Retry;
		}
	} else {
		pPixBtnOff	= pPixBtnOn;
	}

	if (lpVSplt->pPixBtnOff) {
		if (lpVSplt->pPixBtnOn != lpVSplt->pPixBtnOff) {
			XFreePixmap (display, lpVSplt->pPixBtnOff);
		}
	}
	if (lpVSplt->pPixBtnOn) {
		XFreePixmap (display, lpVSplt->pPixBtnOn);
	}

	lpVSplt->pPixBtnOn	= pPixBtnOn;
	lpVSplt->pPixBtnOff	= pPixBtnOff;
	lpVSplt->wPixBtnSize	= attr.height;

	return (TRUE);
}

/*=============================================================================
	CreateVKpltPixBtnList
=============================================================================*/
BOOL	CreateVKpltPixBtnList
(
	LPVKPLT		lpVKplt
)
{
	CPIXATTR	attr;
	int		vc;
	Colormap	cmap;
	Visual		*visual;
	int		depth;
	Pixmap		pPixBtn;
	int		rc;

	vc	= CheckVisual ();

CreateVKpltPixBtnList_Retry:;
	if (vc == VC_MONO) {
		attr.valuemask		 = 0;
		attr.valuemask		|= CPIX_BACKGROUND;
		attr.background		 = WhitePixel (display, screen);
		attr.valuemask		|= CPIX_COLOR_KEY;
		attr.color_key		 = VC_MONO;
	} else {
		attr.valuemask		 = 0;
		attr.valuemask		|= CPIX_BACKGROUND;
		attr.background		 = GetVclrPixel (
					HIBYTE (lpVKplt->wPixBtnBgClr)
					);
		attr.valuemask		|= CPIX_COLOR_KEY;
		if (vc == VC_COLOR) {
			attr.color_key	 = CPIX_COLOR;
		} else {
			attr.color_key	 = CPIX_GRAY;
		}
	}

	rc	= CreatePixmapFromXpmData (
			display, root,
			&pPixBtn, candbtn_xpm, &attr
		);
	if (rc != CPIX_SUCCESS) {
		if (vc == VC_COLOR) {
			vc	= VC_GRAY;
		} else if (vc == VC_GRAY) {
			vc	= VC_MONO;
		} else {
			return (FALSE);
		}
		goto	CreateVKpltPixBtnList_Retry;
	}

	if (lpVKplt->pPixBtn) {
		XFreePixmap (display, lpVKplt->pPixBtn);
	}

	lpVKplt->pPixBtn	= pPixBtn;
	lpVKplt->wPixBtnSize	= attr.height;

	return (TRUE);
}

#else /* !USE_XPM */
/*=============================================================================
	CreateVSpltPixBtnList
=============================================================================*/
BOOL	CreateVSpltPixBtnList
(
	LPVSPLT		lpVSplt
)
{
	XpmColorSymbol		symbol[1];
	Pixmap			mask;
	XpmAttributes		attr;
	int			vc;
	Colormap		cmap;
	Visual			*visual;
	int			depth;
	Pixmap			pPixBtnOn;
	Pixmap			pPixBtnOff;
	char			**btn_xpm;
	int			rc;

	vc	= CheckVisual ();

	if (lpVSplt->wBtnSize < STS_BTN_SIZE_MIN) {
		lpVSplt->wBtnSize	= STS_BTN_SIZE_MIN;
	} else if (lpVSplt->wBtnSize > STS_BTN_SIZE_MAX) {
		lpVSplt->wBtnSize	= STS_BTN_SIZE_MAX;
	}
CreateVSpltPixBtnList_Retry:;
	if (lpVSplt->wBtnSize >= STS_BTN_SIZE_BIG) {
		if (vc == VC_COLOR
		 && (lpVSplt->wBtnType == IDP_BTN12C ||
		     lpVSplt->wBtnType == IDP_BTN20C)) {
			btn_xpm	= c20btnxo_xpm;
			lmemcpy (
				(char *)btn_xpm,
				(char *)c20btnxo_on_xpm,
				 sizeof (c20btnxo_on_xpm)
			);
		} else {
			btn_xpm	= m20btnxo_xpm;
		}
	} else {
		if (vc == VC_COLOR
		 && (lpVSplt->wBtnType == IDP_BTN12C ||
		     lpVSplt->wBtnType == IDP_BTN20C)) {
			btn_xpm	= c12btnxo_xpm;
			lmemcpy (
				(char *)btn_xpm,
				(char *)c12btnxo_on_xpm,
				 sizeof (c12btnxo_on_xpm)
			);
		} else {
			btn_xpm	= m12btnxo_xpm;
		}
	}

	if (vc == VC_MONO) {
		symbol[0].name		= "background";
		symbol[0].value		= NULL;
		symbol[0].pixel		= WhitePixel (display, screen);

		attr.valuemask		 = 0;
		attr.colorsymbols	 = symbol;
		attr.numsymbols		 = 1;
		attr.valuemask		|= XpmColorSymbols;
		attr.color_key		 = XPM_MONO;
		attr.valuemask		|= XpmColorKey;
	} else {
		cmap			= DefaultColormap (display, screen);
		visual			= DefaultVisual (display, screen);
		depth			= DefaultDepth (display, screen);

		symbol[0].name		= "background";
		symbol[0].value		= NULL;
		symbol[0].pixel		= GetVclrPixel (
					HIBYTE (lpVSplt->wPixBtnBgClr)
					);

		attr.valuemask		 = 0;
		attr.visual		 = visual;
		attr.valuemask		|= XpmVisual;
		attr.colormap		 = cmap;
		attr.valuemask		|= XpmColormap;
		attr.depth		 = depth;
		attr.valuemask		|= XpmDepth;
		attr.closeness		 = 65535;
		attr.valuemask		|= XpmCloseness;
		attr.colorsymbols	 = symbol;
		attr.numsymbols		 = 1;
		attr.valuemask		|= XpmColorSymbols;
		if (vc == VC_COLOR) {
			attr.color_key	 = XPM_COLOR;
		} else {
			attr.color_key	 = XPM_GRAY;
		}
		attr.valuemask		|= XpmColorKey;
	}

	rc	= XpmCreatePixmapFromData (
			display, root,
			btn_xpm, &pPixBtnOn, &mask, &attr
		);
	if (rc != XpmSuccess) {
		if (vc == VC_COLOR) {
			vc	= VC_GRAY;
		} else if (vc == VC_GRAY) {
			vc	= VC_MONO;
		} else {
			return (FALSE);
		}
		goto	CreateVSpltPixBtnList_Retry;
	}

	if (vc == VC_COLOR
	 && (lpVSplt->wBtnType == IDP_BTN12C ||
	     lpVSplt->wBtnType == IDP_BTN20C)) {
		if (lpVSplt->wBtnSize >= STS_BTN_SIZE_BIG) {
			lmemcpy (
				(char *)btn_xpm,
				(char *)c20btnxo_off_xpm,
				 sizeof (c20btnxo_off_xpm)
			);
		} else {
			lmemcpy (
				(char *)btn_xpm,
				(char *)c12btnxo_off_xpm,
				 sizeof (c12btnxo_off_xpm)
			);
		}
		rc	= XpmCreatePixmapFromData (
				display, root,
				btn_xpm, &pPixBtnOff, &mask, &attr
			);
		if (rc != XpmSuccess) {
			XFreePixmap (display, pPixBtnOn);
			vc	= VC_GRAY;
			goto	CreateVSpltPixBtnList_Retry;
		}
	} else {
		pPixBtnOff	= pPixBtnOn;
	}

	if (lpVSplt->pPixBtnOff) {
		if (lpVSplt->pPixBtnOn != lpVSplt->pPixBtnOff) {
			XFreePixmap (display, lpVSplt->pPixBtnOff);
		}
	}
	if (lpVSplt->pPixBtnOn) {
		XFreePixmap (display, lpVSplt->pPixBtnOn);
	}

	lpVSplt->pPixBtnOn	= pPixBtnOn;
	lpVSplt->pPixBtnOff	= pPixBtnOff;
	lpVSplt->wPixBtnSize	= attr.height;

	return (TRUE);
}

/*=============================================================================
	CreateVKpltPixBtnList
=============================================================================*/
BOOL	CreateVKpltPixBtnList
(
	LPVKPLT		lpVKplt
)
{
	XpmColorSymbol		symbol[1];
	Pixmap			mask;
	XpmAttributes		attr;
	int			vc;
	Colormap		cmap;
	Visual			*visual;
	int			depth;
	Pixmap			pPixBtn;
	int			rc;

	vc	= CheckVisual ();

CreateVKpltPixBtnList_Retry:;
	if (vc == VC_MONO) {
		symbol[0].name		= "background";
		symbol[0].value		= NULL;
		symbol[0].pixel		= WhitePixel (display, screen);

		attr.valuemask		 = 0;
		attr.colorsymbols	 = symbol;
		attr.numsymbols		 = 1;
		attr.valuemask		|= XpmColorSymbols;
		attr.color_key		 = XPM_MONO;
		attr.valuemask		|= XpmColorKey;
	} else {
		cmap			= DefaultColormap (display, screen);
		visual			= DefaultVisual (display, screen);
		depth			= DefaultDepth (display, screen);

		symbol[0].name		= "background";
		symbol[0].value		= NULL;
		symbol[0].pixel		= GetVclrPixel (
					HIBYTE (lpVKplt->wPixBtnBgClr)
					);

		attr.valuemask		 = 0;
		attr.visual		 = visual;
		attr.valuemask		|= XpmVisual;
		attr.colormap		 = cmap;
		attr.valuemask		|= XpmColormap;
		attr.depth		 = depth;
		attr.valuemask		|= XpmDepth;
		attr.closeness		 = 65535;
		attr.valuemask		|= XpmCloseness;
		attr.colorsymbols	 = symbol;
		attr.numsymbols		 = 1;
		attr.valuemask		|= XpmColorSymbols;
		if (vc == VC_COLOR) {
			attr.color_key	 = XPM_COLOR;
		} else {
			attr.color_key	 = XPM_GRAY;
		}
		attr.valuemask		|= XpmColorKey;
	}

	rc	= XpmCreatePixmapFromData (
			display, root,
			candbtn_xpm, &pPixBtn, &mask, &attr
		);
	if (rc != XpmSuccess) {
		if (vc == VC_COLOR) {
			vc	= VC_GRAY;
		} else if (vc == VC_GRAY) {
			vc	= VC_MONO;
		} else {
			return (FALSE);
		}
		goto	CreateVKpltPixBtnList_Retry;
	}

	if (lpVKplt->pPixBtn) {
		XFreePixmap (display, lpVKplt->pPixBtn);
	}

	lpVKplt->pPixBtn	= pPixBtn;
	lpVKplt->wPixBtnSize	= attr.height;

	return (TRUE);
}
#endif /* !USE_XPM */

/*=============================================================================
	CreateVSpltPixBtnBuff
=============================================================================*/
BOOL	CreateVSpltPixBtnBuff
(
	LPVSPLT		lpVSplt,
	short		width,
	short		height
)
{
	Pixmap	pPixBtn;
	short	depth;

	depth	= DefaultDepth (display, screen);

	pPixBtn	= XCreatePixmap (display, root, width, height, depth);
	if (pPixBtn == 0) {
		return (FALSE);
	}

	if (lpVSplt->pPixBtn) {
		XFreePixmap (display, lpVSplt->pPixBtn);
	}

	lpVSplt->pPixBtn	= pPixBtn;

	return (TRUE);
}

/*=============================================================================
	CreateVSpltBtn
=============================================================================*/
BOOL	CreateVSpltBtn
(
	LPVSPLT		lpVSplt,
	short		*width,
	short		*height
)
{
	VSPLT		tmpVSplt;
	int		tmp_w, tmp_h;
	int		col_end, col_step;
	int		row_end, row_step;
	int		i, j, ii, jj, idx, count;
	BOOL		sts;

	lmemcpy ((char *)&tmpVSplt, (char *)lpVSplt, sizeof (VSPLT));
	tmp_w		= *width;
	tmp_h		= *height;

	col_step	= tmpVSplt.wBtnSize
			+ DRAW_STATUS_WINDOW_BUTTON_BORDER;
	row_step	= tmpVSplt.wBtnSize
			+ DRAW_STATUS_WINDOW_BUTTON_BORDER;
	col_end		= tmp_w
			- DRAW_STATUS_WINDOW_BUTTON_BORDER
			- DRAW_STATUS_WINDOW_BORDER * 2
			- DRAW_STATUS_WINDOW_TITLE_WIDTH
			- col_step;
	row_end		= tmp_h
			- DRAW_STATUS_WINDOW_BUTTON_BORDER
			- DRAW_STATUS_WINDOW_BORDER * 2
			- row_step;

	sts	= FALSE;
	idx	= 0;
	for (i=0,ii=0; i <= row_end; i+=row_step,ii++) {
		for (j=0,jj=0; j <= col_end; j+=col_step,jj++) {
			tmpVSplt.wBtnY[idx]	=
				(DRAW_STATUS_WINDOW_BUTTON_BORDER * (ii + 1))
				+ (tmpVSplt.wBtnSize * ii);
			tmpVSplt.wBtnX[idx]	=
				(DRAW_STATUS_WINDOW_BUTTON_BORDER * (jj + 1))
				+ (tmpVSplt.wBtnSize * jj);
			if (++idx >= tmpVSplt.wBtnCount) {
				break;
			}
		}
		if (ii == 0) {
			tmpVSplt.wBtnCol = idx;
			tmp_w		= tmpVSplt.wBtnX[idx-1]
					+ col_step
					+ DRAW_STATUS_WINDOW_BORDER * 2
					+ DRAW_STATUS_WINDOW_TITLE_WIDTH;
		}
		if (idx >= tmpVSplt.wBtnCount) {
			tmpVSplt.wBtnRow = ii + 1;
			tmp_h		= tmpVSplt.wBtnY[idx-1]
					+ row_step
					+ DRAW_STATUS_WINDOW_BORDER * 2;
			sts	= TRUE;
			break;
		}
	}
	if (sts) {
		lmemcpy ((char *)lpVSplt, (char *)&tmpVSplt, sizeof (VSPLT));
		*width		= tmp_w;
		*height		= tmp_h;
	}

	return (sts);
}

/*=============================================================================
	CalcVSpltBtn
=============================================================================*/
BOOL	CalcVSpltBtn
(
	LPVSPLT	lpVSplt,
	short	*width,
	short	*height
)
{
	int	org_w, org_h;
	int	tmp_w, tmp_h;
	int	root_w, root_h;
	int	btn_w, btn_h;
	int	col, row;

	org_w	= *width;
	org_h	= *height;

	root_w	= DisplayWidth  (display, screen);
	root_h	= DisplayHeight (display, screen);

	if (org_w < 1 || org_w > root_w) {
		org_w	= root_w;
	}
	if (org_h < 1 || org_h > root_h) {
		org_h	= root_h;
	}

	tmp_w	= org_w
		- DRAW_STATUS_WINDOW_BUTTON_BORDER
		- DRAW_STATUS_WINDOW_BORDER * 2
		- DRAW_STATUS_WINDOW_TITLE_WIDTH;
	tmp_h	= org_h
		- DRAW_STATUS_WINDOW_BUTTON_BORDER
		- DRAW_STATUS_WINDOW_BORDER * 2;

	btn_w	= lpVSplt->wBtnSize
		+ DRAW_STATUS_WINDOW_BUTTON_BORDER;
	btn_h	= lpVSplt->wBtnSize
		+ DRAW_STATUS_WINDOW_BUTTON_BORDER;

	col	= tmp_w / btn_w;
	row	= tmp_h / btn_h;

	if (lpVSplt->wBtnCount > col * row) {
		return (FALSE);
	}

	col	= (lpVSplt->wBtnCount < col ? lpVSplt->wBtnCount : col);
	row	= lpVSplt->wBtnCount / col + (lpVSplt->wBtnCount % col ? 1 : 0);

	*width	= org_w - (tmp_w - (col * btn_w));
	*height	= org_h - (tmp_h - (row * btn_h));

	return (TRUE);
}

/*=============================================================================
	CalcVSpltBtnItr
=============================================================================*/
BOOL	CalcVSpltBtnItr
(
	LPVSPLT		lpVSplt,
	short		mode,
	short		wstart,
	short		wend,
	short		wstep,
	short		hstart,
	short		hend,
	short		hstep,
	short		*width,
	short		*height
)
{
	BOOL		rc	= FALSE;
	short		w, h;

	w	= wstart;
	h	= hstart;

	switch (mode) {
	case ITR_HI:
		 wstart	= w;
		 wend	= w;
		 wstep	= w;
	case ITR_WIHI:
		if (wstart <= wend && wstep > 0
		 && hstart <= hend && hstep > 0) {
			for (w = wstart; w <= wend; w += wstep) {
			for (h = hstart; h <= hend; h += hstep) {
				if (CalcVSpltBtn (lpVSplt, &w, &h)) {
					rc	= TRUE;
					goto	ITR_BREAK;
				}
			}
			}
		}
		break;

	case ITR_WDHD:
		if (wstart >= wend && wstep > 0
		 && hstart >= hend && hstep > 0) {
			for (w = wstart; w >= wend; w -= wstep) {
			for (h = hstart; h >= hend; h -= hstep) {
				if (CalcVSpltBtn (lpVSplt, &w, &h)) {
					rc	= TRUE;
					goto	ITR_BREAK;
				}
			}
			}
		}
		break;

	case ITR_HD:
		 wstart	= w;
		 wend	= w;
		 wstep	= w;
	case ITR_WIHD:
		if (wstart <= wend && wstep > 0
		 && hstart >= hend && hstep > 0) {
			for (w = wstart; w <= wend; w += wstep) {
			for (h = hstart; h >= hend; h -= hstep) {
				if (CalcVSpltBtn (lpVSplt, &w, &h)) {
					rc	= TRUE;
					goto	ITR_BREAK;
				}
			}
			}
		}
		break;

	case ITR_WDHI:
		if (wstart >= wend && wstep > 0
		 && hstart <= hend && hstep > 0) {
			for (w = wstart; w >= wend; w -= wstep) {
			for (h = hstart; h <= hend; h += hstep) {
				if (CalcVSpltBtn (lpVSplt, &w, &h)) {
					rc	= TRUE;
					goto	ITR_BREAK;
				}
			}
			}
		}
		break;

	case ITR_WI:
		 hstart	= h;
		 hend	= h;
		 hstep	= h;
	case ITR_HIWI:
		if (hstart <= hend && hstep > 0
		 && wstart <= wend && wstep > 0) {
			for (h = hstart; h <= hend; h += hstep) {
			for (w = wstart; w <= wend; w += wstep) {
				if (CalcVSpltBtn (lpVSplt, &w, &h)) {
					rc	= TRUE;
					goto	ITR_BREAK;
				}
			}
			}
		}
		break;

	case ITR_HDWD:
		if (hstart >= hend && hstep > 0
		 && wstart >= wend && wstep > 0) {
			for (h = hstart; h >= hend; h -= hstep) {
			for (w = wstart; w >= wend; w -= wstep) {
				if (CalcVSpltBtn (lpVSplt, &w, &h)) {
					rc	= TRUE;
					goto	ITR_BREAK;
				}
			}
			}
		}
		break;

	case ITR_WD:
		 hstart	= h;
		 hend	= h;
		 hstep	= h;
	case ITR_HIWD:
		if (hstart <= hend && hstep > 0
		 && wstart >= wend && wstep > 0) {
			for (h = hstart; h <= hend; h += hstep) {
			for (w = wstart; w >= wend; w -= wstep) {
				if (CalcVSpltBtn (lpVSplt, &w, &h)) {
					rc	= TRUE;
					goto	ITR_BREAK;
				}
			}
			}
		}
		break;

	case ITR_HDWI:
		if (hstart >= hend && hstep > 0
		 && wstart <= wend && wstep > 0) {
			for (h = hstart; h >= hend; h -= hstep) {
			for (w = wstart; w <= wend; w += wstep) {
				if (CalcVSpltBtn (lpVSplt, &w, &h)) {
					rc	= TRUE;
					goto	ITR_BREAK;
				}
			}
			}
		}
		break;
	default:
		break;
	}

ITR_BREAK:;
	if (rc) {
		*width	= w;
		*height	= h;
	}

	return (rc);
}

/*=============================================================================
	SaveVSpltMaxBtn
=============================================================================*/
BOOL	SaveVSpltMaxBtn
(
	LPVSPLT	lpVSplt
)
{
	int	i;

	lpVSplt->wMaxBtnPosRoot	= lpVSplt->wBtnPosRoot;
	lpVSplt->wMaxBtnCount	= lpVSplt->wBtnCount;
	for (i=0; i < lpVSplt->wMaxBtnCount; i++) {
		lpVSplt->wMaxBtnFunc[i]		= lpVSplt->wBtnFunc[i];
		lpVSplt->wMaxBtnIndex[i]	= lpVSplt->wBtnIndex[i];
	}
	lpVSplt->wMaxBtnRow	= lpVSplt->wBtnRow;
	lpVSplt->wMaxBtnCol	= lpVSplt->wBtnCol;
}

/*=============================================================================
	ToVSpltMaxBtn
=============================================================================*/
BOOL	ToVSpltMaxBtn
(
	LPVSPLT	lpVSplt
)
{
	int	i;

	lpVSplt->wBtnPosRoot	= lpVSplt->wMaxBtnPosRoot;
	lpVSplt->wBtnCount	= lpVSplt->wMaxBtnCount;
	for (i=0; i < lpVSplt->wBtnCount; i++) {
		lpVSplt->wBtnFunc[i]	= lpVSplt->wMaxBtnFunc[i];
		lpVSplt->wBtnIndex[i]	= lpVSplt->wMaxBtnIndex[i];
	}
	lpVSplt->wBtnRow		= lpVSplt->wMaxBtnRow;
	lpVSplt->wBtnCol		= lpVSplt->wMaxBtnCol;
}

/*=============================================================================
	ToVSpltMinBtn
=============================================================================*/
BOOL	ToVSpltMinBtn
(
	LPVSPLT	lpVSplt
)
{
#define	POS	0
	lpVSplt->wBtnPosRoot	= POS;
	lpVSplt->wBtnCount	= 1;
	lpVSplt->wBtnFunc[POS]	=lpVSplt->wMaxBtnFunc[lpVSplt->wMaxBtnPosRoot];
	lpVSplt->wBtnIndex[POS]	=lpVSplt->wMaxBtnIndex[lpVSplt->wMaxBtnPosRoot];
	lpVSplt->wBtnRow	= 1;
	lpVSplt->wBtnCol	= 1;
}

/*=============================================================================
	IsAccAlive
=============================================================================*/
BOOL	IsAccAlive
(
	WORD	wAccNo
)
{
	LPENV	lpEnv;
	lpEnv	= (LPENV )GetEnv (0);
	if (wAccNo >= MAX_ACC
	 || wAccNo >= lpEnv->aci.wAccCount) {
		return (FALSE);
	}
	return (TRUE);
}

/*=============================================================================
	GetAccString
=============================================================================*/
LPTSTR	GetAccString
(
	WORD	wAccNo,
	int	iMode
)
{
	LPENV	lpEnv;
	LPTSTR	ret;

	lpEnv	= (LPENV )GetEnv (0);
	ret	= NULL;
	if	( IsAccAlive (wAccNo) )	{
		switch	( iMode ) {
		case	0:
			ret = lpEnv->acc[wAccNo].sztAccShort;
			break;
		case	1:
			ret = lpEnv->acc[wAccNo].sztAccLong;
			break;
		}
	}
	return	ret;
}

/*=============================================================================
	GetFuncStr
=============================================================================*/
LPTSTR	WINAPI	GetFuncStr
(
	UINT	uType,
	UINT	uKey,
	UINT	uOpt
)
{
static	TCHAR	sztTemp[MAX_LONG_STR + 1];
	LPTSTR	lptTemp;
	LPENV	lpEnv;
	LPTSTR	ret;
	int	i;

	InLog(__FILE__ "/GetFuncStr");
	lpEnv	= (LPENV )GetEnv(0);
	ret	= GetStr(uType,uKey,uOpt);
	if	( ( uKey  >= F_CNV_OPT1		)
	&&	  ( uKey  <= F_CNV_OPT10	)
	&&	  ( uType == GS_FKLONG		) ) {
		uKey	= uKey - F_CNV_OPT1;
		if	( ( IsDicAlive((WORD)uKey)		)
		&&	  ( lpEnv->dic[uKey].sztDicDesc[0]	) ) {
			lstrcpy(sztTemp,lpEnv->dic[uKey].sztDicDesc);
			lstrcat(sztTemp,TEXT("Ѵ")		   );
			ret	= sztTemp;
		}
	}
	else if	( ( uKey  >= F_EX_ACC1				)
	&&	  ( uKey  <= F_EX_ACC10				)
	&&	  ( uType == GS_FKLONG  || uType == GS_FKSHORT	) ) {
		uKey	= uKey - F_EX_ACC1;
		i	= (uType == GS_FKLONG) ? 1 : 0;
		lptTemp	= (LPTSTR )GetAccString((WORD) uKey,i);
		if	( lptTemp ) {
			ret	= lptTemp;
		}
	}
	OutLog(__FILE__ "/GetFuncStr");
	return	ret;
}

/*=============================================================================
	IsAllAuto
=============================================================================*/
static	BOOL	IsAllAuto
(
	LPENV	lpEnv
)
{
	int	i;

	if	( lpEnv->fix.wEisuFix != AUTO )			return	FALSE;
	if	( lpEnv->fix.wKanaFix != AUTO )			return	FALSE;
	for	( i = 0 ; i < KIGOS ; i++ ) {
		if	( lpEnv->fix.wKigoFix[i] != AUTO )	return	FALSE;
	}
	return	TRUE;
}

/*=============================================================================
	GetFuncState
=============================================================================*/
int	GetFuncState
(
	FXim_Client	*client,
	WORD		wVkey,
	LPTSTR		lptStr
)
{
static	TCHAR		sztSuru[]	= TEXT("[]");
static	TCHAR		sztSinai[]	= TEXT("[ʤ]");
static	TCHAR		sztJidou[]	= TEXT("[ư]");
	PBD		bdata;
	LPENV		lpEnv;
	LPTSTR		lptStat;
	int		ret;

	lpEnv		= (LPENV )GetEnv(0);
	bdata		= (PBD   )GetBDATA (client);
	lptStat		= NULL;
	ret		= 0;
	switch	( wVkey ) {
	case	F_SCRN:
		if	( bdata->wVjeModeFlag & SCREEN_MODE ) {
			if (IsKanaMode (client)) {
				ret	= 1;
				lptStat	= TEXT("[(ʥå)]");
			}
			else {
				ret	= 0;
				lptStat	= TEXT("[]");
			}
		}
		else	{
			ret	= 2;
			lptStat	= TEXT("[]");
		}
		break;
	case	F_ROM:
	case	F_EX_ROMSAVE:
		if	( bdata->wVjeModeFlag & KATA_BIT ) {
			ret	= 1;
			lptStat	= TEXT("[]");
		}
		else {
			ret	= 0;
			lptStat	= TEXT("[޻]");
		}
		break;
	case	F_EX_CHAR_TOG:
		if	( bdata->wVjeModeFlag & EISUU_BIT ) {
			ret	= 3;
			lptStat	= TEXT("[ѿ]");
		}
		else if	( bdata->wVjeModeFlag & KANA_BIT  ) {
			ret	= 1;
			lptStat	= TEXT("[]");
		}
		else {
			ret	= 0;
			lptStat	= TEXT("[Ҥ餬]");
		}
		break;
	case	F_ZEN:
		if	( IsAllAuto(lpEnv)      ) {
			if	( bdata->wVjeModeFlag & ZENKAKU_BIT ) {
				ret	= 0;
				lptStat	= TEXT("[]");
			}
			else {
				ret	= 1;
				lptStat	= TEXT("[Ⱦ]");
			}
		}
		else	{
			if	( bdata->wVjeModeFlag & ZENKAKU_BIT ) {
				ret	= 2;
				lptStat	= TEXT("[(Ⱦ)]");
			}
			else {
				ret	= 3;
				lptStat	= TEXT("[Ⱦ()]");
			}
		}
		break;
	case	F_DMODE:
		if	( bdata->wVjeModeFlag & DIRECT_MODE ) {
			ret	= 0;
			lptStat	= sztSuru;
		}
		else {
			ret	= 1;
			lptStat	= sztSinai;
		}
		break;
	case	F_EX_OKURI_TOG:
		if	(bdata->wHenModFlagV & MOD_OKURI_HONSOKU) {
			ret	= 0;
			lptStat	= TEXT("[§]");
		}
		else if	(bdata->wHenModFlagV & MOD_OKURI_OKURU  ) {
			ret	= 1;
			lptStat	= TEXT("[]");
		}
		else if	(bdata->wHenModFlagV & MOD_OKURI_HABUKU )	{
			ret	= 2;
			lptStat	= TEXT("[ʤ]");
		}
		else {
			ret	= 3;
			lptStat	= TEXT("[٤]");
		}
		break;
	case	F_EX_KANAREG_TOG:
		if	( bdata->wHenModFlagV & MOD_KATAKANA_ON ) {
			ret	= 0;
			lptStat	= sztSuru;
		}
		else {
			ret	= 1;
			lptStat	= sztSinai;
		}
		break;
	case	F_EX_EISUREG_TOG:
		if	( bdata->wHenModFlagV & MOD_EISU_ON ) {
			ret	= 0;
			lptStat	= sztSuru;
		}
		else {
			ret	= 1;
			lptStat	= sztSinai;
		}
		break;
	case	F_EX_CODE_TOG:
		if	( bdata->wHenModFlag & MOD_SJIS   ) {
			ret	= 0;
			lptStat	= TEXT("[SJIS]");
		}
		else if	( bdata->wHenModFlag & MOD_JIS    ) {
			ret	= 1;
			lptStat	= TEXT("[JIS]");
		}
		else if	( bdata->wHenModFlag & MOD_UNICODE) {
			ret	= 3;
			lptStat	= TEXT("[Unicode]");
		}
		else if	( bdata->wHenModFlag & MOD_EUC) {
			ret	= 81; /* 991013:EUC */
			lptStat	= TEXT("[EUC]");
		}
		else {
			ret	= 2;
			lptStat	= TEXT("[]");
		}
		break;
	case	F_EX_BUNPOU_TOG:
		if	( bdata->wHenModFlagV & MOD_BUNSETU ) {
			ret	= 0;
			lptStat	= sztSinai;
		}
		else {
			ret	= 1;
			lptStat	= sztSuru;
		}
		break;
	case	F_EX_KOUGO_TOG:
		if	( bdata->wHenModFlagV & MOD_KOUGO_ON ) {
			ret	= 0;
			lptStat	= sztSuru;
		}
		else {
			ret	= 1;
			lptStat	= sztSinai;
		}
		break;
	case	F_EX_KUTOCNV_TOG:
		if	(bdata->wHenModFlag & MOD_KUTEN_CNV_YES) {
			ret	= 0;
			lptStat	= sztSuru;
		}
		else {
			ret	= 1;
			lptStat	= sztSinai;
		}
		break;
	case	F_EX_CNVMODE_TOG:
		if	( bdata->wHenModFlag & MOD_SAKI ) {
			ret	= 0;
			lptStat	= TEXT("[ɤ]");
		}
		else if	( bdata->wHenModFlag & MOD_REN  ) {
			ret	= 1;
			lptStat	= TEXT("[Ϣʸ]");
		}
		else {
			ret	= 2;
			lptStat	= TEXT("[٤]");
		}
		break;
	case	F_EX_YURAGI_TOG:
		if	( bdata->wHenModFlagV & MOD_YURAGI_ON ) {
			ret	= 0;
			lptStat	= sztSuru;
		}
		else {
			ret	= 1;
			lptStat	= sztSinai;
		}
		break;
	case	F_EX_HOSEI_TOG:
		if	( bdata->wHenModFlagV & MOD_HOSEI_ON ) {
			ret	= 0;
			lptStat	= sztSuru;
		}
		else {
			ret	= 1;
			lptStat	= sztSinai;
		}
		break;
	case	F_EX_CALC_TOG:
		if	( bdata->wHenModFlag & MOD_CALC_ON ) {
			ret	= 0;
			lptStat	= sztSuru;
		}
		else {
			ret	= 1;
			lptStat	= sztSinai;
		}
		break;
	case	F_EX_COMMA_TOG:
		switch	(lpEnv->kbd.wComma) {
		case	NO:
			ret	= 0;
			lptStat	= sztSinai;
			break;
		case	YES:
			ret	= 1;
			lptStat	= sztSuru;
			break;
		case	AUTO:
			ret	= 2;
			lptStat	= sztJidou;
			break;
		}
		break;
	case	F_EX_PERIOD_TOG:
		switch	(lpEnv->kbd.wPeriod) {
		case	NO:
			ret	= 0;
			lptStat	= sztSinai;
			break;
		case	YES:
			ret	= 1;
			lptStat	= sztSuru;
			break;
		case	AUTO:
			ret	= 2;
			lptStat	= sztJidou;
			break;
		}
		break;
	case	F_EX_SLASH_TOG:
		switch	(lpEnv->kbd.wSlash) {
		case	NO:
			ret	= 0;
			lptStat	= sztSinai;
			break;
		case	YES:
			ret	= 1;
			lptStat	= sztSuru;
			break;
		case	AUTO:
			ret	= 2;
			lptStat	= sztJidou;
			break;
		}
		break;
	case	F_EX_HYPHEN_TOG:
		switch	(lpEnv->kbd.wHyphen) {
		case	NO:
			ret	= 0;
			lptStat	= sztSinai;
			break;
		case	YES:
			ret	= 1;
			lptStat	= sztSuru;
			break;
		case	AUTO:
			ret	= 2;
			lptStat	= sztJidou;
			break;
		}
		break;
	case	F_EX_BRACKET_TOG:
		switch	(lpEnv->kbd.wBracket) {
		case	NO:
			ret	= 0;
			lptStat	= sztSinai;
			break;
		case	YES:
			ret	= 1;
			lptStat	= sztSuru;
			break;
		}
		break;
	case	F_EX_TEN_TOG:
		switch	(lpEnv->kbd.wTen) {
		case	NO:
			ret	= 1;
			lptStat	= sztSinai;
			break;
		case	YES:
			ret	= 0;
			lptStat	= sztSuru;
			break;
		}
		break;
	case	F_EX_MARU_TOG:
		switch	(lpEnv->kbd.wMaru) {
		case	NO:
			ret	= 1;
			lptStat	= sztSinai;
			break;
		case	YES:
			ret	= 0;
			lptStat	= sztSuru;
			break;
		}
		break;
	case	F_EX_JISONLY_TOG:
		if	( bdata->wHenModFlagLim & MOD_LIM_JIS_YES ) {
			ret	= 0;
			lptStat	= sztSuru;
		}
		else {
			ret	= 1;
			lptStat	= sztSinai;
		}
		break;
#if 0 /* Delete:KanaCtrl */
	case	F_EX_KANACTRL_TOG:
		if	( bdata->wKeyType == KEY_KANALOCK  ) {
			ret	= 0;
			lptStat	= sztSuru;
		}
		else if	( bdata->wKeyType == KEY_KANALOCK2 ) {
			ret	= 1;
			lptStat	= sztSinai;
		}
		break;
#endif /* Delete:KanaCtrl */

/* koho window */
	case	F_EX_KOHO_SORT_TOP:
		if	( bdata->koho_mode != KOHO_SORT_TOP ) {
			ret	= 0;
			lptStat	= TEXT("[Ƭʸ]");
		} else {
			ret	= 1;
			lptStat	= TEXT("[]");
		}
		break;
	case	F_EX_KOHO_SORT_END:
		if	( bdata->koho_mode != KOHO_SORT_END ) {
			ret	= 0;
			lptStat	= TEXT("[ʸ]");
		} else {
			ret	= 1;
			lptStat	= TEXT("[]");
		}
		break;
	}
	if	( lptStr ) {
		lstrcpy(lptStr,(char *)GetFuncStr(GS_FKLONG,wVkey,0));
		if	( lptStat ) {
			lstrcat(lptStr,lptStat  );
		}
	}
#if 0
	if	( !(bdata->wVjeModeFlag & SCREEN_MODE) ) {
		ret	= ~ret;
	}
#endif
	return	ret;
}

/*=============================================================================
	CheckAtw
=============================================================================*/
BOOL	CheckAtw
(
	LPTSTR		lptName
)
{
	LPENV		lpEnv;
	LPENVINI	ini;
	LPTSTR		lptOut;

	if (!lptName || !(*lptName)) {
		return (FALSE);
	}
	lpEnv	= (LPENV )GetEnv (0);
	ini	= &lpEnv->ini;
	lptOut	= ini->sztAtwTitle;
	while (lptOut = lstrtok (lptOut, TEXT (' '))) {
#if 1
		if (!strncmp (lptName, lptOut, strlen (lptOut))) {
#else
		if (strstr (lptName, lptOut)) {
#endif
			return (TRUE);
		}
	}
	return (FALSE);
}

